// Support Code Declarations

function $i($0)
{
   function $1() {};
   $1.prototype = $0.prototype;
   return new $1();
};

function tobject() {};

tobject.create = function($0)
{
   return $0;
};

tobject.free = function($0)
{
   if ($0)
      $0.destroy();
   return null;
};

tobject.$p = tobject.prototype;

tobject.$p.constructor = tobject;

tobject.$p.destroy = function()
{
};

function chr($0)
{
   return String.fromCharCode($0);
};

function comparestr($0, $1)
{
   return $0.localeCompare($1);
};

function comparetext($0, $1)
{
   return $0.toLocaleUpperCase().localeCompare($1.toLocaleUpperCase());
};

function copy($0, $1, $2)
{
   if ($1 && !($0 instanceof Array))
      $1--;
   if ($1 && ($1 <= 0))
      return $0.slice(0,0);
   else if ($2)
      return $0.slice($1, $1 + ($2 < 0 ? 0 : $2));
   else if ($1)
      return $0.slice($1);
   else
      return $0.slice(0);
};

function datetimetostr($0)
{
   return new Date($0).toLocaleString();
};

function delarray($0, $1, $2)
{
   if ($2)
      return $0.splice($1, $2);
   else
      return $0.splice($1);
};

function floattostr($0, $1)
{
   if ($1)
      return Number($0).toFixed($1);
   else
      return Number($0).toString();
};

function floor($0)
{
   return Math.floor($0);
};

function insarray($0, $1, $2)
{
   return $1.splice($2, 0, $0);
};

function inttohex($0, $1)
{
   var $2 = Number($0).toString(16);
   while ($2.length < $1)
      $2 = "0" + $2;
   return $2;
};

function inttostr($0)
{
   return Number($0).toString(10);
};

function join($0, $1)
{
   if ($1)
      return $0.join($1);
   else
      return $0.join();
};

function length($0)
{
   return $0.length;
};

function max($0, $1)
{
   return ($0 > $1 ? $0 : $1);
};

function min($0, $1)
{
   return ($0 < $1 ? $0 : $1);
};

function pos($0, $1, $2)
{
   if ($2)
      return ($1.indexOf($0, $2 - 1) + 1);
   else
      return ($1.indexOf($0, 0) + 1);
};

function sametext($0, $1)
{
   return ($0.toLocaleUpperCase().localeCompare($1.toLocaleUpperCase()) == 0);
};

function split($0, $1, $2)
{
   if ($2)
      return $0.split($1, $2);
   else
      return $0.split($1);
};

function strtodatetime($0)
{
   return new Date($0).getTime();
};

function strtofloat($0)
{
   return parseFloat($0);
};

function strtoint($0)
{
   return parseInt($0);
};

// WebForms Unit Interface Declarations

var webforms_podesktopcenter = 1, webforms_podesktopcentertop = 2, webforms_mtwarning = 0, webforms_mterror = 1, webforms_mtinformation = 2, webforms_mtconfirmation = 3, webforms_mtcustom = 4, webforms_msgdlg_padding = 12, webforms_msgdlg_button_padding = 8, webforms_msgdlg_button_spacing = 6;

var webforms_application;

// WebCore Unit Interface Declarations

var webcore_cm_removecomp = 2, webcore_cm_compsloaded = 3, webcore_high_int = 2147483647;

// WebDOM Unit Interface Declarations

// WebDOM Unit Implementation Declarations

function webdom_getbodyelement()
{
   var $r;
   $r = window.document.getElementsByTagName("body")[0];
   return $r;
};

function webdom_pixelstostr(value)
{
   var $r;
   $r = inttostr(value) + "px";
   return $r;
};

function webdom_pointstostr(value)
{
   var $r;
   $r = inttostr(value) + "pt";
   return $r;
};

function webdom_strtopoints(value)
{
   var $r, tempstring;
   tempstring = value;
   if (copy(tempstring, (length(tempstring) - 1), 2) == "pt")
      tempstring = copy(tempstring, 1, (length(tempstring) - 2));
   else 
      tempstring = "";
   $r = strtoint(tempstring);
   return $r;
};

function webdom_getrvalue(color)
{
   var $r;
   $r = (color & 255);
   return $r;
};

function webdom_getgvalue(color)
{
   var $r;
   $r = ((color & 65280) >>> 8);
   return $r;
};

function webdom_getbvalue(color)
{
   var $r;
   $r = ((color & 16711680) >>> 16);
   return $r;
};

function webdom_colortostr(value)
{
   var $r;
   $r = "#" + inttohex(webdom_getrvalue(value), 2) + inttohex(webdom_getgvalue(value), 2) + inttohex(webdom_getbvalue(value), 2);
   return $r;
};

function webdom_strtocolor(value)
{
   var $r, tempstring, temprgbstrings = null, i;
   $r = 0;
   tempstring = value;
   if (tempstring.charAt(0) == "#")
   {
      tempstring = "0x" + copy(tempstring, 2);
      $r = strtoint(tempstring);
   }
   else if (sametext(copy(tempstring, 1, 3), "rgb"))
   {
      tempstring = copy(tempstring, 4);
      if ((tempstring.charAt(0) == "(") && (tempstring.charAt(length(tempstring) - 1) == ")"))
      {
         temprgbstrings = split(tempstring, ",");
         if (length(temprgbstrings) == 3)
         {
            tempstring = "0x";
            for (i = 1 ; i <= 3 ; i++)
               tempstring = tempstring + inttohex(strtoint(temprgbstrings[i]), 2);
            $r = strtoint(tempstring);
         }
      }
   }
   return $r;
};

function webdom_getcssstyle(element)
{
   var $r, i, tempstylesheet, temprules;
   $r = null;
   tempstylesheet = null;
   for (i = 0 ; i <= window.document.styleSheets.length - 1 ; i++)
   {
      if (!window.document.styleSheets[i].disabled)
      {
         tempstylesheet = window.document.styleSheets[i];
         break;
      }
   }
   if (tempstylesheet)
   {
      if (tempstylesheet.cssRules)
         temprules = tempstylesheet.cssRules;
      else if (tempstylesheet.rules)
         temprules = tempstylesheet.rules;
      if (temprules)
      {
         for (i = 0 ; i <= temprules.length - 1 ; i++)
         {
            if (sametext(temprules[i].selectorText, "." + element.className))
            {
               $r = temprules[i].style;
               break;
            }
         }
      }
   }
   return $r;
};

function webdom_setactivestylesheet(name)
{
   var $r, i, tempstylesheet;
   $r = false;
   tempstylesheet = null;
   for (i = 0 ; i <= window.document.styleSheets.length - 1 ; i++)
   {
      if ((tempstylesheet == null) && sametext(window.document.styleSheets[i].title, name))
         tempstylesheet = window.document.styleSheets[i];
   }
   if (tempstylesheet)
   {
      for (i = 0 ; i <= window.document.styleSheets.length - 1 ; i++)
      {
         if (window.document.styleSheets[i] != tempstylesheet)
            window.document.styleSheets[i].disabled = true;
      }
      tempstylesheet.disabled = false;
      $r = true;
   }
   return $r;
};

function webdom_setwindoweventhandler(handlertype, handler)
{
   var $r;
   if (window.addEventListener)
      window.addEventListener(handlertype, handler, false);
   else if (window.attachEvent)
      window.attachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot add window event handler for \"" + handlertype + "\" event");
   $r = handler;
   return $r;
};

function webdom_clearwindoweventhandler(handlertype, handler)
{
   if (window.removeEventListener)
      window.removeEventListener(handlertype, handler, false);
   else if (window.detachEvent)
      window.detachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot remove window \"" + handlertype + "\" event handler");
};

function webdom_setdocumenteventhandler(handlertype, handler)
{
   var $r;
   if (window.document.addEventListener)
      window.document.addEventListener(handlertype, handler, false);
   else if (window.document.attachEvent)
      window.document.attachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot add document event handler for \"" + handlertype + "\" event");
   $r = handler;
   return $r;
};

function webdom_cleardocumenteventhandler(handlertype, handler)
{
   if (window.document.removeEventListener)
      window.document.removeEventListener(handlertype, handler, false);
   else if (window.document.detachEvent)
      window.document.detachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot remove document \"" + handlertype + "\" event handler");
};

function webdom_seteventhandler(element, handlertype, handler)
{
   var $r;
   if (element.addEventListener)
      element.addEventListener(handlertype, handler, false);
   else if (element.attachEvent)
      element.attachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot add event handler to \"" + element.tagName + "\" element for \"" + handlertype + "\" event");
   $r = handler;
   return $r;
};

function webdom_cleareventhandler(element, handlertype, handler)
{
   if (element.removeEventListener)
      element.removeEventListener(handlertype, handler, false);
   else if (element.detachEvent)
      element.detachEvent("on" + handlertype, handler);
   else 
      throw new Error("Cannot remove \"" + handlertype + "\" event handler from \"" + element.tagName + "\"");
};

function webdom_canceleventbubble(event)
{
   event.cancelBubble = true;
   if (event.stopPropogation)
      event.stopPropogation();
};

function webdom_seteventresult(event, value)
{
   event.returnValue = value;
   if ((!value) && event.preventDefault)
      event.preventDefault();
};

function webdom_geteventtarget(event)
{
   var $r;
   if (event.target && (event.target instanceof Element))
      $r = event.target;
   else if (event.srcElement && (event.srcElement instanceof Element))
      $r = event.srcElement;
   else 
      $r = null;
   return $r;
};


// WebCore Unit Implementation Declarations

// TComponent Class Declarations

function webcore_tcomponent()
{
   var $t = this;
   Object.call($t);
   $t.tcomponent_fowner = null;
   $t.tcomponent_fname = "";
   $t.tcomponent_fdestroying = false;
   $t.tcomponent_fcomponents = null;
   $t.tcomponent_fnotifications = null;
}

webcore_tcomponent.create = function(instance, aowner)
{
   tobject.create(instance);
   instance.tcomponent_fowner = aowner;
   if (instance.tcomponent_fowner)
      instance.tcomponent_fowner.insertcomponent(instance);
   return instance;
};

webcore_tcomponent.prototype = $i(tobject);
webcore_tcomponent.$p = webcore_tcomponent.prototype;
webcore_tcomponent.$p.constructor = webcore_tcomponent;

webcore_tcomponent.$p.tcomponent_setname = function(value)
{
   var $t = this;
   if (value != $t.tcomponent_fname)
   {
      $t.tcomponent_fname = value;
      $t.namechanged();
   }
};

webcore_tcomponent.$p.namechanged = function()
{
};

webcore_tcomponent.$p.insertcomponent = function(component)
{
   var $t = this;
   if ($t.tcomponent_fcomponents == null)
      $t.tcomponent_fcomponents = webcore_tobjectlist.create(new webcore_tobjectlist());
   $t.tcomponent_fcomponents.add(component);
};

webcore_tcomponent.$p.removecomponent = function(component)
{
   var $t = this;
   if (!$t.tcomponent_fdestroying)
   {
      $t.tcomponent_fcomponents.remove1(component);
      if ($t.tcomponent_fcomponents.tobjectlist_fcount == 0)
         $t.tcomponent_fcomponents = tobject.free($t.tcomponent_fcomponents);
   }
};

webcore_tcomponent.$p.getcomponentcount = function()
{
   var $t = this, $r;
   $r = 0;
   if ($t.tcomponent_fcomponents)
      $r = $t.tcomponent_fcomponents.tobjectlist_fcount;
   return $r;
};

webcore_tcomponent.$p.getcomponent = function(value)
{
   var $t = this, $r;
   $r = null;
   if ($t.tcomponent_fcomponents && (value >= 0) && (value < $t.tcomponent_fcomponents.tobjectlist_fcount))
      $r = $t.tcomponent_fcomponents.getobject(value);
   return $r;
};

webcore_tcomponent.$p.register = function(component)
{
   var $t = this;
   if ($t.tcomponent_fdestroying)
      throw new Error("\" " + $t.tcomponent_fname + "\" component already destroyed");
   if (component.tcomponent_fdestroying)
      throw new Error("\" " + component.tcomponent_fname + "\" component already destroyed");
   if ($t.tcomponent_fnotifications == null)
      $t.tcomponent_fnotifications = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
   if ($t.tcomponent_fnotifications.indexof(component) == -1)
   {
      $t.tcomponent_fnotifications.add(component);
      component.register($t);
   }
};

webcore_tcomponent.$p.unregister = function(component)
{
   var $t = this;
   if ($t.tcomponent_fnotifications)
   {
      $t.tcomponent_fnotifications.remove1(component);
      if ($t.tcomponent_fnotifications.tobjectlist_fcount == 0)
         $t.tcomponent_fnotifications = tobject.free($t.tcomponent_fnotifications);
   }
};

webcore_tcomponent.$p.notification = function(sender, id, data)
{
   var $t = this, $r;
   $r = false;
   switch (id)
   {
      case webcore_cm_removecomp:
      {
         if (sender)
            $t.unregister(sender);
         break;
      }
      case webcore_cm_compsloaded:
      {
         $t.loaded();
         break;
      }
   };
   return $r;
};

webcore_tcomponent.$p.notify = function(id, data)
{
   var $t = this, i;
   if (data == null)
      data = null;
   if ($t.tcomponent_fnotifications)
   {
      for (i = 0 ; i <= $t.tcomponent_fnotifications.tobjectlist_fcount - 1 ; i++)
      {
         if ($t.tcomponent_fnotifications.getobject(i).notification($t, id, data))
            break;
      }
   }
};

webcore_tcomponent.$p.loaded = function()
{
   var $t = this, i;
   if ($t.tcomponent_fcomponents)
   {
      for (i = 0 ; i <= $t.tcomponent_fcomponents.tobjectlist_fcount - 1 ; i++)
         $t.tcomponent_fcomponents.getobject(i).notification($t, webcore_cm_compsloaded, null);
   }
};

webcore_tcomponent.$p.destroy = function()
{
   var $t = this;
   if (!$t.tcomponent_fdestroying)
   {
      $t.tcomponent_fdestroying = true;
      $t.notify(webcore_cm_removecomp);
      $t.tcomponent_fnotifications = tobject.free($t.tcomponent_fnotifications);
      $t.tcomponent_fcomponents = tobject.free($t.tcomponent_fcomponents);
      if ($t.tcomponent_fowner)
         $t.tcomponent_fowner.removecomponent($t);
      tobject.$p.destroy.call($t);
   }
};

// TTimer Class Declarations

function webcore_ttimer()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.ttimer_fenabled = false;
   $t.ttimer_finterval = 1000;
   $t.ttimer_fontimer = null;
   $t.ttimer_fid = 0;
}

webcore_ttimer.prototype = $i(webcore_tcomponent);
webcore_ttimer.$p = webcore_ttimer.prototype;
webcore_ttimer.$p.constructor = webcore_ttimer;

webcore_ttimer.$p.ttimer_setenabled = function(value)
{
   var $t = this;
   if (value != $t.ttimer_fenabled)
   {
      if (value)
         $t.createintervalhandler();
      else 
         $t.freeintervalhandler();
      $t.ttimer_fenabled = value;
   }
};

webcore_ttimer.$p.ttimer_setinterval = function(value)
{
   var $t = this;
   if (value != $t.ttimer_finterval)
   {
      if ($t.ttimer_fenabled)
      {
         $t.ttimer_setenabled(false);
         try
         {
            $t.ttimer_finterval = value;
         }
         finally
         {
            $t.ttimer_setenabled(true);
         }
      }
      else 
         $t.ttimer_finterval = value;
   }
};

webcore_ttimer.$p.createintervalhandler = function()
{
   var $t = this;
   $t.ttimer_fid = window.setInterval(function() { webcore_ttimer.$p.dotimer.call($t); }, $t.ttimer_finterval);
};

webcore_ttimer.$p.freeintervalhandler = function()
{
   var $t = this;
   if ($t.ttimer_fid != 0)
   {
      window.clearInterval($t.ttimer_fid);
      $t.ttimer_fid = 0;
   }
};

webcore_ttimer.$p.dotimer = function()
{
   var $t = this;
   if ($t.ttimer_fontimer)
      $t.ttimer_fontimer($t);
};

webcore_ttimer.$p.destroy = function()
{
   var $t = this;
   $t.ttimer_setenabled(false);
   webcore_tcomponent.$p.destroy.call($t);
};

// TParser Class Declarations

function webcore_tparser()
{
   var $t = this;
   Object.call($t);
}

webcore_tparser.prototype = $i(tobject);
webcore_tparser.$p = webcore_tparser.prototype;
webcore_tparser.$p.constructor = webcore_tparser;

// TObjectList Class Declarations

function webcore_tobjectlist()
{
   var $t = this;
   Object.call($t);
   $t.tobjectlist_fownsobjects = false;
   $t.tobjectlist_fcount = 0;
   $t.tobjectlist_fobjects = null;
   $t.tobjectlist_fdestroying = false;
}

webcore_tobjectlist.create = function(instance)
{
   tobject.create(instance);
   instance.tobjectlist_fownsobjects = true;
   return instance;
};

webcore_tobjectlist.create1 = function(instance, aownsobjects)
{
   tobject.create(instance);
   instance.tobjectlist_fownsobjects = aownsobjects;
   return instance;
};

webcore_tobjectlist.prototype = $i(tobject);
webcore_tobjectlist.$p = webcore_tobjectlist.prototype;
webcore_tobjectlist.$p.constructor = webcore_tobjectlist;

webcore_tobjectlist.$p.tobjectlist_freeobjects = function()
{
   var $t = this, i;
   try
   {
      for (i = $t.tobjectlist_fcount - 1 ; i >= 0 ; i--)
         $t.tobjectlist_fobjects[i] = tobject.free($t.tobjectlist_fobjects[i]);
   }
   finally
   {
      $t.tobjectlist_fcount = 0;
   }
};

webcore_tobjectlist.$p.tobjectlist_addobject = function(newobject)
{
   var $t = this, $r;
   $r = $t.tobjectlist_fcount;
   $t.tobjectlist_fcount++;
   if (!$t.tobjectlist_fobjects)
      $t.tobjectlist_fobjects = [];
   $t.tobjectlist_fobjects.length = $t.tobjectlist_fcount;
   $t.tobjectlist_fobjects[$t.tobjectlist_fcount - 1] = newobject;
   return $r;
};

webcore_tobjectlist.$p.tobjectlist_insertobject = function(insertpos, newobject)
{
   var $t = this;
   if (!$t.tobjectlist_fobjects)
      $t.tobjectlist_fobjects = [];
   $t.tobjectlist_fobjects.length = $t.tobjectlist_fcount;
   insarray(newobject, $t.tobjectlist_fobjects, insertpos);
   $t.tobjectlist_fcount++;
};

webcore_tobjectlist.$p.tobjectlist_deleteobject = function(deletepos, freeownedobject)
{
   var $t = this, tempobject;
   if (freeownedobject == null)
      freeownedobject = true;
   tempobject = $t.tobjectlist_fobjects[deletepos];
   try
   {
      if ($t.tobjectlist_fownsobjects && freeownedobject)
         tempobject = tobject.free(tempobject);
      delarray($t.tobjectlist_fobjects, deletepos, 1);
   }
   finally
   {
      $t.tobjectlist_fcount--;
   }
};

webcore_tobjectlist.$p.checkindex = function(index)
{
   var $t = this;
   if ((index < 0) || (index >= $t.tobjectlist_fcount))
      throw new Error("List index " + inttostr(index) + " out of bounds");
};

webcore_tobjectlist.$p.setcount = function(value)
{
   var $t = this, i;
   if (value != $t.tobjectlist_fcount)
   {
      if (value < $t.tobjectlist_fcount)
      {
         if ($t.tobjectlist_fownsobjects)
         {
            for (i = $t.tobjectlist_fcount - 1 ; i >= value ; i--)
               $t.tobjectlist_fobjects[i] = tobject.free($t.tobjectlist_fobjects[i]);
         }
      }
      if (!$t.tobjectlist_fobjects)
         $t.tobjectlist_fobjects = [];
      $t.tobjectlist_fobjects.length = value;
      $t.tobjectlist_fcount = value;
   }
};

webcore_tobjectlist.$p.getobject = function(index)
{
   var $t = this, $r;
   $t.checkindex(index);
   $r = $t.tobjectlist_fobjects[index];
   return $r;
};

webcore_tobjectlist.$p.setobject = function(index, aobject)
{
   var $t = this;
   $t.checkindex(index);
   $t.tobjectlist_fobjects[index] = aobject;
};

webcore_tobjectlist.$p.destroy = function()
{
   var $t = this;
   $t.tobjectlist_fdestroying = true;
   if ($t.tobjectlist_fownsobjects)
      $t.tobjectlist_freeobjects();
   tobject.$p.destroy.call($t);
};

webcore_tobjectlist.$p.add = function(aobject)
{
   var $t = this, $r;
   $r = $t.tobjectlist_addobject(aobject);
   return $r;
};

webcore_tobjectlist.$p.remove = function(index)
{
   var $t = this;
   $t.checkindex(index);
   $t.tobjectlist_deleteobject(index);
};

webcore_tobjectlist.$p.remove1 = function(aobject)
{
   var $t = this, $r;
   if ($t.tobjectlist_fdestroying)
      $r = -1;
   else 
   {
      $r = $t.indexof(aobject);
      if ($r != -1)
         $t.tobjectlist_deleteobject($r);
   }
   return $r;
};

webcore_tobjectlist.$p.indexof = function(aobject)
{
   var $t = this, $r, i;
   $r = -1;
   for (i = 0 ; i <= $t.tobjectlist_fcount - 1 ; i++)
   {
      if ($t.tobjectlist_fobjects[i] == aobject)
      {
         $r = i;
         break;
      }
   }
   return $r;
};

webcore_tobjectlist.$p.insert = function(index, aobject)
{
   var $t = this;
   $t.tobjectlist_insertobject(index, aobject);
};

webcore_tobjectlist.$p.first = function()
{
   var $t = this, $r;
   $r = null;
   if ($t.tobjectlist_fcount > 0)
      $r = $t.tobjectlist_fobjects[0];
   return $r;
};

webcore_tobjectlist.$p.prior = function(aobject, wrap)
{
   var $t = this, $r, i;
   if (wrap == null)
      wrap = false;
   $r = null;
   i = $t.indexof(aobject);
   if (i != -1)
   {
      if (i > 0)
         $r = $t.tobjectlist_fobjects[i - 1];
      else if (wrap && ($t.tobjectlist_fcount > 0))
         $r = $t.tobjectlist_fobjects[$t.tobjectlist_fcount - 1];
   }
   return $r;
};

webcore_tobjectlist.$p.next = function(aobject, wrap)
{
   var $t = this, $r, i;
   if (wrap == null)
      wrap = false;
   $r = null;
   i = $t.indexof(aobject);
   if (i != -1)
   {
      if (i < ($t.tobjectlist_fcount - 1))
         $r = $t.tobjectlist_fobjects[i + 1];
      else if (wrap && ($t.tobjectlist_fcount > 0))
         $r = $t.tobjectlist_fobjects[0];
   }
   return $r;
};

webcore_tobjectlist.$p.last = function()
{
   var $t = this, $r;
   $r = null;
   if ($t.tobjectlist_fcount > 0)
      $r = $t.tobjectlist_fobjects[$t.tobjectlist_fcount - 1];
   return $r;
};

webcore_tobjectlist.$p.queue = function(aobject)
{
   var $t = this;
   $t.tobjectlist_addobject(aobject);
};

webcore_tobjectlist.$p.dequeue = function()
{
   var $t = this, $r;
   $r = $t.first();
   if ($r)
      $t.tobjectlist_deleteobject(0, false);
   return $r;
};

webcore_tobjectlist.$p.push = function(aobject)
{
   var $t = this;
   $t.tobjectlist_addobject(aobject);
};

webcore_tobjectlist.$p.pop = function()
{
   var $t = this, $r;
   $r = $t.last();
   if ($r)
      $t.tobjectlist_deleteobject(($t.tobjectlist_fcount - 1), false);
   return $r;
};

webcore_tobjectlist.$p.exchange = function(source, dest)
{
   var $t = this, tempobject;
   $t.checkindex(source);
   $t.checkindex(dest);
   tempobject = $t.tobjectlist_fobjects[source];
   $t.tobjectlist_fobjects[source] = $t.tobjectlist_fobjects[dest];
   $t.tobjectlist_fobjects[dest] = tempobject;
};

// TStrings Class Declarations

function webcore_tstrings()
{
   var $t = this;
   Object.call($t);
   $t.tstrings_fnamevalueseparator = "";
   $t.tstrings_flineseparator = "";
   $t.tstrings_fupdatecount = 0;
   $t.tstrings_fupdated = false;
   $t.tstrings_fonchanged = null;
}

webcore_tstrings.create = function(instance)
{
   tobject.create(instance);
   instance.tstrings_flineseparator = "\n";
   instance.tstrings_fnamevalueseparator = "=";
   return instance;
};

webcore_tstrings.prototype = $i(tobject);
webcore_tstrings.$p = webcore_tstrings.prototype;
webcore_tstrings.$p.constructor = webcore_tstrings;

webcore_tstrings.$p.tstrings_getname = function(index)
{
   var $t = this, $r;
   $r = $t.extractname($t.getstring(index));
   return $r;
};

webcore_tstrings.$p.tstrings_getvalue = function(name)
{
   var $t = this, $r, i;
   i = $t.indexofname(name);
   if (i >= 0)
      $r = copy($t.getstring(i), (length(name) + 2));
   else 
      $r = "";
   return $r;
};

webcore_tstrings.$p.tstrings_setvalue = function(name, value)
{
   var $t = this, i, tempstring;
   i = $t.indexofname(name);
   if (value != "")
   {
      tempstring = (name + $t.tstrings_fnamevalueseparator + value);
      if (i < 0)
         $t.add(tempstring);
      else 
         $t.setstring(i, tempstring);
   }
   else 
   {
      if (i >= 0)
         $t.remove(i);
   }
};

webcore_tstrings.$p.tstrings_getvaluefromindex = function(index)
{
   var $t = this, $r, tempstring, tempname;
   if (index >= 0)
   {
      tempstring = $t.getstring(index);
      tempname = $t.extractname(tempstring);
      if (tempname != "")
         $r = copy(tempstring, (length(tempname) + 2));
      else 
         $r = "";
   }
   else 
      $r = "";
   return $r;
};

webcore_tstrings.$p.tstrings_setvaluefromindex = function(index, value)
{
   var $t = this, tempstring;
   if (value != "")
   {
      tempstring = ($t.tstrings_getname(index) + $t.tstrings_fnamevalueseparator + value);
      if (index < 0)
         $t.add(tempstring);
      else 
         $t.setstring(index, tempstring);
   }
   else 
   {
      if (index >= 0)
         $t.remove(index);
   }
};

webcore_tstrings.$p.checkindex = function(index)
{
   var $t = this;
   if ((index < 0) || (index >= $t.getcount()))
      throw new Error("List index " + inttostr(index) + " out of bounds");
};

webcore_tstrings.$p.getcount = function()
{
};

webcore_tstrings.$p.addstring = function(value)
{
};

webcore_tstrings.$p.deletestring = function(index)
{
};

webcore_tstrings.$p.deleteallstrings = function()
{
};

webcore_tstrings.$p.getstring = function(index)
{
};

webcore_tstrings.$p.setstring = function(index, value)
{
   var $t = this;
   $t.dochanged();
};

webcore_tstrings.$p.gettext = function()
{
   var $t = this, $r, i;
   $r = "";
   for (i = 0 ; i <= $t.getcount() - 1 ; i++)
      $r = $r + $t.getstring(i) + $t.tstrings_flineseparator;
   return $r;
};

webcore_tstrings.$p.settext = function(value)
{
   var $t = this, i, tempcount, tempstrings = null;
   $t.deleteallstrings();
   if (value != "")
   {
      if ($t.tstrings_flineseparator != "")
         tempstrings = split(value, $t.tstrings_flineseparator);
      else 
      {
         if (!tempstrings)
            tempstrings = [];
         tempstrings.length = 1;
         tempstrings[0] = value;
      }
   }
   else 
   {
      if (!tempstrings)
         tempstrings = [];
      tempstrings.length = 0;
   }
   if (tempstrings)
   {
      tempcount = length(tempstrings);
      if ((tempcount > 0) && (tempstrings[tempcount - 1] == ""))
         tempcount--;
      for (i = 0 ; i <= tempcount - 1 ; i++)
         $t.addstring(tempstrings[i]);
   }
   $t.dochanged();
};

webcore_tstrings.$p.extractname = function(value)
{
   var $t = this, $r, temppos;
   temppos = pos($t.tstrings_fnamevalueseparator, value);
   if (temppos != 0)
      $r = copy(value, 1, (temppos - 1));
   else 
      $r = "";
   return $r;
};

webcore_tstrings.$p.dochanged = function()
{
   var $t = this;
   if ($t.tstrings_fupdatecount == 0)
   {
      if ($t.tstrings_fonchanged)
         $t.tstrings_fonchanged($t);
   }
   else 
      $t.tstrings_fupdated = true;
};

webcore_tstrings.$p.assign = function(value)
{
   var $t = this, i;
   $t.beginupdate();
   try
   {
      $t.clear();
      for (i = 0 ; i <= value.getcount() - 1 ; i++)
         $t.add(value.getstring(i));
   }
   finally
   {
      $t.endupdate();
   }
};

webcore_tstrings.$p.add = function(value)
{
   var $t = this, $r;
   $r = $t.addstring(value);
   $t.dochanged();
   return $r;
};

webcore_tstrings.$p.beginupdate = function()
{
   var $t = this;
   $t.tstrings_fupdatecount++;
};

webcore_tstrings.$p.clear = function()
{
   var $t = this;
   $t.deleteallstrings();
   $t.dochanged();
};

webcore_tstrings.$p.endupdate = function()
{
   var $t = this;
   if ($t.tstrings_fupdatecount > 0)
   {
      $t.tstrings_fupdatecount--;
      if (($t.tstrings_fupdatecount == 0) && $t.tstrings_fupdated)
      {
         $t.tstrings_fupdated = false;
         $t.dochanged();
      }
   }
};

webcore_tstrings.$p.indexof = function(value)
{
   var $t = this, $r, i;
   $r = -1;
   for (i = 0 ; i <= $t.getcount() - 1 ; i++)
   {
      if ($t.getstring(i) == value)
      {
         $r = i;
         break;
      }
   }
   return $r;
};

webcore_tstrings.$p.indexofname = function(name)
{
   var $t = this, $r, i;
   $r = -1;
   for (i = 0 ; i <= $t.getcount() - 1 ; i++)
   {
      if (sametext($t.extractname($t.getstring(i)), name))
      {
         $r = i;
         break;
      }
   }
   return $r;
};

webcore_tstrings.$p.remove = function(index)
{
   var $t = this;
   $t.deletestring(index);
   $t.dochanged();
};

// TStringList Class Declarations

function webcore_tstringlist()
{
   var $t = this;
   webcore_tstrings.call($t);
   $t.tstringlist_fcount = 0;
   $t.tstringlist_fstrings = null;
}

webcore_tstringlist.prototype = $i(webcore_tstrings);
webcore_tstringlist.$p = webcore_tstringlist.prototype;
webcore_tstringlist.$p.constructor = webcore_tstringlist;

webcore_tstringlist.$p.getcount = function()
{
   var $t = this, $r;
   $r = $t.tstringlist_fcount;
   return $r;
};

webcore_tstringlist.$p.addstring = function(value)
{
   var $t = this, $r;
   $r = $t.tstringlist_fcount;
   $t.tstringlist_fcount++;
   if (!$t.tstringlist_fstrings)
      $t.tstringlist_fstrings = [];
   $t.tstringlist_fstrings.length = $t.tstringlist_fcount;
   $t.tstringlist_fstrings[$t.tstringlist_fcount - 1] = value;
   return $r;
};

webcore_tstringlist.$p.deletestring = function(index)
{
   var $t = this;
   $t.checkindex(index);
   try
   {
      delarray($t.tstringlist_fstrings, index, 1);
   }
   finally
   {
      $t.tstringlist_fcount--;
   }
};

webcore_tstringlist.$p.deleteallstrings = function()
{
   var $t = this;
   if (!$t.tstringlist_fstrings)
      $t.tstringlist_fstrings = [];
   $t.tstringlist_fstrings.length = 0;
   $t.tstringlist_fcount = 0;
};

webcore_tstringlist.$p.getstring = function(index)
{
   var $t = this, $r;
   $t.checkindex(index);
   $r = $t.tstringlist_fstrings[index];
   return $r;
};

webcore_tstringlist.$p.setstring = function(index, value)
{
   var $t = this;
   $t.checkindex(index);
   $t.tstringlist_fstrings[index] = value;
   webcore_tstrings.$p.setstring.call($t, index, value);
};

webcore_tstringlist.$p.gettext = function()
{
   var $t = this, $r;
   if ($t.tstringlist_fcount > 0)
      $r = join($t.tstringlist_fstrings, $t.tstrings_flineseparator);
   else 
      $r = "";
   return $r;
};

webcore_tstringlist.$p.settext = function(value)
{
   var $t = this;
   if (value != "")
   {
      if ($t.tstrings_flineseparator != "")
         $t.tstringlist_fstrings = split(value, $t.tstrings_flineseparator);
      else 
      {
         if (!$t.tstringlist_fstrings)
            $t.tstringlist_fstrings = [];
         $t.tstringlist_fstrings.length = 1;
         $t.tstringlist_fstrings[0] = value;
      }
   }
   else 
   {
      if (!$t.tstringlist_fstrings)
         $t.tstringlist_fstrings = [];
      $t.tstringlist_fstrings.length = 0;
   }
   if ($t.tstringlist_fstrings)
   {
      $t.tstringlist_fcount = length($t.tstringlist_fstrings);
      if (($t.tstringlist_fcount > 0) && ($t.tstringlist_fstrings[$t.tstringlist_fcount - 1] == ""))
         $t.tstringlist_fcount--;
   }
   else 
      $t.tstringlist_fcount = 0;
   $t.dochanged();
};


function webcore_booltostr(value)
{
   var $r;
   if (value)
      $r = "True";
   else 
      $r = "False";
   return $r;
};

function webcore_strtobool(value)
{
   var $r;
   if (sametext(value, "True"))
      $r = true;
   else 
      $r = false;
   return $r;
};


// WebCtrls Unit Interface Declarations

var webctrls_taleftjustify = 0, webctrls_tacenter = 1, webctrls_tarightjustify = 2, webctrls_crauto = 0, webctrls_crcrosshair = 1, webctrls_crdefault = 2, webctrls_crhelp = 3, webctrls_crmove = 4, webctrls_crpointer = 5, webctrls_crprogress = 6, webctrls_crsizenesw = 7, webctrls_crsizens = 8, webctrls_crsizenwse = 9, webctrls_crsizewe = 10, webctrls_crtext = 11, webctrls_crwait = 12, webctrls_fdnormal = 0, webctrls_fdunderline = 1, webctrls_fsnormal = 0, webctrls_fsitalic = 1, webctrls_fwnormal = 0, webctrls_fwbold = 1, webctrls_clivory = 15794175, webctrls_clwhite = 16777215, webctrls_clgray = 8421504, webctrls_clblack = 0, webctrls_clformbackground = 15987699, webctrls_cldesktopbackground = 12434877, webctrls_ssnone = 0, webctrls_sshorizontal = 1, webctrls_ssvertical = 2, webctrls_ssboth = 3, webctrls_mbok = 1, webctrls_mbcancel = 2, webctrls_mbabort = 3, webctrls_mbretry = 4, webctrls_mbignore = 5, webctrls_mbyes = 6, webctrls_mbno = 7, webctrls_mball = 8, webctrls_mbnotoall = 8, webctrls_mbyestoall = 9, webctrls_mbclose = 10, webctrls_mrnone = 0, webctrls_mrok = 1, webctrls_mrcancel = 2, webctrls_mrabort = 3, webctrls_mrretry = 4, webctrls_mrignore = 5, webctrls_mryes = 6, webctrls_mrno = 7, webctrls_mrall = 8, webctrls_mrnotoall = 9, webctrls_mryestoall = 10, webctrls_mrclose = 11, webctrls_vk_back = 8, webctrls_vk_tab = 9, webctrls_vk_return = 13, webctrls_vk_escape = 27, webctrls_vk_space = 32, webctrls_vk_prior = 33, webctrls_vk_next = 34, webctrls_vk_end = 35, webctrls_vk_home = 36, webctrls_vk_left = 37, webctrls_vk_up = 38, webctrls_vk_right = 39, webctrls_vk_down = 40, webctrls_vk_insert = 45, webctrls_vk_delete = 46, webctrls_ctnone = 0;

var webctrls_textmanager, webctrls_dragdropmanager, webctrls_columnsizingmanager;

// WebData Unit Interface Declarations

var webdata_dtunknown = 0, webdata_dtstring = 1, webdata_dtboolean = 2, webdata_dtinteger = 3, webdata_dtfloat = 4, webdata_dtdate = 5, webdata_dttime = 6, webdata_dtdatetime = 7, webdata_dtblob = 8, webdata_sdnone = 0, webdata_sdascending = 1, webdata_sddescending = 2, webdata_dsclosed = 0, webdata_dsbrowse = 1, webdata_dsinsert = 2, webdata_dsupdate = 3, webdata_dsfind = 4, webdata_dsloading = 5, webdata_cm_rowinserted = 50, webdata_cm_rowchanged = 51, webdata_cm_rowdeleted = 52, webdata_cm_rowschanged = 53, webdata_cm_layoutchanged = 54, webdata_cm_updaterow = 55, webdata_cm_updatestate = 56, webdata_cm_focuscontrol = 57, webdata_cm_disabledstatechanged = 58, webdata_cmp_less = -1, webdata_cmp_equal = 0, webdata_cmp_greater = 1;

// WebData Unit Implementation Declarations

// TDataColumn Class Declarations

function webdata_tdatacolumn()
{
   var $t = this;
   Object.call($t);
   $t.tdatacolumn_fdataset = null;
   $t.tdatacolumn_fposition = 0;
   $t.tdatacolumn_fname = "";
   $t.tdatacolumn_fdatatype = 0;
   $t.tdatacolumn_flength = -1;
   $t.tdatacolumn_fscale = -1;
   $t.tdatacolumn_fsortdirection = 0;
}

webdata_tdatacolumn.create = function(instance, dataset, columnpos)
{
   tobject.create(instance);
   instance.tdatacolumn_fdataset = dataset;
   instance.tdatacolumn_fposition = columnpos;
   instance.tdatacolumn_fname = dataset.tcomponent_fname + "_" + inttostr(instance.tdatacolumn_fposition);
   return instance;
};

webdata_tdatacolumn.prototype = $i(tobject);
webdata_tdatacolumn.$p = webdata_tdatacolumn.prototype;
webdata_tdatacolumn.$p.constructor = webdata_tdatacolumn;

webdata_tdatacolumn.$p.tdatacolumn_setname = function(value)
{
   var $t = this;
   if (value != $t.tdatacolumn_fname)
   {
      if (value == "")
         throw new Error("Column names cannot be blank");
      $t.tdatacolumn_fname = value;
   }
};

webdata_tdatacolumn.$p.tdatacolumn_setdatatype = function(value)
{
   var $t = this;
   if (value != $t.tdatacolumn_fdatatype)
   {
      $t.tdatacolumn_fdatatype = value;
      switch ($t.tdatacolumn_fdatatype)
      {
         case webdata_dtstring:
         {
            if ($t.tdatacolumn_fscale > -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dtblob:
         {
            if ($t.tdatacolumn_fscale > -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
         case webdata_dtfloat:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            break;
         }
         case webdata_dtunknown:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dtboolean:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dtinteger:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dtdate:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dttime:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
case webdata_dtdatetime:
         {
            if ($t.tdatacolumn_flength != -1)
               $t.tdatacolumn_flength = -1;
            if ($t.tdatacolumn_fscale != -1)
               $t.tdatacolumn_fscale = -1;
            break;
         }
      };
   }
};

webdata_tdatacolumn.$p.tdatacolumn_setlength = function(value)
{
   var $t = this, tempresult;
   if (value != $t.tdatacolumn_flength)
   {
      tempresult = true;
      switch ($t.tdatacolumn_fdatatype)
      {
         case webdata_dtstring:
         {
            if (value < -1)
               tempresult = false;
            break;
         }
case webdata_dtblob:
         {
            if (value < -1)
               tempresult = false;
            break;
         }
         default:
         {
            if (value != -1)
               tempresult = false;
            break;
         }
      };
      if (!tempresult)
         throw new Error("Invalid column length " + inttostr(value));
      $t.tdatacolumn_flength = value;
   }
};

webdata_tdatacolumn.$p.tdatacolumn_setscale = function(value)
{
   var $t = this, tempresult;
   if (value != $t.tdatacolumn_flength)
   {
      tempresult = true;
      switch ($t.tdatacolumn_fdatatype)
      {
         case webdata_dtfloat:
         {
            if (value < 0)
               tempresult = false;
            break;
         }
         default:
         {
            if (value != -1)
               tempresult = false;
            break;
         }
      };
      if (!tempresult)
         throw new Error("Invalid column scale " + inttostr(value));
      $t.tdatacolumn_fscale = value;
   }
};

webdata_tdatacolumn.$p.tdatacolumn_setsortdirection = function(value)
{
   var $t = this;
   if (value != $t.tdatacolumn_fsortdirection)
   {
      $t.tdatacolumn_fsortdirection = value;
      $t.tdatacolumn_fdataset.updatesort($t);
   }
};

webdata_tdatacolumn.$p.tdatacolumn_getasstring = function()
{
   var $t = this, $r;
   $r = $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).getasstring();
   return $r;
};

webdata_tdatacolumn.$p.tdatacolumn_setasstring = function(value)
{
   var $t = this;
   $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).setasstring(value);
};

webdata_tdatacolumn.$p.tdatacolumn_getasboolean = function()
{
   var $t = this, $r;
   $r = $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).getasboolean();
   return $r;
};

webdata_tdatacolumn.$p.tdatacolumn_setasboolean = function(value)
{
   var $t = this;
   $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).setasboolean(value);
};

webdata_tdatacolumn.$p.tdatacolumn_getasinteger = function()
{
   var $t = this, $r;
   $r = $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).getasinteger();
   return $r;
};

webdata_tdatacolumn.$p.tdatacolumn_setasinteger = function(value)
{
   var $t = this;
   $t.tdatacolumn_fdataset.tdataset_getactiverow().tdatarow_getvalue($t.tdatacolumn_fposition).setasinteger(value);
};

// TDataValue Class Declarations

function webdata_tdatavalue()
{
   var $t = this;
   Object.call($t);
   $t.tdatavalue_frow = null;
   $t.tdatavalue_fcolumn = null;
   $t.tdatavalue_fnull = true;
   $t.tdatavalue_fmodified = false;
}

webdata_tdatavalue.create = function(instance, row, column)
{
   tobject.create(instance);
   instance.tdatavalue_frow = row;
   instance.tdatavalue_fcolumn = column;
   return instance;
};

webdata_tdatavalue.prototype = $i(tobject);
webdata_tdatavalue.$p = webdata_tdatavalue.prototype;
webdata_tdatavalue.$p.constructor = webdata_tdatavalue;

webdata_tdatavalue.$p.tdatavalue_notifychange = function()
{
   var $t = this;
   $t.tdatavalue_fcolumn.tdatacolumn_fdataset.notify(webdata_cm_rowchanged, $t.tdatavalue_fcolumn);
};

webdata_tdatavalue.$p.setmodified = function()
{
   var $t = this;
   $t.tdatavalue_fmodified = true;
   $t.tdatavalue_frow.setmodified();
};

webdata_tdatavalue.$p.setvalue = function()
{
   var $t = this;
   $t.tdatavalue_fnull = false;
   $t.setmodified();
   $t.tdatavalue_notifychange();
};

webdata_tdatavalue.$p.clearvalue = function()
{
};

webdata_tdatavalue.$p.getasstring = function()
{
};

webdata_tdatavalue.$p.setasstring = function(value)
{
};

webdata_tdatavalue.$p.getasinteger = function()
{
};

webdata_tdatavalue.$p.setasinteger = function(value)
{
};

webdata_tdatavalue.$p.getasboolean = function()
{
};

webdata_tdatavalue.$p.setasboolean = function(value)
{
};

webdata_tdatavalue.$p.getasfloat = function()
{
};

webdata_tdatavalue.$p.setasfloat = function(value)
{
};

webdata_tdatavalue.$p.getasdatetime = function()
{
};

webdata_tdatavalue.$p.setasdatetime = function(value)
{
};

webdata_tdatavalue.$p.clear = function()
{
   var $t = this;
   if (!$t.tdatavalue_fnull)
   {
      $t.tdatavalue_fnull = true;
      $t.clearvalue();
      $t.setmodified();
      $t.tdatavalue_notifychange();
   }
};

webdata_tdatavalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   if ($t.tdatavalue_fnull && (!value.tdatavalue_fnull))
      $r = webdata_cmp_less;
   else if ((!$t.tdatavalue_fnull) && value.tdatavalue_fnull)
      $r = webdata_cmp_greater;
   else 
      $r = webdata_cmp_equal;
   return $r;
};

// TStringValue Class Declarations

function webdata_tstringvalue()
{
   var $t = this;
   webdata_tdatavalue.call($t);
   $t.tstringvalue_fvalue = "";
}

webdata_tstringvalue.prototype = $i(webdata_tdatavalue);
webdata_tstringvalue.$p = webdata_tstringvalue.prototype;
webdata_tstringvalue.$p.constructor = webdata_tstringvalue;

webdata_tstringvalue.$p.clearvalue = function()
{
   var $t = this;
   $t.tstringvalue_fvalue = "";
   webdata_tdatavalue.$p.clearvalue.call($t);
};

webdata_tstringvalue.$p.getasstring = function()
{
   var $t = this, $r;
   if ($t.tdatavalue_fnull)
      $r = "";
   else 
      $r = $t.tstringvalue_fvalue;
   return $r;
};

webdata_tstringvalue.$p.setasstring = function(value)
{
   var $t = this;
   $t.tstringvalue_fvalue = value;
   $t.setvalue();
};

webdata_tstringvalue.$p.getasboolean = function()
{
   var $t = this, $r;
   $r = webcore_strtobool($t.tstringvalue_fvalue);
   return $r;
};

webdata_tstringvalue.$p.setasboolean = function(value)
{
   var $t = this;
   $t.tstringvalue_fvalue = webcore_booltostr(value);
   $t.setvalue();
};

webdata_tstringvalue.$p.getasinteger = function()
{
   var $t = this, $r;
   $r = strtoint($t.tstringvalue_fvalue);
   return $r;
};

webdata_tstringvalue.$p.setasinteger = function(value)
{
   var $t = this;
   $t.tstringvalue_fvalue = inttostr(value);
   $t.setvalue();
};

webdata_tstringvalue.$p.getasfloat = function()
{
   var $t = this, $r;
   $r = strtofloat($t.tstringvalue_fvalue);
   return $r;
};

webdata_tstringvalue.$p.setasfloat = function(value)
{
   var $t = this;
   if ($t.tdatavalue_fcolumn.tdatacolumn_fscale != -1)
      $t.tstringvalue_fvalue = floattostr(value, $t.tdatavalue_fcolumn.tdatacolumn_fscale);
   else 
      $t.tstringvalue_fvalue = floattostr(value);
   $t.setvalue();
};

webdata_tstringvalue.$p.getasdatetime = function()
{
   var $t = this, $r;
   $r = strtodatetime($t.tstringvalue_fvalue);
   return $r;
};

webdata_tstringvalue.$p.setasdatetime = function(value)
{
   var $t = this;
   $t.tstringvalue_fvalue = datetimetostr(value);
   $t.setvalue();
};

webdata_tstringvalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   $r = webdata_tdatavalue.$p.compare.call($t, value, caseinsensitive);
   if ($r == webdata_cmp_equal)
   {
      if (caseinsensitive)
         $r = comparetext($t.tstringvalue_fvalue, value.getasstring());
      else 
         $r = comparestr($t.tstringvalue_fvalue, value.getasstring());
   }
   return $r;
};

// TBooleanValue Class Declarations

function webdata_tbooleanvalue()
{
   var $t = this;
   webdata_tdatavalue.call($t);
   $t.tbooleanvalue_fvalue = false;
}

webdata_tbooleanvalue.prototype = $i(webdata_tdatavalue);
webdata_tbooleanvalue.$p = webdata_tbooleanvalue.prototype;
webdata_tbooleanvalue.$p.constructor = webdata_tbooleanvalue;

webdata_tbooleanvalue.$p.clearvalue = function()
{
   var $t = this;
   $t.tbooleanvalue_fvalue = false;
   webdata_tdatavalue.$p.clearvalue.call($t);
};

webdata_tbooleanvalue.$p.getasstring = function()
{
   var $t = this, $r;
   if ($t.tdatavalue_fnull)
      $r = "";
   else 
      $r = webcore_booltostr($t.tbooleanvalue_fvalue);
   return $r;
};

webdata_tbooleanvalue.$p.setasstring = function(value)
{
   var $t = this;
   if (value == "")
      $t.clear();
   else 
   {
      $t.tbooleanvalue_fvalue = webcore_strtobool(value);
      $t.setvalue();
   }
};

webdata_tbooleanvalue.$p.getasboolean = function()
{
   var $t = this, $r;
   $r = $t.tbooleanvalue_fvalue;
   return $r;
};

webdata_tbooleanvalue.$p.setasboolean = function(value)
{
   var $t = this;
   $t.tbooleanvalue_fvalue = value;
   $t.setvalue();
};

webdata_tbooleanvalue.$p.getasinteger = function()
{
   var $t = this, $r;
   if ($t.tbooleanvalue_fvalue)
      $r = 1;
   else 
      $r = 0;
   return $r;
};

webdata_tbooleanvalue.$p.setasinteger = function(value)
{
   var $t = this;
   if (value > 0)
      $t.tbooleanvalue_fvalue = true;
   else 
      $t.tbooleanvalue_fvalue = false;
   $t.setvalue();
};

webdata_tbooleanvalue.$p.getasfloat = function()
{
   var $t = this, $r;
   if ($t.tbooleanvalue_fvalue)
      $r = 1;
   else 
      $r = 0;
   return $r;
};

webdata_tbooleanvalue.$p.setasfloat = function(value)
{
   var $t = this;
   if (value > 0)
      $t.tbooleanvalue_fvalue = true;
   else 
      $t.tbooleanvalue_fvalue = false;
   $t.setvalue();
};

webdata_tbooleanvalue.$p.getasdatetime = function()
{
   var $t = this, $r;
   $r = 0;
   throw new Error("Error converting Boolean value to Date/Time value");
   return $r;
};

webdata_tbooleanvalue.$p.setasdatetime = function(value)
{
   var $t = this;
   throw new Error("Error converting Date/Time value to Boolean value");
};

webdata_tbooleanvalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   $r = webdata_tdatavalue.$p.compare.call($t, value, caseinsensitive);
   if ($r == webdata_cmp_equal)
   {
      if ((!$t.tbooleanvalue_fvalue) && value.getasboolean())
         $r = webdata_cmp_less;
      else if ($t.tbooleanvalue_fvalue && (!value.getasboolean()))
         $r = webdata_cmp_greater;
   }
   return $r;
};

// TIntegerValue Class Declarations

function webdata_tintegervalue()
{
   var $t = this;
   webdata_tdatavalue.call($t);
   $t.tintegervalue_fvalue = 0;
}

webdata_tintegervalue.prototype = $i(webdata_tdatavalue);
webdata_tintegervalue.$p = webdata_tintegervalue.prototype;
webdata_tintegervalue.$p.constructor = webdata_tintegervalue;

webdata_tintegervalue.$p.clearvalue = function()
{
   var $t = this;
   $t.tintegervalue_fvalue = 0;
   webdata_tdatavalue.$p.clearvalue.call($t);
};

webdata_tintegervalue.$p.getasstring = function()
{
   var $t = this, $r;
   if ($t.tdatavalue_fnull)
      $r = "";
   else 
      $r = inttostr($t.tintegervalue_fvalue);
   return $r;
};

webdata_tintegervalue.$p.setasstring = function(value)
{
   var $t = this;
   if (value == "")
      $t.clear();
   else 
   {
      $t.tintegervalue_fvalue = strtoint(value);
      $t.setvalue();
   }
};

webdata_tintegervalue.$p.getasboolean = function()
{
   var $t = this, $r;
   if ($t.tintegervalue_fvalue > 0)
      $r = true;
   else 
      $r = false;
   return $r;
};

webdata_tintegervalue.$p.setasboolean = function(value)
{
   var $t = this;
   if (value)
      $t.tintegervalue_fvalue = 1;
   else 
      $t.tintegervalue_fvalue = 0;
   $t.setvalue();
};

webdata_tintegervalue.$p.getasinteger = function()
{
   var $t = this, $r;
   $r = $t.tintegervalue_fvalue;
   return $r;
};

webdata_tintegervalue.$p.setasinteger = function(value)
{
   var $t = this;
   $t.tintegervalue_fvalue = value;
   $t.setvalue();
};

webdata_tintegervalue.$p.getasfloat = function()
{
   var $t = this, $r;
   $r = $t.tintegervalue_fvalue;
   return $r;
};

webdata_tintegervalue.$p.setasfloat = function(value)
{
   var $t = this;
   $t.tintegervalue_fvalue = floor(value);
   $t.setvalue();
};

webdata_tintegervalue.$p.getasdatetime = function()
{
   var $t = this, $r;
   $r = $t.tintegervalue_fvalue;
   return $r;
};

webdata_tintegervalue.$p.setasdatetime = function(value)
{
   var $t = this;
   $t.tintegervalue_fvalue = value;
   $t.setvalue();
};

webdata_tintegervalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   $r = webdata_tdatavalue.$p.compare.call($t, value, caseinsensitive);
   if ($r == webdata_cmp_equal)
   {
      if ($t.tintegervalue_fvalue < value.getasinteger())
         $r = webdata_cmp_less;
      else if ($t.tintegervalue_fvalue > value.getasinteger())
         $r = webdata_cmp_greater;
   }
   return $r;
};

// TDateTimeValue Class Declarations

function webdata_tdatetimevalue()
{
   var $t = this;
   webdata_tdatavalue.call($t);
   $t.tdatetimevalue_fvalue = 0;
}

webdata_tdatetimevalue.prototype = $i(webdata_tdatavalue);
webdata_tdatetimevalue.$p = webdata_tdatetimevalue.prototype;
webdata_tdatetimevalue.$p.constructor = webdata_tdatetimevalue;

webdata_tdatetimevalue.$p.clearvalue = function()
{
   var $t = this;
   $t.tdatetimevalue_fvalue = 0;
   webdata_tdatavalue.$p.clearvalue.call($t);
};

webdata_tdatetimevalue.$p.getasstring = function()
{
   var $t = this, $r;
   if ($t.tdatavalue_fnull)
      $r = "";
   else 
      $r = datetimetostr($t.tdatetimevalue_fvalue);
   return $r;
};

webdata_tdatetimevalue.$p.setasstring = function(value)
{
   var $t = this;
   if (value == "")
      $t.clear();
   else 
   {
      $t.tdatetimevalue_fvalue = strtodatetime(value);
      $t.setvalue();
   }
};

webdata_tdatetimevalue.$p.getasboolean = function()
{
   var $t = this, $r;
   $r = false;
   throw new Error("Error converting Date/Time value to Boolean value");
   return $r;
};

webdata_tdatetimevalue.$p.setasboolean = function(value)
{
   var $t = this;
   throw new Error("Error converting Boolean value to Date/Time value");
};

webdata_tdatetimevalue.$p.getasinteger = function()
{
   var $t = this, $r;
   $r = $t.tdatetimevalue_fvalue;
   return $r;
};

webdata_tdatetimevalue.$p.setasinteger = function(value)
{
   var $t = this;
   $t.tdatetimevalue_fvalue = value;
   $t.setvalue();
};

webdata_tdatetimevalue.$p.getasfloat = function()
{
   var $t = this, $r;
   $r = 0;
   throw new Error("Error converting Date/Time value to Float value");
   return $r;
};

webdata_tdatetimevalue.$p.setasfloat = function(value)
{
   var $t = this;
   throw new Error("Error converting Float value to Date/Time value");
};

webdata_tdatetimevalue.$p.getasdatetime = function()
{
   var $t = this, $r;
   $r = $t.tdatetimevalue_fvalue;
   return $r;
};

webdata_tdatetimevalue.$p.setasdatetime = function(value)
{
   var $t = this;
   $t.tdatetimevalue_fvalue = value;
   $t.setvalue();
};

webdata_tdatetimevalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   $r = webdata_tdatavalue.$p.compare.call($t, value, caseinsensitive);
   if ($r == webdata_cmp_equal)
   {
      if ($t.tdatetimevalue_fvalue < value.getasdatetime())
         $r = webdata_cmp_less;
      else if ($t.tdatetimevalue_fvalue > value.getasdatetime())
         $r = webdata_cmp_greater;
   }
   return $r;
};

// TFloatValue Class Declarations

function webdata_tfloatvalue()
{
   var $t = this;
   webdata_tdatavalue.call($t);
   $t.tfloatvalue_fvalue = 0;
}

webdata_tfloatvalue.prototype = $i(webdata_tdatavalue);
webdata_tfloatvalue.$p = webdata_tfloatvalue.prototype;
webdata_tfloatvalue.$p.constructor = webdata_tfloatvalue;

webdata_tfloatvalue.$p.clearvalue = function()
{
   var $t = this;
   $t.tfloatvalue_fvalue = 0;
   webdata_tdatavalue.$p.clearvalue.call($t);
};

webdata_tfloatvalue.$p.getasstring = function()
{
   var $t = this, $r;
   if ($t.tdatavalue_fnull)
      $r = "";
   else 
      $r = floattostr($t.tfloatvalue_fvalue);
   return $r;
};

webdata_tfloatvalue.$p.setasstring = function(value)
{
   var $t = this;
   if (value == "")
      $t.clear();
   else 
   {
      $t.tfloatvalue_fvalue = strtofloat(value);
      $t.setvalue();
   }
};

webdata_tfloatvalue.$p.getasboolean = function()
{
   var $t = this, $r;
   if ($t.tfloatvalue_fvalue > 0)
      $r = true;
   else 
      $r = false;
   return $r;
};

webdata_tfloatvalue.$p.setasboolean = function(value)
{
   var $t = this;
   if (value)
      $t.tfloatvalue_fvalue = 1;
   else 
      $t.tfloatvalue_fvalue = 0;
   $t.setvalue();
};

webdata_tfloatvalue.$p.getasinteger = function()
{
   var $t = this, $r;
   $r = floor($t.tfloatvalue_fvalue);
   return $r;
};

webdata_tfloatvalue.$p.setasinteger = function(value)
{
   var $t = this;
   $t.tfloatvalue_fvalue = value;
   $t.setvalue();
};

webdata_tfloatvalue.$p.getasfloat = function()
{
   var $t = this, $r;
   $r = $t.tfloatvalue_fvalue;
   return $r;
};

webdata_tfloatvalue.$p.setasfloat = function(value)
{
   var $t = this;
   $t.tfloatvalue_fvalue = value;
   $t.setvalue();
};

webdata_tfloatvalue.$p.getasdatetime = function()
{
   var $t = this, $r;
   $r = 0;
   throw new Error("Error converting Float value to Date/Time value");
   return $r;
};

webdata_tfloatvalue.$p.setasdatetime = function(value)
{
   var $t = this;
   throw new Error("Error converting Float value to Boolean value");
};

webdata_tfloatvalue.$p.compare = function(value, caseinsensitive)
{
   var $t = this, $r;
   if (caseinsensitive == null)
      caseinsensitive = false;
   $r = webdata_tdatavalue.$p.compare.call($t, value, caseinsensitive);
   if ($r == webdata_cmp_equal)
   {
      if ($t.tfloatvalue_fvalue < value.getasfloat())
         $r = webdata_cmp_less;
      else if ($t.tfloatvalue_fvalue > value.getasfloat())
         $r = webdata_cmp_greater;
   }
   return $r;
};

// TImageValue Class Declarations

function webdata_timagevalue()
{
   var $t = this;
   webdata_tstringvalue.call($t);
}

webdata_timagevalue.prototype = $i(webdata_tstringvalue);
webdata_timagevalue.$p = webdata_timagevalue.prototype;
webdata_timagevalue.$p.constructor = webdata_timagevalue;

// TDataRow Class Declarations

function webdata_tdatarow()
{
   var $t = this;
   Object.call($t);
   $t.tdatarow_fdataset = null;
   $t.tdatarow_fmodified = false;
   $t.tdatarow_fid = 0;
   $t.tdatarow_fvalues = null;
}

webdata_tdatarow.create = function(instance, dataset, rowid)
{
   tobject.create(instance);
   instance.tdatarow_fdataset = dataset;
   instance.tdatarow_fid = rowid;
   instance.tdatarow_fvalues = webcore_tobjectlist.create(new webcore_tobjectlist());
   instance.tdatarow_setvaluecount(instance.tdatarow_fdataset.tdataset_getcolumncount());
   return instance;
};

webdata_tdatarow.prototype = $i(tobject);
webdata_tdatarow.$p = webdata_tdatarow.prototype;
webdata_tdatarow.$p.constructor = webdata_tdatarow;

webdata_tdatarow.$p.tdatarow_setvaluecount = function(value)
{
   var $t = this, tempcount, i;
   tempcount = $t.tdatarow_fvalues.tobjectlist_fcount;
   $t.tdatarow_fvalues.setcount(value);
   if ($t.tdatarow_fvalues.tobjectlist_fcount > tempcount)
   {
      for (i = tempcount ; i <= value - 1 ; i++)
         $t.tdatarow_fvalues.setobject(i, $t.tdatarow_createvalue(i));
   }
};

webdata_tdatarow.$p.tdatarow_createvalue = function(i)
{
   var $t = this, $r;
   switch ($t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i).tdatacolumn_fdatatype)
   {
      case webdata_dtstring:
      {
         $r = webdata_tdatavalue.create(new webdata_tstringvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtboolean:
      {
         $r = webdata_tdatavalue.create(new webdata_tbooleanvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtinteger:
      {
         $r = webdata_tdatavalue.create(new webdata_tintegervalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtfloat:
      {
         $r = webdata_tdatavalue.create(new webdata_tfloatvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtdate:
      {
         $r = webdata_tdatavalue.create(new webdata_tstringvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dttime:
      {
         $r = webdata_tdatavalue.create(new webdata_tstringvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtdatetime:
      {
         $r = webdata_tdatavalue.create(new webdata_tstringvalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      case webdata_dtblob:
      {
         $r = webdata_tdatavalue.create(new webdata_timagevalue(), $t, $t.tdatarow_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn(i));
         break;
      }
      default:
      {
         $r = null;
         break;
      }
   };
   return $r;
};

webdata_tdatarow.$p.tdatarow_getvalue = function(index)
{
   var $t = this, $r;
   $r = $t.tdatarow_fvalues.getobject(index);
   return $r;
};

webdata_tdatarow.$p.setmodified = function()
{
   var $t = this;
   $t.tdatarow_fmodified = true;
};

webdata_tdatarow.$p.destroy = function()
{
   var $t = this;
   $t.tdatarow_fvalues = tobject.free($t.tdatarow_fvalues);
   tobject.$p.destroy.call($t);
};

// TDataSetOperation Class Declarations

function webdata_tdatasetoperation()
{
   var $t = this;
   Object.call($t);
   $t.tdatasetoperation_foperationtype = 0;
}

webdata_tdatasetoperation.create = function(instance, value)
{
   tobject.create(instance);
   instance.tdatasetoperation_foperationtype = value;
   return instance;
};

webdata_tdatasetoperation.prototype = $i(tobject);
webdata_tdatasetoperation.$p = webdata_tdatasetoperation.prototype;
webdata_tdatasetoperation.$p.constructor = webdata_tdatasetoperation;

webdata_tdatasetoperation.$p.destroy = function()
{
   var $t = this;
   tobject.$p.destroy.call($t);
};

// TDataColumns Class Declarations

function webdata_tdatacolumns()
{
   var $t = this;
   Object.call($t);
   $t.tdatacolumns_fdataset = null;
   $t.tdatacolumns_flist = null;
}

webdata_tdatacolumns.create = function(instance, dataset)
{
   tobject.create(instance);
   instance.tdatacolumns_fdataset = dataset;
   instance.tdatacolumns_flist = webcore_tobjectlist.create(new webcore_tobjectlist());
   return instance;
};

webdata_tdatacolumns.prototype = $i(tobject);
webdata_tdatacolumns.$p = webdata_tdatacolumns.prototype;
webdata_tdatacolumns.$p.constructor = webdata_tdatacolumns;

webdata_tdatacolumns.$p.tdatacolumns_getcount = function()
{
   var $t = this, $r;
   $r = $t.tdatacolumns_flist.tobjectlist_fcount;
   return $r;
};

webdata_tdatacolumns.$p.tdatacolumns_getcolumn = function(index)
{
   var $t = this, $r;
   if ((index >= 0) && (index < $t.tdatacolumns_flist.tobjectlist_fcount))
      $r = $t.tdatacolumns_flist.getobject(index);
   else 
      throw new Error("Column index " + inttostr(index) + " out of bounds");
   return $r;
};

webdata_tdatacolumns.$p.tdatacolumns_getcolumn1 = function(name)
{
   var $t = this, $r, i;
   $r = null;
   for (i = 0 ; i <= $t.tdatacolumns_flist.tobjectlist_fcount - 1 ; i++)
   {
      if (sametext($t.tdatacolumns_flist.getobject(i).tdatacolumn_fname, name))
      {
         $r = $t.tdatacolumns_flist.getobject(i);
         break;
      }
   }
   return $r;
};

webdata_tdatacolumns.$p.destroy = function()
{
   var $t = this;
   $t.tdatacolumns_flist = tobject.free($t.tdatacolumns_flist);
   tobject.$p.destroy.call($t);
};

// TDataSet Class Declarations

function webdata_tdataset()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.tdataset_fparser = null;
   $t.tdataset_fcolumns = null;
   $t.tdataset_frows = null;
   $t.tdataset_flastrowid = 0;
   $t.tdataset_frow = null;
   $t.tdataset_frowno = 0;
   $t.tdataset_freadonly = false;
   $t.tdataset_fstate = 0;
   $t.tdataset_fdisablecount = 0;
   $t.tdataset_fbof = true;
   $t.tdataset_feof = true;
   $t.tdataset_fsortcolumns = null;
   $t.tdataset_fsortcaseinsensitive = false;
   $t.tdataset_fbeforeclose = null;
   $t.tdataset_fafterclose = null;
   $t.tdataset_fbeforescroll = null;
   $t.tdataset_fafterscroll = null;
   $t.tdataset_fbeforeinsert = null;
   $t.tdataset_fafterinsert = null;
   $t.tdataset_fbeforeupdate = null;
   $t.tdataset_fafterupdate = null;
   $t.tdataset_fbeforecancel = null;
   $t.tdataset_faftercancel = null;
   $t.tdataset_fbeforedelete = null;
   $t.tdataset_fafterdelete = null;
}

webdata_tdataset.create = function(instance, aowner)
{
   webcore_tcomponent.create(instance, aowner);
   instance.tdataset_fparser = tobject.create(new webcore_tparser());
   instance.tdataset_fcolumns = webdata_tdatacolumns.create(new webdata_tdatacolumns(), instance);
   instance.tdataset_fsortcolumns = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
   instance.tdataset_frows = webcore_tobjectlist.create(new webcore_tobjectlist());
   return instance;
};

webdata_tdataset.prototype = $i(webcore_tcomponent);
webdata_tdataset.$p = webdata_tdataset.prototype;
webdata_tdataset.$p.constructor = webdata_tdataset;

webdata_tdataset.$p.tdataset_getrowid = function()
{
   var $t = this, $r;
   $r = $t.tdataset_getactiverow().tdatarow_fid;
   return $r;
};

webdata_tdataset.$p.tdataset_setrowid = function(value)
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforescroll())
      {
         $t.checkbrowsemode();
         $t.gotorowid(value);
         $t.notify(webdata_cm_rowchanged);
         $t.doafterscroll();
      }
   }
};

webdata_tdataset.$p.tdataset_setrowno = function(value)
{
   var $t = this;
   if (value != $t.tdataset_frowno)
      $t.moveto(value);
};

webdata_tdataset.$p.tdataset_setstate = function(value)
{
   var $t = this;
   if (value != $t.tdataset_fstate)
   {
      $t.tdataset_fstate = value;
      $t.notify(webdata_cm_updatestate);
   }
};

webdata_tdataset.$p.tdataset_getactiverow = function()
{
   var $t = this, $r;
   if (($t.tdataset_frows.tobjectlist_fcount == 0) || ($t.tdataset_fstate == webdata_dsfind))
   {
      if ($t.tdataset_frow == null)
         $t.tdataset_frow = webdata_tdatarow.create(new webdata_tdatarow(), $t, 0);
      $r = $t.tdataset_frow;
   }
   else 
      $r = $t.tdataset_frows.getobject($t.tdataset_frowno - 1);
   return $r;
};

webdata_tdataset.$p.tdataset_getcolumncount = function()
{
   var $t = this, $r;
   $r = $t.tdataset_fcolumns.tdatacolumns_getcount();
   return $r;
};

webdata_tdataset.$p.tdataset_getrowcount = function()
{
   var $t = this, $r;
   $r = $t.tdataset_frows.tobjectlist_fcount;
   return $r;
};

webdata_tdataset.$p.tdataset_getediting = function()
{
   var $t = this, $r;
   $r = (($t.tdataset_fstate != webdata_dsclosed) && ($t.tdataset_fstate != webdata_dsbrowse));
   return $r;
};

webdata_tdataset.$p.tdataset_createnewrow = function()
{
   var $t = this, $r;
   $t.tdataset_flastrowid++;
   $r = webdata_tdatarow.create(new webdata_tdatarow(), $t, $t.tdataset_flastrowid);
   return $r;
};

webdata_tdataset.$p.tdataset_rowschanged = function()
{
   var $t = this;
   $t.tdataset_fstate = webdata_dsloading;
   try
   {
      $t.notify(webdata_cm_rowschanged);
   }
   finally
   {
      $t.tdataset_fstate = webdata_dsbrowse;
   }
};

webdata_tdataset.$p.tdataset_internalclose = function()
{
   var $t = this;
   $t.tdataset_setstate(webdata_dsclosed);
   $t.tdataset_fsortcolumns.setcount(0);
   $t.tdataset_frows.setcount(0);
   $t.tdataset_frow = tobject.free($t.tdataset_frow);
   $t.tdataset_flastrowid = 0;
   $t.tdataset_frowno = 0;
   $t.tdataset_fbof = true;
   $t.tdataset_feof = true;
};

webdata_tdataset.$p.tdataset_sortcompare = function(l, r)
{
   var $t = this, $r, i, j;
   $r = webdata_cmp_equal;
   if ($t.tdataset_fsortcolumns.tobjectlist_fcount > 0)
   {
      for (i = 0 ; i <= $t.tdataset_fsortcolumns.tobjectlist_fcount - 1 ; i++)
      {
         j = $t.tdataset_fsortcolumns.getobject(i).tdatacolumn_fposition;
         with (l.tdatarow_getvalue(j))
         {
            if (tdatavalue_fcolumn.tdatacolumn_fsortdirection != webdata_sdnone)
            {
               $r = compare(r.tdatarow_getvalue(j), $t.tdataset_fsortcaseinsensitive);
               if ($r != webdata_cmp_equal)
               {
                  if (tdatavalue_fcolumn.tdatacolumn_fsortdirection == webdata_sddescending)
                  {
                     if ($r == webdata_cmp_less)
                        $r = webdata_cmp_greater;
                     else 
                        $r = webdata_cmp_less;
                  }
                  break;
               }
            }
         }
      }
   }
   else 
   {
      if (l.tdatarow_fid < r.tdatarow_fid)
         $r = webdata_cmp_less;
      else if (l.tdatarow_fid > r.tdatarow_fid)
         $r = webdata_cmp_greater;
   }
   return $r;
};

webdata_tdataset.$p.tdataset_sortrows = function(l, r)
{
   var $t = this, i, j, temprow;
   do
   {
      i = l;
      j = r;
      temprow = $t.tdataset_frows.getobject((l + r) >>> 1);
      do
      {
         while ($t.tdataset_sortcompare($t.tdataset_frows.getobject(i), temprow) == webdata_cmp_less)
            i++;
         while ($t.tdataset_sortcompare($t.tdataset_frows.getobject(j), temprow) == webdata_cmp_greater)
            j--;
         if (i <= j)
         {
            if (i != j)
               $t.tdataset_frows.exchange(i, j);
            i++;
            j--;
         }
      }
      while (!(i > j));
      if (l < j)
         $t.tdataset_sortrows(l, j);
      l = i;
   }
   while (!(i >= r));
};

webdata_tdataset.$p.tdataset_internalsort = function()
{
   var $t = this, temprowid;
   if ($t.tdataset_frows.tobjectlist_fcount > 1)
   {
      temprowid = $t.tdataset_getrowid();
      try
      {
         $t.tdataset_sortrows(0, $t.tdataset_frows.tobjectlist_fcount - 1);
      }
      finally
      {
         $t.gotorowid(temprowid);
      }
   }
};

webdata_tdataset.$p.dobeforeclose = function()
{
   var $t = this, $r;
   if ($t.tdataset_fbeforeclose)
      $r = $t.tdataset_fbeforeclose($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doafterclose = function()
{
   var $t = this;
   if ($t.tdataset_fafterclose)
      $t.tdataset_fafterclose($t);
};

webdata_tdataset.$p.dobeforescroll = function()
{
   var $t = this, $r;
   if (($t.tdataset_fstate != webdata_dsloading) && $t.tdataset_fbeforescroll)
      $r = $t.tdataset_fbeforescroll($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doafterscroll = function()
{
   var $t = this;
   if (($t.tdataset_fstate != webdata_dsloading) && $t.tdataset_fafterscroll)
      $t.tdataset_fafterscroll($t);
};

webdata_tdataset.$p.dobeforeinsert = function()
{
   var $t = this, $r;
   if ($t.tdataset_fbeforeinsert)
      $r = $t.tdataset_fbeforeinsert($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doafterinsert = function()
{
   var $t = this;
   if ($t.tdataset_fafterinsert)
      $t.tdataset_fafterinsert($t);
};

webdata_tdataset.$p.dobeforeupdate = function()
{
   var $t = this, $r;
   if ($t.tdataset_fbeforeupdate)
      $r = $t.tdataset_fbeforeupdate($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doafterupdate = function()
{
   var $t = this;
   if ($t.tdataset_fafterupdate)
      $t.tdataset_fafterupdate($t);
};

webdata_tdataset.$p.dobeforecancel = function()
{
   var $t = this, $r;
   if ($t.tdataset_fbeforecancel)
      $r = $t.tdataset_fbeforecancel($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doaftercancel = function()
{
   var $t = this;
   if ($t.tdataset_faftercancel)
      $t.tdataset_faftercancel($t);
};

webdata_tdataset.$p.dobeforedelete = function()
{
   var $t = this, $r;
   if ($t.tdataset_fbeforedelete)
      $r = $t.tdataset_fbeforedelete($t);
   else 
      $r = true;
   return $r;
};

webdata_tdataset.$p.doafterdelete = function()
{
   var $t = this;
   if ($t.tdataset_fafterdelete)
      $t.tdataset_fafterdelete($t);
};

webdata_tdataset.$p.notify = function(id, data)
{
   var $t = this;
   if (data == null)
      data = null;
   if (($t.tdataset_fdisablecount == 0) && (($t.tdataset_fstate != webdata_dsloading) || (id == webdata_cm_rowschanged)))
      webcore_tcomponent.$p.notify.call($t, id, data);
};

webdata_tdataset.$p.gotorowid = function(value)
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tdataset_frows.tobjectlist_fcount - 1 ; i++)
   {
      if ($t.tdataset_frows.getobject(i).tdatarow_fid == value)
      {
         $t.tdataset_frowno = (i + 1);
         break;
      }
   }
};

webdata_tdataset.$p.updatesort = function(column)
{
   var $t = this, i;
   i = $t.tdataset_fsortcolumns.indexof(column);
   if (column.tdatacolumn_fsortdirection == webdata_sdnone)
   {
      if (i != -1)
         $t.tdataset_fsortcolumns.remove(i);
   }
   else if (i == -1)
      $t.tdataset_fsortcolumns.add(column);
};

webdata_tdataset.$p.destroy = function()
{
   var $t = this;
   $t.close();
   $t.tdataset_frows = tobject.free($t.tdataset_frows);
   $t.tdataset_fsortcolumns = tobject.free($t.tdataset_fsortcolumns);
   $t.tdataset_fcolumns = tobject.free($t.tdataset_fcolumns);
   $t.tdataset_fparser = tobject.free($t.tdataset_fparser);
   webcore_tcomponent.$p.destroy.call($t);
};

webdata_tdataset.$p.checkbrowsemode = function()
{
   var $t = this;
   if (($t.tdataset_fstate == webdata_dsinsert) || ($t.tdataset_fstate == webdata_dsupdate) || ($t.tdataset_fstate == webdata_dsfind))
   {
      if ($t.tdataset_getactiverow().tdatarow_fmodified)
         $t.save();
      else 
         $t.cancel();
   }
};

webdata_tdataset.$p.close = function()
{
   var $t = this;
   if ($t.tdataset_fstate != webdata_dsclosed)
   {
      if ($t.dobeforeclose())
      {
         if ($t.tdataset_getediting())
            $t.cancel();
         try
         {
            $t.tdataset_internalclose();
         }
         finally
         {
            $t.doafterclose();
         }
      }
   }
};

webdata_tdataset.$p.first = function()
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforescroll())
      {
         $t.checkbrowsemode();
         $t.tdataset_frowno = 1;
         $t.tdataset_fbof = true;
         $t.tdataset_feof = false;
         $t.notify(webdata_cm_rowchanged);
         $t.doafterscroll();
      }
   }
};

webdata_tdataset.$p.next = function()
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforescroll())
      {
         $t.checkbrowsemode();
         $t.tdataset_frowno++;
         $t.tdataset_fbof = false;
         if ($t.tdataset_frowno <= $t.tdataset_frows.tobjectlist_fcount)
            $t.tdataset_feof = false;
         else 
         {
            $t.tdataset_frowno--;
            $t.tdataset_feof = true;
         }
         $t.notify(webdata_cm_rowchanged);
         $t.doafterscroll();
      }
   }
};

webdata_tdataset.$p.moveto = function(value)
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforescroll())
      {
         $t.checkbrowsemode();
         if (value >= $t.tdataset_frows.tobjectlist_fcount)
         {
            $t.tdataset_feof = true;
            $t.tdataset_fbof = false;
            $t.tdataset_frowno = $t.tdataset_frows.tobjectlist_fcount;
         }
         else if (value <= 0)
         {
            $t.tdataset_fbof = true;
            $t.tdataset_feof = false;
            $t.tdataset_frowno = 1;
         }
         else 
         {
            $t.tdataset_fbof = false;
            $t.tdataset_feof = false;
            $t.tdataset_frowno = value;
         }
         $t.notify(webdata_cm_rowchanged);
         $t.doafterscroll();
      }
   }
};

webdata_tdataset.$p.sort = function()
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforescroll())
      {
         $t.checkbrowsemode();
         $t.tdataset_internalsort();
         $t.tdataset_rowschanged();
         $t.doafterscroll();
      }
   }
};

webdata_tdataset.$p.insert = function()
{
   var $t = this;
   if ($t.dobeforeinsert())
   {
      $t.checkbrowsemode();
      $t.tdataset_setstate(webdata_dsinsert);
      $t.tdataset_frows.add($t.tdataset_createnewrow());
      $t.tdataset_frowno = $t.tdataset_frows.tobjectlist_fcount;
      $t.notify(webdata_cm_rowinserted);
      $t.doafterinsert();
   }
};

webdata_tdataset.$p.update = function()
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforeupdate())
      {
         $t.checkbrowsemode();
         $t.tdataset_setstate(webdata_dsupdate);
         $t.notify(webdata_cm_rowchanged);
         $t.doafterupdate();
      }
   }
   else 
      $t.insert();
};

webdata_tdataset.$p.save = function()
{
};

webdata_tdataset.$p.cancel = function()
{
   var $t = this;
   if (($t.tdataset_fstate == webdata_dsinsert) || ($t.tdataset_fstate == webdata_dsupdate) || ($t.tdataset_fstate == webdata_dsfind))
   {
      if ($t.dobeforecancel())
      {
         if ($t.tdataset_fstate == webdata_dsinsert)
         {
            $t.tdataset_frows.remove($t.tdataset_frows.tobjectlist_fcount - 1);
            $t.tdataset_flastrowid--;
            $t.tdataset_frowno = $t.tdataset_frows.tobjectlist_fcount;
         }
         $t.tdataset_setstate(webdata_dsbrowse);
         $t.notify(webdata_cm_rowchanged);
         $t.doaftercancel();
      }
   }
};

webdata_tdataset.$p.$delete = function()
{
   var $t = this;
   if ($t.tdataset_frows.tobjectlist_fcount > 0)
   {
      if ($t.dobeforedelete())
      {
         $t.checkbrowsemode();
         if ($t.tdataset_frows.tobjectlist_fcount > 0)
         {
            $t.notify(webdata_cm_rowdeleted);
            $t.tdataset_frows.remove($t.tdataset_frowno - 1);
            if ($t.tdataset_frowno > $t.tdataset_frows.tobjectlist_fcount)
               $t.tdataset_frowno = $t.tdataset_frows.tobjectlist_fcount;
         }
         $t.doafterdelete();
      }
   }
};


// WebHTTP Unit Interface Declarations

var webhttp_rsuninitialized = 0, webhttp_rsloaded = 4, webhttp_rmget = 0, webhttp_rmpost = 1, webhttp_rmhead = 2, webhttp_default_log_url = "http://localhost/log";

var webhttp_logqueue;

// WebHTTP Unit Implementation Declarations

// TServerRequest Class Declarations

function webhttp_tserverrequest()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.tserverrequest_frequestqueue = null;
   $t.tserverrequest_fhttprequest = null;
   $t.tserverrequest_fid = 0;
   $t.tserverrequest_fdata = null;
   $t.tserverrequest_fmethod = 0;
   $t.tserverrequest_furl = "";
   $t.tserverrequest_fparams = null;
   $t.tserverrequest_fusername = "";
   $t.tserverrequest_fpassword = "";
   $t.tserverrequest_frequestheaders = null;
   $t.tserverrequest_frequestcontent = null;
   $t.tserverrequest_fresponsecontent = null;
   $t.tserverrequest_fresponseheaders = null;
   $t.tserverrequest_fstatuscode = 0;
   $t.tserverrequest_fstatustext = "";
   $t.tserverrequest_foncomplete = null;
}

webhttp_tserverrequest.create = function(instance, aowner)
{
   webcore_tcomponent.create(instance, aowner);
   if (aowner instanceof webhttp_tserverrequestqueue)
      instance.tserverrequest_frequestqueue = aowner;
   instance.tserverrequest_fhttprequest = new XMLHttpRequest();
   instance.tserverrequest_fhttprequest.onreadystatechange = function() { instance.tserverrequest_readystatechangehandler.call(instance); };
   instance.tserverrequest_frequestheaders = webcore_tstrings.create(new webcore_tstringlist());
   instance.tserverrequest_frequestheaders.tstrings_fnamevalueseparator = ":";
   instance.tserverrequest_frequestcontent = webcore_tstrings.create(new webcore_tstringlist());
   instance.tserverrequest_fresponseheaders = webcore_tstrings.create(new webcore_tstringlist());
   instance.tserverrequest_fresponseheaders.tstrings_fnamevalueseparator = ":";
   instance.tserverrequest_fresponsecontent = webcore_tstrings.create(new webcore_tstringlist());
   instance.tserverrequest_fparams = webcore_tstrings.create(new webcore_tstringlist());
   return instance;
};

webhttp_tserverrequest.prototype = $i(webcore_tcomponent);
webhttp_tserverrequest.$p = webhttp_tserverrequest.prototype;
webhttp_tserverrequest.$p.constructor = webhttp_tserverrequest;

webhttp_tserverrequest.$p.tserverrequest_getmethodname = function()
{
   var $t = this, $r;
   switch ($t.tserverrequest_fmethod)
   {
      case webhttp_rmget:
      {
         $r = "GET";
         break;
      }
      case webhttp_rmpost:
      {
         $r = "POST";
         break;
      }
      case webhttp_rmhead:
      {
         $r = "HEAD";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

webhttp_tserverrequest.$p.tserverrequest_complete = function(keepexecuting)
{
   var $t = this;
   if (keepexecuting == null)
      keepexecuting = true;
   try
   {
      if (keepexecuting)
      {
         $t.tserverrequest_fresponseheaders.settext($t.tserverrequest_fhttprequest.getAllResponseHeaders());
         $t.tserverrequest_fresponsecontent.settext($t.tserverrequest_fhttprequest.responseText);
         $t.tserverrequest_fstatuscode = $t.tserverrequest_fhttprequest.status;
         $t.tserverrequest_fstatustext = $t.tserverrequest_fhttprequest.statusText;
         $t.docomplete();
      }
   }
   finally
   {
      if ($t.tserverrequest_frequestqueue)
         $t.tserverrequest_frequestqueue.completerequest($t, keepexecuting);
   }
};

webhttp_tserverrequest.$p.tserverrequest_readystatechangehandler = function()
{
   var $t = this;
   if ($t.tserverrequest_fhttprequest.readyState == webhttp_rsloaded)
      $t.tserverrequest_complete();
};

webhttp_tserverrequest.$p.initialize = function()
{
   var $t = this;
   $t.tserverrequest_fid = 0;
   $t.tserverrequest_fdata = null;
   $t.tserverrequest_fmethod = webhttp_rmget;
   $t.tserverrequest_furl = "";
   $t.tserverrequest_fparams.clear();
   $t.tserverrequest_fusername = "";
   $t.tserverrequest_fpassword = "";
   $t.tserverrequest_frequestheaders.clear();
   $t.tserverrequest_frequestcontent.clear();
   $t.tserverrequest_fresponseheaders.clear();
   $t.tserverrequest_fresponseheaders.clear();
   $t.tserverrequest_fresponsecontent.clear();
   $t.tserverrequest_fstatuscode = 0;
   $t.tserverrequest_fstatustext = "";
};

webhttp_tserverrequest.$p.docomplete = function()
{
   var $t = this;
   if ($t.tserverrequest_foncomplete)
      $t.tserverrequest_foncomplete($t);
};

webhttp_tserverrequest.$p.destroy = function()
{
   var $t = this;
   $t.tserverrequest_fparams = tobject.free($t.tserverrequest_fparams);
   $t.tserverrequest_frequestheaders = tobject.free($t.tserverrequest_frequestheaders);
   $t.tserverrequest_frequestcontent = tobject.free($t.tserverrequest_frequestcontent);
   $t.tserverrequest_fresponseheaders = tobject.free($t.tserverrequest_fresponseheaders);
   $t.tserverrequest_fresponsecontent = tobject.free($t.tserverrequest_fresponsecontent);
   $t.tserverrequest_fhttprequest = null;
   webcore_tcomponent.$p.destroy.call($t);
};

webhttp_tserverrequest.$p.execute = function()
{
   var $t = this, i, tempurl;
   try
   {
      tempurl = $t.tserverrequest_furl;
      if ($t.tserverrequest_fparams.getcount() > 0)
      {
         tempurl = tempurl + "?" + $t.tserverrequest_fparams.getstring(0);
         for (i = 1 ; i <= $t.tserverrequest_fparams.getcount() - 1 ; i++)
            tempurl = tempurl + "&" + $t.tserverrequest_fparams.getstring(i);
      }
      $t.tserverrequest_fhttprequest.open($t.tserverrequest_getmethodname(), encodeURI(tempurl), true, $t.tserverrequest_fusername, $t.tserverrequest_fpassword);
      for (i = 0 ; i <= $t.tserverrequest_frequestheaders.getcount() - 1 ; i++)
      {
         if ($t.tserverrequest_frequestheaders.tstrings_getname(i) != "")
            $t.tserverrequest_fhttprequest.setRequestHeader($t.tserverrequest_frequestheaders.tstrings_getname(i), $t.tserverrequest_frequestheaders.tstrings_getvaluefromindex(i));
      }
      $t.tserverrequest_fhttprequest.send($t.tserverrequest_frequestcontent.gettext());
   }
   catch($e)
   {
               throw new Error("Error executing request \"" + $t.tserverrequest_furl + "\" (" + $e.message + ")");
   }
};

webhttp_tserverrequest.$p.cancel = function(keepexecuting)
{
   var $t = this;
   if (keepexecuting == null)
      keepexecuting = true;
   if ($t.tserverrequest_fhttprequest.readyState > webhttp_rsuninitialized)
      $t.tserverrequest_fhttprequest.abort();
   $t.tserverrequest_complete(keepexecuting);
};

// TServerRequestQueue Class Declarations

function webhttp_tserverrequestqueue()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.tserverrequestqueue_favailablestack = null;
   $t.tserverrequestqueue_fpendingstack = null;
   $t.tserverrequestqueue_fexecuting = false;
   $t.tserverrequestqueue_frequest = null;
}

webhttp_tserverrequestqueue.create = function(instance, aowner)
{
   webcore_tcomponent.create(instance, aowner);
   instance.tserverrequestqueue_favailablestack = webcore_tobjectlist.create(new webcore_tobjectlist());
   instance.tserverrequestqueue_fpendingstack = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
   return instance;
};

webhttp_tserverrequestqueue.prototype = $i(webcore_tcomponent);
webhttp_tserverrequestqueue.$p = webhttp_tserverrequestqueue.prototype;
webhttp_tserverrequestqueue.$p.constructor = webhttp_tserverrequestqueue;

webhttp_tserverrequestqueue.$p.executerequests = function()
{
   var $t = this;
   if (!$t.tserverrequestqueue_fexecuting)
   {
      $t.tserverrequestqueue_fexecuting = true;
      $t.tserverrequestqueue_frequest = $t.tserverrequestqueue_fpendingstack.dequeue();
      if ($t.tserverrequestqueue_frequest)
         $t.tserverrequestqueue_frequest.execute();
      else 
         $t.tserverrequestqueue_fexecuting = false;
   }
};

webhttp_tserverrequestqueue.$p.completerequest = function(value, keepexecuting)
{
   var $t = this;
   if (keepexecuting == null)
      keepexecuting = true;
   if (value)
      $t.tserverrequestqueue_favailablestack.push(value);
   $t.tserverrequestqueue_fexecuting = false;
   $t.tserverrequestqueue_frequest = null;
   if (keepexecuting)
      $t.executerequests();
};

webhttp_tserverrequestqueue.$p.destroy = function()
{
   var $t = this;
   $t.cancelallrequests();
   $t.tserverrequestqueue_fpendingstack = tobject.free($t.tserverrequestqueue_fpendingstack);
   $t.tserverrequestqueue_favailablestack = tobject.free($t.tserverrequestqueue_favailablestack);
   webcore_tcomponent.$p.destroy.call($t);
};

webhttp_tserverrequestqueue.$p.getnewrequest = function()
{
   var $t = this, $r;
   $r = $t.tserverrequestqueue_favailablestack.pop();
   if ($r == null)
      $r = webhttp_tserverrequest.create(new webhttp_tserverrequest(), $t);
   else 
      $r.initialize();
   return $r;
};

webhttp_tserverrequestqueue.$p.addrequest = function(value)
{
   var $t = this;
   $t.tserverrequestqueue_fpendingstack.queue(value);
   $t.executerequests();
};

webhttp_tserverrequestqueue.$p.cancelallrequests = function()
{
   var $t = this;
   if ($t.tserverrequestqueue_fexecuting)
      try
      {
         while ($t.tserverrequestqueue_frequest)
         {
            $t.tserverrequestqueue_frequest.cancel(false);
            $t.tserverrequestqueue_frequest = $t.tserverrequestqueue_fpendingstack.dequeue();
         }
      }
      finally
      {
         $t.tserverrequestqueue_fexecuting = false;
      }
};


function webhttp_init()
{
   webhttp_logqueue = webhttp_tserverrequestqueue.create(new webhttp_tserverrequestqueue(), null);
};

function webhttp_final()
{
   webhttp_logqueue = tobject.free(webhttp_logqueue);
};

// WebCtrls Unit Implementation Declarations

// TTextManager Class Declarations

function webctrls_ttextmanager()
{
   var $t = this;
   Object.call($t);
   $t.ttextmanager_felement = null;
}

webctrls_ttextmanager.create = function(instance)
{
   tobject.create(instance);
   instance.ttextmanager_createelement();
   return instance;
};

webctrls_ttextmanager.prototype = $i(tobject);
webctrls_ttextmanager.$p = webctrls_ttextmanager.prototype;
webctrls_ttextmanager.$p.constructor = webctrls_ttextmanager;

webctrls_ttextmanager.$p.ttextmanager_applyfont = function(font)
{
   var $t = this;
   $t.ttextmanager_felement.style.fontFamily = font.tfont_fname;
   $t.ttextmanager_felement.style.fontSize = webdom_pointstostr(font.tfont_fsize);
   $t.ttextmanager_felement.style.fontStyle = webctrls_fontstyletostr(font.tfont_fstyle);
   $t.ttextmanager_felement.style.fontWeight = webctrls_fontweighttostr(font.tfont_fweight);
   $t.ttextmanager_felement.style.textDecoration = webctrls_fontdecorationtostr(font.tfont_fdecoration);
};

webctrls_ttextmanager.$p.ttextmanager_createelement = function()
{
   var $t = this;
   $t.ttextmanager_felement = window.document.createElement("div");
   $t.ttextmanager_felement.style.top = webdom_pixelstostr(-3000);
   $t.ttextmanager_felement.style.left = webdom_pixelstostr(-3000);
   $t.ttextmanager_felement.style.position = "absolute";
   webdom_getbodyelement().appendChild($t.ttextmanager_felement);
};

webctrls_ttextmanager.$p.ttextmanager_removeelement = function()
{
   var $t = this;
   webdom_getbodyelement().removeChild($t.ttextmanager_felement);
   $t.ttextmanager_felement = null;
};

webctrls_ttextmanager.$p.destroy = function()
{
   var $t = this;
   $t.ttextmanager_removeelement();
   tobject.$p.destroy.call($t);
};

webctrls_ttextmanager.$p.textheight = function(value, font)
{
   var $t = this, $r;
   $t.ttextmanager_applyfont(font);
   $t.ttextmanager_felement.innerHTML = value;
   $r = $t.ttextmanager_felement.offsetHeight;
   return $r;
};

webctrls_ttextmanager.$p.textwidth = function(value, font)
{
   var $t = this, $r;
   $t.ttextmanager_applyfont(font);
   $t.ttextmanager_felement.innerHTML = value;
   $r = $t.ttextmanager_felement.offsetWidth;
   return $r;
};

// TDragDropManager Class Declarations

function webctrls_tdragdropmanager()
{
   var $t = this;
   Object.call($t);
   $t.tdragdropmanager_fstartx = 0;
   $t.tdragdropmanager_fstarty = 0;
   $t.tdragdropmanager_forigx = 0;
   $t.tdragdropmanager_forigy = 0;
   $t.tdragdropmanager_fdeltax = 0;
   $t.tdragdropmanager_fdeltay = 0;
   $t.tdragdropmanager_fcontrol = null;
   $t.tdragdropmanager_fmousemovehandler = null;
   $t.tdragdropmanager_fmouseuphandler = null;
}

webctrls_tdragdropmanager.prototype = $i(tobject);
webctrls_tdragdropmanager.$p = webctrls_tdragdropmanager.prototype;
webctrls_tdragdropmanager.$p.constructor = webctrls_tdragdropmanager;

webctrls_tdragdropmanager.$p.tdragdropmanager_mousemovehandler = function(event)
{
   var $t = this, $r, templeft, temptop;
   templeft = (event.clientX - $t.tdragdropmanager_fdeltax);
   temptop = (event.clientY - $t.tdragdropmanager_fdeltay);
   if (templeft < 0)
      templeft = 0;
   else if ($t.tdragdropmanager_fcontrol.tcontrol_fparent && (templeft >= $t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_getclientwidth()) && (($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_fscrollbars == webctrls_ssnone) || ($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_fscrollbars == webctrls_ssvertical)))
      templeft = ($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_getclientwidth() - 1);
   if (temptop < 0)
      temptop = 0;
   else if ($t.tdragdropmanager_fcontrol.tcontrol_fparent && (temptop >= $t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_getclientheight()) && (($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_fscrollbars == webctrls_ssnone) || ($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_fscrollbars == webctrls_sshorizontal)))
      temptop = ($t.tdragdropmanager_fcontrol.tcontrol_fparent.tcontainercontrol_getclientheight() - 1);
   $t.tdragdropmanager_fcontrol.tcontrol_setleft(templeft);
   $t.tdragdropmanager_fcontrol.tcontrol_settop(temptop);
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tdragdropmanager.$p.tdragdropmanager_mouseuphandler = function(event)
{
   var $t = this, $r;
   $t.enddrag();
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tdragdropmanager.$p.begindrag = function(controltodrag, x, y)
{
   var $t = this;
   $t.enddrag();
   $t.tdragdropmanager_fcontrol = controltodrag;
   $t.tdragdropmanager_fcontrol.tcontrol_setcursor(webctrls_crmove);
   $t.tdragdropmanager_fstartx = x;
   $t.tdragdropmanager_fstarty = y;
   $t.tdragdropmanager_forigx = $t.tdragdropmanager_fcontrol.tcontrol_getleft();
   $t.tdragdropmanager_forigy = $t.tdragdropmanager_fcontrol.tcontrol_gettop();
   $t.tdragdropmanager_fdeltax = ($t.tdragdropmanager_fstartx - $t.tdragdropmanager_forigx);
   $t.tdragdropmanager_fdeltay = ($t.tdragdropmanager_fstarty - $t.tdragdropmanager_forigy);
   $t.tdragdropmanager_fmousemovehandler = webdom_setdocumenteventhandler("mousemove", function(event) { webctrls_tdragdropmanager.$p.tdragdropmanager_mousemovehandler.call($t, event); });
   $t.tdragdropmanager_fmouseuphandler = webdom_setdocumenteventhandler("mouseup", function(event) { webctrls_tdragdropmanager.$p.tdragdropmanager_mouseuphandler.call($t, event); });
};

webctrls_tdragdropmanager.$p.enddrag = function()
{
   var $t = this;
   if ($t.tdragdropmanager_fcontrol)
   {
      $t.tdragdropmanager_fcontrol.tcontrol_setcursor(webctrls_crauto);
      webdom_cleardocumenteventhandler("mousemove", $t.tdragdropmanager_fmousemovehandler);
      webdom_cleardocumenteventhandler("mouseup", $t.tdragdropmanager_fmouseuphandler);
      if ($t.tdragdropmanager_fcontrol instanceof webctrls_tcontainercontrol)
         $t.tdragdropmanager_fcontrol.setfocus();
      $t.tdragdropmanager_fcontrol = null;
   }
};

// TColumnSizingManager Class Declarations

function webctrls_tcolumnsizingmanager()
{
   var $t = this;
   Object.call($t);
   $t.tcolumnsizingmanager_fstartx = 0;
   $t.tcolumnsizingmanager_forigx = 0;
   $t.tcolumnsizingmanager_fdeltax = 0;
   $t.tcolumnsizingmanager_fcolumn = null;
   $t.tcolumnsizingmanager_foldcursor = 0;
   $t.tcolumnsizingmanager_fmousemovehandler = null;
   $t.tcolumnsizingmanager_fmouseuphandler = null;
}

webctrls_tcolumnsizingmanager.prototype = $i(tobject);
webctrls_tcolumnsizingmanager.$p = webctrls_tcolumnsizingmanager.prototype;
webctrls_tcolumnsizingmanager.$p.constructor = webctrls_tcolumnsizingmanager;

webctrls_tcolumnsizingmanager.$p.tcolumnsizingmanager_mousemovehandler = function(event)
{
   var $t = this, $r, tempright;
   tempright = (event.clientX - $t.tcolumnsizingmanager_fdeltax);
   if (tempright < 0)
      tempright = 0;
   if ((tempright - $t.tcolumnsizingmanager_fcolumn.scrollleft()) > $t.tcolumnsizingmanager_fcolumn.sizerwidth())
      $t.tcolumnsizingmanager_fcolumn.tgridcolumn_setwidth((tempright - $t.tcolumnsizingmanager_fcolumn.scrollleft()));
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcolumnsizingmanager.$p.tcolumnsizingmanager_mouseuphandler = function(event)
{
   var $t = this, $r;
   $t.endsize();
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcolumnsizingmanager.$p.beginsize = function(columntosize, x)
{
   var $t = this;
   $t.endsize();
   $t.tcolumnsizingmanager_fcolumn = columntosize;
   $t.tcolumnsizingmanager_foldcursor = $t.tcolumnsizingmanager_fcolumn.tgridcolumn_fgrid.tcontrol_fcursor;
   $t.tcolumnsizingmanager_fcolumn.tgridcolumn_fgrid.tcontrol_setcursor(webctrls_crsizewe);
   $t.tcolumnsizingmanager_fstartx = x;
   $t.tcolumnsizingmanager_forigx = ($t.tcolumnsizingmanager_fcolumn.scrollleft() + $t.tcolumnsizingmanager_fcolumn.tgridcolumn_fwidth);
   $t.tcolumnsizingmanager_fdeltax = ($t.tcolumnsizingmanager_fstartx - $t.tcolumnsizingmanager_forigx);
   $t.tcolumnsizingmanager_fmousemovehandler = webdom_setdocumenteventhandler("mousemove", function(event) { webctrls_tcolumnsizingmanager.$p.tcolumnsizingmanager_mousemovehandler.call($t, event); });
   $t.tcolumnsizingmanager_fmouseuphandler = webdom_setdocumenteventhandler("mouseup", function(event) { webctrls_tcolumnsizingmanager.$p.tcolumnsizingmanager_mouseuphandler.call($t, event); });
};

webctrls_tcolumnsizingmanager.$p.endsize = function()
{
   var $t = this;
   if ($t.tcolumnsizingmanager_fcolumn)
   {
      $t.tcolumnsizingmanager_fcolumn.tgridcolumn_fgrid.tcontrol_setcursor($t.tcolumnsizingmanager_foldcursor);
      webdom_cleardocumenteventhandler("mousemove", $t.tcolumnsizingmanager_fmousemovehandler);
      webdom_cleardocumenteventhandler("mouseup", $t.tcolumnsizingmanager_fmouseuphandler);
      $t.tcolumnsizingmanager_fcolumn.tgridcolumn_fgrid.setfocus();
      $t.tcolumnsizingmanager_fcolumn = null;
   }
};

// TFont Class Declarations

function webctrls_tfont()
{
   var $t = this;
   Object.call($t);
   $t.tfont_fname = "";
   $t.tfont_fcolor = webctrls_clblack;
   $t.tfont_fdecoration = webctrls_fdnormal;
   $t.tfont_fsize = 0;
   $t.tfont_fstyle = webctrls_fsnormal;
   $t.tfont_fweight = webctrls_fwnormal;
   $t.tfont_fonchanged = null;
}

webctrls_tfont.prototype = $i(tobject);
webctrls_tfont.$p = webctrls_tfont.prototype;
webctrls_tfont.$p.constructor = webctrls_tfont;

webctrls_tfont.$p.tfont_setname = function(value)
{
   var $t = this;
   if (value != $t.tfont_fname)
   {
      $t.tfont_fname = value;
      $t.dochanged();
   }
};

webctrls_tfont.$p.tfont_setcolor = function(value)
{
   var $t = this;
   if (value != $t.tfont_fcolor)
   {
      $t.tfont_fcolor = value;
      $t.dochanged();
   }
};

webctrls_tfont.$p.tfont_setdecoration = function(value)
{
   var $t = this;
   if (value != $t.tfont_fdecoration)
   {
      if ((value >= webctrls_fdnormal) && (value <= webctrls_fdunderline))
      {
         $t.tfont_fdecoration = value;
         $t.dochanged();
      }
      else 
         throw new Error("Invalid font decoration (" + inttostr(value) + ")");
   }
};

webctrls_tfont.$p.tfont_setsize = function(value)
{
   var $t = this;
   if (value != $t.tfont_fsize)
   {
      $t.tfont_fsize = value;
      $t.dochanged();
   }
};

webctrls_tfont.$p.tfont_setstyle = function(value)
{
   var $t = this;
   if (value != $t.tfont_fstyle)
   {
      if ((value >= webctrls_fsnormal) && (value <= webctrls_fsitalic))
      {
         $t.tfont_fstyle = value;
         $t.dochanged();
      }
      else 
         throw new Error("Invalid font style (" + inttostr(value) + ")");
   }
};

webctrls_tfont.$p.tfont_setweight = function(value)
{
   var $t = this;
   if (value != $t.tfont_fweight)
   {
      if ((value >= webctrls_fwnormal) && (value <= webctrls_fwbold))
      {
         $t.tfont_fweight = value;
         $t.dochanged();
      }
      else 
         throw new Error("Invalid font weight (" + inttostr(value) + ")");
   }
};

webctrls_tfont.$p.tfont_internalassign = function(value)
{
   var $t = this;
   $t.tfont_fname = value.tfont_fname;
   $t.tfont_fcolor = value.tfont_fcolor;
   $t.tfont_fdecoration = value.tfont_fdecoration;
   $t.tfont_fsize = value.tfont_fsize;
   $t.tfont_fstyle = value.tfont_fstyle;
   $t.tfont_fweight = value.tfont_fweight;
};

webctrls_tfont.$p.dochanged = function(fromparent)
{
   var $t = this;
   if (fromparent == null)
      fromparent = false;
   if ($t.tfont_fonchanged)
      $t.tfont_fonchanged(fromparent);
};

webctrls_tfont.$p.inherit = function(value)
{
   var $t = this;
   $t.tfont_internalassign(value);
   $t.dochanged(true);
};

webctrls_tfont.$p.assign = function(value)
{
   var $t = this;
   $t.tfont_internalassign(value);
   $t.dochanged(false);
};

// TControl Class Declarations

function webctrls_tcontrol()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.tcontrol_fparent = null;
   $t.tcontrol_fparentcolor = true;
   $t.tcontrol_falignment = webctrls_taleftjustify;
   $t.tcontrol_fcolor = webctrls_clblack;
   $t.tcontrol_fcursor = webctrls_crauto;
   $t.tcontrol_fparentfont = true;
   $t.tcontrol_ffont = null;
   $t.tcontrol_fbase = null;
   $t.tcontrol_ftarget = null;
   $t.tcontrol_fdisplay = null;
   $t.tcontrol_fover = false;
   $t.tcontrol_ftabstop = false;
   $t.tcontrol_ffocused = false;
   $t.tcontrol_fvisible = false;
   $t.tcontrol_fclickhandler = null;
   $t.tcontrol_fdblclickhandler = null;
   $t.tcontrol_fblurhandler = null;
   $t.tcontrol_ffocushandler = null;
   $t.tcontrol_fkeydownhandler = null;
   $t.tcontrol_fkeyuphandler = null;
   $t.tcontrol_fkeypresshandler = null;
   $t.tcontrol_fmousedownhandler = null;
   $t.tcontrol_fmouseenterhandler = null;
   $t.tcontrol_fmouseleavehandler = null;
   $t.tcontrol_fmousemovehandler = null;
   $t.tcontrol_fmouseuphandler = null;
   $t.tcontrol_fonclick = null;
   $t.tcontrol_fondblclick = null;
   $t.tcontrol_fonenter = null;
   $t.tcontrol_fonexit = null;
   $t.tcontrol_fonhide = null;
   $t.tcontrol_fonkeydown = null;
   $t.tcontrol_fonkeyup = null;
   $t.tcontrol_fonkeypress = null;
   $t.tcontrol_fonmousedown = null;
   $t.tcontrol_fonmouseenter = null;
   $t.tcontrol_fonmouseleave = null;
   $t.tcontrol_fonmousemove = null;
   $t.tcontrol_fonmouseup = null;
   $t.tcontrol_fonshow = null;
   $t.tcontrol_factive = false;
   $t.tcontrol_fcanedit = false;
   $t.tcontrol_fcolumn = null;
   $t.tcontrol_fdatacolumn = "";
   $t.tcontrol_fdataset = null;
   $t.tcontrol_fediting = false;
   $t.tcontrol_fmodified = false;
   $t.tcontrol_fupdating = false;
}

webctrls_tcontrol.create = function(instance, aowner)
{
   webcore_tcomponent.create(instance, aowner);
   instance.tcontrol_fbase = instance.createelement();
   instance.initelement();
   instance.tcontrol_ffont = tobject.create(new webctrls_tfont());
   instance.tcontrol_ffont.tfont_fonchanged = function(fromparent) { instance.fontchanged.call(instance, fromparent); };
   instance.setcontrolproperties();
   instance.tcontrol_fparentcolor = true;
   instance.tcontrol_fparentfont = true;
   instance.tcontrol_ftabstop = true;
   instance.tcontrol_fvisible = true;
   if (instance.tcomponent_fowner instanceof webctrls_tcontainercontrol)
      instance.tcontrol_setparent(instance.tcomponent_fowner);
   instance.seteventhandlers();
   return instance;
};

webctrls_tcontrol.prototype = $i(webcore_tcomponent);
webctrls_tcontrol.$p = webctrls_tcontrol.prototype;
webctrls_tcontrol.$p.constructor = webctrls_tcontrol;

webctrls_tcontrol.$p.tcontrol_setalignment = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_falignment)
   {
      if ((value >= webctrls_taleftjustify) && (value <= webctrls_tarightjustify))
      {
         $t.tcontrol_ftarget.style.textAlign = webctrls_alignmenttostr(value);
         $t.tcontrol_falignment = value;
      }
      else 
         throw new Error("Invalid alignment (" + inttostr(value) + ")");
   }
};

webctrls_tcontrol.$p.tcontrol_setcursor = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fcursor)
   {
      if ((value >= webctrls_crauto) && (value <= webctrls_crwait))
      {
         switch (value)
         {
            case webctrls_crauto:
            {
               $t.tcontrol_fbase.style.cursor = "auto";
               break;
            }
            case webctrls_crcrosshair:
            {
               $t.tcontrol_fbase.style.cursor = "crosshair";
               break;
            }
            case webctrls_crdefault:
            {
               $t.tcontrol_fbase.style.cursor = "default";
               break;
            }
            case webctrls_crhelp:
            {
               $t.tcontrol_fbase.style.cursor = "help";
               break;
            }
            case webctrls_crmove:
            {
               $t.tcontrol_fbase.style.cursor = "move";
               break;
            }
            case webctrls_crpointer:
            {
               $t.tcontrol_fbase.style.cursor = "pointer";
               break;
            }
            case webctrls_crprogress:
            {
               $t.tcontrol_fbase.style.cursor = "progress";
               break;
            }
            case webctrls_crsizenesw:
            {
               $t.tcontrol_fbase.style.cursor = "ne-resize";
               break;
            }
            case webctrls_crsizens:
            {
               $t.tcontrol_fbase.style.cursor = "n-resize";
               break;
            }
            case webctrls_crsizenwse:
            {
               $t.tcontrol_fbase.style.cursor = "nw-resize";
               break;
            }
            case webctrls_crsizewe:
            {
               $t.tcontrol_fbase.style.cursor = "e-resize";
               break;
            }
            case webctrls_crtext:
            {
               $t.tcontrol_fbase.style.cursor = "text";
               break;
            }
            case webctrls_crwait:
            {
               $t.tcontrol_fbase.style.cursor = "wait";
               break;
            }
         };
         $t.tcontrol_fcursor = value;
      }
      else 
         throw new Error("Invalid cursor (" + inttostr(value) + ")");
   }
};

webctrls_tcontrol.$p.tcontrol_setfont = function(value)
{
   var $t = this;
   $t.tcontrol_ffont.assign(value);
};

webctrls_tcontrol.$p.tcontrol_setparent = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fparent)
   {
      if ($t.tcontrol_fparent)
         $t.tcontrol_fparent.removecontrol($t);
      if (value)
         value.addcontrol($t);
      $t.tcontrol_fparent = value;
      if ($t.tcontrol_fparent)
      {
         if ($t.tcontrol_fparentcolor)
            $t.tcontrol_fcolor = $t.tcontrol_fparent.tcontrol_fcolor;
         if ($t.tcontrol_fparentfont)
            $t.tcontrol_ffont.inherit($t.tcontrol_fparent.tcontrol_ffont);
      }
      $t.parentchanged();
   }
};

webctrls_tcontrol.$p.tcontrol_setparentcolor = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fparentcolor)
   {
      $t.tcontrol_fparentcolor = value;
      if ($t.tcontrol_fparentcolor && $t.tcontrol_fparent)
         $t.tcontrol_fcolor = $t.tcontrol_fparent.tcontrol_fcolor;
   }
};

webctrls_tcontrol.$p.tcontrol_setparentfont = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fparentfont)
   {
      if (value && $t.tcontrol_fparent)
         $t.tcontrol_ffont.inherit($t.tcontrol_fparent.tcontrol_ffont);
      $t.tcontrol_fparentfont = value;
   }
};

webctrls_tcontrol.$p.tcontrol_gettaborder = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.getcontroltaborder($t);
   else 
      $r = -1;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_settaborder = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_gettaborder())
   {
      if ($t.tcontrol_fparent)
         $t.tcontrol_fparent.setcontroltaborder($t, value);
   }
};

webctrls_tcontrol.$p.tcontrol_settabstop = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_ftabstop)
   {
      $t.tcontrol_ftabstop = value;
      if ($t.tcontrol_fparent)
         $t.tcontrol_fparent.setcontroltaborder($t, -1);
   }
};

webctrls_tcontrol.$p.tcontrol_gettop = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.offsetTop;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_settop = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_gettop())
   {
      $t.tcontrol_fbase.style.top = webdom_pixelstostr(value);
      $t.topchanged();
   }
};

webctrls_tcontrol.$p.tcontrol_gettoporigin = function()
{
   var $t = this, $r, tempelement;
   $r = 0;
   tempelement = $t.tcontrol_fbase;
   while (tempelement && (tempelement != webdom_getbodyelement()))
   {
      $r += tempelement.offsetTop;
      tempelement = tempelement.offsetParent;
   }
   return $r;
};

webctrls_tcontrol.$p.tcontrol_getleft = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.offsetLeft;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_setleft = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_getleft())
   {
      $t.tcontrol_fbase.style.left = webdom_pixelstostr(value);
      $t.leftchanged();
   }
};

webctrls_tcontrol.$p.tcontrol_getleftorigin = function()
{
   var $t = this, $r, tempelement;
   $r = 0;
   tempelement = $t.tcontrol_fbase;
   while (tempelement && (tempelement != webdom_getbodyelement()))
   {
      $r += tempelement.offsetLeft;
      tempelement = tempelement.offsetParent;
   }
   return $r;
};

webctrls_tcontrol.$p.tcontrol_getheight = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.offsetHeight;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_setheight = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_getheight())
   {
      $t.tcontrol_fbase.style.height = webdom_pixelstostr(value);
      $t.heightchanged();
   }
};

webctrls_tcontrol.$p.tcontrol_getwidth = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.offsetWidth;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_setwidth = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_getwidth())
   {
      $t.tcontrol_fbase.style.width = webdom_pixelstostr(value);
      $t.widthchanged();
   }
};

webctrls_tcontrol.$p.tcontrol_gethint = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.title;
   return $r;
};

webctrls_tcontrol.$p.tcontrol_sethint = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_gethint())
      $t.tcontrol_fbase.title = value;
};

webctrls_tcontrol.$p.tcontrol_setvisible = function(value)
{
   var $t = this;
   if (value)
      $t.show();
   else 
      $t.hide();
};

webctrls_tcontrol.$p.tcontrol_getcanmodify = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fcanedit && $t.tcontrol_fdataset && (!$t.tcontrol_fdataset.tdataset_freadonly);
   return $r;
};

webctrls_tcontrol.$p.tcontrol_setactive = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_factive)
   {
      $t.tcontrol_factive = value;
      $t.activechanged();
   }
};

webctrls_tcontrol.$p.tcontrol_setcanedit = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fcanedit)
   {
      $t.tcontrol_fcanedit = value;
      $t.updatestate();
   }
};

webctrls_tcontrol.$p.tcontrol_setdatacolumn = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fdatacolumn)
   {
      $t.tcontrol_fdatacolumn = value;
      $t.bind();
   }
};

webctrls_tcontrol.$p.tcontrol_setcolumn = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fcolumn)
   {
      $t.tcontrol_fcolumn = value;
      $t.editingchanged();
      $t.rowchanged(value);
   }
};

webctrls_tcontrol.$p.tcontrol_setdataset = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fdataset)
   {
      if ($t.tcontrol_fdataset)
         $t.tcontrol_fdataset.unregister($t);
      if (value)
         value.register($t);
      $t.tcontrol_fdataset = value;
      $t.updatestate();
   }
};

webctrls_tcontrol.$p.tcontrol_setediting = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fediting)
   {
      $t.tcontrol_fediting = value;
      $t.tcontrol_fmodified = false;
   }
};

webctrls_tcontrol.$p.clickhandler = function(event)
{
   var $t = this, $r;
   $r = $t.doclick();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.dblclickhandler = function(event)
{
   var $t = this, $r;
   $r = $t.dodblclick();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.focushandler = function(event)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $t.tcontrol_fparent.setactivecontrol($t);
   $t.doenter();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.blurhandler = function(event)
{
   var $t = this, $r;
   $t.doexit();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.keydownhandler = function(event)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeydown(event.keyCode, event.shiftKey, event.ctrlKey, event.altKey);
   else 
      $r = true;
   if ($r)
      $r = $t.dokeydown(event.keyCode, event.shiftKey, event.ctrlKey, event.altKey);
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.keyuphandler = function(event)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeyup(event.keyCode, event.shiftKey, event.ctrlKey, event.altKey);
   else 
      $r = true;
   if ($r)
      $r = $t.dokeyup(event.keyCode, event.shiftKey, event.ctrlKey, event.altKey);
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.keypresshandler = function(event)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeypress(chr(event.charCode), event.shiftKey, event.ctrlKey, event.altKey);
   else 
      $r = true;
   if ($r)
      $r = $t.dokeypress(chr(event.charCode), event.shiftKey, event.ctrlKey, event.altKey);
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.mousedownhandler = function(event)
{
   var $t = this, $r;
   $t.activatecontainer();
   $r = $t.domousedown(event.button, event.shiftKey, event.ctrlKey, event.altKey, event.clientX, event.clientY);
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.mouseenterhandler = function(event)
{
   var $t = this, $r;
   $r = $t.domouseenter();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.mouseleavehandler = function(event)
{
   var $t = this, $r;
   $r = $t.domouseleave();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.mousemovehandler = function(event)
{
   var $t = this, $r;
   if ((webctrls_dragdropmanager.tdragdropmanager_fcontrol == null) && (webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null))
   {
      $r = $t.domousemove(event.shiftKey, event.ctrlKey, event.altKey, event.clientX, event.clientY);
      webdom_canceleventbubble(event);
   }
   else 
      $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.mouseuphandler = function(event)
{
   var $t = this, $r;
   if ((webctrls_dragdropmanager.tdragdropmanager_fcontrol == null) && (webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null))
   {
      $r = $t.domouseup(event.button, event.shiftKey, event.ctrlKey, event.altKey, event.clientX, event.clientY);
      webdom_canceleventbubble(event);
   }
   else 
      $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcontrol.$p.begindrag = function(x, y)
{
   var $t = this;
   webctrls_dragdropmanager.begindrag($t, x, y);
};

webctrls_tcontrol.$p.createelement = function()
{
   var $t = this, $r;
   $r = null;
   return $r;
};

webctrls_tcontrol.$p.initelement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase)
      $t.tcontrol_fbase.style.position = "absolute";
   $t.tcontrol_ftarget = $t.tcontrol_fbase;
   $t.tcontrol_fdisplay = $t.tcontrol_fbase;
};

webctrls_tcontrol.$p.setelementfontname = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.fontFamily = $t.tcontrol_ffont.tfont_fname;
};

webctrls_tcontrol.$p.setelementfontcolor = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.color = webdom_colortostr($t.tcontrol_ffont.tfont_fcolor);
};

webctrls_tcontrol.$p.setelementfontdecoration = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.textDecoration = webctrls_fontdecorationtostr($t.tcontrol_ffont.tfont_fdecoration);
};

webctrls_tcontrol.$p.setelementfontsize = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.fontSize = webdom_pointstostr($t.tcontrol_ffont.tfont_fsize);
};

webctrls_tcontrol.$p.setelementfontstyle = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.fontStyle = webctrls_fontstyletostr($t.tcontrol_ffont.tfont_fstyle);
};

webctrls_tcontrol.$p.setelementfontweight = function()
{
   var $t = this;
   if ($t.tcontrol_fdisplay)
      $t.tcontrol_fdisplay.style.fontWeight = webctrls_fontweighttostr($t.tcontrol_ffont.tfont_fweight);
};

webctrls_tcontrol.$p.removeelement = function()
{
   var $t = this;
   $t.tcontrol_fbase = null;
};

webctrls_tcontrol.$p.seteventhandlers = function()
{
   var $t = this;
   if ($t.tcontrol_ftarget)
   {
      $t.tcontrol_fclickhandler = webdom_seteventhandler($t.tcontrol_ftarget, "click", function(event) { webctrls_tcontrol.$p.clickhandler.call($t, event); });
      $t.tcontrol_fdblclickhandler = webdom_seteventhandler($t.tcontrol_ftarget, "dblclick", function(event) { webctrls_tcontrol.$p.dblclickhandler.call($t, event); });
      $t.tcontrol_ffocushandler = webdom_seteventhandler($t.tcontrol_ftarget, "focus", function(event) { webctrls_tcontrol.$p.focushandler.call($t, event); });
      $t.tcontrol_fblurhandler = webdom_seteventhandler($t.tcontrol_ftarget, "blur", function(event) { webctrls_tcontrol.$p.blurhandler.call($t, event); });
      $t.tcontrol_fkeydownhandler = webdom_seteventhandler($t.tcontrol_ftarget, "keydown", function(event) { webctrls_tcontrol.$p.keydownhandler.call($t, event); });
      $t.tcontrol_fkeyuphandler = webdom_seteventhandler($t.tcontrol_ftarget, "keyup", function(event) { webctrls_tcontrol.$p.keyuphandler.call($t, event); });
      $t.tcontrol_fkeypresshandler = webdom_seteventhandler($t.tcontrol_ftarget, "keypress", function(event) { webctrls_tcontrol.$p.keypresshandler.call($t, event); });
      $t.tcontrol_fmousedownhandler = webdom_seteventhandler($t.tcontrol_ftarget, "mousedown", function(event) { webctrls_tcontrol.$p.mousedownhandler.call($t, event); });
      $t.tcontrol_fmouseenterhandler = webdom_seteventhandler($t.tcontrol_ftarget, "mouseover", function(event) { webctrls_tcontrol.$p.mouseenterhandler.call($t, event); });
      $t.tcontrol_fmouseleavehandler = webdom_seteventhandler($t.tcontrol_ftarget, "mouseout", function(event) { webctrls_tcontrol.$p.mouseleavehandler.call($t, event); });
      $t.tcontrol_fmousemovehandler = webdom_seteventhandler($t.tcontrol_ftarget, "mousemove", function(event) { webctrls_tcontrol.$p.mousemovehandler.call($t, event); });
      $t.tcontrol_fmouseuphandler = webdom_seteventhandler($t.tcontrol_ftarget, "mouseup", function(event) { webctrls_tcontrol.$p.mouseuphandler.call($t, event); });
   }
};

webctrls_tcontrol.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.tcontrol_ftarget)
   {
      webdom_cleareventhandler($t.tcontrol_ftarget, "click", $t.tcontrol_fclickhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "dblclick", $t.tcontrol_fdblclickhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "focus", $t.tcontrol_ffocushandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "blur", $t.tcontrol_fblurhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "keydown", $t.tcontrol_fkeydownhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "keyup", $t.tcontrol_fkeyuphandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "keypress", $t.tcontrol_fkeypresshandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "mousedown", $t.tcontrol_fmousedownhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "mouseover", $t.tcontrol_fmouseenterhandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "mouseout", $t.tcontrol_fmouseleavehandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "mousemove", $t.tcontrol_fmousemovehandler);
      webdom_cleareventhandler($t.tcontrol_ftarget, "mouseup", $t.tcontrol_fmouseuphandler);
   }
};

webctrls_tcontrol.$p.applycolorstyle = function(value)
{
   var $t = this;
   if (value)
   {
      if (value.backgroundColor != "")
         $t.tcontrol_fcolor = webdom_strtocolor(value.backgroundColor);
   }
};

webctrls_tcontrol.$p.applyfontstyle = function(value)
{
   var $t = this;
   if (value)
   {
      if (value.fontFamily != "")
         $t.tcontrol_ffont.tfont_setname(value.fontFamily);
      if (value.color != "")
         $t.tcontrol_ffont.tfont_setcolor(webdom_strtocolor(value.color));
      if (value.textDecoration != "")
         $t.tcontrol_ffont.tfont_setdecoration(webctrls_strtofontdecoration(value.textDecoration));
      if (value.fontSize != "")
         $t.tcontrol_ffont.tfont_setsize(webdom_strtopoints(value.fontSize));
      if (value.fontStyle != "")
         $t.tcontrol_ffont.tfont_setstyle(webctrls_strtofontstyle(value.fontStyle));
      if (value.fontWeight != "")
         $t.tcontrol_ffont.tfont_setweight(webctrls_strtofontweight(value.fontWeight));
   }
};

webctrls_tcontrol.$p.setcontrolproperties = function()
{
   var $t = this;
   if ($t.tcontrol_fparent)
   {
      if ($t.tcontrol_fparentcolor)
         $t.tcontrol_fcolor = $t.tcontrol_fparent.tcontrol_fcolor;
      if ($t.tcontrol_fparentfont)
         $t.tcontrol_ffont.inherit($t.tcontrol_fparent.tcontrol_ffont);
   }
};

webctrls_tcontrol.$p.setcolor = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fcolor)
   {
      $t.tcontrol_fbase.style.backgroundColor = webdom_colortostr(value);
      $t.tcontrol_fcolor = value;
      $t.colorchanged();
   }
};

webctrls_tcontrol.$p.resetcolor = function()
{
   var $t = this;
   $t.setcolor($t.tcontrol_fcolor);
};

webctrls_tcontrol.$p.colorchanged = function()
{
   var $t = this;
   $t.tcontrol_fparentcolor = false;
};

webctrls_tcontrol.$p.fontchanged = function(fromparent)
{
   var $t = this;
   $t.setelementfontname();
   $t.setelementfontcolor();
   $t.setelementfontdecoration();
   $t.setelementfontsize();
   $t.setelementfontstyle();
   $t.setelementfontweight();
   if (!fromparent)
      $t.tcontrol_fparentfont = false;
};

webctrls_tcontrol.$p.namechanged = function()
{
   var $t = this;
   $t.tcontrol_ftarget.id = $t.tcomponent_fname;
};

webctrls_tcontrol.$p.parentchanged = function()
{
};

webctrls_tcontrol.$p.resettheme = function()
{
   var $t = this;
   $t.setcontrolproperties();
   $t.heightchanged();
   $t.widthchanged();
};

webctrls_tcontrol.$p.topchanged = function()
{
};

webctrls_tcontrol.$p.leftchanged = function()
{
};

webctrls_tcontrol.$p.heightchanged = function()
{
};

webctrls_tcontrol.$p.widthchanged = function()
{
};

webctrls_tcontrol.$p.tabindexenabled = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.tabindexenabled();
   else 
      $r = false;
   return $r;
};

webctrls_tcontrol.$p.settabindex = function(value)
{
};

webctrls_tcontrol.$p.firstcontrol = function()
{
   var $t = this;
   $t.setfocus();
};

webctrls_tcontrol.$p.lastcontrol = function()
{
   var $t = this;
   $t.setfocus();
};

webctrls_tcontrol.$p.setcontrolstate = function()
{
};

webctrls_tcontrol.$p.activatecontainer = function()
{
   var $t = this;
   if ($t.tcontrol_fparent)
      $t.tcontrol_fparent.activatecontainer();
};

webctrls_tcontrol.$p.closecontainer = function(value)
{
   var $t = this;
   if ($t.tcontrol_fparent)
      $t.tcontrol_fparent.closecontainer(value);
};

webctrls_tcontrol.$p.setzindex = function(value)
{
   var $t = this;
   $t.tcontrol_fbase.style.zIndex = inttostr(value);
};

webctrls_tcontrol.$p.getclasssuffix = function()
{
   var $t = this, $r;
   $r = "";
   return $r;
};

webctrls_tcontrol.$p.doclick = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fonclick)
      $t.tcontrol_fonclick($t);
   $r = true;
   return $r;
};

webctrls_tcontrol.$p.dodblclick = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fondblclick)
      $t.tcontrol_fondblclick($t);
   $r = true;
   return $r;
};

webctrls_tcontrol.$p.doenter = function()
{
   var $t = this;
   if ($t.tcontrol_fonenter)
      $t.tcontrol_fonenter($t);
   $t.tcontrol_fover = false;
   $t.tcontrol_ffocused = true;
   $t.setcontrolstate();
};

webctrls_tcontrol.$p.doexit = function()
{
   var $t = this;
   $t.tcontrol_fover = false;
   $t.tcontrol_ffocused = false;
   $t.setcontrolstate();
   if ($t.tcontrol_fonexit)
      $t.tcontrol_fonexit($t);
};

webctrls_tcontrol.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fonkeydown)
      $r = $t.tcontrol_fonkeydown($t, key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   if ($r)
   {
      if ($t.canfocus() && (key == webctrls_vk_tab))
      {
         if ($t.tabindexenabled() && $t.tcontrol_fparent)
         {
            if (shiftkey)
               $t.tcontrol_fparent.priorcontrol();
            else 
               $t.tcontrol_fparent.nextcontrol();
         }
         $r = false;
      }
   }
   return $r;
};

webctrls_tcontrol.$p.dokeyup = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fonkeyup)
      $t.tcontrol_fonkeyup($t, key, shiftkey, ctrlkey, altkey);
   $r = true;
   return $r;
};

webctrls_tcontrol.$p.dokeypress = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fonkeypress)
      $r = $t.tcontrol_fonkeypress($t, key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tcontrol.$p.domousedown = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   if ($t.tcontrol_fonmousedown)
      $t.tcontrol_fonmousedown($t, button, shiftkey, ctrlkey, altkey, x, y);
   $t.setfocus();
   $r = false;
   return $r;
};

webctrls_tcontrol.$p.domouseenter = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fonmouseenter)
      $t.tcontrol_fonmouseenter($t);
   $r = true;
   $t.tcontrol_fover = true;
   $t.setcontrolstate();
   return $r;
};

webctrls_tcontrol.$p.domouseleave = function()
{
   var $t = this, $r;
   $t.tcontrol_fover = false;
   $t.setcontrolstate();
   if ($t.tcontrol_fonmouseleave)
      $t.tcontrol_fonmouseleave($t);
   $r = true;
   return $r;
};

webctrls_tcontrol.$p.domousemove = function(shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   if ($t.tcontrol_fonmousemove)
      $t.tcontrol_fonmousemove($t, shiftkey, ctrlkey, altkey, x, y);
   $r = false;
   return $r;
};

webctrls_tcontrol.$p.domouseup = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   if ($t.tcontrol_fonmouseup)
      $t.tcontrol_fonmouseup($t, button, shiftkey, ctrlkey, altkey, x, y);
   $r = true;
   return $r;
};

webctrls_tcontrol.$p.doshow = function()
{
   var $t = this;
   if ($t.tcontrol_fonshow)
      $t.tcontrol_fonshow($t);
};

webctrls_tcontrol.$p.dohide = function()
{
   var $t = this;
   if ($t.tcontrol_fonhide)
      $t.tcontrol_fonhide($t);
};

webctrls_tcontrol.$p.activechanged = function()
{
   var $t = this;
   $t.bind();
};

webctrls_tcontrol.$p.bind = function()
{
   var $t = this, tempcolumn;
   if ($t.tcontrol_factive && ($t.tcontrol_fdatacolumn != ""))
   {
      $t.tcontrol_fcolumn = null;
      tempcolumn = $t.tcontrol_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn1($t.tcontrol_fdatacolumn);
      if (tempcolumn == null)
         throw new Error("Column \"" + $t.tcontrol_fdatacolumn + "\" not found");
      else 
         $t.tcontrol_setcolumn(tempcolumn);
   }
   else 
      $t.tcontrol_setcolumn(null);
};

webctrls_tcontrol.$p.databound = function()
{
   var $t = this, $r;
   $r = ($t.tcontrol_fdataset && $t.tcontrol_fcolumn);
   return $r;
};

webctrls_tcontrol.$p.datachanged = function()
{
};

webctrls_tcontrol.$p.rowschanged = function()
{
   var $t = this;
   $t.rowchanged(null);
};

webctrls_tcontrol.$p.edit = function()
{
   var $t = this, $r;
   if ($t.tcontrol_getcanmodify())
      $t.tcontrol_fdataset.update();
   $r = $t.tcontrol_fediting;
   return $r;
};

webctrls_tcontrol.$p.editingchanged = function()
{
   var $t = this;
   $t.tcontrol_setediting($t.tcontrol_fediting && $t.tcontrol_getcanmodify());
};

webctrls_tcontrol.$p.columnfocus = function(value)
{
   var $t = this, $r;
   $r = false;
   if (value && (value == $t.tcontrol_fcolumn))
   {
      if ($t.canfocus())
      {
         $t.setfocus();
         $r = true;
      }
   }
   return $r;
};

webctrls_tcontrol.$p.layoutchanged = function()
{
   var $t = this;
   $t.rowchanged(null);
   $t.bind();
};

webctrls_tcontrol.$p.modified = function()
{
   var $t = this;
   $t.tcontrol_fmodified = true;
};

webctrls_tcontrol.$p.notification = function(sender, id, data)
{
   var $t = this, $r;
   webcore_tcomponent.$p.notification.call($t, sender, id, data);
   $r = false;
   if ((id == webcore_cm_removecomp) && (sender == $t.tcontrol_fdataset))
      $t.tcontrol_fdataset = null;
   else if (id == webdata_cm_updatestate)
      $t.updatestate();
   else 
   {
      if ($t.tcontrol_factive)
      {
         switch (id)
         {
            case webdata_cm_rowinserted:
            {
               $t.rowinserted();
               break;
            }
            case webdata_cm_rowchanged:
            {
               if (!$t.tcontrol_fupdating)
                  $t.rowchanged(data);
               break;
            }
            case webdata_cm_rowdeleted:
            {
               $t.rowdeleted();
               break;
            }
            case webdata_cm_rowschanged:
            {
               $t.rowschanged();
               break;
            }
            case webdata_cm_layoutchanged:
            {
               $t.layoutchanged();
               break;
            }
            case webdata_cm_updaterow:
            {
               $t.updaterow();
               break;
            }
            case webdata_cm_focuscontrol:
            {
               $r = $t.columnfocus(data);
               break;
            }
            case webdata_cm_disabledstatechanged:
            {
               $t.rowschanged();
               break;
            }
         };
      }
   }
   return $r;
};

webctrls_tcontrol.$p.reset = function()
{
   var $t = this;
   $t.datachanged();
};

webctrls_tcontrol.$p.rowinserted = function()
{
   var $t = this;
   $t.rowchanged(null);
};

webctrls_tcontrol.$p.rowchanged = function(value)
{
   var $t = this;
   if ((value == null) || (value == $t.tcontrol_fcolumn))
   {
      $t.datachanged();
      $t.tcontrol_fmodified = false;
   }
};

webctrls_tcontrol.$p.rowdeleted = function()
{
   var $t = this;
   $t.rowchanged(null);
};

webctrls_tcontrol.$p.updatedata = function()
{
};

webctrls_tcontrol.$p.updaterow = function()
{
   var $t = this;
   $t.tcontrol_fupdating = true;
   try
   {
      if ($t.tcontrol_fmodified)
      {
         $t.updatedata();
         $t.tcontrol_fmodified = false;
      }
   }
   finally
   {
      $t.tcontrol_fupdating = false;
   }
};

webctrls_tcontrol.$p.updatestate = function()
{
   var $t = this;
   $t.tcontrol_setactive($t.tcontrol_fdataset && ($t.tcontrol_fdataset.tdataset_fstate != webdata_dsclosed));
   $t.tcontrol_setediting($t.tcontrol_fdataset && $t.tcontrol_fdataset.tdataset_getediting() && $t.tcontrol_fcanedit);
};

webctrls_tcontrol.$p.destroy = function()
{
   var $t = this;
   $t.cleareventhandlers();
   $t.tcontrol_ffont = tobject.free($t.tcontrol_ffont);
   $t.tcontrol_setparent(null);
   $t.removeelement();
   webcore_tcomponent.$p.destroy.call($t);
};

webctrls_tcontrol.$p.canfocus = function()
{
   var $t = this, $r;
   $r = false;
   return $r;
};

webctrls_tcontrol.$p.setfocus = function()
{
   var $t = this;
   if ($t.canfocus() && $t.tcontrol_ftarget)
      $t.tcontrol_ftarget.focus();
};

webctrls_tcontrol.$p.bringtofront = function()
{
   var $t = this;
   if ($t.tcontrol_fparent)
   {
      $t.tcontrol_fparent.activatecontainer();
      $t.tcontrol_fparent.setcontrolposition($t, $t.tcontrol_fparent.tcontainercontrol_getcontrolcount() - 1);
   }
};

webctrls_tcontrol.$p.show = function()
{
   var $t = this;
   if (!$t.tcontrol_fvisible)
   {
      $t.tcontrol_fbase.style.visibility = "";
      $t.tcontrol_fvisible = true;
      if ($t.tcontrol_fparent)
         $t.tcontrol_fparent.setcontroltaborder($t, -1);
      $t.doshow();
   }
};

webctrls_tcontrol.$p.hide = function()
{
   var $t = this;
   if ($t.tcontrol_fvisible)
   {
      $t.dohide();
      $t.tcontrol_fbase.style.visibility = "hidden";
      $t.tcontrol_fvisible = false;
      if ($t.tcontrol_fparent)
         $t.tcontrol_fparent.setcontroltaborder($t, -1);
   }
};

// TInputControl Class Declarations

function webctrls_tinputcontrol()
{
   var $t = this;
   webctrls_tcontrol.call($t);
   $t.tinputcontrol_finput = null;
}

webctrls_tinputcontrol.create = function(instance, aowner)
{
   webctrls_tcontrol.create(instance, aowner);
   return instance;
};

webctrls_tinputcontrol.prototype = $i(webctrls_tcontrol);
webctrls_tinputcontrol.$p = webctrls_tinputcontrol.prototype;
webctrls_tinputcontrol.$p.constructor = webctrls_tinputcontrol;

webctrls_tinputcontrol.$p.tinputcontrol_getenabled = function()
{
   var $t = this, $r;
   $r = (!$t.tinputcontrol_finput.disabled);
   return $r;
};

webctrls_tinputcontrol.$p.tinputcontrol_setenabled = function(value)
{
   var $t = this;
   if (value != $t.tinputcontrol_getenabled())
   {
      $t.tinputcontrol_finput.disabled = (!value);
      $t.enabledchanged();
   }
};

webctrls_tinputcontrol.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("input");
   return $r;
};

webctrls_tinputcontrol.$p.createelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("div");
   $t.tinputcontrol_finput = $t.createinputelement();
   return $r;
};

webctrls_tinputcontrol.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontrol.$p.initelement.call($t);
   $t.tinputcontrol_finput.style.backgroundColor = "transparent";
   $t.tinputcontrol_finput.style.outlineWidth = webdom_pixelstostr(0);
   $t.tcontrol_fbase.appendChild($t.tinputcontrol_finput);
   $t.tcontrol_ftarget = $t.tinputcontrol_finput;
   $t.tcontrol_fdisplay = $t.tinputcontrol_finput;
};

webctrls_tinputcontrol.$p.removeelement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase && $t.tinputcontrol_finput)
   {
      $t.tcontrol_fbase.removeChild($t.tinputcontrol_finput);
      $t.tinputcontrol_finput = null;
   }
   webctrls_tcontrol.$p.removeelement.call($t);
};

webctrls_tinputcontrol.$p.getclasssuffix = function()
{
   var $t = this, $r;
   if ($t.tinputcontrol_getenabled())
   {
      if ($t.tcontrol_fover)
         $r = "hot";
      else if ($t.tcontrol_ffocused)
         $r = "fcs";
      else 
         $r = "nrm";
   }
   else 
      $r = "dsb";
   return $r;
};

webctrls_tinputcontrol.$p.setelementfontcolor = function()
{
   var $t = this;
   if ($t.tinputcontrol_getenabled())
      webctrls_tcontrol.$p.setelementfontcolor.call($t);
   else 
      $t.tinputcontrol_finput.style.color = "";
};

webctrls_tinputcontrol.$p.enabledchanged = function()
{
   var $t = this;
   $t.setcontrolstate();
};

webctrls_tinputcontrol.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getheight() > 0)
      $t.tinputcontrol_finput.style.height = webdom_pixelstostr($t.tcontrol_getheight());
};

webctrls_tinputcontrol.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
      $t.tinputcontrol_finput.style.width = webdom_pixelstostr($t.tcontrol_getwidth());
};

webctrls_tinputcontrol.$p.settabindex = function(value)
{
   var $t = this;
   $t.tinputcontrol_finput.tabIndex = (value + 1);
};

webctrls_tinputcontrol.$p.domousedown = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   webctrls_tcontrol.$p.domousedown.call($t, button, shiftkey, ctrlkey, altkey, x, y);
   $r = true;
   return $r;
};

webctrls_tinputcontrol.$p.domousemove = function(shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   webctrls_tcontrol.$p.domousemove.call($t, shiftkey, ctrlkey, altkey, x, y);
   $r = true;
   return $r;
};

webctrls_tinputcontrol.$p.canfocus = function()
{
   var $t = this, $r;
   $r = true;
   return $r;
};

// TButtonControl Class Declarations

function webctrls_tbuttoncontrol()
{
   var $t = this;
   webctrls_tinputcontrol.call($t);
   $t.tbuttoncontrol_fdown = false;
}

webctrls_tbuttoncontrol.prototype = $i(webctrls_tinputcontrol);
webctrls_tbuttoncontrol.$p = webctrls_tbuttoncontrol.prototype;
webctrls_tbuttoncontrol.$p.constructor = webctrls_tbuttoncontrol;

webctrls_tbuttoncontrol.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createinputelement.call($t);
   $r.type = "button";
   return $r;
};

webctrls_tbuttoncontrol.$p.getcaption = function()
{
   var $t = this, $r;
   $r = "";
   return $r;
};

webctrls_tbuttoncontrol.$p.setcaption = function(value)
{
};

webctrls_tbuttoncontrol.$p.getclasssuffix = function()
{
   var $t = this, $r;
   if ($t.tinputcontrol_getenabled())
   {
      if ($t.tbuttoncontrol_fdown)
         $r = "psh";
      else if ($t.tcontrol_fover)
         $r = "hot";
      else if ($t.tcontrol_ffocused)
         $r = "fcs";
      else 
         $r = "nrm";
   }
   else 
      $r = "dsb";
   return $r;
};

webctrls_tbuttoncontrol.$p.doclick = function()
{
   var $t = this, $r;
   $t.tbuttoncontrol_fdown = false;
   $t.setcontrolstate();
   $r = webctrls_tcontrol.$p.doclick.call($t);
   return $r;
};

webctrls_tbuttoncontrol.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.dokeydown.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r && (key == webctrls_vk_space))
   {
      $t.tbuttoncontrol_fdown = true;
      $t.setcontrolstate();
      $r = false;
   }
   return $r;
};

webctrls_tbuttoncontrol.$p.dokeyup = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.dokeyup.call($t, key, shiftkey, ctrlkey, altkey);
   $t.tbuttoncontrol_fdown = false;
   $t.setcontrolstate();
   if ($r && (key == webctrls_vk_space))
   {
      $t.doclick();
      $r = false;
   }
   return $r;
};

webctrls_tbuttoncontrol.$p.domousedown = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.domousedown.call($t, button, shiftkey, ctrlkey, altkey, x, y);
   $t.tbuttoncontrol_fdown = true;
   $t.setcontrolstate();
   return $r;
};

webctrls_tbuttoncontrol.$p.domouseleave = function()
{
   var $t = this, $r;
   $t.tbuttoncontrol_fdown = false;
   $r = webctrls_tcontrol.$p.domouseleave.call($t);
   return $r;
};

webctrls_tbuttoncontrol.$p.domouseup = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   $t.tbuttoncontrol_fdown = false;
   $t.setcontrolstate();
   $r = webctrls_tcontrol.$p.domouseup.call($t, button, shiftkey, ctrlkey, altkey, x, y);
   return $r;
};

// TButton Class Declarations

function webctrls_tbutton()
{
   var $t = this;
   webctrls_tbuttoncontrol.call($t);
   $t.tbutton_fmodalresult = 0;
   $t.tbutton_fleft = null;
   $t.tbutton_fmiddle = null;
   $t.tbutton_fright = null;
}

webctrls_tbutton.prototype = $i(webctrls_tbuttoncontrol);
webctrls_tbutton.$p = webctrls_tbutton.prototype;
webctrls_tbutton.$p.constructor = webctrls_tbutton;

webctrls_tbutton.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   with (window.document)
   {
      $t.tbutton_fleft = createElement("div");
      $t.tbutton_fmiddle = createElement("div");
      $t.tbutton_fright = createElement("div");
   }
   return $r;
};

webctrls_tbutton.$p.initelement = function()
{
   var $t = this;
   $t.tcontrol_fbase.className = "btn";
   $t.tinputcontrol_finput.className = "btn_tx_nrm";
   $t.tbutton_fleft.className = "btn_l_nrm";
   $t.tcontrol_fbase.appendChild($t.tbutton_fleft);
   $t.tbutton_fmiddle.className = "btn_m_nrm";
   $t.tcontrol_fbase.appendChild($t.tbutton_fmiddle);
   $t.tbutton_fright.className = "btn_r_nrm";
   $t.tcontrol_fbase.appendChild($t.tbutton_fright);
   webctrls_tinputcontrol.$p.initelement.call($t);
};

webctrls_tbutton.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.getclasssuffix();
   $t.tbutton_fleft.className = "btn_l_" + suffix;
   $t.tbutton_fmiddle.className = "btn_m_" + suffix;
   $t.tbutton_fright.className = "btn_r_" + suffix;
   $t.tinputcontrol_finput.className = "btn_tx_" + suffix;
};

webctrls_tbutton.$p.doclick = function()
{
   var $t = this, $r;
   $r = webctrls_tbuttoncontrol.$p.doclick.call($t);
   if ($r && ($t.tbutton_fmodalresult != webctrls_mrnone))
      $t.closecontainer($t.tbutton_fmodalresult);
   return $r;
};

webctrls_tbutton.$p.getcaption = function()
{
   var $t = this, $r;
   $r = $t.tinputcontrol_finput.value;
   return $r;
};

webctrls_tbutton.$p.setcaption = function(value)
{
   var $t = this;
   if (value != $t.getcaption())
      $t.tinputcontrol_finput.value = value;
};

webctrls_tbutton.$p.widthchanged = function()
{
   var $t = this;
   webctrls_tinputcontrol.$p.widthchanged.call($t);
   if ($t.tcontrol_getwidth() > 0)
      $t.tbutton_fmiddle.style.width = webdom_pixelstostr($t.tcontrol_fbase.offsetWidth - ($t.tbutton_fleft.offsetWidth + $t.tbutton_fright.offsetWidth));
};

// TStateButtonControl Class Declarations

function webctrls_tstatebuttoncontrol()
{
   var $t = this;
   webctrls_tbuttoncontrol.call($t);
   $t.tstatebuttoncontrol_fchecked = false;
   $t.tstatebuttoncontrol_fimage = null;
   $t.tstatebuttoncontrol_flabel = null;
   $t.tstatebuttoncontrol_flabelmouseenterhandler = null;
   $t.tstatebuttoncontrol_flabelmouseleavehandler = null;
}

webctrls_tstatebuttoncontrol.prototype = $i(webctrls_tbuttoncontrol);
webctrls_tstatebuttoncontrol.$p = webctrls_tstatebuttoncontrol.prototype;
webctrls_tstatebuttoncontrol.$p.constructor = webctrls_tstatebuttoncontrol;

webctrls_tstatebuttoncontrol.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   with (window.document)
   {
      $t.tstatebuttoncontrol_fimage = createElement("div");
      $t.tstatebuttoncontrol_flabel = createElement("label");
   }
   return $r;
};

webctrls_tstatebuttoncontrol.$p.initelement = function()
{
   var $t = this;
   webctrls_tinputcontrol.$p.initelement.call($t);
   $t.tcontrol_fdisplay = $t.tstatebuttoncontrol_flabel;
};

webctrls_tstatebuttoncontrol.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   if ($t.tstatebuttoncontrol_flabel)
   {
      $t.tstatebuttoncontrol_flabelmouseenterhandler = webdom_seteventhandler($t.tstatebuttoncontrol_flabel, "mouseover", function(event) { webctrls_tstatebuttoncontrol.$p.mouseenterhandler.call($t, event); });
      $t.tstatebuttoncontrol_flabelmouseleavehandler = webdom_seteventhandler($t.tstatebuttoncontrol_flabel, "mouseout", function(event) { webctrls_tstatebuttoncontrol.$p.mouseleavehandler.call($t, event); });
   }
};

webctrls_tstatebuttoncontrol.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.tstatebuttoncontrol_flabel)
   {
      webdom_cleareventhandler($t.tstatebuttoncontrol_flabel, "mouseover", $t.tstatebuttoncontrol_flabelmouseenterhandler);
      webdom_cleareventhandler($t.tstatebuttoncontrol_flabel, "mouseout", $t.tstatebuttoncontrol_flabelmouseleavehandler);
   }
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
};

webctrls_tstatebuttoncontrol.$p.getcaption = function()
{
   var $t = this, $r;
   $r = $t.tstatebuttoncontrol_flabel.innerHTML;
   return $r;
};

webctrls_tstatebuttoncontrol.$p.setcaption = function(value)
{
   var $t = this;
   if (value != $t.getcaption())
   {
      $t.tstatebuttoncontrol_flabel.innerHTML = value;
      $t.heightchanged();
   }
};

webctrls_tstatebuttoncontrol.$p.setchecked = function(value)
{
   var $t = this;
   if (value != $t.tstatebuttoncontrol_fchecked)
   {
      $t.tstatebuttoncontrol_fchecked = value;
      $t.setcontrolstate();
   }
};

webctrls_tstatebuttoncontrol.$p.namechanged = function()
{
   var $t = this;
   webctrls_tcontrol.$p.namechanged.call($t);
   $t.tstatebuttoncontrol_flabel.htmlFor = $t.tinputcontrol_finput.id;
};

webctrls_tstatebuttoncontrol.$p.fontchanged = function(fromparent)
{
   var $t = this;
   webctrls_tcontrol.$p.fontchanged.call($t, fromparent);
   $t.heightchanged();
};

webctrls_tstatebuttoncontrol.$p.heightchanged = function()
{
   var $t = this;
   webctrls_tinputcontrol.$p.heightchanged.call($t);
   if ($t.tcontrol_getheight() > 0)
      $t.tstatebuttoncontrol_flabel.style.top = webdom_pixelstostr(floor(($t.tcontrol_getheight() - $t.tstatebuttoncontrol_flabel.offsetHeight) / 2));
};

webctrls_tstatebuttoncontrol.$p.widthchanged = function()
{
   var $t = this;
   webctrls_tinputcontrol.$p.widthchanged.call($t);
   if ($t.tcontrol_getwidth() > 0)
      $t.tstatebuttoncontrol_flabel.style.width = webdom_pixelstostr($t.tcontrol_getwidth() - $t.tstatebuttoncontrol_fimage.offsetWidth);
};

webctrls_tstatebuttoncontrol.$p.doclick = function()
{
   var $t = this, $r;
   if ($t.databound())
      $r = $t.edit();
   else 
      $r = true;
   if ($r)
   {
      $t.setchecked(!$t.tstatebuttoncontrol_fchecked);
      if ($t.databound())
         $t.modified();
      $r = webctrls_tbuttoncontrol.$p.doclick.call($t);
   }
   return $r;
};

webctrls_tstatebuttoncontrol.$p.doexit = function()
{
   var $t = this;
   if ($t.databound())
      try
      {
         $t.updaterow();
      }
      catch($e)
      {
         $t.setfocus();
         throw $e;
      }
   webctrls_tcontrol.$p.doexit.call($t);
};

// TCheckBox Class Declarations

function webctrls_tcheckbox()
{
   var $t = this;
   webctrls_tstatebuttoncontrol.call($t);
}

webctrls_tcheckbox.prototype = $i(webctrls_tstatebuttoncontrol);
webctrls_tcheckbox.$p = webctrls_tcheckbox.prototype;
webctrls_tcheckbox.$p.constructor = webctrls_tcheckbox;

webctrls_tcheckbox.$p.initelement = function()
{
   var $t = this;
   $t.tinputcontrol_finput.className = "chk";
   $t.tstatebuttoncontrol_fimage.className = "chk_u_nrm";
   $t.tcontrol_fbase.appendChild($t.tstatebuttoncontrol_fimage);
   $t.tstatebuttoncontrol_flabel.className = "chk_tx_nrm";
   $t.tcontrol_fbase.appendChild($t.tstatebuttoncontrol_flabel);
   webctrls_tstatebuttoncontrol.$p.initelement.call($t);
};

webctrls_tcheckbox.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.getclasssuffix();
   if ($t.tstatebuttoncontrol_fchecked)
      $t.tstatebuttoncontrol_fimage.className = "chk_c_" + suffix;
   else 
      $t.tstatebuttoncontrol_fimage.className = "chk_u_" + suffix;
   $t.tstatebuttoncontrol_flabel.className = "chk_tx_" + suffix;
};

webctrls_tcheckbox.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.setchecked($t.tcontrol_fcolumn.tdatacolumn_getasboolean());
   else 
      $t.setchecked(false);
};

webctrls_tcheckbox.$p.updatedata = function()
{
   var $t = this;
   $t.tcontrol_fcolumn.tdatacolumn_setasboolean($t.tstatebuttoncontrol_fchecked);
};

// TRadioButton Class Declarations

function webctrls_tradiobutton()
{
   var $t = this;
   webctrls_tstatebuttoncontrol.call($t);
   $t.tradiobutton_fgroupindex = 0;
}

webctrls_tradiobutton.prototype = $i(webctrls_tstatebuttoncontrol);
webctrls_tradiobutton.$p = webctrls_tradiobutton.prototype;
webctrls_tradiobutton.$p.constructor = webctrls_tradiobutton;

webctrls_tradiobutton.$p.tradiobutton_setgroupindex = function(value)
{
   var $t = this;
   if (value != $t.tradiobutton_fgroupindex)
   {
      $t.tradiobutton_fgroupindex = value;
      if ($t.tstatebuttoncontrol_fchecked)
         $t.tradiobutton_updatechecked();
   }
};

webctrls_tradiobutton.$p.tradiobutton_updatechecked = function()
{
   var $t = this, i;
   if ($t.tcontrol_fparent)
   {
      for (i = 0 ; i <= $t.tcontrol_fparent.tcontainercontrol_getcontrolcount() - 1 ; i++)
      {
         if (($t.tcontrol_fparent.tcontainercontrol_getcontrol(i) != $t) && ($t.tcontrol_fparent.tcontainercontrol_getcontrol(i) instanceof webctrls_tradiobutton))
         {
            if (($t.tcontrol_fparent.tcontainercontrol_getcontrol(i).tradiobutton_fgroupindex == $t.tradiobutton_fgroupindex) && $t.tcontrol_fparent.tcontainercontrol_getcontrol(i).tstatebuttoncontrol_fchecked)
            {
               $t.tcontrol_fparent.tcontainercontrol_getcontrol(i).tradiobutton_clearchecked();
               break;
            }
         }
      }
   }
};

webctrls_tradiobutton.$p.tradiobutton_clearchecked = function()
{
   var $t = this;
   webctrls_tstatebuttoncontrol.$p.setchecked.call($t, false);
};

webctrls_tradiobutton.$p.initelement = function()
{
   var $t = this;
   $t.tinputcontrol_finput.className = "rdo";
   $t.tstatebuttoncontrol_fimage.className = "rdo_u_nrm";
   $t.tcontrol_fbase.appendChild($t.tstatebuttoncontrol_fimage);
   $t.tstatebuttoncontrol_flabel.className = "rdo_tx_nrm";
   $t.tcontrol_fbase.appendChild($t.tstatebuttoncontrol_flabel);
   webctrls_tstatebuttoncontrol.$p.initelement.call($t);
};

webctrls_tradiobutton.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.getclasssuffix();
   if ($t.tstatebuttoncontrol_fchecked)
      $t.tstatebuttoncontrol_fimage.className = "rdo_s_" + suffix;
   else 
      $t.tstatebuttoncontrol_fimage.className = "rdo_u_" + suffix;
   $t.tstatebuttoncontrol_flabel.className = "rdo_tx_" + suffix;
};

webctrls_tradiobutton.$p.setchecked = function(value)
{
   var $t = this;
   if (!$t.tstatebuttoncontrol_fchecked)
   {
      webctrls_tstatebuttoncontrol.$p.setchecked.call($t, value);
      if ($t.tstatebuttoncontrol_fchecked)
         $t.tradiobutton_updatechecked();
   }
};

webctrls_tradiobutton.$p.getordinal = function()
{
   var $t = this, $r, i;
   $r = 0;
   if ($t.tcontrol_fparent)
   {
      for (i = 0 ; i <= $t.tcontrol_fparent.tcontainercontrol_getcontrolcount() - 1 ; i++)
      {
         if ($t.tcontrol_fparent.tcontainercontrol_getcontrol(i) instanceof webctrls_tradiobutton)
         {
            if ($t.tcontrol_fparent.tcontainercontrol_getcontrol(i).tradiobutton_fgroupindex == $t.tradiobutton_fgroupindex)
            {
               $r++;
               if ($t.tcontrol_fparent.tcontainercontrol_getcontrol(i) == $t)
                  break;
            }
         }
      }
   }
   return $r;
};

webctrls_tradiobutton.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.setchecked($t.tcontrol_fcolumn.tdatacolumn_getasinteger() == $t.getordinal());
   else 
      $t.setchecked(false);
};

webctrls_tradiobutton.$p.updatedata = function()
{
   var $t = this;
   if ($t.tstatebuttoncontrol_fchecked)
      $t.tcontrol_fcolumn.tdatacolumn_setasinteger($t.getordinal());
};

// TControlBorder Class Declarations

function webctrls_tcontrolborder()
{
   var $t = this;
   Object.call($t);
   $t.tcontrolborder_fcontrol = null;
   $t.tcontrolborder_ftopleft = null;
   $t.tcontrolborder_fleft = null;
   $t.tcontrolborder_fbottomleft = null;
   $t.tcontrolborder_ftop = null;
   $t.tcontrolborder_fbottom = null;
   $t.tcontrolborder_ftopright = null;
   $t.tcontrolborder_fright = null;
   $t.tcontrolborder_fbottomright = null;
}

webctrls_tcontrolborder.create = function(instance, control)
{
   tobject.create(instance);
   instance.tcontrolborder_fcontrol = control;
   return instance;
};

webctrls_tcontrolborder.prototype = $i(tobject);
webctrls_tcontrolborder.$p = webctrls_tcontrolborder.prototype;
webctrls_tcontrolborder.$p.constructor = webctrls_tcontrolborder;

webctrls_tcontrolborder.$p.createelements = function()
{
   var $t = this;
   with (window.document)
   {
      $t.tcontrolborder_ftopleft = createElement("div");
      $t.tcontrolborder_fleft = createElement("div");
      $t.tcontrolborder_fbottomleft = createElement("div");
      $t.tcontrolborder_ftop = createElement("div");
      $t.tcontrolborder_fbottom = createElement("div");
      $t.tcontrolborder_ftopright = createElement("div");
      $t.tcontrolborder_fright = createElement("div");
      $t.tcontrolborder_fbottomright = createElement("div");
   }
};

webctrls_tcontrolborder.$p.initelements = function()
{
   var $t = this;
   $t.tcontrolborder_ftopleft.className = "brd_tl_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_ftopleft);
   $t.tcontrolborder_fleft.className = "brd_l_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_fleft);
   $t.tcontrolborder_fbottomleft.className = "brd_bl_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_fbottomleft);
   $t.tcontrolborder_ftop.className = "brd_t_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_ftop);
   $t.tcontrolborder_fbottom.className = "brd_b_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_fbottom);
   $t.tcontrolborder_ftopright.className = "brd_tr_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_ftopright);
   $t.tcontrolborder_fright.className = "brd_r_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_fright);
   $t.tcontrolborder_fbottomright.className = "brd_br_nrm";
   $t.tcontrolborder_fcontrol.tcontrol_fbase.appendChild($t.tcontrolborder_fbottomright);
};

webctrls_tcontrolborder.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.tcontrolborder_fcontrol.getclasssuffix();
   $t.tcontrolborder_ftopleft.className = "brd_tl_" + suffix;
   $t.tcontrolborder_fleft.className = "brd_l_" + suffix;
   $t.tcontrolborder_fbottomleft.className = "brd_bl_" + suffix;
   $t.tcontrolborder_ftop.className = "brd_t_" + suffix;
   $t.tcontrolborder_fbottom.className = "brd_b_" + suffix;
   $t.tcontrolborder_ftopright.className = "brd_tr_" + suffix;
   $t.tcontrolborder_fright.className = "brd_r_" + suffix;
   $t.tcontrolborder_fbottomright.className = "brd_br_" + suffix;
};

webctrls_tcontrolborder.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrolborder_fcontrol.tcontrol_getheight() > 0)
   {
      $t.tcontrolborder_fleft.style.height = webdom_pixelstostr($t.tcontrolborder_fcontrol.tcontrol_getheight() - ($t.tcontrolborder_ftopleft.offsetHeight + $t.tcontrolborder_fbottomleft.offsetHeight));
      $t.tcontrolborder_fright.style.height = webdom_pixelstostr($t.tcontrolborder_fcontrol.tcontrol_getheight() - ($t.tcontrolborder_ftopright.offsetHeight + $t.tcontrolborder_fbottomright.offsetHeight));
   }
};

webctrls_tcontrolborder.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrolborder_fcontrol.tcontrol_getwidth() > 0)
   {
      $t.tcontrolborder_ftop.style.width = webdom_pixelstostr($t.tcontrolborder_fcontrol.tcontrol_getwidth() - ($t.tcontrolborder_ftopleft.offsetWidth + $t.tcontrolborder_fbottomleft.offsetWidth));
      $t.tcontrolborder_fbottom.style.width = webdom_pixelstostr($t.tcontrolborder_fcontrol.tcontrol_getwidth() - ($t.tcontrolborder_fbottomleft.offsetWidth + $t.tcontrolborder_fbottomright.offsetWidth));
   }
};

webctrls_tcontrolborder.$p.topheight = function()
{
   var $t = this, $r;
   $r = $t.tcontrolborder_ftop.offsetHeight;
   return $r;
};

webctrls_tcontrolborder.$p.totalheight = function()
{
   var $t = this, $r;
   $r = ($t.tcontrolborder_ftop.offsetHeight + $t.tcontrolborder_fbottom.offsetHeight);
   return $r;
};

webctrls_tcontrolborder.$p.totalwidth = function()
{
   var $t = this, $r;
   $r = ($t.tcontrolborder_fleft.offsetWidth + $t.tcontrolborder_fright.offsetWidth);
   return $r;
};

// TEditControl Class Declarations

function webctrls_teditcontrol()
{
   var $t = this;
   webctrls_tinputcontrol.call($t);
   $t.teditcontrol_fkeypressed = false;
   $t.teditcontrol_fmaxlength = 0;
   $t.teditcontrol_freadonly = false;
   $t.teditcontrol_fcuthandler = null;
   $t.teditcontrol_fcopyhandler = null;
   $t.teditcontrol_fpastehandler = null;
   $t.teditcontrol_fonchange = null;
}

webctrls_teditcontrol.prototype = $i(webctrls_tinputcontrol);
webctrls_teditcontrol.$p = webctrls_teditcontrol.prototype;
webctrls_teditcontrol.$p.constructor = webctrls_teditcontrol;

webctrls_teditcontrol.$p.teditcontrol_setmaxlength = function(value)
{
   var $t = this;
   if (value != $t.teditcontrol_fmaxlength)
   {
      $t.teditcontrol_fmaxlength = value;
      if ($t.teditcontrol_fmaxlength > 0)
         $t.tinputcontrol_finput.maxLength = value;
      else 
         $t.tinputcontrol_finput.maxLength = webcore_high_int;
   }
};

webctrls_teditcontrol.$p.teditcontrol_setreadonly = function(value)
{
   var $t = this;
   if (value != $t.teditcontrol_freadonly)
   {
      $t.teditcontrol_freadonly = value;
      $t.readonlychanged();
   }
};

webctrls_teditcontrol.$p.teditcontrol_gettext = function()
{
   var $t = this, $r;
   $r = $t.tinputcontrol_finput.value;
   return $r;
};

webctrls_teditcontrol.$p.teditcontrol_settext = function(value)
{
   var $t = this;
   if (value != $t.teditcontrol_gettext())
   {
      $t.tinputcontrol_finput.value = value;
      $t.valuechanged();
   }
};

webctrls_teditcontrol.$p.cuthandler = function(event)
{
   var $t = this, $r;
   $r = $t.docut();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_teditcontrol.$p.copyhandler = function(event)
{
   var $t = this, $r;
   $r = $t.docopy();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_teditcontrol.$p.pastehandler = function(event)
{
   var $t = this, $r;
   $r = $t.dopaste();
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_teditcontrol.$p.initelement = function()
{
   var $t = this;
   webctrls_tinputcontrol.$p.initelement.call($t);
   $t.tinputcontrol_finput.maxLength = webcore_high_int;
   $t.readonlychanged();
};

webctrls_teditcontrol.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   if ($t.tinputcontrol_finput)
   {
      $t.teditcontrol_fcuthandler = webdom_seteventhandler($t.tinputcontrol_finput, "cut", function(event) { webctrls_teditcontrol.$p.cuthandler.call($t, event); });
      $t.teditcontrol_fcopyhandler = webdom_seteventhandler($t.tinputcontrol_finput, "copy", function(event) { webctrls_teditcontrol.$p.copyhandler.call($t, event); });
      $t.teditcontrol_fpastehandler = webdom_seteventhandler($t.tinputcontrol_finput, "paste", function(event) { webctrls_teditcontrol.$p.pastehandler.call($t, event); });
   }
};

webctrls_teditcontrol.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.tinputcontrol_finput)
   {
      webdom_cleareventhandler($t.tinputcontrol_finput, "cut", $t.teditcontrol_fcuthandler);
      webdom_cleareventhandler($t.tinputcontrol_finput, "copy", $t.teditcontrol_fcopyhandler);
      webdom_cleareventhandler($t.tinputcontrol_finput, "paste", $t.teditcontrol_fpastehandler);
   }
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
};

webctrls_teditcontrol.$p.readonlychanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.tcontrol_setcanedit((!$t.teditcontrol_freadonly));
   $t.tinputcontrol_finput.readOnly = $t.teditcontrol_freadonly;
};

webctrls_teditcontrol.$p.valuechanged = function()
{
};

webctrls_teditcontrol.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $t.teditcontrol_fkeypressed = false;
   $r = webctrls_tcontrol.$p.dokeydown.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r)
   {
      if ($t.tinputcontrol_finput.readOnly && (!(shiftkey || ctrlkey || altkey)) && (key == webctrls_vk_back))
         $r = false;
      else if ($t.databound())
      {
         if ((key == webctrls_vk_delete) || (key == webctrls_vk_back) || ((key == webctrls_vk_insert) && shiftkey))
            $r = $t.edit();
         else if ((!(shiftkey || ctrlkey || altkey)) && (key == webctrls_vk_escape))
         {
            $t.reset();
            $r = false;
         }
      }
   }
   return $r;
};

webctrls_teditcontrol.$p.dokeyup = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.dokeyup.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r && ($t.teditcontrol_fkeypressed || (key == webctrls_vk_delete) || (key == webctrls_vk_back)))
      $t.dochange();
   return $r;
};

webctrls_teditcontrol.$p.dokeypress = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.dokeypress.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r)
   {
      $t.teditcontrol_fkeypressed = true;
      if ($t.databound())
      {
         if (key >= " ")
            $r = $t.edit();
      }
   }
   return $r;
};

webctrls_teditcontrol.$p.dochange = function()
{
   var $t = this, tempresult;
   tempresult = true;
   if ($t.databound())
   {
      if ($t.tcontrol_fediting)
         $t.modified();
      else 
         tempresult = false;
   }
   if (tempresult)
   {
      $t.valuechanged();
      if ($t.teditcontrol_fonchange)
         $t.teditcontrol_fonchange($t);
   }
};

webctrls_teditcontrol.$p.docut = function()
{
   var $t = this, $r;
   if ($t.databound())
      $r = $t.edit();
   else 
      $r = true;
   if ($r)
      $t.teditcontrol_fkeypressed = true;
   return $r;
};

webctrls_teditcontrol.$p.docopy = function()
{
   var $t = this, $r;
   $r = true;
   return $r;
};

webctrls_teditcontrol.$p.dopaste = function()
{
   var $t = this, $r;
   if ($t.databound())
      $r = $t.edit();
   else 
      $r = true;
   if ($r)
      $t.teditcontrol_fkeypressed = true;
   return $r;
};

webctrls_teditcontrol.$p.doenter = function()
{
   var $t = this;
   if ($t.databound())
      $t.reset();
   webctrls_tcontrol.$p.doenter.call($t);
};

webctrls_teditcontrol.$p.doexit = function()
{
   var $t = this;
   if ($t.databound())
      try
      {
         $t.updaterow();
      }
      catch($e)
      {
         $t.setfocus();
         throw $e;
      }
   webctrls_tcontrol.$p.doexit.call($t);
};

webctrls_teditcontrol.$p.activechanged = function()
{
   var $t = this;
   webctrls_tcontrol.$p.activechanged.call($t);
   if ($t.databound())
   {
      if ($t.tcontrol_fcolumn.tdatacolumn_fdatatype == webdata_dtstring)
         $t.teditcontrol_setmaxlength($t.tcontrol_fcolumn.tdatacolumn_flength);
      $t.readonlychanged();
   }
};

webctrls_teditcontrol.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.teditcontrol_settext($t.tcontrol_fcolumn.tdatacolumn_getasstring());
   else 
      $t.teditcontrol_settext("");
};

webctrls_teditcontrol.$p.updatedata = function()
{
   var $t = this;
   $t.tcontrol_fcolumn.tdatacolumn_setasstring($t.teditcontrol_gettext());
};

// TEdit Class Declarations

function webctrls_tedit()
{
   var $t = this;
   webctrls_teditcontrol.call($t);
   $t.tedit_fpassword = false;
   $t.tedit_fleft = null;
   $t.tedit_fmiddle = null;
   $t.tedit_fright = null;
}

webctrls_tedit.prototype = $i(webctrls_teditcontrol);
webctrls_tedit.$p = webctrls_tedit.prototype;
webctrls_tedit.$p.constructor = webctrls_tedit;

webctrls_tedit.$p.tedit_setpassword = function(value)
{
   var $t = this, tempvalue, temptabindex;
   if (value != $t.tedit_fpassword)
   {
      if (window.document.attachEvent)
      {
         temptabindex = $t.tinputcontrol_finput.tabIndex;
         tempvalue = $t.tinputcontrol_finput.value;
         $t.tcontrol_fbase.removeChild($t.tinputcontrol_finput);
         $t.tinputcontrol_finput = null;
         if (value)
         {
            $t.tinputcontrol_finput = webctrls_tinputcontrol.$p.createinputelement.call($t);
            $t.tinputcontrol_finput.type = "password";
         }
         else 
            $t.tinputcontrol_finput = $t.createinputelement();
         webctrls_teditcontrol.$p.initelement.call($t);
         $t.seteventhandlers();
         $t.namechanged();
         $t.setelementfontname();
         $t.setelementfontcolor();
         $t.setelementfontdecoration();
         $t.setelementfontsize();
         $t.setelementfontstyle();
         $t.setelementfontweight();
         $t.tinputcontrol_finput.tabIndex = temptabindex;
         $t.tinputcontrol_finput.value = tempvalue;
         $t.setcontrolstate();
         $t.widthchanged();
      }
      else 
      {
         if (value)
            $t.tinputcontrol_finput.type = "password";
         else 
            $t.tinputcontrol_finput.type = "text";
      }
      $t.tedit_fpassword = value;
   }
};

webctrls_tedit.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createinputelement.call($t);
   $r.type = "text";
   return $r;
};

webctrls_tedit.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   with (window.document)
   {
      $t.tedit_fleft = createElement("div");
      $t.tedit_fmiddle = createElement("div");
      $t.tedit_fright = createElement("div");
   }
   return $r;
};

webctrls_tedit.$p.initelement = function()
{
   var $t = this;
   $t.tcontrol_fbase.className = "edt";
   $t.tinputcontrol_finput.className = "edt_tx_nrm";
   $t.tedit_fleft.className = "edt_l_nrm";
   $t.tcontrol_fbase.appendChild($t.tedit_fleft);
   $t.tedit_fmiddle.className = "edt_m_nrm";
   $t.tcontrol_fbase.appendChild($t.tedit_fmiddle);
   $t.tedit_fright.className = "edt_r_nrm";
   $t.tcontrol_fbase.appendChild($t.tedit_fright);
   webctrls_teditcontrol.$p.initelement.call($t);
};

webctrls_tedit.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.getclasssuffix();
   $t.tedit_fleft.className = "edt_l_" + suffix;
   $t.tedit_fmiddle.className = "edt_m_" + suffix;
   $t.tedit_fright.className = "edt_r_" + suffix;
   $t.tinputcontrol_finput.className = "edt_tx_" + suffix;
};

webctrls_tedit.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tinputcontrol_finput.style.width = webdom_pixelstostr($t.tcontrol_getwidth() - ($t.tedit_fleft.offsetWidth + $t.tedit_fright.offsetWidth));
      $t.tedit_fmiddle.style.width = webdom_pixelstostr($t.tinputcontrol_finput.offsetWidth);
   }
};

webctrls_tedit.$p.doenter = function()
{
   var $t = this;
   webctrls_teditcontrol.$p.doenter.call($t);
};

// TMemo Class Declarations

function webctrls_tmemo()
{
   var $t = this;
   webctrls_teditcontrol.call($t);
   $t.tmemo_fborder = null;
   $t.tmemo_flines = null;
   $t.tmemo_fassigning = false;
}

webctrls_tmemo.create = function(instance, aowner)
{
   instance.tmemo_fborder = webctrls_tcontrolborder.create(new webctrls_tcontrolborder(), instance);
   webctrls_tinputcontrol.create(instance, aowner);
   instance.tmemo_flines = webcore_tstrings.create(new webcore_tstringlist());
   instance.tmemo_flines.tstrings_fonchanged = function(sender) { instance.tmemo_textchanged.call(instance, sender); };
   return instance;
};

webctrls_tmemo.prototype = $i(webctrls_teditcontrol);
webctrls_tmemo.$p = webctrls_tmemo.prototype;
webctrls_tmemo.$p.constructor = webctrls_tmemo;

webctrls_tmemo.$p.tmemo_textchanged = function(sender)
{
   var $t = this;
   if (!$t.tmemo_fassigning)
      $t.teditcontrol_settext($t.tmemo_flines.gettext());
};

webctrls_tmemo.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("textarea");
   return $r;
};

webctrls_tmemo.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   $t.tmemo_fborder.createelements();
   return $r;
};

webctrls_tmemo.$p.initelement = function()
{
   var $t = this;
   $t.tcontrol_fbase.className = "mem";
   $t.tinputcontrol_finput.className = "mem_tx_nrm";
   $t.tinputcontrol_finput.wrap = "off";
   $t.tinputcontrol_finput.style.overflowX = "hidden";
   $t.tinputcontrol_finput.style.overflowY = "hidden";
   $t.tinputcontrol_finput.style.whiteSpace = "pre";
   $t.tmemo_fborder.initelements();
   webctrls_teditcontrol.$p.initelement.call($t);
};

webctrls_tmemo.$p.setcontrolstate = function()
{
   var $t = this;
   $t.tmemo_fborder.setcontrolstate();
   $t.tinputcontrol_finput.className = "mem_tx_" + $t.getclasssuffix();
};

webctrls_tmemo.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getheight() > 0)
   {
      $t.tmemo_fborder.heightchanged();
      $t.tinputcontrol_finput.style.height = webdom_pixelstostr($t.tcontrol_getheight() - $t.tmemo_fborder.totalheight());
   }
};

webctrls_tmemo.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tinputcontrol_finput.style.width = webdom_pixelstostr($t.tcontrol_getwidth() - $t.tmemo_fborder.totalwidth());
      $t.tmemo_fborder.widthchanged();
   }
};

webctrls_tmemo.$p.valuechanged = function()
{
   var $t = this;
   $t.tmemo_fassigning = true;
   try
   {
      $t.tmemo_flines.settext($t.teditcontrol_gettext());
   }
   finally
   {
      $t.tmemo_fassigning = false;
   }
};

webctrls_tmemo.$p.destroy = function()
{
   var $t = this;
   $t.tmemo_flines = tobject.free($t.tmemo_flines);
   webctrls_tcontrol.$p.destroy.call($t);
   $t.tmemo_fborder = tobject.free($t.tmemo_fborder);
};

// TListStrings Class Declarations

function webctrls_tliststrings()
{
   var $t = this;
   webcore_tstrings.call($t);
   $t.tliststrings_fselect = null;
}

webctrls_tliststrings.create = function(instance, selectelement)
{
   webcore_tstrings.create(instance);
   instance.tliststrings_fselect = selectelement;
   return instance;
};

webctrls_tliststrings.prototype = $i(webcore_tstrings);
webctrls_tliststrings.$p = webctrls_tliststrings.prototype;
webctrls_tliststrings.$p.constructor = webctrls_tliststrings;

webctrls_tliststrings.$p.createoptionelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("option");
   return $r;
};

webctrls_tliststrings.$p.getcount = function()
{
   var $t = this, $r;
   $r = $t.tliststrings_fselect.options.length;
   return $r;
};

webctrls_tliststrings.$p.addstring = function(value)
{
   var $t = this, $r, tempoption;
   tempoption = $t.createoptionelement();
   tempoption.label = value;
   tempoption.text = value;
   $t.tliststrings_fselect.add(tempoption, null);
   $r = ($t.tliststrings_fselect.length - 1);
   return $r;
};

webctrls_tliststrings.$p.deletestring = function(index)
{
   var $t = this;
   $t.checkindex(index);
   $t.tliststrings_fselect.remove(index);
};

webctrls_tliststrings.$p.deleteallstrings = function()
{
   var $t = this;
   $t.tliststrings_fselect.options.length = 0;
};

webctrls_tliststrings.$p.getstring = function(index)
{
   var $t = this, $r;
   $t.checkindex(index);
   $r = $t.tliststrings_fselect.options[index].text;
   return $r;
};

webctrls_tliststrings.$p.setstring = function(index, value)
{
   var $t = this;
   $t.checkindex(index);
   $t.tliststrings_fselect.options[index].text = value;
};

// TListControl Class Declarations

function webctrls_tlistcontrol()
{
   var $t = this;
   webctrls_tinputcontrol.call($t);
   $t.tlistcontrol_fborder = null;
   $t.tlistcontrol_fitems = null;
   $t.tlistcontrol_fchangehandler = null;
   $t.tlistcontrol_fonchange = null;
}

webctrls_tlistcontrol.create = function(instance, aowner)
{
   instance.tlistcontrol_fborder = webctrls_tcontrolborder.create(new webctrls_tcontrolborder(), instance);
   webctrls_tinputcontrol.create(instance, aowner);
   return instance;
};

webctrls_tlistcontrol.prototype = $i(webctrls_tinputcontrol);
webctrls_tlistcontrol.$p = webctrls_tlistcontrol.prototype;
webctrls_tlistcontrol.$p.constructor = webctrls_tlistcontrol;

webctrls_tlistcontrol.$p.tlistcontrol_getitemindex = function()
{
   var $t = this, $r;
   $r = $t.tinputcontrol_finput.selectedIndex;
   return $r;
};

webctrls_tlistcontrol.$p.tlistcontrol_setitemindex = function(value)
{
   var $t = this;
   $t.tinputcontrol_finput.selectedIndex = value;
};

webctrls_tlistcontrol.$p.tlistcontrol_gettext = function()
{
   var $t = this, $r;
   if ($t.tlistcontrol_fitems && ($t.tlistcontrol_getitemindex() != -1))
      $r = $t.tlistcontrol_fitems.getstring($t.tlistcontrol_getitemindex());
   else 
      $r = "";
   return $r;
};

webctrls_tlistcontrol.$p.changehandler = function(event)
{
   var $t = this, $r;
   $t.dochange();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tlistcontrol.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("select");
   $t.tlistcontrol_fitems = webctrls_tliststrings.create(new webctrls_tliststrings(), $r);
   $r.size = 2;
   return $r;
};

webctrls_tlistcontrol.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   $t.tlistcontrol_fborder.createelements();
   return $r;
};

webctrls_tlistcontrol.$p.initelement = function()
{
   var $t = this;
   $t.tcontrol_fbase.className = "lsb";
   $t.tinputcontrol_finput.className = "lsb_tx_nrm";
   $t.tlistcontrol_fborder.initelements();
   webctrls_tinputcontrol.$p.initelement.call($t);
};

webctrls_tlistcontrol.$p.setcontrolstate = function()
{
   var $t = this;
   $t.tlistcontrol_fborder.setcontrolstate();
   $t.tinputcontrol_finput.className = "lsb_tx_" + $t.getclasssuffix();
};

webctrls_tlistcontrol.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   if ($t.tinputcontrol_finput)
      $t.tlistcontrol_fchangehandler = webdom_seteventhandler($t.tinputcontrol_finput, "change", function(event) { webctrls_tlistcontrol.$p.changehandler.call($t, event); });
};

webctrls_tlistcontrol.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.tinputcontrol_finput)
      webdom_cleareventhandler($t.tinputcontrol_finput, "change", $t.tlistcontrol_fchangehandler);
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
};

webctrls_tlistcontrol.$p.dochange = function()
{
   var $t = this;
   if ($t.tlistcontrol_fonchange)
      $t.tlistcontrol_fonchange($t);
};

webctrls_tlistcontrol.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getheight() > 0)
   {
      $t.tlistcontrol_fborder.heightchanged();
      $t.tinputcontrol_finput.style.height = webdom_pixelstostr($t.tcontrol_getheight() - $t.tlistcontrol_fborder.totalheight());
   }
};

webctrls_tlistcontrol.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tinputcontrol_finput.style.width = webdom_pixelstostr($t.tcontrol_getwidth() - $t.tlistcontrol_fborder.totalwidth());
      $t.tlistcontrol_fborder.widthchanged();
   }
};

webctrls_tlistcontrol.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.tlistcontrol_setitemindex($t.tlistcontrol_fitems.indexof($t.tcontrol_fcolumn.tdatacolumn_getasstring()));
};

webctrls_tlistcontrol.$p.updatedata = function()
{
   var $t = this;
   $t.tcontrol_fcolumn.tdatacolumn_setasstring($t.tlistcontrol_gettext());
};

webctrls_tlistcontrol.$p.destroy = function()
{
   var $t = this;
   $t.tlistcontrol_fitems = tobject.free($t.tlistcontrol_fitems);
   webctrls_tcontrol.$p.destroy.call($t);
   $t.tlistcontrol_fborder = tobject.free($t.tlistcontrol_fborder);
};

// TComboListControl Class Declarations

function webctrls_tcombolistcontrol()
{
   var $t = this;
   webctrls_tlistcontrol.call($t);
   $t.tcombolistcontrol_fcombobox = null;
}

webctrls_tcombolistcontrol.create = function(instance, aowner)
{
   webctrls_tlistcontrol.create(instance, aowner);
   instance.tcombolistcontrol_fcombobox = aowner;
   return instance;
};

webctrls_tcombolistcontrol.prototype = $i(webctrls_tlistcontrol);
webctrls_tcombolistcontrol.$p = webctrls_tcombolistcontrol.prototype;
webctrls_tcombolistcontrol.$p.constructor = webctrls_tcombolistcontrol;

webctrls_tcombolistcontrol.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ((!(shiftkey || ctrlkey || altkey)) && (key == webctrls_vk_return))
   {
      $t.tcombolistcontrol_fcombobox.setfocus();
      $r = true;
   }
   else 
   {
      if ((key == webctrls_vk_escape) || (key == webctrls_vk_tab))
         $t.tcombolistcontrol_fcombobox.setfocus();
      $r = $t.tcombolistcontrol_fcombobox.dokeydown(key, shiftkey, ctrlkey, altkey);
   }
   return $r;
};

webctrls_tcombolistcontrol.$p.doclick = function()
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.doclick.call($t);
   if ($t.tlistcontrol_getitemindex() != -1)
   {
      $t.dochange();
      $t.tcombolistcontrol_fcombobox.setfocus();
   }
   return $r;
};

webctrls_tcombolistcontrol.$p.dochange = function()
{
   var $t = this;
   if ((!$t.tcombolistcontrol_fcombobox.teditcontrol_freadonly) && ($t.tlistcontrol_gettext() != $t.tcombolistcontrol_fcombobox.teditcontrol_gettext()))
   {
      $t.tcombolistcontrol_fcombobox.dochange();
      $t.tcombolistcontrol_fcombobox.teditcontrol_settext($t.tlistcontrol_gettext());
      if ($t.tcombolistcontrol_fcombobox.databound())
         $t.tcombolistcontrol_fcombobox.updatedata();
   }
};

webctrls_tcombolistcontrol.$p.doexit = function()
{
   var $t = this;
   $t.tcombolistcontrol_fcombobox.closeup();
   webctrls_tcontrol.$p.doexit.call($t);
};

// TComboBox Class Declarations

function webctrls_tcombobox()
{
   var $t = this;
   webctrls_teditcontrol.call($t);
   $t.tcombobox_flist = null;
   $t.tcombobox_fallowedit = true;
   $t.tcombobox_fitems = null;
   $t.tcombobox_fdropdowncount = 8;
   $t.tcombobox_fdroppingdown = false;
   $t.tcombobox_fdroppeddown = false;
   $t.tcombobox_fclosingup = false;
   $t.tcombobox_foncloseup = null;
   $t.tcombobox_fleft = null;
   $t.tcombobox_fmiddle = null;
   $t.tcombobox_fright = null;
   $t.tcombobox_fbutton = null;
   $t.tcombobox_fbuttonmousedownhandler = null;
   $t.tcombobox_fbuttonmouseoverhandler = null;
   $t.tcombobox_fbuttonmouseouthandler = null;
   $t.tcombobox_fbuttonmouseuphandler = null;
   $t.tcombobox_fbuttondown = false;
}

webctrls_tcombobox.create = function(instance, aowner)
{
   webctrls_tinputcontrol.create(instance, aowner);
   instance.tcombobox_flist = webctrls_tcombolistcontrol.create(new webctrls_tcombolistcontrol(), instance);
   instance.tcombobox_flist.tcontrol_ffont.assign(instance.tcontrol_ffont);
   instance.tcombobox_flist.tcontrol_setvisible(false);
   instance.tcombobox_fitems = webcore_tstrings.create(new webcore_tstringlist());
   return instance;
};

webctrls_tcombobox.prototype = $i(webctrls_teditcontrol);
webctrls_tcombobox.$p = webctrls_tcombobox.prototype;
webctrls_tcombobox.$p.constructor = webctrls_tcombobox;

webctrls_tcombobox.$p.tcombobox_createbutton = function()
{
   var $t = this;
   $t.tcombobox_fbutton = window.document.createElement("div");
   $t.tcombobox_fbuttonmousedownhandler = webdom_seteventhandler($t.tcombobox_fbutton, "mousedown", function(event) { webctrls_tcombobox.$p.tcombobox_buttonmousedownhandler.call($t, event); });
   $t.tcombobox_fbuttonmouseoverhandler = webdom_seteventhandler($t.tcombobox_fbutton, "mouseover", function(event) { webctrls_tcombobox.$p.tcombobox_buttonmouseoverhandler.call($t, event); });
   $t.tcombobox_fbuttonmouseuphandler = webdom_seteventhandler($t.tcombobox_fbutton, "mouseup", function(event) { webctrls_tcombobox.$p.tcombobox_buttonmouseuphandler.call($t, event); });
   $t.tcombobox_fbuttonmouseouthandler = webdom_seteventhandler($t.tcombobox_fbutton, "mouseout", function(event) { webctrls_tcombobox.$p.tcombobox_buttonmouseouthandler.call($t, event); });
};

webctrls_tcombobox.$p.tcombobox_buttonmousedownhandler = function(event)
{
   var $t = this, $r;
   $t.activatecontainer();
   $t.setfocus();
   $t.tcombobox_fbutton.className = "cmb_dwn";
   $t.tcombobox_fbuttondown = true;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcombobox.$p.tcombobox_buttonmouseoverhandler = function(event)
{
   var $t = this, $r;
   $t.domouseenter();
   if (!$t.tcombobox_fbuttondown)
      $t.tcombobox_fbutton.className = "cmb_hot";
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcombobox.$p.tcombobox_buttonmouseouthandler = function(event)
{
   var $t = this, $r;
   $t.domouseleave();
   $t.tcombobox_fbutton.className = "cmb_nrm";
   $t.tcombobox_fbuttondown = false;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcombobox.$p.tcombobox_buttonmouseuphandler = function(event)
{
   var $t = this, $r;
   if ($t.tcombobox_fdroppeddown)
      $t.setfocus();
   else 
      $t.dropdown();
   $t.tcombobox_fbutton.className = "cmb_hot";
   $t.tcombobox_fbuttondown = false;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tcombobox.$p.createinputelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createinputelement.call($t);
   $r.type = "text";
   return $r;
};

webctrls_tcombobox.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tinputcontrol.$p.createelement.call($t);
   with (window.document)
   {
      $t.tcombobox_fleft = createElement("div");
      $t.tcombobox_fmiddle = createElement("div");
      $t.tcombobox_fright = createElement("div");
   }
   $t.tcombobox_createbutton();
   return $r;
};

webctrls_tcombobox.$p.initelement = function()
{
   var $t = this;
   $t.tcontrol_fbase.className = "edt";
   $t.tinputcontrol_finput.className = "edt_tx_nrm";
   $t.tcombobox_fleft.className = "edt_l_nrm";
   $t.tcontrol_fbase.appendChild($t.tcombobox_fleft);
   $t.tcombobox_fmiddle.className = "edt_m_nrm";
   $t.tcontrol_fbase.appendChild($t.tcombobox_fmiddle);
   $t.tcombobox_fright.className = "edt_r_nrm";
   $t.tcontrol_fbase.appendChild($t.tcombobox_fright);
   $t.tcombobox_fbutton.className = "cmb_nrm";
   $t.tcontrol_fbase.appendChild($t.tcombobox_fbutton);
   webctrls_teditcontrol.$p.initelement.call($t);
};

webctrls_tcombobox.$p.fontchanged = function(fromparent)
{
   var $t = this;
   webctrls_tcontrol.$p.fontchanged.call($t, fromparent);
   if ($t.tcombobox_flist)
      $t.tcombobox_flist.tcontrol_ffont.assign($t.tcontrol_ffont);
};

webctrls_tcombobox.$p.setcontrolstate = function()
{
   var $t = this, suffix;
   suffix = $t.getclasssuffix();
   $t.tcombobox_fleft.className = "edt_l_" + suffix;
   $t.tcombobox_fmiddle.className = "edt_m_" + suffix;
   $t.tcombobox_fright.className = "edt_r_" + suffix;
   $t.tinputcontrol_finput.className = "edt_tx_" + suffix;
};

webctrls_tcombobox.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tinputcontrol_finput.style.width = webdom_pixelstostr($t.tcontrol_getwidth() - ($t.tcombobox_fleft.offsetWidth + $t.tcombobox_fright.offsetWidth + $t.tcombobox_fbutton.offsetWidth));
      $t.tcombobox_fmiddle.style.width = webdom_pixelstostr($t.tinputcontrol_finput.offsetWidth + $t.tcombobox_fbutton.offsetWidth);
   }
};

webctrls_tcombobox.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_teditcontrol.$p.dokeydown.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r && (!(shiftkey || ctrlkey)) && altkey && (key == webctrls_vk_down))
      $t.dropdown();
   return $r;
};

webctrls_tcombobox.$p.doenter = function()
{
   var $t = this;
   webctrls_teditcontrol.$p.doenter.call($t);
};

webctrls_tcombobox.$p.doexit = function()
{
   var $t = this;
   if (!$t.tcombobox_fdroppingdown)
      $t.closeup();
   else 
      $t.tcombobox_fdroppingdown = false;
   webctrls_teditcontrol.$p.doexit.call($t);
};

webctrls_tcombobox.$p.readonlychanged = function()
{
   var $t = this;
   webctrls_teditcontrol.$p.readonlychanged.call($t);
   if (!$t.tcombobox_fallowedit)
      $t.tinputcontrol_finput.readOnly = true;
};

webctrls_tcombobox.$p.docloseup = function()
{
   var $t = this;
   if ($t.tcombobox_foncloseup)
      $t.tcombobox_foncloseup($t);
};

webctrls_tcombobox.$p.destroy = function()
{
   var $t = this;
   $t.tcombobox_fitems = tobject.free($t.tcombobox_fitems);
   $t.tcombobox_flist = tobject.free($t.tcombobox_flist);
   webctrls_tcontrol.$p.destroy.call($t);
};

webctrls_tcombobox.$p.closeup = function()
{
   var $t = this;
   if ($t.tcombobox_fdroppeddown && (!$t.tcombobox_fclosingup))
   {
      $t.tcombobox_fclosingup = true;
      try
      {
         $t.tcombobox_flist.tcontrol_setvisible(false);
         if (webdom_getbodyelement)
            webdom_getbodyelement().removeChild($t.tcombobox_flist.tcontrol_fbase);
      }
      finally
      {
         $t.tcombobox_fdroppeddown = false;
         $t.docloseup();
         $t.tcombobox_fclosingup = false;
      }
   }
};

webctrls_tcombobox.$p.dropdown = function()
{
   var $t = this;
   if (!$t.tcombobox_fdroppeddown)
   {
      $t.tcombobox_fdroppingdown = true;
      webdom_getbodyelement().appendChild($t.tcombobox_flist.tcontrol_fbase);
      $t.tcombobox_flist.tcontrol_settop(($t.tcontrol_gettoporigin() + $t.tcontrol_getheight()));
      $t.tcombobox_flist.tcontrol_setleft($t.tcontrol_getleftorigin());
      if ($t.tcombobox_fitems.getcount() > 0)
         $t.tcombobox_flist.tcontrol_setheight((min($t.tcombobox_fdropdowncount, $t.tcombobox_fitems.getcount()) * (webctrls_textmanager.textheight("W", $t.tcombobox_flist.tcontrol_ffont) + 2)));
      else 
         $t.tcombobox_flist.tcontrol_setheight($t.tcontrol_getheight());
      $t.tcombobox_flist.tcontrol_setwidth($t.tcontrol_getwidth());
      $t.tcombobox_flist.setzindex(32768);
      $t.tcombobox_flist.tlistcontrol_fitems.assign($t.tcombobox_fitems);
      $t.tcombobox_flist.tlistcontrol_setitemindex($t.tcombobox_fitems.indexof($t.teditcontrol_gettext()));
      $t.tcombobox_flist.tcontrol_setvisible(true);
      $t.tcombobox_flist.setfocus();
      $t.tcombobox_fdroppeddown = true;
   }
};

// TLabel Class Declarations

function webctrls_tlabel()
{
   var $t = this;
   webctrls_tcontrol.call($t);
   $t.tlabel_fautosize = true;
   $t.tlabel_ffocuscontrol = null;
   $t.tlabel_ftransparent = false;
   $t.tlabel_fwordwrap = false;
   $t.tlabel_floaded = false;
}

webctrls_tlabel.prototype = $i(webctrls_tcontrol);
webctrls_tlabel.$p = webctrls_tlabel.prototype;
webctrls_tlabel.$p.constructor = webctrls_tlabel;

webctrls_tlabel.$p.tlabel_setautosize = function(value)
{
   var $t = this;
   if (value != $t.tlabel_fautosize)
   {
      $t.tlabel_fautosize = value;
      $t.updatesize();
   }
};

webctrls_tlabel.$p.tlabel_getcaption = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fbase.innerHTML;
   return $r;
};

webctrls_tlabel.$p.tlabel_setcaption = function(value)
{
   var $t = this;
   if (value != $t.tlabel_getcaption())
   {
      $t.tcontrol_fbase.innerHTML = value;
      $t.updatesize();
   }
};

webctrls_tlabel.$p.tlabel_settransparent = function(value)
{
   var $t = this;
   if (value != $t.tlabel_ftransparent)
   {
      if (value)
         $t.tcontrol_fbase.style.backgroundColor = "transparent";
      else 
         $t.resetcolor();
      $t.tlabel_ftransparent = value;
   }
};

webctrls_tlabel.$p.tlabel_setwordwrap = function(value)
{
   var $t = this;
   if (value != $t.tlabel_fwordwrap)
   {
      if (value)
         $t.tcontrol_fbase.style.whiteSpace = "pre-wrap";
      else 
         $t.tcontrol_fbase.style.whiteSpace = "pre";
      $t.tlabel_fwordwrap = value;
      $t.updatesize();
   }
};

webctrls_tlabel.$p.createelement = function()
{
   var $t = this, $r;
   $r = window.document.createElement("label");
   return $r;
};

webctrls_tlabel.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontrol.$p.initelement.call($t);
   $t.tcontrol_fbase.style.overflow = "hidden";
   $t.tcontrol_fbase.style.backgroundColor = "transparent";
   $t.tcontrol_fbase.style.whiteSpace = "pre";
};

webctrls_tlabel.$p.resettheme = function()
{
   var $t = this;
   webctrls_tcontrol.$p.resettheme.call($t);
   $t.updatesize();
};

webctrls_tlabel.$p.notification = function(sender, id, data)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.notification.call($t, sender, id, data);
   if ((id == webcore_cm_removecomp) && (sender == $t.tlabel_ffocuscontrol))
      $t.tlabel_ffocuscontrol = null;
   return $r;
};

webctrls_tlabel.$p.updatesize = function(loading)
{
   var $t = this, tempwidth, templeft;
   if (loading == null)
      loading = false;
   if ($t.tlabel_fautosize && $t.tlabel_floaded)
   {
      templeft = $t.tcontrol_getleft();
      tempwidth = $t.tcontrol_getwidth();
      if (!loading)
      {
         $t.tcontrol_fbase.style.height = "";
         if (!$t.tlabel_fwordwrap)
            $t.tcontrol_fbase.style.width = "";
      }
      if ($t.tcontrol_falignment == webctrls_tarightjustify)
         templeft += (tempwidth - $t.tcontrol_getwidth());
      $t.tcontrol_fbase.style.left = webdom_pixelstostr(templeft);
      $t.tcontrol_fbase.style.height = webdom_pixelstostr($t.tcontrol_getheight());
      $t.tcontrol_fbase.style.width = webdom_pixelstostr($t.tcontrol_getwidth());
   }
};

webctrls_tlabel.$p.loaded = function()
{
   var $t = this;
   webcore_tcomponent.$p.loaded.call($t);
   $t.tlabel_floaded = true;
   $t.updatesize(true);
};

webctrls_tlabel.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.tlabel_setcaption($t.tcontrol_fcolumn.tdatacolumn_getasstring());
   else 
      $t.tlabel_setcaption("");
};

// TImage Class Declarations

function webctrls_timage()
{
   var $t = this;
   webctrls_tcontrol.call($t);
   $t.timage_fimage = null;
   $t.timage_floaded = false;
   $t.timage_fcenter = false;
   $t.timage_fimagename = "";
   $t.timage_fstretch = false;
   $t.timage_ftransparent = false;
   $t.timage_faborthandler = null;
   $t.timage_ferrorhandler = null;
   $t.timage_floadhandler = null;
   $t.timage_fonabort = null;
   $t.timage_fonerror = null;
   $t.timage_fonload = null;
}

webctrls_timage.prototype = $i(webctrls_tcontrol);
webctrls_timage.$p = webctrls_timage.prototype;
webctrls_timage.$p.constructor = webctrls_timage;

webctrls_timage.$p.timage_setimagename = function(value)
{
   var $t = this;
   if (value != $t.timage_fimagename)
   {
      $t.timage_floaded = false;
      $t.timage_fimage.style.visibility = "hidden";
      $t.timage_fimage.src = value;
   }
};

webctrls_timage.$p.timage_setstretch = function(value)
{
   var $t = this;
   if (value != $t.timage_fstretch)
   {
      $t.timage_fstretch = value;
      $t.heightchanged();
      $t.widthchanged();
   }
};

webctrls_timage.$p.timage_settransparent = function(value)
{
   var $t = this;
   if (value != $t.timage_ftransparent)
   {
      if (value)
         $t.tcontrol_fbase.style.backgroundColor = "transparent";
      else 
         $t.resetcolor();
      $t.timage_ftransparent = value;
   }
};

webctrls_timage.$p.aborthandler = function(event)
{
   var $t = this, $r;
   $t.doabort();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_timage.$p.errorhandler = function(event)
{
   var $t = this, $r;
   $t.doerror();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_timage.$p.loadhandler = function(event)
{
   var $t = this, $r;
   $t.timage_floaded = true;
   $t.heightchanged();
   $t.widthchanged();
   $t.timage_fimage.style.visibility = "";
   $t.doload();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_timage.$p.createelement = function()
{
   var $t = this, $r;
   with (window.document)
   {
      $r = createElement("div");
      $t.timage_fimage = createElement("img");
   }
   return $r;
};

webctrls_timage.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontrol.$p.initelement.call($t);
   $t.tcontrol_fbase.style.overflow = "hidden";
   $t.timage_fimage.style.position = "absolute";
   $t.tcontrol_fbase.appendChild($t.timage_fimage);
};

webctrls_timage.$p.removeelement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase && $t.timage_fimage)
   {
      $t.tcontrol_fbase.removeChild($t.timage_fimage);
      $t.timage_fimage = null;
   }
   webctrls_tcontrol.$p.removeelement.call($t);
};

webctrls_timage.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   if ($t.timage_fimage)
   {
      $t.timage_faborthandler = webdom_seteventhandler($t.timage_fimage, "abort", function(event) { webctrls_timage.$p.aborthandler.call($t, event); });
      $t.timage_ferrorhandler = webdom_seteventhandler($t.timage_fimage, "error", function(event) { webctrls_timage.$p.errorhandler.call($t, event); });
      $t.timage_floadhandler = webdom_seteventhandler($t.timage_fimage, "load", function(event) { webctrls_timage.$p.loadhandler.call($t, event); });
   }
};

webctrls_timage.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.timage_fimage)
   {
      webdom_cleareventhandler($t.timage_fimage, "abort", $t.timage_faborthandler);
      webdom_cleareventhandler($t.timage_fimage, "error", $t.timage_ferrorhandler);
      webdom_cleareventhandler($t.timage_fimage, "load", $t.timage_floadhandler);
   }
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
};

webctrls_timage.$p.doabort = function()
{
   var $t = this;
   if ($t.timage_fonabort)
      $t.timage_fonabort($t);
};

webctrls_timage.$p.doerror = function()
{
   var $t = this;
   if ($t.timage_fonerror)
      $t.timage_fonerror($t);
};

webctrls_timage.$p.doload = function()
{
   var $t = this;
   if ($t.timage_fonload)
      $t.timage_fonload($t);
};

webctrls_timage.$p.namechanged = function()
{
   var $t = this;
   webctrls_tcontrol.$p.namechanged.call($t);
   $t.timage_fimage.name = $t.tcomponent_fname;
};

webctrls_timage.$p.heightchanged = function()
{
   var $t = this;
   if (($t.tcontrol_getheight() > 0) && $t.timage_floaded)
   {
      if ($t.timage_fstretch)
      {
         $t.timage_fimage.style.top = webdom_pixelstostr(0);
         $t.timage_fimage.style.height = webdom_pixelstostr($t.tcontrol_getheight());
      }
      else if ($t.timage_fcenter)
      {
         $t.timage_fimage.style.top = webdom_pixelstostr(floor(($t.tcontrol_getheight() - $t.timage_fimage.height) / 2));
         $t.timage_fimage.style.height = webdom_pixelstostr($t.timage_fimage.height);
      }
      else 
      {
         $t.timage_fimage.style.top = webdom_pixelstostr(0);
         $t.timage_fimage.style.height = webdom_pixelstostr($t.timage_fimage.height);
      }
   }
};

webctrls_timage.$p.widthchanged = function()
{
   var $t = this;
   if (($t.tcontrol_getwidth() > 0) && $t.timage_floaded)
   {
      if ($t.timage_fstretch)
      {
         $t.timage_fimage.style.left = webdom_pixelstostr(0);
         $t.timage_fimage.style.width = webdom_pixelstostr($t.tcontrol_getwidth());
      }
      else if ($t.timage_fcenter)
      {
         $t.timage_fimage.style.left = webdom_pixelstostr(floor(($t.tcontrol_getwidth() - $t.timage_fimage.width) / 2));
         $t.timage_fimage.style.width = webdom_pixelstostr($t.timage_fimage.width);
      }
      else 
      {
         $t.timage_fimage.style.left = webdom_pixelstostr(0);
         $t.timage_fimage.style.width = webdom_pixelstostr($t.timage_fimage.width);
      }
   }
};

webctrls_timage.$p.datachanged = function()
{
   var $t = this;
   if ($t.databound())
      $t.timage_setimagename($t.tcontrol_fcolumn.tdatacolumn_getasstring());
   else 
      $t.timage_setimagename("");
};

// TGridColumn Class Declarations

function webctrls_tgridcolumn()
{
   var $t = this;
   Object.call($t);
   $t.tgridcolumn_fgrid = null;
   $t.tgridcolumn_falignment = webctrls_taleftjustify;
   $t.tgridcolumn_fcaption = "";
   $t.tgridcolumn_fcolor = webctrls_clwhite;
   $t.tgridcolumn_fcolumn = null;
   $t.tgridcolumn_fdatacolumn = "";
   $t.tgridcolumn_fenabled = true;
   $t.tgridcolumn_findex = 0;
   $t.tgridcolumn_fsortdirection = webdata_sdnone;
   $t.tgridcolumn_fvisible = false;
   $t.tgridcolumn_fwidth = 50;
   $t.tgridcolumn_foverheader = false;
   $t.tgridcolumn_fheaderdown = false;
   $t.tgridcolumn_fsizing = false;
   $t.tgridcolumn_fcolumncells = null;
   $t.tgridcolumn_fheader = null;
   $t.tgridcolumn_fleft = null;
   $t.tgridcolumn_fmiddle = null;
   $t.tgridcolumn_fright = null;
   $t.tgridcolumn_fsizer = null;
   $t.tgridcolumn_fsort = null;
   $t.tgridcolumn_ftitle = null;
   $t.tgridcolumn_fheadermouseenterhandler = null;
   $t.tgridcolumn_fheadermouseleavehandler = null;
   $t.tgridcolumn_fheadermousedownhandler = null;
   $t.tgridcolumn_fheadermouseuphandler = null;
   $t.tgridcolumn_fsizermouseenterhandler = null;
   $t.tgridcolumn_fsizermouseleavehandler = null;
   $t.tgridcolumn_fsizermousedownhandler = null;
}

webctrls_tgridcolumn.create = function(instance, grid, columnindex)
{
   tobject.create(instance);
   instance.tgridcolumn_fgrid = grid;
   instance.tgridcolumn_findex = columnindex;
   instance.tgridcolumn_setvisible(true);
   instance.widthchanged();
   return instance;
};

webctrls_tgridcolumn.prototype = $i(tobject);
webctrls_tgridcolumn.$p = webctrls_tgridcolumn.prototype;
webctrls_tgridcolumn.$p.constructor = webctrls_tgridcolumn;

webctrls_tgridcolumn.$p.tgridcolumn_headermouseenterhandler = function(event)
{
   var $t = this, $r;
   $t.tgridcolumn_fgrid.domouseenter();
   if ((webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null) && $t.tgridcolumn_fgrid.tgrid_fallowcolumnheaderclicks)
   {
      $t.tgridcolumn_foverheader = true;
      $t.tgridcolumn_fheaderdown = false;
      $t.setheaderstate();
   }
   $r = true;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_headermouseleavehandler = function(event)
{
   var $t = this, $r;
   $t.tgridcolumn_fgrid.domouseleave();
   if ((webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null) && $t.tgridcolumn_fgrid.tgrid_fallowcolumnheaderclicks)
   {
      $t.tgridcolumn_foverheader = false;
      $t.tgridcolumn_fheaderdown = false;
      $t.setheaderstate();
   }
   $r = true;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_headermousedownhandler = function(event)
{
   var $t = this, $r;
   if ($t.tgridcolumn_fenabled && (webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null) && $t.tgridcolumn_fgrid.tgrid_fallowcolumnheaderclicks)
   {
      $t.tgridcolumn_fheaderdown = true;
      $t.setheaderstate();
   }
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_headermouseuphandler = function(event)
{
   var $t = this, $r;
   if ($t.tgridcolumn_fenabled && (webctrls_columnsizingmanager.tcolumnsizingmanager_fcolumn == null) && $t.tgridcolumn_fgrid.tgrid_fallowcolumnheaderclicks && $t.tgridcolumn_fheaderdown)
   {
      $t.tgridcolumn_fheaderdown = false;
      $t.togglesortdirection();
      $t.setheaderstate();
      $t.tgridcolumn_fgrid.docolumnheaderclick($t);
   }
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_cellmousedownhandler = function(event)
{
   var $t = this, $r, temptarget;
   if ($t.tgridcolumn_fenabled)
   {
      temptarget = webdom_geteventtarget(event);
      if (temptarget)
         $t.tgridcolumn_fgrid.moveto($t.tgridcolumn_findex, (floor(temptarget.offsetTop / temptarget.offsetHeight)));
   }
   $t.tgridcolumn_fgrid.internalfocus();
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_sizermouseenterhandler = function(event)
{
   var $t = this, $r;
   if ($t.tgridcolumn_fgrid.tgrid_fenablecolumnsizing)
      $t.tgridcolumn_fsizer.style.cursor = "e-resize";
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_sizermouseleavehandler = function(event)
{
   var $t = this, $r;
   if ($t.tgridcolumn_fgrid.tgrid_fenablecolumnsizing && (!$t.tgridcolumn_fsizing))
      $t.tgridcolumn_fsizer.style.cursor = "";
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_sizermousedownhandler = function(event)
{
   var $t = this, $r;
   $t.tgridcolumn_fsizer.style.cursor = "";
   webctrls_columnsizingmanager.beginsize($t, event.clientX);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgridcolumn.$p.tgridcolumn_setenabled = function(value)
{
   var $t = this;
   if (value != $t.tgridcolumn_fenabled)
   {
      $t.tgridcolumn_fenabled = value;
      $t.setheaderstate();
      $t.updatecellelements();
   }
};

webctrls_tgridcolumn.$p.tgridcolumn_setsortdirection = function(value)
{
   var $t = this;
   if (value != $t.tgridcolumn_fsortdirection)
   {
      $t.tgridcolumn_fsortdirection = value;
      if ($t.cansort())
      {
         $t.setheaderstate();
         $t.tgridcolumn_fgrid.updatesort($t);
      }
   }
};

webctrls_tgridcolumn.$p.tgridcolumn_setvisible = function(value)
{
   var $t = this;
   if (value != $t.tgridcolumn_fvisible)
   {
      if (value)
         $t.show();
      else 
         $t.hide();
   }
};

webctrls_tgridcolumn.$p.tgridcolumn_setwidth = function(value)
{
   var $t = this;
   if (value != $t.tgridcolumn_fwidth)
   {
      $t.tgridcolumn_fwidth = value;
      $t.widthchanged();
   }
};

webctrls_tgridcolumn.$p.createcolumnelement = function(offset)
{
   var $t = this;
   $t.tgridcolumn_fcolumncells = window.document.createElement("div");
   $t.tgridcolumn_fcolumncells.style.position = "absolute";
   $t.tgridcolumn_fcolumncells.style.left = webdom_pixelstostr(offset);
   $t.tgridcolumn_fgrid.tgrid_ftable.appendChild($t.tgridcolumn_fcolumncells);
};

webctrls_tgridcolumn.$p.removecolumnelement = function()
{
   var $t = this;
   if ($t.tgridcolumn_fgrid.tgrid_ftable && $t.tgridcolumn_fcolumncells)
   {
      $t.tgridcolumn_fgrid.tgrid_ftable.removeChild($t.tgridcolumn_fcolumncells);
      $t.tgridcolumn_fcolumncells = null;
   }
};

webctrls_tgridcolumn.$p.createheaderelement = function(offset)
{
   var $t = this;
   with (window.document)
   {
      $t.tgridcolumn_fheader = createElement("div");
      $t.tgridcolumn_fleft = createElement("div");
      $t.tgridcolumn_fmiddle = createElement("div");
      $t.tgridcolumn_fright = createElement("div");
      $t.tgridcolumn_fsort = createElement("div");
      $t.tgridcolumn_ftitle = createElement("div");
   }
   $t.tgridcolumn_fheader.style.position = "absolute";
   $t.tgridcolumn_fheader.style.height = webdom_pixelstostr($t.tgridcolumn_fgrid.tgrid_fheaders.offsetHeight);
   $t.tgridcolumn_fgrid.tgrid_fheaders.appendChild($t.tgridcolumn_fheader);
   $t.tgridcolumn_fleft.className = "grd_hdr_l_nrm";
   $t.tgridcolumn_fheader.appendChild($t.tgridcolumn_fleft);
   $t.tgridcolumn_fmiddle.className = "grd_hdr_m_nrm";
   $t.tgridcolumn_fheader.appendChild($t.tgridcolumn_fmiddle);
   $t.tgridcolumn_fright.className = "grd_hdr_r_nrm";
   $t.tgridcolumn_fheader.appendChild($t.tgridcolumn_fright);
   $t.tgridcolumn_fheader.appendChild($t.tgridcolumn_fsort);
   $t.tgridcolumn_ftitle.className = "grd_hdr_tx_nrm";
   $t.tgridcolumn_ftitle.style.textAlign = webctrls_alignmenttostr($t.tgridcolumn_falignment);
   $t.tgridcolumn_ftitle.innerHTML = $t.tgridcolumn_fcaption;
   $t.tgridcolumn_fheader.appendChild($t.tgridcolumn_ftitle);
   $t.tgridcolumn_fheadermouseenterhandler = webdom_seteventhandler($t.tgridcolumn_fheader, "mouseover", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_headermouseenterhandler.call($t, event); });
   $t.tgridcolumn_fheadermouseleavehandler = webdom_seteventhandler($t.tgridcolumn_fheader, "mouseout", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_headermouseleavehandler.call($t, event); });
   $t.tgridcolumn_fheadermousedownhandler = webdom_seteventhandler($t.tgridcolumn_fheader, "mousedown", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_headermousedownhandler.call($t, event); });
   $t.tgridcolumn_fheadermouseuphandler = webdom_seteventhandler($t.tgridcolumn_fheader, "mouseup", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_headermouseuphandler.call($t, event); });
};

webctrls_tgridcolumn.$p.removeheaderelement = function()
{
   var $t = this;
   if ($t.tgridcolumn_fheader)
   {
      webdom_cleareventhandler($t.tgridcolumn_fheader, "mouseover", $t.tgridcolumn_fheadermouseenterhandler);
      webdom_cleareventhandler($t.tgridcolumn_fheader, "mouseout", $t.tgridcolumn_fheadermouseleavehandler);
      webdom_cleareventhandler($t.tgridcolumn_fheader, "mousedown", $t.tgridcolumn_fheadermousedownhandler);
      webdom_cleareventhandler($t.tgridcolumn_fheader, "mouseup", $t.tgridcolumn_fheadermouseuphandler);
      $t.tgridcolumn_fgrid.tgrid_fheaders.removeChild($t.tgridcolumn_fheader);
      $t.tgridcolumn_fheader = null;
   }
};

webctrls_tgridcolumn.$p.createsizerelement = function()
{
   var $t = this;
   $t.tgridcolumn_fsizer = window.document.createElement("div");
   $t.tgridcolumn_fsizer.style.position = "absolute";
   $t.tgridcolumn_fgrid.tgrid_fheaders.appendChild($t.tgridcolumn_fsizer);
   $t.tgridcolumn_fsizermouseenterhandler = webdom_seteventhandler($t.tgridcolumn_fsizer, "mouseover", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_sizermouseenterhandler.call($t, event); });
   $t.tgridcolumn_fsizermouseleavehandler = webdom_seteventhandler($t.tgridcolumn_fsizer, "mouseout", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_sizermouseleavehandler.call($t, event); });
   $t.tgridcolumn_fsizermousedownhandler = webdom_seteventhandler($t.tgridcolumn_fsizer, "mousedown", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_sizermousedownhandler.call($t, event); });
};

webctrls_tgridcolumn.$p.updatesizerelement = function()
{
   var $t = this;
   $t.tgridcolumn_fsizer.style.height = webdom_pixelstostr($t.tgridcolumn_fheader.offsetHeight);
   $t.tgridcolumn_fsizer.style.left = webdom_pixelstostr(($t.tgridcolumn_fcolumncells.offsetLeft + $t.tgridcolumn_fcolumncells.offsetWidth) - (floor($t.sizerwidth() / 2)));
   $t.tgridcolumn_fsizer.style.width = webdom_pixelstostr($t.sizerwidth());
};

webctrls_tgridcolumn.$p.removesizerelement = function()
{
   var $t = this;
   if ($t.tgridcolumn_fgrid.tgrid_fheaders && $t.tgridcolumn_fsizer)
   {
      webdom_cleareventhandler($t.tgridcolumn_fsizer, "mouseover", $t.tgridcolumn_fsizermouseenterhandler);
      webdom_cleareventhandler($t.tgridcolumn_fsizer, "mouseout", $t.tgridcolumn_fsizermouseleavehandler);
      webdom_cleareventhandler($t.tgridcolumn_fsizer, "mousedown", $t.tgridcolumn_fsizermousedownhandler);
      $t.tgridcolumn_fgrid.tgrid_fheaders.removeChild($t.tgridcolumn_fsizer);
      $t.tgridcolumn_fsizer = null;
   }
};

webctrls_tgridcolumn.$p.setcellelement = function(cell)
{
   var $t = this;
   cell.style.backgroundColor = webdom_colortostr($t.tgridcolumn_fcolor);
   cell.style.textAlign = webctrls_alignmenttostr($t.tgridcolumn_falignment);
   cell.style.textDecoration = webctrls_fontdecorationtostr($t.tgridcolumn_fgrid.tcontrol_ffont.tfont_fdecoration);
};

webctrls_tgridcolumn.$p.createcellelement = function(rowindex)
{
   var $t = this, $r;
   $r = window.document.createElement("div");
   $r.className = "grd_cell_" + $t.getcellclasssuffix(rowindex, false);
   $t.setcellelement($r);
   if ($t.tgridcolumn_fcolumncells.childNodes.length > rowindex)
      $t.tgridcolumn_fcolumncells.insertBefore($r, $t.tgridcolumn_fcolumncells.childNodes[rowindex]);
   else 
      $t.tgridcolumn_fcolumncells.appendChild($r);
   webdom_seteventhandler($r, "mousedown", function(event) { webctrls_tgridcolumn.$p.tgridcolumn_cellmousedownhandler.call($t, event); });
   return $r;
};

webctrls_tgridcolumn.$p.createcellelements = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgridcolumn_fgrid.tgrid_frowcount - 1 ; i++)
      $t.createcellelement(i);
};

webctrls_tgridcolumn.$p.updatecellelement = function(rowindex)
{
   var $t = this, tempcell;
   tempcell = $t.tgridcolumn_fcolumncells.childNodes[rowindex];
   tempcell.className = "grd_cell_" + $t.getcellclasssuffix(rowindex, false);
   $t.setcellelement(tempcell);
};

webctrls_tgridcolumn.$p.updatecellelements = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgridcolumn_fgrid.tgrid_frowcount - 1 ; i++)
      $t.updatecellelement(i);
};

webctrls_tgridcolumn.$p.removecellelement = function(rowindex)
{
   var $t = this;
   $t.tgridcolumn_fcolumncells.removeChild($t.tgridcolumn_fcolumncells.childNodes[rowindex]);
};

webctrls_tgridcolumn.$p.setcellcount = function(value)
{
   var $t = this, i;
   if (value > $t.tgridcolumn_fcolumncells.childNodes.length)
   {
      for (i = $t.tgridcolumn_fcolumncells.childNodes.length ; i <= value - 1 ; i++)
         $t.createcellelement(i);
   }
   else if (value < $t.tgridcolumn_fcolumncells.childNodes.length)
   {
      for (i = $t.tgridcolumn_fcolumncells.childNodes.length - 1 ; i >= value ; i--)
         $t.removecellelement(i);
   }
};

webctrls_tgridcolumn.$p.getheaderclasssuffix = function()
{
   var $t = this, $r;
   if ($t.tgridcolumn_fenabled)
   {
      if ($t.tgridcolumn_fheaderdown)
         $r = "psh";
      else if ($t.tgridcolumn_foverheader)
         $r = "hot";
      else 
         $r = "nrm";
   }
   else 
      $r = "dsb";
   return $r;
};

webctrls_tgridcolumn.$p.setheaderstate = function()
{
   var $t = this, suffix, tempoffset;
   suffix = $t.getheaderclasssuffix();
   $t.tgridcolumn_fleft.className = "grd_hdr_l_" + suffix;
   $t.tgridcolumn_fmiddle.className = "grd_hdr_m_" + suffix;
   $t.tgridcolumn_fright.className = "grd_hdr_r_" + suffix;
   $t.tgridcolumn_ftitle.style.left = "";
   if ($t.tgridcolumn_fsortdirection != webdata_sdnone)
   {
      switch ($t.tgridcolumn_fsortdirection)
      {
         case webdata_sdascending:
         {
            $t.tgridcolumn_fsort.className = "grd_hdr_a_" + suffix;
            break;
         }
         case webdata_sddescending:
         {
            $t.tgridcolumn_fsort.className = "grd_hdr_d_" + suffix;
            break;
         }
      };
      tempoffset = ($t.tgridcolumn_fsort.offsetLeft + $t.tgridcolumn_fsort.offsetWidth);
   }
   else 
   {
      $t.tgridcolumn_fsort.className = "";
      tempoffset = 0;
   }
   $t.tgridcolumn_ftitle.style.left = webdom_pixelstostr(tempoffset + $t.tgridcolumn_ftitle.offsetLeft);
   $t.tgridcolumn_ftitle.className = "grd_hdr_tx_" + suffix;
};

webctrls_tgridcolumn.$p.getcellclasssuffix = function(rowindex, over)
{
   var $t = this, $r;
   if (over)
      $r = "hot";
   else if (($t.tgridcolumn_fgrid.tgrid_falwaysshowselection || $t.tgridcolumn_fgrid.tcontrol_ffocused) && ($t.tgridcolumn_fgrid.tgrid_frowindex == rowindex) && ($t.tgridcolumn_fgrid.tgrid_frowselect || ($t.tgridcolumn_fgrid.tgrid_fcolumnindex == $t.tgridcolumn_findex)))
      $r = "fcs";
   else if ($t.tgridcolumn_fenabled)
      $r = "nrm";
   else 
      $r = "dsb";
   return $r;
};

webctrls_tgridcolumn.$p.setcellstate = function(rowindex, over)
{
   var $t = this, suffix, tempcell;
   if (over == null)
      over = false;
   suffix = $t.getcellclasssuffix(rowindex, over);
   tempcell = $t.tgridcolumn_fcolumncells.childNodes[rowindex];
   if (suffix == "nrm")
      tempcell.style.backgroundColor = webdom_colortostr($t.tgridcolumn_fcolor);
   else 
      tempcell.style.backgroundColor = "";
   tempcell.className = "grd_cell_" + suffix;
};

webctrls_tgridcolumn.$p.makecolumnvisible = function()
{
   var $t = this;
   if (($t.tgridcolumn_fcolumncells.offsetLeft + $t.tgridcolumn_fcolumncells.offsetWidth) > ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft + $t.tgridcolumn_fgrid.tgrid_ftable.clientWidth))
   {
      if ($t.tgridcolumn_fcolumncells.offsetWidth <= $t.tgridcolumn_fgrid.tgrid_ftable.clientWidth)
         $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft = ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft + (($t.tgridcolumn_fcolumncells.offsetLeft + $t.tgridcolumn_fcolumncells.offsetWidth) - ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft + $t.tgridcolumn_fgrid.tgrid_ftable.clientWidth)));
      else 
         $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft = ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft + ($t.tgridcolumn_fcolumncells.offsetLeft - $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft));
   }
   else if ($t.tgridcolumn_fcolumncells.offsetLeft < $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft)
      $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft = ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft - ($t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft - $t.tgridcolumn_fcolumncells.offsetLeft));
};

webctrls_tgridcolumn.$p.makecellvisible = function(rowindex)
{
   var $t = this, tempcell;
   $t.makecolumnvisible();
   tempcell = $t.tgridcolumn_fcolumncells.childNodes[rowindex];
   if ((tempcell.offsetTop + tempcell.offsetHeight) > ($t.tgridcolumn_fgrid.tgrid_ftable.scrollTop + $t.tgridcolumn_fgrid.tgrid_ftable.clientHeight))
      $t.tgridcolumn_fgrid.tgrid_ftable.scrollTop = ($t.tgridcolumn_fgrid.tgrid_ftable.scrollTop + ((tempcell.offsetTop + tempcell.offsetHeight) - ($t.tgridcolumn_fgrid.tgrid_ftable.scrollTop + $t.tgridcolumn_fgrid.tgrid_ftable.clientHeight)));
   else if (tempcell.offsetTop < $t.tgridcolumn_fgrid.tgrid_ftable.scrollTop)
      $t.tgridcolumn_fgrid.tgrid_ftable.scrollTop = ($t.tgridcolumn_fgrid.tgrid_ftable.scrollTop - ($t.tgridcolumn_fgrid.tgrid_ftable.scrollTop - tempcell.offsetTop));
};

webctrls_tgridcolumn.$p.widthchanged = function()
{
   var $t = this, tempwidth;
   if ($t.tgridcolumn_fvisible && ($t.tgridcolumn_fwidth > 0))
   {
      $t.tgridcolumn_fcolumncells.style.width = webdom_pixelstostr($t.tgridcolumn_fwidth);
      if ($t.tgridcolumn_fheader)
      {
         $t.tgridcolumn_fheader.style.width = webdom_pixelstostr($t.tgridcolumn_fwidth);
         $t.tgridcolumn_ftitle.style.width = webdom_pixelstostr(max(0, $t.tgridcolumn_fwidth - ($t.tgridcolumn_ftitle.offsetLeft + $t.tgridcolumn_fright.offsetWidth)));
         tempwidth = ($t.tgridcolumn_fwidth - ($t.tgridcolumn_fleft.offsetWidth + $t.tgridcolumn_fright.offsetWidth));
         if ($t.tgridcolumn_findex == 0)
         {
            $t.tgridcolumn_fmiddle.style.left = webdom_pixelstostr(0);
            $t.tgridcolumn_fmiddle.style.width = webdom_pixelstostr($t.tgridcolumn_fleft.offsetWidth + tempwidth);
         }
         else 
         {
            $t.tgridcolumn_fmiddle.style.left = "";
            $t.tgridcolumn_fmiddle.style.width = webdom_pixelstostr(tempwidth);
         }
      }
      $t.tgridcolumn_fgrid.updatecolumns($t.tgridcolumn_findex);
   }
};

webctrls_tgridcolumn.$p.updateposition = function()
{
   var $t = this, tempoffset;
   if ($t.tgridcolumn_fvisible)
   {
      tempoffset = $t.tgridcolumn_fgrid.getcolumnoffset($t.tgridcolumn_findex);
      $t.tgridcolumn_fcolumncells.style.left = webdom_pixelstostr(tempoffset);
      if ($t.tgridcolumn_fgrid.tgrid_fshowcolumnheaders)
         $t.tgridcolumn_fheader.style.left = webdom_pixelstostr(tempoffset);
      if ($t.tgridcolumn_fgrid.tgrid_fenablecolumnsizing)
         $t.updatesizerelement();
   }
};

webctrls_tgridcolumn.$p.scrollleft = function()
{
   var $t = this, $r;
   $r = ($t.tgridcolumn_fcolumncells.offsetLeft - $t.tgridcolumn_fgrid.tgrid_ftable.scrollLeft);
   return $r;
};

webctrls_tgridcolumn.$p.sizerwidth = function()
{
   var $t = this, $r;
   if ($t.tgridcolumn_fgrid.tgrid_fshowcolumnheaders)
      $r = (($t.tgridcolumn_fleft.offsetWidth + $t.tgridcolumn_fright.offsetWidth) * 2);
   else 
      $r = 8;
   return $r;
};

webctrls_tgridcolumn.$p.bind = function()
{
   var $t = this;
   if ($t.tgridcolumn_fgrid.databound() && ($t.tgridcolumn_fdatacolumn != ""))
   {
      $t.tgridcolumn_fcolumn = $t.tgridcolumn_fgrid.tcontrol_fdataset.tdataset_fcolumns.tdatacolumns_getcolumn1($t.tgridcolumn_fdatacolumn);
      if ($t.tgridcolumn_fcolumn == null)
         throw new Error("Column \"" + $t.tgridcolumn_fdatacolumn + "\" not found");
   }
   else 
      $t.tgridcolumn_fcolumn = null;
};

webctrls_tgridcolumn.$p.cansort = function()
{
   var $t = this, $r;
   $r = ($t.tgridcolumn_fgrid.databound() && ($t.tgridcolumn_fcolumn != null));
   return $r;
};

webctrls_tgridcolumn.$p.togglesortdirection = function()
{
   var $t = this;
   if ($t.cansort())
   {
      switch ($t.tgridcolumn_fsortdirection)
      {
         case webdata_sdnone:
         {
            $t.tgridcolumn_fsortdirection = webdata_sdascending;
            break;
         }
         case webdata_sdascending:
         {
            $t.tgridcolumn_fsortdirection = webdata_sddescending;
            break;
         }
         case webdata_sddescending:
         {
            $t.tgridcolumn_fsortdirection = webdata_sdnone;
            break;
         }
      };
      $t.tgridcolumn_fgrid.updatesort($t);
   }
};

webctrls_tgridcolumn.$p.destroy = function()
{
   var $t = this;
   $t.removecolumnelement();
   tobject.$p.destroy.call($t);
};

webctrls_tgridcolumn.$p.show = function()
{
   var $t = this, tempoffset;
   if (!$t.tgridcolumn_fvisible)
   {
      tempoffset = $t.tgridcolumn_fgrid.getcolumnoffset($t.tgridcolumn_findex);
      $t.createcolumnelement(tempoffset);
      if ($t.tgridcolumn_fgrid.tgrid_fshowcolumnheaders)
         $t.createheaderelement(tempoffset);
      if ($t.tgridcolumn_fgrid.tgrid_fenablecolumnsizing)
         $t.createsizerelement();
      $t.createcellelements();
      $t.tgridcolumn_fvisible = true;
      $t.tgridcolumn_fgrid.incvisiblecolumncount();
      $t.tgridcolumn_fgrid.updatecolumns($t.tgridcolumn_findex);
   }
};

webctrls_tgridcolumn.$p.hide = function()
{
   var $t = this;
   if ($t.tgridcolumn_fvisible)
   {
      if ($t.tgridcolumn_fcolumncells)
      {
         $t.tgridcolumn_fgrid.tgrid_ftable.removeChild($t.tgridcolumn_fcolumncells);
         $t.tgridcolumn_fcolumncells = null;
      }
      $t.tgridcolumn_fvisible = false;
      $t.tgridcolumn_fgrid.decvisiblecolumncount();
      $t.tgridcolumn_fgrid.updatecolumns($t.tgridcolumn_findex);
   }
};

// TGridColumns Class Declarations

function webctrls_tgridcolumns()
{
   var $t = this;
   Object.call($t);
   $t.tgridcolumns_fgrid = null;
   $t.tgridcolumns_flist = null;
}

webctrls_tgridcolumns.create = function(instance, grid)
{
   tobject.create(instance);
   instance.tgridcolumns_fgrid = grid;
   instance.tgridcolumns_flist = webcore_tobjectlist.create(new webcore_tobjectlist());
   return instance;
};

webctrls_tgridcolumns.prototype = $i(tobject);
webctrls_tgridcolumns.$p = webctrls_tgridcolumns.prototype;
webctrls_tgridcolumns.$p.constructor = webctrls_tgridcolumns;

webctrls_tgridcolumns.$p.tgridcolumns_getcount = function()
{
   var $t = this, $r;
   $r = $t.tgridcolumns_flist.tobjectlist_fcount;
   return $r;
};

webctrls_tgridcolumns.$p.tgridcolumns_getcolumn = function(index)
{
   var $t = this, $r;
   if ((index >= 0) && (index < $t.tgridcolumns_flist.tobjectlist_fcount))
      $r = $t.tgridcolumns_flist.getobject(index);
   else 
      throw new Error("Column index " + inttostr(index) + " out of bounds");
   return $r;
};

webctrls_tgridcolumns.$p.destroy = function()
{
   var $t = this;
   $t.tgridcolumns_flist = tobject.free($t.tgridcolumns_flist);
   tobject.$p.destroy.call($t);
};

// TGrid Class Declarations

function webctrls_tgrid()
{
   var $t = this;
   webctrls_tcontrol.call($t);
   $t.tgrid_fborder = null;
   $t.tgrid_fcolumns = null;
   $t.tgrid_fsortcolumns = null;
   $t.tgrid_fallowcolumnheaderclicks = false;
   $t.tgrid_fallowdeletes = true;
   $t.tgrid_fallowinserts = true;
   $t.tgrid_falwaysshowselection = false;
   $t.tgrid_fenablecolumnsizing = true;
   $t.tgrid_frowcount = 0;
   $t.tgrid_fvisiblecolumncount = 0;
   $t.tgrid_fvisiblerowcount = 0;
   $t.tgrid_fcolumnindex = 0;
   $t.tgrid_frowindex = 0;
   $t.tgrid_flastrowindex = 0;
   $t.tgrid_frowselect = false;
   $t.tgrid_fshowcolumnheaders = true;
   $t.tgrid_foncolumnheaderclick = null;
   $t.tgrid_ffocusing = false;
   $t.tgrid_fcolumnswidth = 0;
   $t.tgrid_fheaders = null;
   $t.tgrid_fblankheader = null;
   $t.tgrid_fblankleft = null;
   $t.tgrid_fblankmiddle = null;
   $t.tgrid_ftable = null;
   $t.tgrid_fheadersmousedownhandler = null;
   $t.tgrid_ftablemousedownhandler = null;
   $t.tgrid_ftablescrollhandler = null;
}

webctrls_tgrid.create = function(instance, aowner)
{
   instance.tgrid_fborder = webctrls_tcontrolborder.create(new webctrls_tcontrolborder(), instance);
   webctrls_tcontrol.create(instance, aowner);
   instance.tgrid_fcolumns = webctrls_tgridcolumns.create(new webctrls_tgridcolumns(), instance);
   instance.tgrid_fsortcolumns = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
   instance.createcolumnheaders();
   return instance;
};

webctrls_tgrid.prototype = $i(webctrls_tcontrol);
webctrls_tgrid.$p = webctrls_tgrid.prototype;
webctrls_tgrid.$p.constructor = webctrls_tgrid;

webctrls_tgrid.$p.tgrid_headersmousedownhandler = function(event)
{
   var $t = this, $r;
   $t.internalfocus();
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgrid.$p.tgrid_tablemousedownhandler = function(event)
{
   var $t = this, $r;
   $t.internalfocus();
   $r = false;
   webdom_canceleventbubble(event);
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tgrid.$p.tgrid_tablescrollhandler = function(event)
{
   var $t = this, $r;
   if ($t.tgrid_fshowcolumnheaders)
   {
      $t.tgrid_updateblankheader();
      $t.tgrid_fheaders.scrollLeft = $t.tgrid_ftable.scrollLeft;
   }
   $r = true;
   return $r;
};

webctrls_tgrid.$p.tgrid_getcolumncount = function()
{
   var $t = this, $r;
   $r = $t.tgrid_fcolumns.tgridcolumns_getcount();
   return $r;
};

webctrls_tgrid.$p.tgrid_getrowheight = function()
{
   var $t = this, $r;
   if ($t.tgrid_fblankmiddle)
      $r = $t.tgrid_fblankmiddle.offsetHeight;
   else 
      $r = 0;
   return $r;
};

webctrls_tgrid.$p.tgrid_setalwaysshowselection = function(value)
{
   var $t = this;
   if (value != $t.tgrid_falwaysshowselection)
   {
      $t.tgrid_falwaysshowselection = value;
      if ($t.tgrid_frowcount > 0)
         $t.setrowstate($t.tgrid_frowindex);
   }
};

webctrls_tgrid.$p.tgrid_setenablecolumnsizing = function(value)
{
   var $t = this;
   if (value != $t.tgrid_fenablecolumnsizing)
   {
      $t.tgrid_fenablecolumnsizing = value;
      if ($t.tgrid_fshowcolumnheaders && $t.tgrid_fenablecolumnsizing)
         $t.createcolumnsizers();
      else 
         $t.removecolumnsizers();
   }
};

webctrls_tgrid.$p.tgrid_setrowselect = function(value)
{
   var $t = this;
   if (value != $t.tgrid_frowselect)
   {
      $t.tgrid_frowselect = value;
      if (value)
         $t.tgrid_fcolumnindex = 0;
      $t.setrowstate($t.tgrid_frowindex);
   }
};

webctrls_tgrid.$p.tgrid_setshowcolumnheaders = function(value)
{
   var $t = this;
   if (value != $t.tgrid_fshowcolumnheaders)
   {
      if (value)
         $t.createcolumnheaders();
      else 
         $t.removecolumnheaders();
      $t.tgrid_fshowcolumnheaders = value;
      $t.heightchanged();
   }
};

webctrls_tgrid.$p.tgrid_updateblankheader = function()
{
   var $t = this, tempwidth;
   $t.tgrid_fblankheader.style.left = webdom_pixelstostr($t.tgrid_fcolumnswidth);
   tempwidth = (($t.tgrid_ftable.scrollLeft + $t.tgrid_ftable.offsetWidth) - $t.tgrid_fcolumnswidth);
   if (tempwidth > 0)
   {
      $t.tgrid_fblankheader.style.width = webdom_pixelstostr(($t.tgrid_ftable.scrollLeft + $t.tgrid_ftable.offsetWidth) - $t.tgrid_fcolumnswidth);
      if ($t.tgrid_fblankheader.offsetWidth >= $t.tgrid_fblankleft.offsetWidth)
         $t.tgrid_fblankmiddle.style.width = webdom_pixelstostr($t.tgrid_fblankheader.offsetWidth - $t.tgrid_fblankleft.offsetWidth);
      else 
         $t.tgrid_fblankmiddle.style.width = webdom_pixelstostr(0);
   }
   else 
      $t.tgrid_fblankheader.style.width = webdom_pixelstostr(0);
};

webctrls_tgrid.$p.tgrid_updaterowcount = function()
{
   var $t = this, i;
   $t.tgrid_frowcount = $t.tcontrol_fdataset.tdataset_getrowcount();
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).setcellcount($t.tgrid_frowcount);
   }
};

webctrls_tgrid.$p.tgrid_loadrow = function(arow)
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
      {
         if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fcolumn)
            $t.setcell(i, arow, $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fcolumn.tdatacolumn_getasstring());
      }
   }
};

webctrls_tgrid.$p.createelement = function()
{
   var $t = this, $r;
   with (window.document)
   {
      $r = createElement("div");
      $t.tgrid_ftable = createElement("div");
   }
   $t.tgrid_fborder.createelements();
   return $r;
};

webctrls_tgrid.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontrol.$p.initelement.call($t);
   $t.tcontrol_fbase.className = "grd";
   $t.tcontrol_fbase.style.outlineWidth = webdom_pixelstostr(0);
   $t.tgrid_fborder.initelements();
   $t.tgrid_ftable.className = "grd_tbl";
   $t.tgrid_ftable.style.overflowX = "auto";
   $t.tgrid_ftable.style.overflowY = "auto";
   $t.tcontrol_fbase.appendChild($t.tgrid_ftable);
   $t.tgrid_ftablemousedownhandler = webdom_seteventhandler($t.tgrid_ftable, "mousedown", function(event) { webctrls_tgrid.$p.tgrid_tablemousedownhandler.call($t, event); });
   $t.tgrid_ftablescrollhandler = webdom_seteventhandler($t.tgrid_ftable, "scroll", function(event) { webctrls_tgrid.$p.tgrid_tablescrollhandler.call($t, event); });
   $t.tcontrol_fdisplay = $t.tgrid_ftable;
};

webctrls_tgrid.$p.removeelement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase)
   {
      if ($t.tgrid_ftable)
      {
         $t.tcontrol_fbase.removeChild($t.tgrid_ftable);
         $t.tgrid_ftable = null;
      }
   }
   webctrls_tcontrol.$p.removeelement.call($t);
};

webctrls_tgrid.$p.getclasssuffix = function()
{
   var $t = this, $r;
   if ($t.tcontrol_fover)
      $r = "hot";
   else if ($t.tcontrol_ffocused)
      $r = "fcs";
   else 
      $r = "nrm";
   return $r;
};

webctrls_tgrid.$p.setcontrolstate = function()
{
   var $t = this;
   $t.tgrid_fborder.setcontrolstate();
};

webctrls_tgrid.$p.fontchanged = function(fromparent)
{
   var $t = this, i;
   webctrls_tcontrol.$p.fontchanged.call($t, fromparent);
   if ($t.tgrid_fcolumns)
   {
      for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
      {
         if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
            $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).updatecellelements();
      }
   }
};

webctrls_tgrid.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getheight() > 0)
   {
      $t.tgrid_fborder.heightchanged();
      if ($t.tgrid_fheaders)
      {
         $t.tgrid_fheaders.style.top = webdom_pixelstostr($t.tgrid_fborder.topheight());
         $t.tgrid_ftable.style.top = webdom_pixelstostr($t.tgrid_fborder.topheight() + $t.tgrid_fheaders.offsetHeight);
         $t.tgrid_ftable.style.height = webdom_pixelstostr($t.tcontrol_getheight() - ($t.tgrid_fborder.totalheight() + $t.tgrid_fheaders.offsetHeight));
      }
      else 
      {
         $t.tgrid_ftable.style.top = webdom_pixelstostr($t.tgrid_fborder.topheight());
         $t.tgrid_ftable.style.height = webdom_pixelstostr($t.tcontrol_getheight() - $t.tgrid_fborder.totalheight());
      }
      $t.tgrid_fvisiblerowcount = (floor($t.tgrid_ftable.clientHeight / $t.tgrid_getrowheight()));
   }
};

webctrls_tgrid.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tgrid_fborder.widthchanged();
      $t.tgrid_fheaders.style.width = webdom_pixelstostr(($t.tcontrol_getwidth() - $t.tgrid_fborder.totalwidth()));
      $t.tgrid_ftable.style.width = webdom_pixelstostr($t.tgrid_fheaders.offsetWidth);
      if ($t.tgrid_fcolumns.tgridcolumns_getcount() == 0)
      {
         if ($t.tgrid_fshowcolumnheaders)
            $t.tgrid_updateblankheader();
      }
      else 
         $t.updatecolumns(0);
   }
};

webctrls_tgrid.$p.settabindex = function(value)
{
   var $t = this;
   $t.tcontrol_ftarget.tabIndex = (value + 1);
};

webctrls_tgrid.$p.internalfocus = function()
{
   var $t = this;
   if ($t.tcontrol_ffocused && $t.tgrid_ftable.attachEvent)
      $t.tgrid_ffocusing = true;
   else 
      $t.setfocus();
};

webctrls_tgrid.$p.dokeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   $r = webctrls_tcontrol.$p.dokeydown.call($t, key, shiftkey, ctrlkey, altkey);
   if ($r)
   {
      $r = false;
      if (!(shiftkey || ctrlkey || altkey))
      {
         switch (key)
         {
            case webctrls_vk_down:
            {
               if ($t.databound() && $t.tgrid_fallowinserts && (($t.tgrid_frowcount == 0) || (($t.tgrid_frowcount > 0) && ($t.tgrid_frowindex == ($t.tgrid_frowcount - 1)))))
               {
                  if ($t.tcontrol_fdataset.tdataset_fstate != webdata_dsinsert)
                     $t.tcontrol_fdataset.insert();
               }
               else 
                  $t.nextrow();
               break;
            }
            case webctrls_vk_escape:
            {
               if ($t.databound() && $t.tcontrol_fdataset.tdataset_getediting())
                  $t.tcontrol_fdataset.cancel();
               break;
            }
            case webctrls_vk_insert:
            {
               if ($t.databound() && $t.tgrid_fallowinserts)
                  $t.tcontrol_fdataset.insert();
               break;
            }
            case webctrls_vk_up:
            {
               $t.priorrow();
               break;
            }
            case webctrls_vk_next:
            {
               $t.nextpage();
               break;
            }
            case webctrls_vk_prior:
            {
               $t.priorpage();
               break;
            }
            case webctrls_vk_home:
            {
               $t.firstcolumn();
               break;
            }
            case webctrls_vk_end:
            {
               $t.lastcolumn();
               break;
            }
            case webctrls_vk_right:
            {
               $t.nextcolumn();
               break;
            }
            case webctrls_vk_left:
            {
               $t.priorcolumn();
               break;
            }
            default:
            {
               $r = true;
               break;
            }
         };
      }
      else if (ctrlkey && (!(shiftkey || altkey)))
      {
         switch (key)
         {
            case webctrls_vk_delete:
            {
               if ($t.databound() && $t.tgrid_fallowdeletes && ($t.tgrid_frowcount > 0))
                  $t.tcontrol_fdataset.$delete();
               break;
            }
            case webctrls_vk_home:
            {
               $t.firstrow();
               break;
            }
            case webctrls_vk_end:
            {
               $t.lastrow();
               break;
            }
            default:
            {
               $r = true;
               break;
            }
         };
      }
      else if (shiftkey && (!(ctrlkey || altkey)))
      {
         switch (key)
         {
            case webctrls_vk_insert:
            {
               if ($t.databound() && $t.tgrid_fallowinserts)
                  $t.tcontrol_fdataset.insert();
               break;
            }
            default:
            {
               $r = true;
               break;
            }
         };
      }
      else 
         $r = true;
   }
   return $r;
};

webctrls_tgrid.$p.doenter = function()
{
   var $t = this;
   if ($t.tgrid_ffocusing)
      $t.tgrid_ffocusing = false;
   else 
   {
      webctrls_tcontrol.$p.doenter.call($t);
      if ($t.tgrid_frowcount > 0)
         $t.setrowstate($t.tgrid_frowindex);
   }
};

webctrls_tgrid.$p.doexit = function()
{
   var $t = this;
   if (!$t.tgrid_ffocusing)
   {
      webctrls_tcontrol.$p.doexit.call($t);
      if ($t.tgrid_frowcount > 0)
         $t.setrowstate($t.tgrid_frowindex);
   }
   else 
      $t.setfocus();
};

webctrls_tgrid.$p.docolumnheaderclick = function(column)
{
   var $t = this;
   if ($t.tgrid_foncolumnheaderclick)
      $t.tgrid_foncolumnheaderclick($t, column);
};

webctrls_tgrid.$p.createheaderselement = function()
{
   var $t = this;
   with (window.document)
   {
      $t.tgrid_fheaders = createElement("div");
      $t.tgrid_fblankheader = createElement("div");
      $t.tgrid_fblankleft = createElement("div");
      $t.tgrid_fblankmiddle = createElement("div");
   }
   $t.tgrid_fheaders.className = "grd_hdr";
   $t.tcontrol_fbase.appendChild($t.tgrid_fheaders);
   $t.tgrid_fheadersmousedownhandler = webdom_seteventhandler($t.tgrid_fheaders, "mousedown", function(event) { webctrls_tgrid.$p.tgrid_headersmousedownhandler.call($t, event); });
   $t.tgrid_fblankheader.style.position = "absolute";
   $t.tgrid_fheaders.appendChild($t.tgrid_fblankheader);
   $t.tgrid_fblankleft.className = "grd_hdr_l_nrm";
   $t.tgrid_fblankheader.appendChild($t.tgrid_fblankleft);
   $t.tgrid_fblankmiddle.className = "grd_hdr_m_nrm";
   $t.tgrid_fblankheader.appendChild($t.tgrid_fblankmiddle);
};

webctrls_tgrid.$p.removeheaderselement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase)
   {
      if ($t.tgrid_fheaders)
      {
         webdom_cleareventhandler($t.tgrid_fheaders, "mousedown", $t.tgrid_fheadersmousedownhandler);
         $t.tcontrol_fbase.removeChild($t.tgrid_fheaders);
         $t.tgrid_fheaders = null;
      }
   }
};

webctrls_tgrid.$p.createcolumnheaders = function()
{
   var $t = this, i;
   $t.createheaderselement();
   $t.tgrid_fcolumnswidth = 0;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
      {
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).createheaderelement($t.tgrid_fcolumnswidth);
         if ($t.tgrid_fenablecolumnsizing)
            $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).createsizerelement();
         $t.tgrid_fcolumnswidth += $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fwidth;
      }
   }
   $t.tgrid_updateblankheader();
};

webctrls_tgrid.$p.removecolumnheaders = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
      {
         if ($t.tgrid_fenablecolumnsizing)
            $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).removesizerelement();
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).removeheaderelement();
      }
   }
   $t.removeheaderselement();
};

webctrls_tgrid.$p.createcolumnsizers = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).createsizerelement();
   }
};

webctrls_tgrid.$p.removecolumnsizers = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).removesizerelement();
   }
};

webctrls_tgrid.$p.updatecolumns = function(acol)
{
   var $t = this, i;
   if (acol < $t.tgrid_fcolumns.tgridcolumns_getcount())
   {
      $t.tgrid_fcolumnswidth = 0;
      for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
      {
         if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         {
            if (i >= acol)
               $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).updateposition();
            $t.tgrid_fcolumnswidth += $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fwidth;
         }
      }
      if ($t.tgrid_fshowcolumnheaders)
         $t.tgrid_updateblankheader();
   }
};

webctrls_tgrid.$p.createrow = function(arow)
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).createcellelement(arow);
   }
};

webctrls_tgrid.$p.removerow = function(arow)
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).removecellelement(arow);
   }
};

webctrls_tgrid.$p.checkcell = function(acol, arow)
{
   var $t = this;
   if ((acol < 0) || (acol >= $t.tgrid_getcolumncount()))
      throw new Error("Column index " + inttostr(acol) + " out of bounds");
   if ((arow < 0) || (arow >= $t.tgrid_frowcount))
      throw new Error("Row index " + inttostr(arow) + " out of bounds");
};

webctrls_tgrid.$p.getcellelement = function(acol, arow)
{
   var $t = this, $r;
   $t.checkcell(acol, arow);
   $r = $t.tgrid_ftable.childNodes[acol].childNodes[arow];
   return $r;
};

webctrls_tgrid.$p.setcell = function(acol, arow, value)
{
   var $t = this, tempelement;
   tempelement = $t.getcellelement(acol, arow);
   tempelement.innerHTML = value;
   tempelement.title = value;
};

webctrls_tgrid.$p.getcolumnoffset = function(acol)
{
   var $t = this, $r, i;
   $r = 0;
   for (i = 0 ; i <= acol - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
         $r += $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fwidth;
   }
   return $r;
};

webctrls_tgrid.$p.setrowstate = function(arow, over)
{
   var $t = this, i;
   if (over == null)
      over = false;
   if ($t.tgrid_frowcount > 0)
   {
      for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
      {
         if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible)
            $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).setcellstate(arow, over);
      }
   }
};

webctrls_tgrid.$p.incvisiblecolumncount = function()
{
   var $t = this;
   $t.tgrid_fvisiblecolumncount++;
};

webctrls_tgrid.$p.decvisiblecolumncount = function()
{
   var $t = this;
   if ($t.tgrid_fvisiblecolumncount > 0)
      $t.tgrid_fvisiblecolumncount--;
};

webctrls_tgrid.$p.makerowvisible = function(index)
{
   var $t = this;
   $t.tgrid_fcolumns.tgridcolumns_getcolumn($t.tgrid_fcolumnindex).makecellvisible(index);
};

webctrls_tgrid.$p.getgridcolumn = function(value)
{
   var $t = this, $r, i;
   $r = null;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
   {
      if ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fvisible && ($t.tgrid_fcolumns.tgridcolumns_getcolumn(i).tgridcolumn_fcolumn == value))
      {
         $r = $t.tgrid_fcolumns.tgridcolumns_getcolumn(i);
         break;
      }
   }
   return $r;
};

webctrls_tgrid.$p.updatesort = function(column)
{
   var $t = this;
   if ($t.databound())
   {
      if (column.tgridcolumn_fcolumn != null)
         column.tgridcolumn_fcolumn.tdatacolumn_setsortdirection(column.tgridcolumn_fsortdirection);
      $t.tcontrol_fdataset.sort();
   }
};

webctrls_tgrid.$p.activechanged = function()
{
   var $t = this;
   webctrls_tcontrol.$p.activechanged.call($t);
   $t.rowschanged();
};

webctrls_tgrid.$p.bind = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tgrid_fcolumns.tgridcolumns_getcount() - 1 ; i++)
      $t.tgrid_fcolumns.tgridcolumns_getcolumn(i).bind();
};

webctrls_tgrid.$p.databound = function()
{
   var $t = this, $r;
   $r = $t.tcontrol_fdataset;
   return $r;
};

webctrls_tgrid.$p.rowschanged = function()
{
   var $t = this, i, temprowid;
   $t.tgrid_flastrowindex = $t.tgrid_frowindex;
   $t.tgrid_updaterowcount();
   if ($t.tgrid_frowcount > 0)
   {
      temprowid = $t.tcontrol_fdataset.tdataset_getrowid();
      try
      {
         $t.tcontrol_fdataset.first();
         for (i = 0 ; i <= $t.tgrid_frowcount - 1 ; i++)
         {
            $t.tgrid_loadrow(i);
            $t.tcontrol_fdataset.next();
         }
      }
      finally
      {
         $t.tcontrol_fdataset.tdataset_setrowid(temprowid);
      }
      $t.tgrid_frowindex = ($t.tcontrol_fdataset.tdataset_frowno - 1);
      if ($t.tgrid_flastrowindex < $t.tgrid_frowcount)
         $t.setrowstate($t.tgrid_flastrowindex);
      $t.makerowvisible($t.tgrid_frowindex);
      $t.setrowstate($t.tgrid_frowindex);
   }
   else 
      $t.tgrid_frowindex = 0;
};

webctrls_tgrid.$p.rowinserted = function()
{
   var $t = this;
   $t.addrow();
};

webctrls_tgrid.$p.rowchanged = function(value)
{
   var $t = this, tempgridcolumn;
   $t.tgrid_updaterowcount();
   if ($t.tgrid_frowcount > 0)
   {
      if (value == null)
      {
         $t.tgrid_flastrowindex = $t.tgrid_frowindex;
         $t.tgrid_frowindex = ($t.tcontrol_fdataset.tdataset_frowno - 1);
         if ($t.tgrid_flastrowindex < $t.tgrid_frowcount)
            $t.setrowstate($t.tgrid_flastrowindex);
         $t.tgrid_loadrow($t.tgrid_frowindex);
         $t.makerowvisible($t.tgrid_frowindex);
         $t.setrowstate($t.tgrid_frowindex);
      }
      else 
      {
         tempgridcolumn = $t.getgridcolumn(value);
         if (tempgridcolumn)
            $t.setcell(tempgridcolumn.tgridcolumn_findex, $t.tgrid_frowindex, value.tdatacolumn_getasstring());
      }
   }
   webctrls_tcontrol.$p.rowchanged.call($t, value);
};

webctrls_tgrid.$p.rowdeleted = function()
{
   var $t = this;
   $t.deleterow($t.tcontrol_fdataset.tdataset_frowno - 1);
};

webctrls_tgrid.$p.destroy = function()
{
   var $t = this;
   if ($t.tgrid_fshowcolumnheaders)
      $t.removecolumnheaders();
   $t.tgrid_fsortcolumns = tobject.free($t.tgrid_fsortcolumns);
   $t.tgrid_fcolumns = tobject.free($t.tgrid_fcolumns);
   webctrls_tcontrol.$p.destroy.call($t);
   $t.tgrid_fborder = tobject.free($t.tgrid_fborder);
};

webctrls_tgrid.$p.canfocus = function()
{
   var $t = this, $r;
   $r = true;
   return $r;
};

webctrls_tgrid.$p.addrow = function()
{
   var $t = this;
   $t.tgrid_flastrowindex = $t.tgrid_frowindex;
   $t.createrow($t.tgrid_frowcount);
   $t.tgrid_frowindex = $t.tgrid_frowcount;
   $t.tgrid_frowcount++;
   if ($t.tgrid_frowcount > 1)
      $t.setrowstate($t.tgrid_flastrowindex);
   $t.makerowvisible($t.tgrid_frowindex);
   $t.tgrid_fcolumnindex = 0;
   $t.setrowstate($t.tgrid_frowindex);
};

webctrls_tgrid.$p.deleterow = function(arow)
{
   var $t = this;
   $t.checkcell(0, arow);
   $t.tgrid_flastrowindex = $t.tgrid_frowindex;
   $t.removerow(arow);
   $t.tgrid_frowcount--;
   if ($t.tgrid_flastrowindex < $t.tgrid_frowcount)
      $t.setrowstate($t.tgrid_flastrowindex);
   if ($t.tgrid_frowcount > 0)
   {
      if ($t.tgrid_frowindex == $t.tgrid_frowcount)
         $t.tgrid_frowindex--;
      $t.makerowvisible($t.tgrid_frowindex);
      $t.setrowstate($t.tgrid_frowindex);
   }
   else 
   {
      $t.tgrid_fcolumnindex = 0;
      $t.tgrid_frowindex = 0;
   }
};

webctrls_tgrid.$p.firstrow = function()
{
   var $t = this;
   if ($t.tgrid_frowcount > 0)
      $t.moveto($t.tgrid_fcolumnindex, 0);
};

webctrls_tgrid.$p.lastrow = function()
{
   var $t = this;
   if ($t.tgrid_frowcount > 0)
      $t.moveto($t.tgrid_fcolumnindex, ($t.tgrid_frowcount - 1));
};

webctrls_tgrid.$p.nextrow = function()
{
   var $t = this;
   if (($t.tgrid_frowcount > 0) && ($t.tgrid_frowindex < ($t.tgrid_frowcount - 1)))
      $t.moveto($t.tgrid_fcolumnindex, ($t.tgrid_frowindex + 1));
};

webctrls_tgrid.$p.priorrow = function()
{
   var $t = this;
   if (($t.tgrid_frowcount > 0) && ($t.tgrid_frowindex > 0))
      $t.moveto($t.tgrid_fcolumnindex, ($t.tgrid_frowindex - 1));
};

webctrls_tgrid.$p.nextpage = function()
{
   var $t = this, tempindex;
   if ($t.tgrid_frowcount > 0)
   {
      tempindex = min(($t.tgrid_frowindex + $t.tgrid_fvisiblerowcount), ($t.tgrid_frowcount - 1));
      if (tempindex != $t.tgrid_frowindex)
         $t.moveto($t.tgrid_fcolumnindex, tempindex);
   }
};

webctrls_tgrid.$p.priorpage = function()
{
   var $t = this, tempindex;
   if ($t.tgrid_frowcount > 0)
   {
      tempindex = max(($t.tgrid_frowindex - $t.tgrid_fvisiblerowcount), 0);
      if (tempindex != $t.tgrid_frowindex)
         $t.moveto($t.tgrid_fcolumnindex, tempindex);
   }
};

webctrls_tgrid.$p.moveto = function(acol, arow)
{
   var $t = this;
   if ((acol != $t.tgrid_fcolumnindex) || (arow != $t.tgrid_frowindex))
   {
      $t.checkcell(acol, arow);
      $t.tgrid_flastrowindex = $t.tgrid_frowindex;
      $t.tgrid_fcolumnindex = acol;
      if ($t.databound())
      {
         if (arow != $t.tgrid_frowindex)
         {
            $t.tcontrol_fdataset.moveto(arow + 1);
            if ($t.tcontrol_fdataset.tdataset_getrowcount() > 0)
               $t.tgrid_frowindex = ($t.tcontrol_fdataset.tdataset_frowno - 1);
            else 
               $t.tgrid_frowindex = 0;
         }
      }
      else 
         $t.tgrid_frowindex = arow;
      if ($t.tgrid_flastrowindex < $t.tgrid_frowcount)
         $t.setrowstate($t.tgrid_flastrowindex);
      $t.makerowvisible($t.tgrid_frowindex);
      $t.setrowstate($t.tgrid_frowindex);
   }
};

webctrls_tgrid.$p.firstcolumn = function()
{
   var $t = this;
   if ((!$t.tgrid_frowselect) && ($t.tgrid_fvisiblecolumncount > 0))
      $t.moveto(0, $t.tgrid_frowindex);
};

webctrls_tgrid.$p.lastcolumn = function()
{
   var $t = this;
   if ((!$t.tgrid_frowselect) && ($t.tgrid_fvisiblecolumncount > 0))
      $t.moveto(($t.tgrid_fvisiblecolumncount - 1), $t.tgrid_frowindex);
};

webctrls_tgrid.$p.nextcolumn = function()
{
   var $t = this;
   if ((!$t.tgrid_frowselect) && ($t.tgrid_fvisiblecolumncount > 0) && ($t.tgrid_fcolumnindex < ($t.tgrid_fvisiblecolumncount - 1)))
      $t.moveto(($t.tgrid_fcolumnindex + 1), $t.tgrid_frowindex);
};

webctrls_tgrid.$p.priorcolumn = function()
{
   var $t = this;
   if ((!$t.tgrid_frowselect) && ($t.tgrid_fvisiblecolumncount > 0) && ($t.tgrid_fcolumnindex > 0))
      $t.moveto(($t.tgrid_fcolumnindex - 1), $t.tgrid_frowindex);
};

// TContainerControl Class Declarations

function webctrls_tcontainercontrol()
{
   var $t = this;
   webctrls_tcontrol.call($t);
   $t.tcontainercontrol_fcontrols = null;
   $t.tcontainercontrol_ftabcontrols = null;
   $t.tcontainercontrol_fscrollbars = webctrls_ssnone;
   $t.tcontainercontrol_fcontainer = null;
   $t.tcontainercontrol_fclient = null;
   $t.tcontainercontrol_factivecontrol = null;
   $t.tcontainercontrol_ffindingcontrol = false;
}

webctrls_tcontainercontrol.prototype = $i(webctrls_tcontrol);
webctrls_tcontainercontrol.$p = webctrls_tcontainercontrol.prototype;
webctrls_tcontainercontrol.$p.constructor = webctrls_tcontainercontrol;

webctrls_tcontainercontrol.$p.tcontainercontrol_setscrollbars = function(value)
{
   var $t = this;
   if (value != $t.tcontainercontrol_fscrollbars)
   {
      if ((value >= webctrls_ssnone) && (value <= webctrls_ssboth))
      {
         $t.tcontainercontrol_fclient.style.overflowX = webctrls_scrollstyletoxstr(value, true);
         $t.tcontainercontrol_fclient.style.overflowY = webctrls_scrollstyletoystr(value, true);
         $t.tcontainercontrol_fscrollbars = value;
      }
      else 
         throw new Error("Invalid scroll bars (" + inttostr(value) + ")");
   }
};

webctrls_tcontainercontrol.$p.tcontainercontrol_getclientheight = function()
{
   var $t = this, $r;
   $r = $t.tcontainercontrol_fclient.offsetHeight;
   return $r;
};

webctrls_tcontainercontrol.$p.tcontainercontrol_setclientheight = function(value)
{
   var $t = this, tempoffset;
   if (value != $t.tcontainercontrol_getclientheight())
   {
      tempoffset = ($t.tcontrol_getheight() - $t.tcontainercontrol_getclientheight());
      $t.tcontrol_setheight((value + tempoffset));
   }
};

webctrls_tcontainercontrol.$p.tcontainercontrol_getclientwidth = function()
{
   var $t = this, $r;
   $r = $t.tcontainercontrol_fclient.offsetWidth;
   return $r;
};

webctrls_tcontainercontrol.$p.tcontainercontrol_setclientwidth = function(value)
{
   var $t = this, tempoffset;
   if (value != $t.tcontainercontrol_getclientwidth())
   {
      tempoffset = ($t.tcontrol_getwidth() - $t.tcontainercontrol_getclientwidth());
      $t.tcontrol_setwidth((value + tempoffset));
   }
};

webctrls_tcontainercontrol.$p.tcontainercontrol_getcontrolcount = function()
{
   var $t = this, $r;
   $r = 0;
   if ($t.tcontainercontrol_fcontrols)
      $r = $t.tcontainercontrol_fcontrols.tobjectlist_fcount;
   return $r;
};

webctrls_tcontainercontrol.$p.tcontainercontrol_getcontrol = function(value)
{
   var $t = this, $r;
   $r = null;
   if ($t.tcontainercontrol_fcontrols && (value >= 0) && (value < $t.tcontainercontrol_fcontrols.tobjectlist_fcount))
      $r = $t.tcontainercontrol_fcontrols.getobject(value);
   return $r;
};

webctrls_tcontainercontrol.$p.tcontainercontrol_createlist = function()
{
   var $t = this;
   if ($t.tcontainercontrol_fcontrols == null)
      $t.tcontainercontrol_fcontrols = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
};

webctrls_tcontainercontrol.$p.tcontainercontrol_freelist = function()
{
   var $t = this;
   if ($t.tcontainercontrol_fcontrols && ($t.tcontainercontrol_fcontrols.tobjectlist_fcount == 0))
      $t.tcontainercontrol_fcontrols = tobject.free($t.tcontainercontrol_fcontrols);
};

webctrls_tcontainercontrol.$p.tcontainercontrol_createtablist = function()
{
   var $t = this;
   if ($t.tcontainercontrol_ftabcontrols == null)
      $t.tcontainercontrol_ftabcontrols = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
};

webctrls_tcontainercontrol.$p.tcontainercontrol_freetablist = function()
{
   var $t = this;
   if ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount == 0))
      $t.tcontainercontrol_ftabcontrols = tobject.free($t.tcontainercontrol_ftabcontrols);
};

webctrls_tcontainercontrol.$p.createelement = function()
{
   var $t = this, $r;
   with (window.document)
   {
      $r = createElement("div");
      $t.tcontainercontrol_fcontainer = createElement("div");
      $t.tcontainercontrol_fclient = createElement("div");
   }
   return $r;
};

webctrls_tcontainercontrol.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontrol.$p.initelement.call($t);
   $t.tcontrol_fbase.style.cursor = "default";
   $t.tcontainercontrol_fcontainer.style.position = "absolute";
   $t.tcontrol_fbase.appendChild($t.tcontainercontrol_fcontainer);
   $t.tcontainercontrol_fclient.style.position = "absolute";
   $t.tcontainercontrol_fclient.style.overflowX = "hidden";
   $t.tcontainercontrol_fclient.style.overflowY = "hidden";
   $t.tcontainercontrol_fcontainer.appendChild($t.tcontainercontrol_fclient);
   $t.tcontrol_ftarget = $t.tcontainercontrol_fclient;
   $t.tcontrol_fdisplay = $t.tcontainercontrol_fclient;
};

webctrls_tcontainercontrol.$p.removeelement = function()
{
   var $t = this;
   if ($t.tcontrol_fbase && $t.tcontainercontrol_fcontainer)
   {
      if ($t.tcontainercontrol_fclient)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tcontainercontrol_fclient);
         $t.tcontainercontrol_fclient = null;
      }
      $t.tcontrol_fbase.removeChild($t.tcontainercontrol_fcontainer);
      $t.tcontainercontrol_fcontainer = null;
   }
   webctrls_tcontrol.$p.removeelement.call($t);
};

webctrls_tcontainercontrol.$p.setcolor = function(value)
{
   var $t = this;
   if (value != $t.tcontrol_fcolor)
   {
      $t.tcontainercontrol_fclient.style.backgroundColor = webdom_colortostr(value);
      $t.colorchanged();
   }
};

webctrls_tcontainercontrol.$p.fontchanged = function(fromparent)
{
   var $t = this, i;
   webctrls_tcontrol.$p.fontchanged.call($t, fromparent);
   if ($t.tcontainercontrol_fcontrols)
   {
      for (i = 0 ; i <= $t.tcontainercontrol_fcontrols.tobjectlist_fcount - 1 ; i++)
      {
         if ($t.tcontainercontrol_fcontrols.getobject(i).tcontrol_fparentfont)
            $t.tcontainercontrol_fcontrols.getobject(i).tcontrol_ffont.inherit($t.tcontrol_ffont);
      }
   }
};

webctrls_tcontainercontrol.$p.heightchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getheight() > 0)
   {
      $t.tcontainercontrol_fcontainer.style.top = webdom_pixelstostr(0);
      $t.tcontainercontrol_fcontainer.style.height = webdom_pixelstostr($t.tcontrol_getheight());
      $t.tcontainercontrol_fclient.style.top = webdom_pixelstostr(0);
      $t.tcontainercontrol_fclient.style.height = webdom_pixelstostr($t.tcontrol_getheight());
   }
};

webctrls_tcontainercontrol.$p.widthchanged = function()
{
   var $t = this;
   if ($t.tcontrol_getwidth() > 0)
   {
      $t.tcontainercontrol_fcontainer.style.left = webdom_pixelstostr(0);
      $t.tcontainercontrol_fcontainer.style.width = webdom_pixelstostr($t.tcontrol_getwidth());
      $t.tcontainercontrol_fclient.style.left = webdom_pixelstostr(0);
      $t.tcontainercontrol_fclient.style.width = webdom_pixelstostr($t.tcontrol_getwidth());
   }
};

webctrls_tcontainercontrol.$p.resettheme = function()
{
   var $t = this, i;
   webctrls_tcontrol.$p.resettheme.call($t);
   if ($t.tcontainercontrol_fcontrols)
   {
      for (i = 0 ; i <= $t.tcontainercontrol_fcontrols.tobjectlist_fcount - 1 ; i++)
         $t.tcontainercontrol_fcontrols.getobject(i).resettheme();
   }
};

webctrls_tcontainercontrol.$p.addcontrol = function(control)
{
   var $t = this, $r;
   $t.tcontainercontrol_fclient.appendChild(control.tcontrol_fbase);
   $t.tcontainercontrol_createlist();
   $r = $t.tcontainercontrol_fcontrols.add(control);
   $t.updatecontrolzindexes();
   $t.tcontainercontrol_createtablist();
   if (control.canfocus() && control.tcontrol_ftabstop && control.tcontrol_fvisible)
   {
      $t.tcontainercontrol_ftabcontrols.add(control);
      if ($t.tcontrol_fparent && $t.tcontrol_ftabstop && ($t.tcontrol_gettaborder() == -1))
         $t.tcontrol_fparent.setcontroltaborder($t, -1);
   }
   $t.updatecontroltabindexes();
   return $r;
};

webctrls_tcontainercontrol.$p.removecontrol = function(control)
{
   var $t = this;
   if ($t.tcontainercontrol_fclient)
      $t.tcontainercontrol_fclient.removeChild(control.tcontrol_fbase);
   $t.tcontainercontrol_fcontrols.remove1(control);
   $t.tcontainercontrol_freelist();
   $t.updatecontrolzindexes();
   if (control.canfocus() && control.tcontrol_ftabstop && control.tcontrol_fvisible)
      $t.tcontainercontrol_ftabcontrols.remove1(control);
   $t.tcontainercontrol_freetablist();
   $t.updatecontroltabindexes();
};

webctrls_tcontainercontrol.$p.setcontrolposition = function(control, newpos)
{
   var $t = this, index;
   index = $t.tcontainercontrol_fcontrols.indexof(control);
   if (index != -1)
   {
      if (newpos < 0)
         newpos = 0;
      if (newpos >= $t.tcontainercontrol_fcontrols.tobjectlist_fcount)
         newpos = ($t.tcontainercontrol_fcontrols.tobjectlist_fcount - 1);
      if (newpos != index)
      {
         $t.tcontainercontrol_fcontrols.remove(index);
         $t.tcontainercontrol_fcontrols.insert(newpos, control);
         $t.updatecontrolzindexes();
      }
   }
};

webctrls_tcontainercontrol.$p.updatecontrolzindexes = function()
{
   var $t = this, i;
   if ((!$t.tcomponent_fdestroying) && $t.tcontainercontrol_fcontrols)
   {
      for (i = 0 ; i <= $t.tcontainercontrol_fcontrols.tobjectlist_fcount - 1 ; i++)
         $t.tcontainercontrol_fcontrols.getobject(i).setzindex(i);
   }
};

webctrls_tcontainercontrol.$p.setactivecontrol = function(control)
{
   var $t = this;
   if ($t.tcontrol_fparent)
      $t.tcontrol_fparent.setactivecontrol($t);
   $t.tcontainercontrol_factivecontrol = control;
};

webctrls_tcontainercontrol.$p.getcontroltaborder = function(control)
{
   var $t = this, $r;
   if ($t.tcontainercontrol_ftabcontrols)
      $r = $t.tcontainercontrol_ftabcontrols.indexof(control);
   else 
      $r = -1;
   return $r;
};

webctrls_tcontainercontrol.$p.setcontroltaborder = function(control, neworder)
{
   var $t = this, index;
   $t.tcontainercontrol_createtablist();
   if (neworder != -1)
   {
      index = $t.tcontainercontrol_ftabcontrols.indexof(control);
      if (index != -1)
      {
         if (neworder < 0)
            neworder = 0;
         if (neworder >= $t.tcontainercontrol_ftabcontrols.tobjectlist_fcount)
            neworder = ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount - 1);
         if (neworder != index)
         {
            $t.tcontainercontrol_ftabcontrols.remove1(control);
            $t.tcontainercontrol_ftabcontrols.insert(neworder, control);
            $t.updatecontroltabindexes();
         }
      }
   }
   else 
   {
      if (control.tcontrol_ftabstop && control.tcontrol_fvisible)
      {
         index = $t.tcontainercontrol_fcontrols.indexof(control);
         if (index != -1)
            $t.tcontainercontrol_ftabcontrols.insert(index, control);
      }
      else 
      {
         index = $t.tcontainercontrol_ftabcontrols.indexof(control);
         if (index != -1)
         {
            if (control == $t.tcontainercontrol_factivecontrol)
               $t.nextcontrol();
            $t.tcontainercontrol_ftabcontrols.remove1(control);
         }
      }
      $t.updatecontroltabindexes();
   }
};

webctrls_tcontainercontrol.$p.updatecontroltabindexes = function()
{
   var $t = this, i;
   if ((!$t.tcomponent_fdestroying) && $t.tcontainercontrol_ftabcontrols)
   {
      if ($t.tabindexenabled())
      {
         for (i = 0 ; i <= $t.tcontainercontrol_ftabcontrols.tobjectlist_fcount - 1 ; i++)
            $t.tcontainercontrol_ftabcontrols.getobject(i).settabindex(i);
      }
      else 
      {
         for (i = 0 ; i <= $t.tcontainercontrol_ftabcontrols.tobjectlist_fcount - 1 ; i++)
            $t.tcontainercontrol_ftabcontrols.getobject(i).settabindex(-2);
      }
   }
};

webctrls_tcontainercontrol.$p.wraptabcontrols = function()
{
   var $t = this, $r;
   $r = false;
   return $r;
};

webctrls_tcontainercontrol.$p.getfirsttabcontrol = function()
{
   var $t = this, $r;
   if ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount > 0))
      $r = $t.tcontainercontrol_ftabcontrols.first();
   else 
      $r = null;
   return $r;
};

webctrls_tcontainercontrol.$p.getpriortabcontrol = function(curcontrol)
{
   var $t = this, $r;
   if ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount > 0))
      $r = $t.tcontainercontrol_ftabcontrols.prior(curcontrol, $t.wraptabcontrols());
   else 
      $r = null;
   return $r;
};

webctrls_tcontainercontrol.$p.getnexttabcontrol = function(curcontrol)
{
   var $t = this, $r;
   if ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount > 0))
      $r = $t.tcontainercontrol_ftabcontrols.next(curcontrol, $t.wraptabcontrols());
   else 
      $r = null;
   return $r;
};

webctrls_tcontainercontrol.$p.getlasttabcontrol = function()
{
   var $t = this, $r;
   if ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount > 0))
      $r = $t.tcontainercontrol_ftabcontrols.last();
   else 
      $r = null;
   return $r;
};

webctrls_tcontainercontrol.$p.firstcontrol = function()
{
   var $t = this;
   if (!$t.tcontainercontrol_ffindingcontrol)
   {
      $t.tcontainercontrol_ffindingcontrol = true;
      try
      {
         $t.tcontainercontrol_factivecontrol = $t.getfirsttabcontrol();
         if ($t.tcontainercontrol_factivecontrol)
            $t.tcontainercontrol_factivecontrol.firstcontrol();
         else if ($t.tcontrol_fparent)
            $t.tcontrol_fparent.firstcontrol();
      }
      finally
      {
         $t.tcontainercontrol_ffindingcontrol = false;
      }
   }
};

webctrls_tcontainercontrol.$p.priorcontrol = function()
{
   var $t = this;
   if (!$t.tcontainercontrol_ffindingcontrol)
   {
      $t.tcontainercontrol_ffindingcontrol = true;
      try
      {
         $t.tcontainercontrol_factivecontrol = $t.getpriortabcontrol($t.tcontainercontrol_factivecontrol);
         if ($t.tcontainercontrol_factivecontrol)
            $t.tcontainercontrol_factivecontrol.lastcontrol();
         else if ($t.tcontrol_fparent)
            $t.tcontrol_fparent.priorcontrol();
      }
      finally
      {
         $t.tcontainercontrol_ffindingcontrol = false;
      }
   }
};

webctrls_tcontainercontrol.$p.nextcontrol = function()
{
   var $t = this;
   if (!$t.tcontainercontrol_ffindingcontrol)
   {
      $t.tcontainercontrol_ffindingcontrol = true;
      try
      {
         $t.tcontainercontrol_factivecontrol = $t.getnexttabcontrol($t.tcontainercontrol_factivecontrol);
         if ($t.tcontainercontrol_factivecontrol)
            $t.tcontainercontrol_factivecontrol.firstcontrol();
         else if ($t.tcontrol_fparent)
            $t.tcontrol_fparent.nextcontrol();
      }
      finally
      {
         $t.tcontainercontrol_ffindingcontrol = false;
      }
   }
};

webctrls_tcontainercontrol.$p.lastcontrol = function()
{
   var $t = this;
   if (!$t.tcontainercontrol_ffindingcontrol)
   {
      $t.tcontainercontrol_ffindingcontrol = true;
      try
      {
         $t.tcontainercontrol_factivecontrol = $t.getlasttabcontrol();
         if ($t.tcontainercontrol_factivecontrol)
            $t.tcontainercontrol_factivecontrol.lastcontrol();
         else if ($t.tcontrol_fparent)
            $t.tcontrol_fparent.lastcontrol();
      }
      finally
      {
         $t.tcontainercontrol_ffindingcontrol = false;
      }
   }
};

webctrls_tcontainercontrol.$p.checkkeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeydown(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tcontainercontrol.$p.checkkeyup = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeyup(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tcontainercontrol.$p.checkkeypress = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tcontrol_fparent)
      $r = $t.tcontrol_fparent.checkkeypress(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tcontainercontrol.$p.destroy = function()
{
   var $t = this;
   $t.tcontainercontrol_freelist();
   $t.tcontainercontrol_freetablist();
   webctrls_tcontrol.$p.destroy.call($t);
};

webctrls_tcontainercontrol.$p.canfocus = function()
{
   var $t = this, $r;
   $r = ($t.tcontainercontrol_ftabcontrols && ($t.tcontainercontrol_ftabcontrols.tobjectlist_fcount > 0));
   return $r;
};

webctrls_tcontainercontrol.$p.setfocus = function()
{
   var $t = this;
   if ($t.tcontainercontrol_factivecontrol)
      $t.tcontainercontrol_factivecontrol.setfocus();
};

webctrls_tcontainercontrol.$p.hide = function()
{
   var $t = this, i;
   if ($t.tcontainercontrol_fcontrols)
   {
      for (i = 0 ; i <= $t.tcontainercontrol_fcontrols.tobjectlist_fcount - 1 ; i++)
      {
         if ($t.tcontainercontrol_fcontrols.getobject(i) instanceof webctrls_tcombobox)
            $t.tcontainercontrol_fcontrols.getobject(i).closeup();
      }
   }
   webctrls_tcontrol.$p.hide.call($t);
};

// TPanel Class Declarations

function webctrls_tpanel()
{
   var $t = this;
   webctrls_tcontainercontrol.call($t);
   $t.tpanel_fcaption = "";
   $t.tpanel_fonclosequery = null;
   $t.tpanel_fonclose = null;
   $t.tpanel_fenabledrag = false;
   $t.tpanel_fkeypreview = false;
   $t.tpanel_fshowborder = true;
   $t.tpanel_fshowcaption = true;
   $t.tpanel_fshowclosebutton = true;
   $t.tpanel_fshowicon = true;
   $t.tpanel_fshowshadow = true;
   $t.tpanel_fbordertopleft = null;
   $t.tpanel_fbordertop = null;
   $t.tpanel_fbordertopright = null;
   $t.tpanel_fborderleft = null;
   $t.tpanel_fborderright = null;
   $t.tpanel_fborderbottomleft = null;
   $t.tpanel_fborderbottom = null;
   $t.tpanel_fborderbottomright = null;
   $t.tpanel_fcaptionbar = null;
   $t.tpanel_fcaptionleft = null;
   $t.tpanel_fcaptionmiddle = null;
   $t.tpanel_fcaptionicon = null;
   $t.tpanel_fcaptiontext = null;
   $t.tpanel_fcaptionclosebutton = null;
   $t.tpanel_fcaptionright = null;
   $t.tpanel_fshadowtopright = null;
   $t.tpanel_fshadowright = null;
   $t.tpanel_fshadowbottomleft = null;
   $t.tpanel_fshadowbottom = null;
   $t.tpanel_fshadowbottomright = null;
   $t.tpanel_fclosebuttonmousedownhandler = null;
   $t.tpanel_fclosebuttonmouseoverhandler = null;
   $t.tpanel_fclosebuttonmouseouthandler = null;
   $t.tpanel_fclosebuttonmouseuphandler = null;
   $t.tpanel_fcaptionmousedownhandler = null;
   $t.tpanel_fclosebuttondown = false;
}

webctrls_tpanel.create = function(instance, aowner)
{
   webctrls_tcontrol.create(instance, aowner);
   instance.tpanel_updatecaptionborder();
   instance.tpanel_setshowshadow(false);
   instance.tpanel_setshowclosebutton(false);
   return instance;
};

webctrls_tpanel.prototype = $i(webctrls_tcontainercontrol);
webctrls_tpanel.$p = webctrls_tpanel.prototype;
webctrls_tpanel.$p.constructor = webctrls_tpanel;

webctrls_tpanel.$p.tpanel_createborder = function()
{
   var $t = this;
   with (window.document)
   {
      $t.tpanel_fbordertopleft = createElement("div");
      $t.tpanel_fbordertop = createElement("div");
      $t.tpanel_fbordertopright = createElement("div");
      $t.tpanel_fborderleft = createElement("div");
      $t.tpanel_fborderright = createElement("div");
      $t.tpanel_fborderbottomleft = createElement("div");
      $t.tpanel_fborderbottom = createElement("div");
      $t.tpanel_fborderbottomright = createElement("div");
   }
};

webctrls_tpanel.$p.tpanel_initborder = function()
{
   var $t = this, prefix;
   prefix = $t.getclassprefix();
   $t.tpanel_fbordertopleft.className = prefix + "_tl";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fbordertopleft);
   $t.tpanel_fbordertop.className = prefix + "_t";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fbordertop);
   $t.tpanel_fbordertopright.className = prefix + "_tr";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fbordertopright);
   $t.tpanel_fborderleft.className = prefix + "_l";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fborderleft);
   $t.tpanel_fborderright.className = prefix + "_r";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fborderright);
   $t.tpanel_fborderbottomleft.className = prefix + "_bl";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fborderbottomleft);
   $t.tpanel_fborderbottom.className = prefix + "_b";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fborderbottom);
   $t.tpanel_fborderbottomright.className = prefix + "_br";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fborderbottomright);
};

webctrls_tpanel.$p.tpanel_removeborder = function()
{
   var $t = this;
   if ($t.tcontainercontrol_fcontainer)
   {
      if ($t.tpanel_fbordertopleft)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fbordertopleft);
         $t.tpanel_fbordertopleft = null;
      }
      if ($t.tpanel_fbordertop)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fbordertop);
         $t.tpanel_fbordertop = null;
      }
      if ($t.tpanel_fbordertopright)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fbordertopright);
         $t.tpanel_fbordertopright = null;
      }
      if ($t.tpanel_fborderleft)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fborderleft);
         $t.tpanel_fborderleft = null;
      }
      if ($t.tpanel_fborderright)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fborderright);
         $t.tpanel_fborderright = null;
      }
      if ($t.tpanel_fborderbottomleft)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fborderbottomleft);
         $t.tpanel_fborderbottomleft = null;
      }
      if ($t.tpanel_fborderbottom)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fborderbottom);
         $t.tpanel_fborderbottom = null;
      }
      if ($t.tpanel_fborderbottomright)
      {
         $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fborderbottomright);
         $t.tpanel_fborderbottomright = null;
      }
   }
};

webctrls_tpanel.$p.tpanel_createcaption = function()
{
   var $t = this;
   with (window.document)
   {
      $t.tpanel_fcaptionbar = createElement("div");
      $t.tpanel_fcaptionleft = createElement("div");
      $t.tpanel_fcaptionmiddle = createElement("div");
      $t.tpanel_fcaptionicon = createElement("div");
      $t.tpanel_fcaptiontext = createElement("div");
      $t.tpanel_fcaptionclosebutton = createElement("div");
      $t.tpanel_fcaptionright = createElement("div");
   }
};

webctrls_tpanel.$p.tpanel_initcaption = function()
{
   var $t = this, prefix;
   prefix = $t.getclassprefix();
   $t.tpanel_fcaptionbar.className = prefix + "_cap";
   $t.tcontainercontrol_fcontainer.appendChild($t.tpanel_fcaptionbar);
   $t.tpanel_fcaptionleft.className = prefix + "_cap_l";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptionleft);
   $t.tpanel_fcaptionmiddle.className = prefix + "_cap_m";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptionmiddle);
   $t.tpanel_fcaptionicon.className = prefix + "_cap_ico";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptionicon);
   $t.tpanel_fcaptiontext.className = prefix + "_cap_txt";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptiontext);
   $t.tpanel_fcaptionclosebutton.className = prefix + "_cap_cl_nrm";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptionclosebutton);
   $t.tpanel_fcaptionright.className = prefix + "_cap_r";
   $t.tpanel_fcaptionbar.appendChild($t.tpanel_fcaptionright);
   $t.tpanel_fcaptionmousedownhandler = webdom_seteventhandler($t.tpanel_fcaptionbar, "mousedown", function(event) { webctrls_tpanel.$p.tpanel_captionmousedownhandler.call($t, event); });
   $t.tpanel_fclosebuttonmousedownhandler = webdom_seteventhandler($t.tpanel_fcaptionclosebutton, "mousedown", function(event) { webctrls_tpanel.$p.tpanel_closebuttonmousedownhandler.call($t, event); });
   $t.tpanel_fclosebuttonmouseoverhandler = webdom_seteventhandler($t.tpanel_fcaptionclosebutton, "mouseover", function(event) { webctrls_tpanel.$p.tpanel_closebuttonmouseoverhandler.call($t, event); });
   $t.tpanel_fclosebuttonmouseuphandler = webdom_seteventhandler($t.tpanel_fcaptionclosebutton, "mouseup", function(event) { webctrls_tpanel.$p.tpanel_closebuttonmouseuphandler.call($t, event); });
   $t.tpanel_fclosebuttonmouseouthandler = webdom_seteventhandler($t.tpanel_fcaptionclosebutton, "mouseout", function(event) { webctrls_tpanel.$p.tpanel_closebuttonmouseouthandler.call($t, event); });
};

webctrls_tpanel.$p.tpanel_removecaption = function()
{
   var $t = this;
   if ($t.tpanel_fcaptionclosebutton)
   {
      webdom_cleareventhandler($t.tpanel_fcaptionclosebutton, "mousedown", $t.tpanel_fclosebuttonmousedownhandler);
      webdom_cleareventhandler($t.tpanel_fcaptionclosebutton, "mouseover", $t.tpanel_fclosebuttonmouseoverhandler);
      webdom_cleareventhandler($t.tpanel_fcaptionclosebutton, "mouseup", $t.tpanel_fclosebuttonmouseuphandler);
      webdom_cleareventhandler($t.tpanel_fcaptionclosebutton, "mouseout", $t.tpanel_fclosebuttonmouseouthandler);
   }
   if ($t.tcontainercontrol_fcontainer && $t.tpanel_fcaptionbar)
   {
      webdom_cleareventhandler($t.tpanel_fcaptionbar, "mousedown", $t.tpanel_fcaptionmousedownhandler);
      $t.tcontainercontrol_fcontainer.removeChild($t.tpanel_fcaptionbar);
      $t.tpanel_fcaptionbar = null;
   }
};

webctrls_tpanel.$p.tpanel_updatecaption = function(value)
{
   var $t = this;
   $t.tpanel_fcaptiontext.innerHTML = value;
};

webctrls_tpanel.$p.tpanel_updatecaptionborder = function()
{
   var $t = this;
   if ($t.tpanel_fshowborder)
   {
      if ($t.tpanel_fshowcaption)
      {
         $t.tpanel_fbordertopleft.style.visibility = "hidden";
         $t.tpanel_fbordertop.style.visibility = "hidden";
         $t.tpanel_fbordertopright.style.visibility = "hidden";
      }
      else 
      {
         $t.tpanel_fbordertopleft.style.visibility = "";
         $t.tpanel_fbordertop.style.visibility = "";
         $t.tpanel_fbordertopright.style.visibility = "";
      }
   }
};

webctrls_tpanel.$p.tpanel_createshadow = function()
{
   var $t = this;
   with (window.document)
   {
      $t.tpanel_fshadowtopright = createElement("div");
      $t.tpanel_fshadowright = createElement("div");
      $t.tpanel_fshadowbottomleft = createElement("div");
      $t.tpanel_fshadowbottom = createElement("div");
      $t.tpanel_fshadowbottomright = createElement("div");
   }
};

webctrls_tpanel.$p.tpanel_initshadow = function()
{
   var $t = this, prefix;
   prefix = $t.getclassprefix();
   $t.tpanel_fshadowtopright.className = prefix + "_tr_sh";
   $t.tcontrol_fbase.appendChild($t.tpanel_fshadowtopright);
   $t.tpanel_fshadowright.className = prefix + "_r_sh";
   $t.tcontrol_fbase.appendChild($t.tpanel_fshadowright);
   $t.tpanel_fshadowbottomleft.className = prefix + "_bl_sh";
   $t.tcontrol_fbase.appendChild($t.tpanel_fshadowbottomleft);
   $t.tpanel_fshadowbottom.className = prefix + "_b_sh";
   $t.tcontrol_fbase.appendChild($t.tpanel_fshadowbottom);
   $t.tpanel_fshadowbottomright.className = prefix + "_br_sh";
   $t.tcontrol_fbase.appendChild($t.tpanel_fshadowbottomright);
};

webctrls_tpanel.$p.tpanel_removeshadow = function()
{
   var $t = this;
   if ($t.tcontrol_fbase)
   {
      if ($t.tpanel_fshadowtopright)
      {
         $t.tcontrol_fbase.removeChild($t.tpanel_fshadowtopright);
         $t.tpanel_fshadowtopright = null;
      }
      if ($t.tpanel_fshadowright)
      {
         $t.tcontrol_fbase.removeChild($t.tpanel_fshadowright);
         $t.tpanel_fshadowright = null;
      }
      if ($t.tpanel_fshadowbottomleft)
      {
         $t.tcontrol_fbase.removeChild($t.tpanel_fshadowbottomleft);
         $t.tpanel_fshadowbottomleft = null;
      }
      if ($t.tpanel_fshadowbottom)
      {
         $t.tcontrol_fbase.removeChild($t.tpanel_fshadowbottom);
         $t.tpanel_fshadowbottom = null;
      }
      if ($t.tpanel_fshadowbottomright)
      {
         $t.tcontrol_fbase.removeChild($t.tpanel_fshadowbottomright);
         $t.tpanel_fshadowbottomright = null;
      }
   }
};

webctrls_tpanel.$p.tpanel_setshowborder = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fshowborder)
   {
      if (value)
      {
         $t.tpanel_createborder();
         $t.tpanel_initborder();
         if ($t.tpanel_fshowcaption)
         {
            $t.tpanel_createcaption();
            $t.tpanel_initcaption();
            $t.tpanel_updatecaption($t.tpanel_fcaption);
         }
      }
      else 
      {
         if ($t.tpanel_fshowcaption)
            $t.tpanel_removecaption();
         $t.tpanel_removeborder();
      }
      $t.tpanel_fshowborder = value;
      $t.heightchanged();
      $t.widthchanged();
   }
};

webctrls_tpanel.$p.tpanel_setcaption = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fcaption)
   {
      $t.tpanel_updatecaption(value);
      $t.tpanel_fcaption = value;
   }
};

webctrls_tpanel.$p.tpanel_setshowcaption = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fshowcaption)
   {
      if ($t.tpanel_fshowborder)
      {
         if (value)
         {
            $t.tpanel_createcaption();
            $t.tpanel_initcaption();
            $t.tpanel_updatecaption($t.tpanel_fcaption);
         }
         else 
            $t.tpanel_removecaption();
      }
      $t.tpanel_fshowcaption = value;
      $t.tpanel_updatecaptionborder();
      $t.heightchanged();
      $t.widthchanged();
   }
};

webctrls_tpanel.$p.tpanel_setshowclosebutton = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fshowclosebutton)
   {
      if (value)
         $t.tpanel_fcaptionclosebutton.style.visibility = "";
      else 
         $t.tpanel_fcaptionclosebutton.style.visibility = "hidden";
      $t.tpanel_fshowclosebutton = value;
   }
};

webctrls_tpanel.$p.tpanel_setshowicon = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fshowicon)
   {
      if ($t.tpanel_fshowborder && $t.tpanel_fshowcaption)
      {
         if (value)
            $t.tpanel_fcaptionicon.style.visibility = "";
         else 
            $t.tpanel_fcaptionicon.style.visibility = "hidden";
      }
      $t.tpanel_fshowicon = value;
      $t.widthchanged();
   }
};

webctrls_tpanel.$p.tpanel_setshowshadow = function(value)
{
   var $t = this;
   if (value != $t.tpanel_fshowshadow)
   {
      if (value)
      {
         $t.tpanel_createshadow();
         $t.tpanel_initshadow();
      }
      else 
         $t.tpanel_removeshadow();
      $t.tpanel_fshowshadow = value;
      $t.heightchanged();
      $t.widthchanged();
   }
};

webctrls_tpanel.$p.tpanel_closebuttonmousedownhandler = function(event)
{
   var $t = this, $r;
   $t.activatecontainer();
   $t.tpanel_fcaptionclosebutton.className = $t.getclassprefix() + "_cap_cl_dwn";
   $t.tpanel_fclosebuttondown = true;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tpanel.$p.tpanel_closebuttonmouseoverhandler = function(event)
{
   var $t = this, $r;
   if (!$t.tpanel_fclosebuttondown)
      $t.tpanel_fcaptionclosebutton.className = $t.getclassprefix() + "_cap_cl_hot";
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tpanel.$p.tpanel_closebuttonmouseouthandler = function(event)
{
   var $t = this, $r;
   $t.tpanel_fcaptionclosebutton.className = $t.getclassprefix() + "_cap_cl_nrm";
   $t.tpanel_fclosebuttondown = false;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tpanel.$p.tpanel_closebuttonmouseuphandler = function(event)
{
   var $t = this, $r;
   $t.close();
   $t.tpanel_fcaptionclosebutton.className = $t.getclassprefix() + "_cap_cl_hot";
   $t.tpanel_fclosebuttondown = false;
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tpanel.$p.tpanel_captionmousedownhandler = function(event)
{
   var $t = this, $r;
   $t.activatecontainer();
   if ($t.tpanel_fenabledrag)
      $t.begindrag(event.clientX, event.clientY);
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webctrls_tpanel.$p.getclassprefix = function()
{
   var $t = this, $r;
   $r = "pnl";
   return $r;
};

webctrls_tpanel.$p.createelement = function()
{
   var $t = this, $r;
   $r = webctrls_tcontainercontrol.$p.createelement.call($t);
   $t.tpanel_createborder();
   $t.tpanel_createcaption();
   $t.tpanel_createshadow();
   return $r;
};

webctrls_tpanel.$p.initelement = function()
{
   var $t = this, prefix;
   webctrls_tcontainercontrol.$p.initelement.call($t);
   prefix = $t.getclassprefix();
   $t.tcontainercontrol_fcontainer.className = prefix;
   $t.tcontainercontrol_fclient.className = prefix + "_back";
   $t.tpanel_initborder();
   $t.tpanel_initcaption();
   $t.tpanel_initshadow();
};

webctrls_tpanel.$p.removeelement = function()
{
   var $t = this;
   if ($t.tpanel_fshowborder)
   {
      if ($t.tpanel_fshowcaption)
         $t.tpanel_removecaption();
      $t.tpanel_removeborder();
   }
   if ($t.tpanel_fshowshadow)
      $t.tpanel_removeshadow();
   webctrls_tcontainercontrol.$p.removeelement.call($t);
};

webctrls_tpanel.$p.heightchanged = function()
{
   var $t = this, containerheight, clienttop, clientheight, captionheight, shadowheight;
   if (($t.tcontrol_getheight() > 0) && ($t.tpanel_fshowborder || $t.tpanel_fshowshadow))
   {
      containerheight = $t.tcontrol_getheight();
      if ($t.tpanel_fshowshadow)
      {
         containerheight -= $t.tpanel_fshadowbottom.offsetHeight;
         shadowheight = containerheight;
         shadowheight -= $t.tpanel_fshadowtopright.offsetHeight;
      }
      clienttop = 0;
      clientheight = containerheight;
      if ($t.tpanel_fshowborder)
      {
         if ($t.tpanel_fshowcaption)
         {
            captionheight = $t.tpanel_fcaptionbar.offsetHeight;
            clienttop += captionheight;
            clientheight -= (captionheight + $t.tpanel_fborderbottom.offsetHeight);
         }
         else 
         {
            clienttop += $t.tpanel_fbordertop.offsetHeight;
            clientheight -= ($t.tpanel_fbordertop.offsetHeight + $t.tpanel_fborderbottom.offsetHeight);
         }
      }
      $t.tcontainercontrol_fcontainer.style.height = webdom_pixelstostr(containerheight);
      $t.tcontainercontrol_fclient.style.top = webdom_pixelstostr(clienttop);
      $t.tcontainercontrol_fclient.style.height = webdom_pixelstostr(clientheight);
      if ($t.tpanel_fshowborder)
      {
         containerheight -= ($t.tpanel_fbordertop.offsetHeight + $t.tpanel_fborderbottom.offsetHeight);
         $t.tpanel_fborderleft.style.top = webdom_pixelstostr(clienttop);
         $t.tpanel_fborderleft.style.height = webdom_pixelstostr(clientheight);
         $t.tpanel_fborderright.style.top = webdom_pixelstostr(clienttop);
         $t.tpanel_fborderright.style.height = webdom_pixelstostr(clientheight);
      }
      if ($t.tpanel_fshowshadow)
         $t.tpanel_fshadowright.style.height = webdom_pixelstostr(shadowheight);
   }
   else 
      webctrls_tcontainercontrol.$p.heightchanged.call($t);
};

webctrls_tpanel.$p.widthchanged = function()
{
   var $t = this, containerwidth, clientleft, clientwidth, captionwidth, shadowwidth;
   if (($t.tcontrol_getwidth() > 0) && ($t.tpanel_fshowborder || $t.tpanel_fshowshadow))
   {
      containerwidth = $t.tcontrol_getwidth();
      if ($t.tpanel_fshowshadow)
      {
         containerwidth -= $t.tpanel_fshadowright.offsetWidth;
         shadowwidth = containerwidth;
         shadowwidth -= $t.tpanel_fshadowbottomleft.offsetWidth;
      }
      clientleft = 0;
      clientwidth = containerwidth;
      if ($t.tpanel_fshowborder)
      {
         clientleft += $t.tpanel_fborderleft.offsetWidth;
         clientwidth -= ($t.tpanel_fborderleft.offsetWidth + $t.tpanel_fborderright.offsetWidth);
         if ($t.tpanel_fshowcaption)
         {
            captionwidth = containerwidth;
            captionwidth -= ($t.tpanel_fcaptionleft.offsetWidth + $t.tpanel_fcaptionright.offsetWidth);
         }
      }
      $t.tcontainercontrol_fcontainer.style.width = webdom_pixelstostr(containerwidth);
      $t.tcontainercontrol_fclient.style.left = webdom_pixelstostr(clientleft);
      $t.tcontainercontrol_fclient.style.width = webdom_pixelstostr(clientwidth);
      if ($t.tpanel_fshowborder)
      {
         if ($t.tpanel_fshowcaption)
         {
            $t.tpanel_fcaptionbar.style.width = webdom_pixelstostr(containerwidth);
            $t.tpanel_fcaptionmiddle.style.width = webdom_pixelstostr(captionwidth);
            $t.tpanel_fcaptiontext.style.left = "";
            if ($t.tpanel_fshowclosebutton)
            {
               if ($t.tpanel_fshowicon)
                  $t.tpanel_fcaptiontext.style.width = webdom_pixelstostr($t.tpanel_fcaptionclosebutton.offsetLeft - (($t.tpanel_fcaptiontext.offsetLeft * 2) + $t.tpanel_fcaptionicon.offsetLeft + $t.tpanel_fcaptionicon.offsetWidth));
               else 
                  $t.tpanel_fcaptiontext.style.width = webdom_pixelstostr($t.tpanel_fcaptionclosebutton.offsetLeft - ($t.tpanel_fcaptiontext.offsetLeft * 2));
            }
            else 
            {
               if ($t.tpanel_fshowicon)
                  $t.tpanel_fcaptiontext.style.width = webdom_pixelstostr(captionwidth - (($t.tpanel_fcaptiontext.offsetLeft * 2) + $t.tpanel_fcaptionicon.offsetLeft + $t.tpanel_fcaptionicon.offsetWidth));
               else 
                  $t.tpanel_fcaptiontext.style.width = webdom_pixelstostr(captionwidth - ($t.tpanel_fcaptiontext.offsetLeft * 2));
            }
            if ($t.tpanel_fshowicon)
               $t.tpanel_fcaptiontext.style.left = webdom_pixelstostr(($t.tpanel_fcaptionicon.offsetLeft * 2) + $t.tpanel_fcaptionicon.offsetWidth);
            else 
               $t.tpanel_fcaptiontext.style.left = webdom_pixelstostr($t.tpanel_fcaptionicon.offsetLeft * 2);
         }
         containerwidth -= ($t.tpanel_fborderleft.offsetWidth + $t.tpanel_fborderright.offsetWidth);
         $t.tpanel_fbordertop.style.width = webdom_pixelstostr(containerwidth);
         $t.tpanel_fborderbottom.style.width = webdom_pixelstostr(containerwidth);
      }
      if ($t.tpanel_fshowshadow)
         $t.tpanel_fshadowbottom.style.width = webdom_pixelstostr(shadowwidth);
   }
   else 
      webctrls_tcontainercontrol.$p.widthchanged.call($t);
};

webctrls_tpanel.$p.checkkeydown = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tpanel_fkeypreview)
      $r = $t.dokeydown(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tpanel.$p.checkkeyup = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tpanel_fkeypreview)
      $r = $t.dokeyup(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tpanel.$p.checkkeypress = function(key, shiftkey, ctrlkey, altkey)
{
   var $t = this, $r;
   if ($t.tpanel_fkeypreview)
      $r = $t.dokeypress(key, shiftkey, ctrlkey, altkey);
   else 
      $r = true;
   return $r;
};

webctrls_tpanel.$p.doclose = function()
{
   var $t = this;
   if ($t.tpanel_fonclose)
      $t.tpanel_fonclose($t);
};

webctrls_tpanel.$p.doclosequery = function()
{
   var $t = this, $r;
   $r = true;
   if ($t.tpanel_fonclosequery)
      $r = $t.tpanel_fonclosequery($t);
   return $r;
};

webctrls_tpanel.$p.shadowheight = function()
{
   var $t = this, $r;
   if ($t.tpanel_fshowshadow)
      $r = $t.tpanel_fshadowbottom.offsetHeight;
   else 
      $r = 0;
   return $r;
};

webctrls_tpanel.$p.shadowwidth = function()
{
   var $t = this, $r;
   if ($t.tpanel_fshowshadow)
      $r = $t.tpanel_fshadowright.offsetWidth;
   else 
      $r = 0;
   return $r;
};

webctrls_tpanel.$p.wraptabcontrols = function()
{
   var $t = this, $r;
   $r = true;
   return $r;
};

webctrls_tpanel.$p.destroy = function()
{
   var $t = this;
   webctrls_tcontainercontrol.$p.destroy.call($t);
};

webctrls_tpanel.$p.close = function()
{
   var $t = this;
   if ($t.tcontrol_fvisible)
   {
      if ($t.doclosequery())
      {
         $t.hide();
         $t.doclose();
      }
   }
};


function webctrls_fontdecorationtostr(value)
{
   var $r;
   switch (value)
   {
      case webctrls_fdnormal:
      {
         $r = "none";
         break;
      }
      case webctrls_fdunderline:
      {
         $r = "underline";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_strtofontdecoration(value)
{
   var $r;
   switch (value)
   {
      case "none":
      {
         $r = webctrls_fdnormal;
         break;
      }
      case "underline":
      {
         $r = webctrls_fdunderline;
         break;
      }
      default:
      {
         $r = webctrls_fdnormal;
         break;
      }
   };
   return $r;
};

function webctrls_fontstyletostr(value)
{
   var $r;
   switch (value)
   {
      case webctrls_fsnormal:
      {
         $r = "normal";
         break;
      }
      case webctrls_fsitalic:
      {
         $r = "italic";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_strtofontstyle(value)
{
   var $r;
   switch (value)
   {
      case "normal":
      {
         $r = webctrls_fsnormal;
         break;
      }
      case "italic":
      {
         $r = webctrls_fsitalic;
         break;
      }
      default:
      {
         $r = webctrls_fsnormal;
         break;
      }
   };
   return $r;
};

function webctrls_fontweighttostr(value)
{
   var $r;
   switch (value)
   {
      case webctrls_fwnormal:
      {
         $r = "normal";
         break;
      }
      case webctrls_fwbold:
      {
         $r = "bold";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_strtofontweight(value)
{
   var $r;
   switch (value)
   {
      case "normal":
      {
         $r = webctrls_fwnormal;
         break;
      }
      case "bold":
      {
         $r = webctrls_fwbold;
         break;
      }
      default:
      {
         $r = webctrls_fwnormal;
         break;
      }
   };
   return $r;
};

function webctrls_msgdlgbtntostr(value)
{
   var $r;
   switch (value)
   {
      case webctrls_mbok:
      {
         $r = "OK";
         break;
      }
      case webctrls_mbcancel:
      {
         $r = "Cancel";
         break;
      }
      case webctrls_mbabort:
      {
         $r = "Abort";
         break;
      }
      case webctrls_mbretry:
      {
         $r = "Retry";
         break;
      }
      case webctrls_mbignore:
      {
         $r = "Ignore";
         break;
      }
      case webctrls_mbyes:
      {
         $r = "Yes";
         break;
      }
      case webctrls_mbno:
      {
         $r = "No";
         break;
      }
      case webctrls_mball:
      {
         $r = "All";
         break;
      }
      case webctrls_mbnotoall:
      {
         $r = "No to All";
         break;
      }
      case webctrls_mbyestoall:
      {
         $r = "Yes to All";
         break;
      }
      case webctrls_mbclose:
      {
         $r = "Close";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_msgdlgbtntoresult(value)
{
   var $r;
   switch (value)
   {
      case webctrls_mbok:
      {
         $r = webctrls_mrok;
         break;
      }
      case webctrls_mbcancel:
      {
         $r = webctrls_mrcancel;
         break;
      }
      case webctrls_mbabort:
      {
         $r = webctrls_mrabort;
         break;
      }
      case webctrls_mbretry:
      {
         $r = webctrls_mrretry;
         break;
      }
      case webctrls_mbignore:
      {
         $r = webctrls_mrignore;
         break;
      }
      case webctrls_mbyes:
      {
         $r = webctrls_mryes;
         break;
      }
      case webctrls_mbno:
      {
         $r = webctrls_mrno;
         break;
      }
      case webctrls_mball:
      {
         $r = webctrls_mrall;
         break;
      }
      case webctrls_mbnotoall:
      {
         $r = webctrls_mrnotoall;
         break;
      }
      case webctrls_mbyestoall:
      {
         $r = webctrls_mryestoall;
         break;
      }
      case webctrls_mbclose:
      {
         $r = webctrls_mrclose;
         break;
      }
      default:
      {
         $r = webctrls_mrnone;
         break;
      }
   };
   return $r;
};

function webctrls_scrollstyletoxstr(value, auto)
{
   var $r;
   if (auto == null)
      auto = false;
   switch (value)
   {
      case webctrls_ssnone:
      {
         $r = "hidden";
         break;
      }
      case webctrls_sshorizontal:
      {
         if (auto)
            $r = "auto";
         else 
            $r = "scroll";
         break;
      }
      case webctrls_ssvertical:
      {
         $r = "hidden";
         break;
      }
      case webctrls_ssboth:
      {
         if (auto)
            $r = "auto";
         else 
            $r = "scroll";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_scrollstyletoystr(value, auto)
{
   var $r;
   if (auto == null)
      auto = false;
   switch (value)
   {
      case webctrls_ssnone:
      {
         $r = "hidden";
         break;
      }
      case webctrls_sshorizontal:
      {
         $r = "hidden";
         break;
      }
      case webctrls_ssvertical:
      {
         if (auto)
            $r = "auto";
         else 
            $r = "scroll";
         break;
      }
      case webctrls_ssboth:
      {
         if (auto)
            $r = "auto";
         else 
            $r = "scroll";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};

function webctrls_alignmenttostr(value)
{
   var $r;
   switch (value)
   {
      case webctrls_taleftjustify:
      {
         $r = "left";
         break;
      }
      case webctrls_tacenter:
      {
         $r = "center";
         break;
      }
      case webctrls_tarightjustify:
      {
         $r = "right";
         break;
      }
      default:
      {
         $r = "";
         break;
      }
   };
   return $r;
};


function webctrls_init()
{
   webctrls_textmanager = webctrls_ttextmanager.create(new webctrls_ttextmanager());
   webctrls_dragdropmanager = tobject.create(new webctrls_tdragdropmanager());
   webctrls_columnsizingmanager = tobject.create(new webctrls_tcolumnsizingmanager());
};

function webctrls_final()
{
   webctrls_columnsizingmanager = tobject.free(webctrls_columnsizingmanager);
   webctrls_textmanager = tobject.free(webctrls_textmanager);
};

// WebForms Unit Implementation Declarations

// TDesktop Class Declarations

function webforms_tdesktop()
{
   var $t = this;
   webctrls_tcontainercontrol.call($t);
   $t.tdesktop_fforms = null;
   $t.tdesktop_factiveform = null;
   $t.tdesktop_fautoheight = false;
   $t.tdesktop_fautowidth = true;
   $t.tdesktop_fmodalcount = 0;
   $t.tdesktop_fmodaloverlay = null;
   $t.tdesktop_fmodalclickhandler = null;
   $t.tdesktop_fresizescreenhandler = null;
   $t.tdesktop_fonresize = null;
   $t.tdesktop_fresettingtheme = false;
}

webforms_tdesktop.create = function(instance, aowner)
{
   webctrls_tcontrol.create(instance, aowner);
   instance.tdesktop_fforms = webcore_tobjectlist.create1(new webcore_tobjectlist(), false);
   instance.setzindex(1);
   return instance;
};

webforms_tdesktop.prototype = $i(webctrls_tcontainercontrol);
webforms_tdesktop.$p = webforms_tdesktop.prototype;
webforms_tdesktop.$p.constructor = webforms_tdesktop;

webforms_tdesktop.$p.tdesktop_setautoheight = function(value)
{
   var $t = this;
   if (value != $t.tdesktop_fautoheight)
   {
      if (value)
         $t.tcontrol_fbase.style.height = "100%";
      else 
         $t.tcontrol_fbase.style.height = webdom_pixelstostr($t.tcontrol_fbase.offsetHeight);
      $t.tdesktop_fautoheight = value;
      webctrls_tcontainercontrol.$p.heightchanged.call($t);
      $t.positionforms();
   }
};

webforms_tdesktop.$p.tdesktop_setautowidth = function(value)
{
   var $t = this;
   if (value != $t.tdesktop_fautowidth)
   {
      if (value)
         $t.tcontrol_fbase.style.width = "100%";
      else 
         $t.tcontrol_fbase.style.width = webdom_pixelstostr($t.tcontrol_fbase.offsetWidth);
      $t.tdesktop_fautowidth = value;
      webctrls_tcontainercontrol.$p.widthchanged.call($t);
      $t.positionforms();
   }
};

webforms_tdesktop.$p.tdesktop_getformcount = function()
{
   var $t = this, $r;
   $r = $t.tdesktop_fforms.tobjectlist_fcount;
   return $r;
};

webforms_tdesktop.$p.tdesktop_modalclickhandler = function(event)
{
   var $t = this, $r;
   if ($t.tdesktop_factiveform)
      $t.tdesktop_factiveform.setfocus();
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webforms_tdesktop.$p.tdesktop_resizescreenhandler = function(event)
{
   var $t = this, $r;
   $t.doresize();
   webdom_canceleventbubble(event);
   $r = true;
   webdom_seteventresult(event, $r);
   return $r;
};

webforms_tdesktop.$p.initelement = function()
{
   var $t = this;
   webctrls_tcontainercontrol.$p.initelement.call($t);
   webdom_getbodyelement().appendChild($t.tcontrol_fbase);
   $t.tcontrol_fbase.className = "dsk";
   $t.tcontrol_fbase.style.height = "100%";
   $t.tcontrol_fbase.style.width = "100%";
   webctrls_tcontainercontrol.$p.heightchanged.call($t);
   webctrls_tcontainercontrol.$p.widthchanged.call($t);
};

webforms_tdesktop.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   $t.tdesktop_fresizescreenhandler = webdom_setwindoweventhandler("resize", function(event) { webforms_tdesktop.$p.tdesktop_resizescreenhandler.call($t, event); });
};

webforms_tdesktop.$p.cleareventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
   webdom_clearwindoweventhandler("resize", function(event) { webforms_tdesktop.$p.tdesktop_resizescreenhandler.call($t, event); });
};

webforms_tdesktop.$p.heightchanged = function()
{
   var $t = this;
   if (!$t.tdesktop_fresettingtheme)
      $t.tdesktop_setautoheight(false);
   $t.positionforms();
   webctrls_tcontainercontrol.$p.heightchanged.call($t);
};

webforms_tdesktop.$p.widthchanged = function()
{
   var $t = this;
   if (!$t.tdesktop_fresettingtheme)
      $t.tdesktop_setautowidth(false);
   $t.positionforms();
   webctrls_tcontainercontrol.$p.widthchanged.call($t);
};

webforms_tdesktop.$p.doclick = function()
{
   var $t = this, $r;
   webctrls_tcontrol.$p.doclick.call($t);
   $r = false;
   return $r;
};

webforms_tdesktop.$p.dodblclick = function()
{
   var $t = this, $r;
   webctrls_tcontrol.$p.dodblclick.call($t);
   $r = false;
   return $r;
};

webforms_tdesktop.$p.domousedown = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   webctrls_tcontrol.$p.domousedown.call($t, button, shiftkey, ctrlkey, altkey, x, y);
   $r = false;
   return $r;
};

webforms_tdesktop.$p.domousemove = function(shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   webctrls_tcontrol.$p.domousemove.call($t, shiftkey, ctrlkey, altkey, x, y);
   $r = false;
   return $r;
};

webforms_tdesktop.$p.domouseup = function(button, shiftkey, ctrlkey, altkey, x, y)
{
   var $t = this, $r;
   webctrls_tcontrol.$p.domouseup.call($t, button, shiftkey, ctrlkey, altkey, x, y);
   $r = false;
   return $r;
};

webforms_tdesktop.$p.addform = function(value)
{
   var $t = this;
   $t.tdesktop_fforms.add(value);
   $t.updateformzindexes();
   $t.activeformchanged();
};

webforms_tdesktop.$p.removeform = function(value)
{
   var $t = this;
   $t.tdesktop_fforms.remove1(value);
   $t.updateformzindexes();
   $t.activeformchanged();
};

webforms_tdesktop.$p.setformposition = function(form, newpos)
{
   var $t = this, index;
   index = $t.tdesktop_fforms.indexof(form);
   if (index != -1)
   {
      if (newpos < 0)
         newpos = 0;
      if (newpos >= $t.tdesktop_fforms.tobjectlist_fcount)
         newpos = ($t.tdesktop_fforms.tobjectlist_fcount - 1);
      if (newpos != index)
      {
         $t.tdesktop_fforms.remove(index);
         $t.tdesktop_fforms.insert(newpos, form);
         $t.updateformzindexes();
      }
      $t.activeformchanged();
   }
};

webforms_tdesktop.$p.updateformzindexes = function()
{
   var $t = this, i;
   if ((!$t.tcomponent_fdestroying) && ($t.tdesktop_fforms.tobjectlist_fcount > 0))
   {
      for (i = 0 ; i <= $t.tdesktop_fforms.tobjectlist_fcount - 1 ; i++)
         $t.tdesktop_fforms.getobject(i).setzindex(i + 1);
      if ($t.tdesktop_fmodalcount > 0)
      {
         $t.tdesktop_fmodaloverlay.style.zIndex = inttostr($t.tdesktop_fforms.tobjectlist_fcount);
         $t.tdesktop_fforms.last().setzindex($t.tdesktop_fforms.tobjectlist_fcount + 1);
      }
      else 
         $t.tdesktop_fforms.last().setzindex($t.tdesktop_fforms.tobjectlist_fcount);
   }
};

webforms_tdesktop.$p.activeformchanged = function()
{
   var $t = this, tempform, i;
   if ($t.tdesktop_fforms.tobjectlist_fcount > 0)
   {
      if (($t.tdesktop_factiveform != $t.tdesktop_fforms.last()) || (!$t.tdesktop_factiveform.tcontrol_fvisible))
      {
         tempform = $t.tdesktop_factiveform;
         $t.tdesktop_factiveform = null;
         if (tempform)
            tempform.updatecontroltabindexes();
         i = ($t.tdesktop_fforms.tobjectlist_fcount - 1);
         while ((i >= 0) && (!$t.tdesktop_fforms.getobject(i).tcontrol_fvisible))
            i--;
         if (i >= 0)
            $t.tdesktop_factiveform = $t.tdesktop_fforms.getobject(i);
         if ($t.tdesktop_factiveform)
         {
            $t.tdesktop_factiveform.updatecontroltabindexes();
            $t.tdesktop_factiveform.setfocus();
         }
      }
      else 
      {
         if ($t.tdesktop_factiveform)
            $t.tdesktop_factiveform.setfocus();
      }
   }
   else 
      $t.tdesktop_factiveform = null;
};

webforms_tdesktop.$p.startmodalform = function(form, overlaycolor, overlayopacity)
{
   var $t = this;
   if (overlaycolor == null)
      overlaycolor = webctrls_clblack;
   if (overlayopacity == null)
      overlayopacity = 20;
   if ($t.tdesktop_fmodalcount == 0)
   {
      $t.tdesktop_fmodaloverlay = window.document.createElement("div");
      with ($t.tdesktop_fmodaloverlay.style)
      {
         position = "absolute";
         display = "none";
         cursor = "wait";
         filter = "alpha(opacity=" + floattostr(overlayopacity) + ")";
         opacity = floattostr(overlayopacity / 100);
         backgroundColor = webdom_colortostr(overlaycolor);
         top = webdom_pixelstostr(0);
         left = webdom_pixelstostr(0);
         height = webdom_pixelstostr($t.tcontrol_getheight());
         width = webdom_pixelstostr($t.tcontrol_getwidth());
      }
      webdom_getbodyelement().appendChild($t.tdesktop_fmodaloverlay);
      $t.tdesktop_fmodaloverlay.style.display = "";
      $t.tdesktop_fmodalclickhandler = webdom_seteventhandler($t.tdesktop_fmodaloverlay, "click", function(event) { webforms_tdesktop.$p.tdesktop_modalclickhandler.call($t, event); });
   }
   $t.tdesktop_fmodalcount++;
};

webforms_tdesktop.$p.endmodalform = function()
{
   var $t = this;
   if ($t.tdesktop_fmodalcount > 0)
      $t.tdesktop_fmodalcount--;
   if ($t.tdesktop_fmodalcount == 0)
   {
      if ($t.tdesktop_fmodaloverlay)
      {
         webdom_cleareventhandler($t.tdesktop_fmodaloverlay, "click", $t.tdesktop_fmodalclickhandler);
         webdom_getbodyelement().removeChild($t.tdesktop_fmodaloverlay);
         $t.tdesktop_fmodaloverlay = null;
      }
   }
   $t.updateformzindexes();
};

webforms_tdesktop.$p.domsgdlgclose = function(sender)
{
   var $t = this;
   try
   {
      sender.doresult(sender.tform_fmodalresult);
   }
   finally
   {
      sender = tobject.free(sender);
   }
};

webforms_tdesktop.$p.domsgdlgbtnclick = function(sender)
{
   var $t = this;
   sender.tcomponent_fowner.tform_setmodalresult(sender.tbutton_fmodalresult);
};

webforms_tdesktop.$p.resetformstheme = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tdesktop_fforms.tobjectlist_fcount - 1 ; i++)
      $t.tdesktop_fforms.getobject(i).resettheme();
};

webforms_tdesktop.$p.resettheme = function()
{
   var $t = this;
   $t.tdesktop_fresettingtheme = true;
   try
   {
      webctrls_tcontainercontrol.$p.resettheme.call($t);
      $t.resetformstheme();
   }
   finally
   {
      $t.tdesktop_fresettingtheme = false;
      $t.doresize();
   }
};

webforms_tdesktop.$p.positionforms = function()
{
   var $t = this, i;
   if ($t.tdesktop_fforms.tobjectlist_fcount > 0)
   {
      for (i = 0 ; i <= $t.tdesktop_fforms.tobjectlist_fcount - 1 ; i++)
         $t.tdesktop_fforms.getobject(i).positionform();
   }
};

webforms_tdesktop.$p.updatesize = function()
{
   var $t = this;
   if ($t.tdesktop_fautoheight)
   {
      $t.tcontrol_fbase.style.height = "100%";
      webctrls_tcontainercontrol.$p.heightchanged.call($t);
      $t.positionforms();
   }
   if ($t.tdesktop_fautowidth)
   {
      $t.tcontrol_fbase.style.width = "100%";
      webctrls_tcontainercontrol.$p.widthchanged.call($t);
      $t.positionforms();
   }
};

webforms_tdesktop.$p.doresize = function()
{
   var $t = this;
   $t.updatesize();
   if ($t.tdesktop_fonresize)
      $t.tdesktop_fonresize($t);
};

webforms_tdesktop.$p.destroy = function()
{
   var $t = this;
   $t.tdesktop_fforms = tobject.free($t.tdesktop_fforms);
   webctrls_tcontainercontrol.$p.destroy.call($t);
};

webforms_tdesktop.$p.messagedlg = function(msg, dlgcaption, dlgtype, buttons, defaultbutton, msgdlgresult, closebutton, overlaycolor, overlayopacity)
{
   var $t = this, tempform, templabel, tempbutton, tempdefaultbutton, tempwidth, tempcaption, tempbuttonwidth, templeft, i;
   if (msgdlgresult == null)
      msgdlgresult = null;
   if (closebutton == null)
      closebutton = false;
   if (overlaycolor == null)
      overlaycolor = webctrls_clblack;
   if (overlayopacity == null)
      overlayopacity = 20;
   if (length(buttons) > 0)
   {
      tempform = webforms_tform.create(new webforms_tmsgdlgform(), webforms_application);
      with (tempform)
      {
         tpanel_setshowclosebutton(closebutton);
         tpanel_setcaption(dlgcaption);
         switch (dlgtype)
         {
            case webforms_mtwarning:
            {
               tpanel_fcaptionicon.className = "dlg_wrn_cap_ico";
               break;
            }
            case webforms_mterror:
            {
               tpanel_fcaptionicon.className = "dlg_err_cap_ico";
               break;
            }
            case webforms_mtinformation:
            {
               tpanel_fcaptionicon.className = "dlg_inf_cap_ico";
               break;
            }
            case webforms_mtconfirmation:
            {
               tpanel_fcaptionicon.className = "dlg_cnf_cap_ico";
               break;
            }
            case webforms_mtcustom:
            {
               tpanel_setshowicon(false);
               break;
            }
            default:
            {
               tpanel_setshowicon(false);
               break;
            }
         };
         tcontrol_setheight($t.tcontrol_getheight());
         tcontrol_setwidth(((floor($t.tcontrol_getwidth() / 4)) + (webforms_msgdlg_padding * 2)));
      }
      templabel = webctrls_tcontrol.create(new webctrls_tlabel(), tempform);
      with (templabel)
      {
         tcontrol_settop(webforms_msgdlg_padding);
         tcontrol_setleft(webforms_msgdlg_padding);
         tcontrol_setheight(40);
         tcontrol_setwidth((tempform.tcontrol_getwidth() - (webforms_msgdlg_padding * 2)));
         loaded();
         tlabel_setcaption(msg);
         tlabel_setwordwrap(true);
         tempwidth = max(300, (tcontrol_getwidth() + (webforms_msgdlg_padding * 2)));
      }
      tempbuttonwidth = 50;
      for (i = 0 ; i <= length(buttons) - 1 ; i++)
      {
         tempcaption = webctrls_msgdlgbtntostr(buttons[i]);
         tempbuttonwidth = max(tempbuttonwidth, webctrls_textmanager.textwidth(tempcaption, tempform.tcontrol_ffont));
      }
      tempbuttonwidth += (webforms_msgdlg_button_padding * 2);
      templeft = (tempwidth - webforms_msgdlg_padding - ((length(buttons) * tempbuttonwidth) + ((length(buttons) - 1) * webforms_msgdlg_button_spacing)));
      tempdefaultbutton = null;
      for (i = 0 ; i <= length(buttons) - 1 ; i++)
      {
         tempbutton = webctrls_tinputcontrol.create(new webctrls_tbutton(), tempform);
         with (tempbutton)
         {
            tcontrol_settop((templabel.tcontrol_gettop() + templabel.tcontrol_getheight() + webforms_msgdlg_padding));
            tcontrol_setleft(templeft);
            tcontrol_setwidth(tempbuttonwidth);
            setcaption(webctrls_msgdlgbtntostr(buttons[i]));
            tbutton_fmodalresult = webctrls_msgdlgbtntoresult(buttons[i]);
            tcontrol_fonclick = function(sender) { webforms_tdesktop.$p.domsgdlgbtnclick.call($t, sender); };
         }
         if (buttons[i] == defaultbutton)
            tempdefaultbutton = tempbutton;
         templeft += (tempbuttonwidth + webforms_msgdlg_button_spacing);
      }
      with (tempform)
      {
         tcontainercontrol_setclientheight((templabel.tcontrol_getheight() + (webforms_msgdlg_padding * 3) + tempbutton.tcontrol_getheight()));
         tcontainercontrol_setclientwidth(tempwidth);
         tpanel_fenabledrag = true;
         tform_setposition(webforms_podesktopcenter);
         tpanel_fonclose = function(sender) { webforms_tdesktop.$p.domsgdlgclose.call($t, sender); };
         tmsgdlgform_fonresult = msgdlgresult;
         showmodal(overlaycolor, overlayopacity);
      }
      if (tempdefaultbutton)
         tempdefaultbutton.setfocus();
   }
};

// TApplication Class Declarations

function webforms_tapplication()
{
   var $t = this;
   webcore_tcomponent.call($t);
   $t.tapplication_finitialized = false;
   $t.tapplication_frunning = false;
   $t.tapplication_fdesktop = null;
   $t.tapplication_fonerror = null;
   $t.tapplication_fhandlingerror = false;
   $t.tapplication_fimagepath = "";
   $t.tapplication_fthemepath = "";
   $t.tapplication_ftheme = "";
   $t.tapplication_fmainform = null;
}

webforms_tapplication.create = function(instance, aowner)
{
   webcore_tcomponent.create(instance, aowner);
   instance.tapplication_fdesktop = webforms_tdesktop.create(new webforms_tdesktop(), instance);
   return instance;
};

webforms_tapplication.prototype = $i(webcore_tcomponent);
webforms_tapplication.$p = webforms_tapplication.prototype;
webforms_tapplication.$p.constructor = webforms_tapplication;

webforms_tapplication.$p.tapplication_setactivetheme = function(value)
{
   var $t = this;
   webdom_setactivestylesheet(value);
   $t.tapplication_fdesktop.resettheme();
};

webforms_tapplication.$p.tapplication_settheme = function(value)
{
   var $t = this;
   if (value != $t.tapplication_ftheme)
   {
      if ($t.tapplication_finitialized)
         $t.tapplication_setactivetheme(value);
      $t.tapplication_ftheme = value;
   }
};

webforms_tapplication.$p.tapplication_errorhandler = function(message, url, line)
{
   var $t = this, $r, tempbuttons = [webctrls_mbok];
   if (!$t.tapplication_fhandlingerror)
   {
      $t.tapplication_fhandlingerror = true;
      try
      {
         if ($t.tapplication_fonerror)
            $r = $t.tapplication_fonerror($t, message, url, line);
         else 
         {
            $r = true;
            if ($t.tapplication_fdesktop)
               $t.tapplication_fdesktop.messagedlg(message + "<br><br><b>Line:</b> " + inttostr(line), "Application Error", webforms_mterror, tempbuttons, webctrls_mbok);
         }
      }
      finally
      {
         $t.tapplication_fhandlingerror = false;
      }
   }
   return $r;
};

webforms_tapplication.$p.destroy = function()
{
   var $t = this;
   $t.tapplication_fdesktop = tobject.free($t.tapplication_fdesktop);
   webcore_tcomponent.$p.destroy.call($t);
};

webforms_tapplication.$p.initialize = function()
{
   var $t = this;
   if (!$t.tapplication_finitialized)
   {
      window.onerror = function(message, url, line) { webforms_tapplication.$p.tapplication_errorhandler.call($t, message, url, line); };
      if ($t.tapplication_ftheme == "")
         $t.tapplication_ftheme = "Default";
      $t.tapplication_setactivetheme($t.tapplication_ftheme);
      $t.tapplication_finitialized = true;
   }
};

webforms_tapplication.$p.run = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.getcomponentcount() - 1 ; i++)
   {
      if ($t.getcomponent(i) instanceof webforms_tform)
      {
         if ($t.tapplication_fmainform == null)
            $t.tapplication_fmainform = $t.getcomponent(i);
      }
   }
   $t.tapplication_fmainform.tcontrol_setvisible(true);
   $t.tapplication_frunning = true;
};

// TForm Class Declarations

function webforms_tform()
{
   var $t = this;
   webctrls_tpanel.call($t);
   $t.tform_fmodal = false;
   $t.tform_fmodalresult = 0;
   $t.tform_foncreate = null;
   $t.tform_fondestroy = null;
   $t.tform_fthemecolor = true;
   $t.tform_fthemefont = true;
   $t.tform_fposition = 0;
   $t.tform_factivatemousedownhandler = null;
}

webforms_tform.create = function(instance, aowner)
{
   webctrls_tpanel.create(instance, aowner);
   webforms_application.tapplication_fdesktop.addform(instance);
   instance.tcontrol_setvisible(false);
   instance.tpanel_setshowshadow(true);
   instance.tpanel_setshowclosebutton(true);
   instance.initialize();
   instance.docreate();
   return instance;
};

webforms_tform.prototype = $i(webctrls_tpanel);
webforms_tform.$p = webforms_tform.prototype;
webforms_tform.$p.constructor = webforms_tform;

webforms_tform.$p.tform_setthemecolor = function(value)
{
   var $t = this;
   if (value != $t.tform_fthemecolor)
   {
      $t.tform_fthemecolor = value;
      if ($t.tform_fthemecolor)
      {
         $t.setcontrolproperties();
         $t.setallcontrolproperties();
      }
   }
};

webforms_tform.$p.tform_setmodalresult = function(value)
{
   var $t = this;
   if ($t.tform_fmodal && (value >= 0) && (value <= 10))
   {
      $t.tform_fmodalresult = value;
      if ($t.tform_fmodalresult != webctrls_mrnone)
         $t.close();
   }
};

webforms_tform.$p.tform_setposition = function(value)
{
   var $t = this;
   if ((value != $t.tform_fposition) && (value >= 0) && (value <= 2))
   {
      $t.tform_fposition = value;
      $t.positionform();
   }
};

webforms_tform.$p.tform_activatemousedownhandler = function(event)
{
   var $t = this, $r;
   $t.bringtofront();
   webdom_canceleventbubble(event);
   $r = false;
   webdom_seteventresult(event, $r);
   return $r;
};

webforms_tform.$p.getclassprefix = function()
{
   var $t = this, $r;
   $r = "frm";
   return $r;
};

webforms_tform.$p.initelement = function()
{
   var $t = this;
   webdom_getbodyelement().appendChild($t.tcontrol_fbase);
   webctrls_tpanel.$p.initelement.call($t);
};

webforms_tform.$p.seteventhandlers = function()
{
   var $t = this;
   webctrls_tcontrol.$p.seteventhandlers.call($t);
   if ($t.tcontainercontrol_fcontainer)
      $t.tform_factivatemousedownhandler = webdom_seteventhandler($t.tcontainercontrol_fcontainer, "mousedown", function(event) { webforms_tform.$p.tform_activatemousedownhandler.call($t, event); });
};

webforms_tform.$p.cleareventhandlers = function()
{
   var $t = this;
   if ($t.tcontainercontrol_fcontainer)
      webdom_cleareventhandler($t.tcontainercontrol_fcontainer, "mousedown", $t.tform_factivatemousedownhandler);
   webctrls_tcontrol.$p.cleareventhandlers.call($t);
};

webforms_tform.$p.setcontrolproperties = function()
{
   var $t = this, tempstyle;
   if ($t.tcontainercontrol_fcontainer)
   {
      tempstyle = webdom_getcssstyle($t.tcontainercontrol_fcontainer);
      if ($t.tform_fthemecolor)
         $t.applycolorstyle(tempstyle);
      if ($t.tform_fthemefont)
         $t.applyfontstyle(tempstyle);
   }
   if ($t.tcontainercontrol_fclient)
   {
      tempstyle = webdom_getcssstyle($t.tcontainercontrol_fclient);
      if ($t.tform_fthemecolor)
         $t.applycolorstyle(tempstyle);
      if ($t.tform_fthemefont)
         $t.applyfontstyle(tempstyle);
   }
};

webforms_tform.$p.setallcontrolproperties = function()
{
   var $t = this, i;
   for (i = 0 ; i <= $t.tcontainercontrol_getcontrolcount() - 1 ; i++)
      $t.tcontainercontrol_getcontrol(i).setcontrolproperties();
};

webforms_tform.$p.positionform = function()
{
   var $t = this;
   switch ($t.tform_fposition)
   {
      case webforms_podesktopcenter:
      {
         $t.tcontrol_settop((floor((webforms_application.tapplication_fdesktop.tcontainercontrol_getclientheight() - ($t.tcontrol_getheight() - $t.shadowheight())) / 2)));
         $t.tcontrol_setleft((floor((webforms_application.tapplication_fdesktop.tcontainercontrol_getclientwidth() - ($t.tcontrol_getwidth() - $t.shadowwidth())) / 2)));
         break;
      }
      case webforms_podesktopcentertop:
      {
         $t.tcontrol_settop(0);
         $t.tcontrol_setleft((floor((webforms_application.tapplication_fdesktop.tcontainercontrol_getclientwidth() - ($t.tcontrol_getwidth() - $t.shadowwidth())) / 2)));
         break;
      }
   };
};

webforms_tform.$p.activatecontainer = function()
{
   var $t = this;
   $t.bringtofront();
};

webforms_tform.$p.closecontainer = function(value)
{
   var $t = this;
   $t.tform_setmodalresult(value);
};

webforms_tform.$p.tabindexenabled = function()
{
   var $t = this, $r;
   if (!$t.tcomponent_fdestroying)
      $r = (webforms_application.tapplication_fdesktop.tdesktop_factiveform == $t);
   else 
      $r = false;
   return $r;
};

webforms_tform.$p.initialize = function()
{
   var $t = this;
   $t.loaded();
};

webforms_tform.$p.doclose = function()
{
   var $t = this;
   if ($t.tform_fmodal)
   {
      webforms_application.tapplication_fdesktop.endmodalform();
      $t.tform_fmodal = false;
   }
   webctrls_tpanel.$p.doclose.call($t);
};

webforms_tform.$p.docreate = function()
{
   var $t = this;
   if ($t.tform_foncreate)
      $t.tform_foncreate($t);
};

webforms_tform.$p.dodestroy = function()
{
   var $t = this;
   if ($t.tform_fondestroy)
      $t.tform_fondestroy($t);
};

webforms_tform.$p.destroy = function()
{
   var $t = this;
   if (webforms_application.tapplication_fdesktop)
      webforms_application.tapplication_fdesktop.removeform($t);
   $t.dodestroy();
   webctrls_tpanel.$p.destroy.call($t);
};

webforms_tform.$p.bringtofront = function()
{
   var $t = this;
   webforms_application.tapplication_fdesktop.setformposition($t, webforms_application.tapplication_fdesktop.tdesktop_getformcount() - 1);
};

webforms_tform.$p.sendtoback = function()
{
   var $t = this;
   webforms_application.tapplication_fdesktop.setformposition($t, 0);
};

webforms_tform.$p.show = function()
{
   var $t = this;
   if (!$t.tcontrol_fvisible)
   {
      webctrls_tcontrol.$p.show.call($t);
      $t.positionform();
      $t.firstcontrol();
   }
   $t.bringtofront();
};

webforms_tform.$p.hide = function()
{
   var $t = this;
   if ($t.tcontrol_fvisible)
   {
      webctrls_tcontainercontrol.$p.hide.call($t);
      $t.sendtoback();
   }
};

webforms_tform.$p.showmodal = function(overlaycolor, overlayopacity)
{
   var $t = this;
   if (overlaycolor == null)
      overlaycolor = webctrls_clblack;
   if (overlayopacity == null)
      overlayopacity = 20;
   if (!$t.tcontrol_fvisible)
   {
      webforms_application.tapplication_fdesktop.startmodalform($t, overlaycolor, overlayopacity);
      $t.show();
      $t.tform_fmodal = true;
   }
};

// TMsgDlgForm Class Declarations

function webforms_tmsgdlgform()
{
   var $t = this;
   webforms_tform.call($t);
   $t.tmsgdlgform_fonresult = null;
}

webforms_tmsgdlgform.prototype = $i(webforms_tform);
webforms_tmsgdlgform.$p = webforms_tmsgdlgform.prototype;
webforms_tmsgdlgform.$p.constructor = webforms_tmsgdlgform;

webforms_tmsgdlgform.$p.doresult = function(dlgresult)
{
   var $t = this;
   if ($t.tmsgdlgform_fonresult)
      $t.tmsgdlgform_fonresult(dlgresult);
};


function webforms_init()
{
   webforms_application = webforms_tapplication.create(new webforms_tapplication(), null);
};

function webforms_final()
{
   webforms_application = tobject.free(webforms_application);
};

// Unit1 Unit Interface Declarations

var unit1_form1;

// Unit1 Unit Implementation Declarations

// TForm1 Class Declarations

function unit1_tform1()
{
   var $t = this;
   webforms_tform.call($t);
   $t.tform1_image1 = null;
   $t.tform1_panel1 = null;
   $t.tform1_label1 = null;
   $t.tform1_label2 = null;
   $t.tform1_label3 = null;
   $t.tform1_label4 = null;
   $t.tform1_label5 = null;
   $t.tform1_label6 = null;
   $t.tform1_homepanel = null;
   $t.tform1_label9 = null;
   $t.tform1_label10 = null;
   $t.tform1_label11 = null;
   $t.tform1_edit1 = null;
   $t.tform1_edit2 = null;
   $t.tform1_image2 = null;
   $t.tform1_label7 = null;
   $t.tform1_image3 = null;
   $t.tform1_label15 = null;
   $t.tform1_label20 = null;
   $t.tform1_image5 = null;
   $t.tform1_label19 = null;
   $t.tform1_label21 = null;
   $t.tform1_label8 = null;
   $t.tform1_productpanel = null;
   $t.tform1_image6 = null;
   $t.tform1_label23 = null;
   $t.tform1_label25 = null;
   $t.tform1_downloadpanel = null;
   $t.tform1_supportpanel = null;
   $t.tform1_label37 = null;
   $t.tform1_label38 = null;
   $t.tform1_label39 = null;
   $t.tform1_salespanel = null;
   $t.tform1_label44 = null;
   $t.tform1_label45 = null;
   $t.tform1_label46 = null;
   $t.tform1_registerpanel = null;
   $t.tform1_label51 = null;
   $t.tform1_label52 = null;
   $t.tform1_label54 = null;
   $t.tform1_label55 = null;
   $t.tform1_label56 = null;
   $t.tform1_label57 = null;
   $t.tform1_label58 = null;
   $t.tform1_emailedit = null;
   $t.tform1_passwordedit = null;
   $t.tform1_passwordcedit = null;
   $t.tform1_companyedit = null;
   $t.tform1_contactedit = null;
   $t.tform1_telephoneedit = null;
   $t.tform1_label59 = null;
   $t.tform1_label53 = null;
   $t.tform1_errorpanel = null;
   $t.tform1_label60 = null;
   $t.tform1_label61 = null;
   $t.tform1_label62 = null;
   $t.tform1_label24 = null;
   $t.tform1_label27 = null;
   $t.tform1_label26 = null;
   $t.tform1_label28 = null;
   $t.tform1_label63 = null;
   $t.tform1_image9 = null;
   $t.tform1_image15 = null;
   $t.tform1_label32 = null;
   $t.tform1_label31 = null;
   $t.tform1_label33 = null;
   $t.tform1_image8 = null;
   $t.tform1_timer1 = null;
   $t.tform1_label34 = null;
   $t.tform1_label14 = null;
   $t.tform1_label35 = null;
   $t.tform1_label40 = null;
   $t.tform1_label41 = null;
   $t.tform1_label42 = null;
   $t.tform1_label47 = null;
   $t.tform1_edit3 = null;
   $t.tform1_edit4 = null;
   $t.tform1_edit5 = null;
   $t.tform1_edit6 = null;
   $t.tform1_memo1 = null;
   $t.tform1_label48 = null;
   $t.tform1_checkbox1 = null;
   $t.tform1_label49 = null;
   $t.tform1_label64 = null;
   $t.tform1_label65 = null;
   $t.tform1_image4 = null;
   $t.tform1_image10 = null;
   $t.tform1_label12 = null;
   $t.tform1_label13 = null;
   $t.tform1_label16 = null;
   $t.fcolor = 0;
   $t.requestqueue = null;
   $t.phpfunction = 0;
   $t.adv1 = "";
   $t.adv2 = "";
   $t.adv3 = "";
   $t.advheader1 = "";
   $t.advheader2 = "";
   $t.advheader3 = "";
   $t.addcount = 0;
   $t.loggedon = false;
}

unit1_tform1.prototype = $i(webforms_tform);
unit1_tform1.$p = unit1_tform1.prototype;
unit1_tform1.$p.constructor = unit1_tform1;

unit1_tform1.$p.tform1_form1create = function(sender)
{
   var $t = this;
   $t.fcolor = $t.tcontrol_fcolor;
   $t.addcount = 0;
   $t.adv1 = "IQExport for TargetView was released for testing on 25 March 2012. It was beta tested up to 3 million records, which TargetView imported with ease." + "\n   It is currently being tested by a number of our distributors for final release on 30 th March. Please contact Targetview if you" + " would like to participate in the final testing";
   $t.advheader1 = "IQExport released";
   $t.adv2 = "PastelExport for TargetView was released for testing on 25 March 2012. It was beta tested on 300,000 records, which TargetView imported with ease." + "\n   It is currently being tested by a number of our distributors for final release on 30 th March. Please contact Targetview if you" + " would like to participate in the final testing. It exports 300,000 records in under 60 seconds";
   $t.advheader2 = "PastelExport released";
   $t.adv3 = "TargetView! The final release date is 31 March 2012. Please download the demo version from the website to get the TargetView Experience!" + "\n" + "\n" + " We unlock your data.";
   $t.advheader3 = "TargetView released";
   $t.tform1_label19.tlabel_setcaption($t.advheader3);
   $t.tform1_label21.tlabel_setcaption($t.adv3);
   $t.tform1_image8.timage_setimagename("images/targetview.jpg");
   $t.requestqueue = webhttp_tserverrequestqueue.create(new webhttp_tserverrequestqueue(), null);
   $t.tform1_homepanel.tcontrol_setleft(192);
   $t.tform1_homepanel.tcontrol_settop(137);
   $t.tform1_homepanel.bringtofront();
   $t.loggedon = false;
   $t.tform1_image1.timage_setimagename("images/Background.gif");
   $t.tform1_image2.timage_setimagename("images/TargetView.jpg");
   $t.tform1_image5.timage_setimagename("images/img3.gif");
   $t.tform1_image3.timage_setimagename("images/dreaM.JPG");
   $t.tform1_image6.timage_setimagename("images/netops.jpg");
   $t.tform1_image9.timage_setimagename("images/iqenterprise.jpg");
   $t.tform1_image15.timage_setimagename("images/pastel.jpg");
   $t.tform1_image10.timage_setimagename("images/support.jpg");
   $t.tform1_image4.timage_setimagename("images/download.jpg");
};

unit1_tform1.$p.tform1_label1mouseenter = function(sender)
{
   var $t = this;
   sender.tcontrol_ffont.tfont_setcolor(webctrls_clwhite);
};

unit1_tform1.$p.tform1_label1mouseleave = function(sender)
{
   var $t = this;
   sender.tcontrol_ffont.tfont_setcolor(webctrls_clgray);
};

unit1_tform1.$p.tform1_edit1change = function(sender)
{
   var $t = this;
   $t.tform1_label7.tcontrol_setvisible(($t.tform1_edit1.teditcontrol_gettext() > "") && ($t.tform1_edit2.teditcontrol_gettext() > ""));
};

unit1_tform1.$p.tform1_label13click = function(sender)
{
};

unit1_tform1.$p.tform1_label2click = function(sender)
{
   var $t = this;
   $t.setuppanel($t.tform1_productpanel);
};

unit1_tform1.$p.tform1_label1click = function(sender)
{
   var $t = this;
   $t.tform1_homepanel.tcontrol_setparentcolor(false);
   $t.tform1_homepanel.setcolor(webctrls_clivory);
   $t.tform1_homepanel.bringtofront();
};

unit1_tform1.$p.tform1_label4click = function(sender)
{
   var $t = this;
   $t.setuppanel($t.tform1_downloadpanel);
   $t.tform1_label65.tcontrol_setvisible(false);
};

unit1_tform1.$p.tform1_label3click = function(sender)
{
   var $t = this;
   $t.tform1_supportpanel.setcolor(webctrls_clformbackground);
   $t.setuppanel($t.tform1_supportpanel);
};

unit1_tform1.$p.tform1_label5click = function(sender)
{
   var $t = this;
   $t.tform1_salespanel.setcolor(webctrls_clformbackground);
   $t.setuppanel($t.tform1_salespanel);
};

unit1_tform1.$p.tform1_label6click = function(sender)
{
   var $t = this;
   $t.setuppanel($t.tform1_registerpanel);
};

unit1_tform1.$p.tform1_label59click = function(sender)
{
   var $t = this;
   if ($t.tform1_emailedit.teditcontrol_gettext() == "")
   {
      $t.tform1_emailedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The email address must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ((pos(".", $t.tform1_emailedit.teditcontrol_gettext()) == 0) || (pos("@", $t.tform1_emailedit.teditcontrol_gettext()) == 0))
   {
      $t.tform1_emailedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The email address is invalid");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_passwordedit.teditcontrol_gettext() == "")
   {
      $t.tform1_passwordedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The password must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_passwordcedit.teditcontrol_gettext() == "")
   {
      $t.tform1_passwordcedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The password confirmation must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_passwordcedit.teditcontrol_gettext() != $t.tform1_passwordedit.teditcontrol_gettext())
   {
      $t.tform1_passwordedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The passwords must be identical");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_contactedit.teditcontrol_gettext() == "")
   {
      $t.tform1_contactedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The contact person must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_companyedit.teditcontrol_gettext() == "")
   {
      $t.tform1_companyedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The company name must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else if ($t.tform1_telephoneedit.teditcontrol_gettext() == "")
   {
      $t.tform1_telephoneedit.setfocus();
      $t.tform1_errorpanel.tlabel_setcaption("The telephone number must be entered");
      $t.tform1_errorpanel.tcontrol_setvisible(true);
   }
   else 
   {
      $t.phpfunction = 1;
      $t.tform1_errorpanel.tcontrol_setvisible(true);
      $t.tform1_errorpanel.tlabel_setcaption("Please wait.......");
      if ($t.doregister($t.tform1_emailedit.teditcontrol_gettext(), $t.tform1_passwordedit.teditcontrol_gettext(), $t.tform1_companyedit.teditcontrol_gettext(), $t.tform1_contactedit.teditcontrol_gettext(), $t.tform1_telephoneedit.teditcontrol_gettext()))
      {
         $t.tform1_label53.tcontrol_setvisible(true);
         $t.tform1_label53.tlabel_setcaption("Welcome " + $t.tform1_contactedit.teditcontrol_gettext() + " from " + $t.tform1_companyedit.teditcontrol_gettext());
      }
   }
};

unit1_tform1.$p.tform1_label7click = function(sender)
{
   var $t = this, mylogin, mypassword, myserverrequest;
   $t.phpfunction = 2;
   mypassword = $t.tform1_edit2.teditcontrol_gettext();
   mylogin = $t.tform1_edit1.teditcontrol_gettext();
   myserverrequest = $t.requestqueue.getnewrequest();
   with (myserverrequest)
   {
      myserverrequest.tserverrequest_fresponsecontent.tstrings_flineseparator = "\n" + "\n";
      myserverrequest.tserverrequest_foncomplete = function(request) { unit1_tform1.$p.requestcomplete.call($t, request); };
      tserverrequest_furl = "login-exec.php";
      tserverrequest_frequestheaders.tstrings_setvalue("Content-Type", "multipart/form-data; boundary=AaB03x");
      with (tserverrequest_frequestcontent)
      {
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"login\"");
         add("");
         add(mylogin);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"password\"");
         add("");
         add(mypassword);
         add("--AaB03x");
      }
      tserverrequest_fmethod = webhttp_rmpost;
      tserverrequest_frequestqueue.addrequest(myserverrequest);
   }
};

unit1_tform1.$p.tform1_image9click = function(sender)
{
   var $t = this;
   if (!$t.loggedon)
      $t.tform1_label65.tcontrol_setvisible(true);
   else 
      window.location.href = "downloads/IQExport.exe";
};

unit1_tform1.$p.tform1_image15click = function(sender)
{
   var $t = this;
   if (!$t.loggedon)
      $t.tform1_label65.tcontrol_setvisible(true);
   else 
      window.location.href = "downloads/PastelExport.exe";
};

unit1_tform1.$p.tform1_timer1timer = function(sender)
{
   var $t = this;
   $t.addcount++;
   if ($t.addcount > 3)
      $t.addcount = 1;
   switch ($t.addcount)
   {
      case 1:
      {
         $t.tform1_label19.tlabel_setcaption($t.advheader1);
         $t.tform1_label21.tlabel_setcaption($t.adv1);
         $t.tform1_image8.timage_setimagename("images/iqenterprise.jpg");
         break;
      }
      case 2:
      {
         $t.tform1_label19.tlabel_setcaption($t.advheader2);
         $t.tform1_label21.tlabel_setcaption($t.adv2);
         $t.tform1_image8.timage_setimagename("images/pastel.jpg");
         break;
      }
      case 3:
      {
         $t.tform1_label19.tlabel_setcaption($t.advheader3);
         $t.tform1_label21.tlabel_setcaption($t.adv3);
         $t.tform1_image8.timage_setimagename("images/targetview.jpg");
         break;
      }
   };
};

unit1_tform1.$p.tform1_label48click = function(sender)
{
   var $t = this, m;
   if ($t.tform1_edit3.teditcontrol_gettext() == "")
      $t.tform1_edit3.setfocus();
   else if ($t.tform1_edit4.teditcontrol_gettext() == "")
      $t.tform1_edit4.setfocus();
   else if ($t.tform1_edit5.teditcontrol_gettext() == "")
      $t.tform1_edit5.setfocus();
   else if ($t.tform1_edit6.teditcontrol_gettext() == "")
      $t.tform1_edit5.setfocus();
   else if ($t.tform1_memo1.tmemo_flines.getcount() == 0)
      $t.tform1_memo1.setfocus();
   else 
   {
      m = "Company :" + $t.tform1_edit3.teditcontrol_gettext() + "\n" + "\n" + "Name :" + $t.tform1_edit4.teditcontrol_gettext() + "\n" + "\n" + "Phone :" + $t.tform1_edit5.teditcontrol_gettext() + "\n" + "\n" + "Mail :" + $t.tform1_edit6.teditcontrol_gettext() + "\n" + "\n" + "Memo :" + $t.tform1_memo1.teditcontrol_gettext();
      $t.sendmail("support@targetview.co.za", "Support", m, "");
      if ($t.tform1_checkbox1.tstatebuttoncontrol_fchecked)
         $t.sendmail($t.tform1_edit6.teditcontrol_gettext(), "Support", m, "");
      $t.tform1_label64.tlabel_setcaption("Thank you " + $t.tform1_edit4.teditcontrol_gettext() + ". Your mail was sent and we will respond as soon as possible");
      $t.tform1_label64.tcontrol_setvisible(true);
   }
};

unit1_tform1.$p.tform1_label60click = function(sender)
{
   var $t = this;
   $t.loggedon = false;
   $t.tform1_edit1.teditcontrol_settext("");
   $t.tform1_edit2.teditcontrol_settext("");
   $t.tform1_label53.tcontrol_setvisible(false);
   $t.tform1_label60.tcontrol_setvisible(false);
};

unit1_tform1.$p.tform1_image4click = function(sender)
{
   var $t = this;
   if (!$t.loggedon)
      $t.tform1_label65.tcontrol_setvisible(true);
   else 
      window.location.href = "downloads/TargetViewSetup.exe";
};

unit1_tform1.$p.sendmail = function(email, subject, message, headers)
{
   var $t = this, myserverrequest;
   if (headers == "")
      headers = "From:support@targetview.co.za";
   $t.phpfunction = 3;
   myserverrequest = $t.requestqueue.getnewrequest();
   with (myserverrequest)
   {
      myserverrequest.tserverrequest_fresponsecontent.tstrings_flineseparator = "\n" + "\n";
      myserverrequest.tserverrequest_foncomplete = function(request) { unit1_tform1.$p.requestcomplete.call($t, request); };
      tserverrequest_furl = "email-thankyou.php";
      tserverrequest_frequestheaders.tstrings_setvalue("Content-Type", "multipart/form-data; boundary=AaB03x");
      with (tserverrequest_frequestcontent)
      {
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"email\"");
         add("");
         add(email);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"subject\"");
         add("");
         add(subject);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"message\"");
         add("");
         add(message);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"headerx\"");
         add("");
         add(headers);
         add("--AaB03x");
      }
      tserverrequest_fmethod = webhttp_rmpost;
      tserverrequest_frequestqueue.addrequest(myserverrequest);
   }
};

unit1_tform1.$p.requestcomplete = function(request)
{
   var $t = this, fname, lname, qs, x1;
   $t.tform1_label53.tcontrol_setvisible(true);
   if (request.tserverrequest_fstatuscode == 200)
   {
      if (request)
      {
         qs = request.tserverrequest_fresponsecontent.gettext();
         if ($t.phpfunction == 1)
         {
            if (pos("~1~", qs) > 0)
               $t.tform1_errorpanel.tlabel_setcaption("Failed to connect to server");
            if (pos("~2~", qs) > 0)
               $t.tform1_errorpanel.tlabel_setcaption("Unable to connect to database");
            if (pos("~3~", qs) > 0)
               $t.tform1_errorpanel.tlabel_setcaption("Query failed");
            if (pos("~4~", qs) > 0)
               $t.tform1_errorpanel.tlabel_setcaption("Email already in use");
            if (pos("~5~", qs) > 0)
            {
               $t.tform1_label60.tcontrol_setvisible(true);
               $t.tform1_label53.tcontrol_setvisible(true);
               $t.tform1_label53.tlabel_setcaption("Welcome " + $t.tform1_contactedit.teditcontrol_gettext() + " from " + $t.tform1_companyedit.teditcontrol_gettext());
               $t.sendmail($t.tform1_emailedit.teditcontrol_gettext(), "Registering with TargetView", $t.tform1_contactedit.teditcontrol_gettext() + " Thank you for registering with TargetView. We trust that you will enjoy the power and versatility" + " of the program. Contact us if you have any questions." + " We are on standby to ensure your satisfaction", "");
               $t.sendmail("support@targetview.co.za", "Registered", "Mail:" + $t.tform1_emailedit.teditcontrol_gettext() + " Name:" + $t.tform1_contactedit.teditcontrol_gettext() + " Company:" + $t.tform1_companyedit.teditcontrol_gettext() + " Tel:" + $t.tform1_telephoneedit.teditcontrol_gettext(), "");
               $t.tform1_homepanel.bringtofront();
               $t.tform1_errorpanel.tlabel_setcaption("Success. You have been registered");
            }
            if (pos("~6~", qs) > 0)
               $t.tform1_errorpanel.tlabel_setcaption("The registration failed. Please try again");
         }
         if ($t.phpfunction == 2)
         {
            $t.tform1_label53.tcontrol_setvisible(true);
            $t.tform1_label53.tlabel_setcaption(qs);
            if (pos("~1~", qs) > 0)
               $t.tform1_label53.tlabel_setcaption("Failed to connect to server");
            if (pos("~2~", qs) > 0)
               $t.tform1_label53.tlabel_setcaption("Unable to connect to database");
            if (pos("~3~", qs) > 0)
               $t.tform1_label53.tlabel_setcaption("Login Failed");
            if (pos("~5~", qs) > 0)
            {
               $t.tform1_label60.tcontrol_setvisible(true);
               x1 = pos("Firstname:", qs);
               if (x1 == 0)
                  return;
               qs = copy(qs, x1 + 10, length(qs));
               x1 = pos(":", qs);
               if (x1 == 0)
                  return;
               fname = copy(qs, 1, x1 - 1);
               x1 = pos("Lastname:", qs);
               if (x1 == 0)
                  return;
               qs = copy(qs, x1 + 9, length(qs));
               x1 = pos(":", qs);
               if (x1 == 0)
                  return;
               lname = copy(qs, 1, x1 - 1);
               $t.tform1_label53.tcontrol_setvisible(true);
               $t.tform1_label53.tlabel_setcaption("Welcome " + fname + " from " + lname);
               $t.loggedon = true;
               $t.tform1_homepanel.bringtofront();
            }
         }
      }
   }
   else 
      {
         $t.tform1_label53.tcontrol_setvisible(true);
         $t.tform1_label53.tlabel_setcaption(qs);
         $t.tform1_errorpanel.tlabel_setcaption("The registration did not succeed");
      }
};

unit1_tform1.$p.setuppanel = function(apanel)
{
   var $t = this;
   apanel.tcontrol_setleft($t.tform1_homepanel.tcontrol_getleft());
   apanel.tcontrol_settop($t.tform1_homepanel.tcontrol_gettop());
   apanel.setcolor(webctrls_clivory);
   apanel.tcontrol_setparentcolor(false);
   apanel.setcolor(webctrls_clivory);
   apanel.bringtofront();
   apanel.tcontrol_setheight(1200);
   apanel.tcontrol_setvisible(true);
};

unit1_tform1.$p.doregister = function(email, mypass, company, contact, telephone)
{
   var $t = this, $r, myserverrequest;
   $r = true;
   myserverrequest = $t.requestqueue.getnewrequest();
   with (myserverrequest)
   {
      myserverrequest.tserverrequest_fresponsecontent.tstrings_flineseparator = "\n" + "\n";
      myserverrequest.tserverrequest_foncomplete = function(request) { unit1_tform1.$p.requestcomplete.call($t, request); };
      tserverrequest_furl = "register-exec.php";
      tserverrequest_frequestheaders.tstrings_setvalue("Content-Type", "multipart/form-data; boundary=AaB03x");
      with (tserverrequest_frequestcontent)
      {
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"email\"");
         add("");
         add(email);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"password\"");
         add("");
         add(mypass);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"company\"");
         add("");
         add(company);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"contact\"");
         add("");
         add(contact);
         add("--AaB03x");
         add("Content-Disposition: form-data; name=\"telephone\"");
         add("");
         add(telephone);
         add("--AaB03x");
      }
      tserverrequest_fmethod = webhttp_rmpost;
      tserverrequest_frequestqueue.addrequest(myserverrequest);
   }
   return $r;
};

unit1_tform1.$p.initialize = function()
{
   var $t = this;
   $t.tcomponent_setname("Form1");
   $t.tform1_image1 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image1.tcomponent_setname("Image1");
   $t.tform1_label1 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label1.tcomponent_setname("Label1");
   $t.tform1_label2 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label2.tcomponent_setname("Label2");
   $t.tform1_label3 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label3.tcomponent_setname("Label3");
   $t.tform1_label4 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label4.tcomponent_setname("Label4");
   $t.tform1_label5 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label5.tcomponent_setname("Label5");
   $t.tform1_label6 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label6.tcomponent_setname("Label6");
   $t.tform1_label9 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label9.tcomponent_setname("Label9");
   $t.tform1_label10 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label10.tcomponent_setname("Label10");
   $t.tform1_label11 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label11.tcomponent_setname("Label11");
   $t.tform1_image2 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image2.tcomponent_setname("Image2");
   $t.tform1_label7 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label7.tcomponent_setname("Label7");
   $t.tform1_label8 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label8.tcomponent_setname("Label8");
   $t.tform1_label53 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label53.tcomponent_setname("Label53");
   $t.tform1_label60 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label60.tcomponent_setname("Label60");
   $t.tform1_panel1 = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_panel1.tcomponent_setname("Panel1");
   $t.tform1_label20 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label20.tcomponent_setname("Label20");
   $t.tform1_label20.tcontrol_setparent($t.tform1_panel1);
   $t.tform1_image5 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image5.tcomponent_setname("Image5");
   $t.tform1_image5.tcontrol_setparent($t.tform1_panel1);
   $t.tform1_label19 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label19.tcomponent_setname("Label19");
   $t.tform1_label19.tcontrol_setparent($t.tform1_panel1);
   $t.tform1_label21 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label21.tcomponent_setname("Label21");
   $t.tform1_label21.tcontrol_setparent($t.tform1_panel1);
   $t.tform1_image8 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image8.tcomponent_setname("Image8");
   $t.tform1_image8.tcontrol_setparent($t.tform1_panel1);
   $t.tform1_edit1 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit1.tcomponent_setname("Edit1");
   $t.tform1_edit2 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit2.tcomponent_setname("Edit2");
   $t.tform1_productpanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_productpanel.tcomponent_setname("ProductPanel");
   $t.tform1_image6 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image6.tcomponent_setname("Image6");
   $t.tform1_image6.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label23 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label23.tcomponent_setname("Label23");
   $t.tform1_label23.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label25 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label25.tcomponent_setname("Label25");
   $t.tform1_label25.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label61 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label61.tcomponent_setname("Label61");
   $t.tform1_label61.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label62 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label62.tcomponent_setname("Label62");
   $t.tform1_label62.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label24 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label24.tcomponent_setname("Label24");
   $t.tform1_label24.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label27 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label27.tcomponent_setname("Label27");
   $t.tform1_label27.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label26 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label26.tcomponent_setname("Label26");
   $t.tform1_label26.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label28 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label28.tcomponent_setname("Label28");
   $t.tform1_label28.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_label63 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label63.tcomponent_setname("Label63");
   $t.tform1_label63.tcontrol_setparent($t.tform1_productpanel);
   $t.tform1_salespanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_salespanel.tcomponent_setname("SalesPanel");
   $t.tform1_label44 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label44.tcomponent_setname("Label44");
   $t.tform1_label44.tcontrol_setparent($t.tform1_salespanel);
   $t.tform1_label45 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label45.tcomponent_setname("Label45");
   $t.tform1_label45.tcontrol_setparent($t.tform1_salespanel);
   $t.tform1_label46 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label46.tcomponent_setname("Label46");
   $t.tform1_label46.tcontrol_setparent($t.tform1_salespanel);
   $t.tform1_registerpanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_registerpanel.tcomponent_setname("RegisterPanel");
   $t.tform1_label51 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label51.tcomponent_setname("Label51");
   $t.tform1_label51.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label52 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label52.tcomponent_setname("Label52");
   $t.tform1_label52.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label54 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label54.tcomponent_setname("Label54");
   $t.tform1_label54.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label55 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label55.tcomponent_setname("Label55");
   $t.tform1_label55.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label56 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label56.tcomponent_setname("Label56");
   $t.tform1_label56.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label57 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label57.tcomponent_setname("Label57");
   $t.tform1_label57.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label58 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label58.tcomponent_setname("Label58");
   $t.tform1_label58.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label59 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label59.tcomponent_setname("Label59");
   $t.tform1_label59.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_errorpanel = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_errorpanel.tcomponent_setname("ErrorPanel");
   $t.tform1_errorpanel.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_label12 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label12.tcomponent_setname("Label12");
   $t.tform1_label12.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_emailedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_emailedit.tcomponent_setname("Emailedit");
   $t.tform1_emailedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_passwordedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_passwordedit.tcomponent_setname("Passwordedit");
   $t.tform1_passwordedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_passwordcedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_passwordcedit.tcomponent_setname("Passwordcedit");
   $t.tform1_passwordcedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_companyedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_companyedit.tcomponent_setname("CompanyEdit");
   $t.tform1_companyedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_contactedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_contactedit.tcomponent_setname("ContactEdit");
   $t.tform1_contactedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_telephoneedit = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_telephoneedit.tcomponent_setname("Telephoneedit");
   $t.tform1_telephoneedit.tcontrol_setparent($t.tform1_registerpanel);
   $t.tform1_timer1 = webcore_tcomponent.create(new webcore_ttimer(), $t);
   $t.tform1_timer1.tcomponent_setname("Timer1");
   $t.tform1_supportpanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_supportpanel.tcomponent_setname("SupportPanel");
   $t.tform1_label37 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label37.tcomponent_setname("Label37");
   $t.tform1_label37.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label38 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label38.tcomponent_setname("Label38");
   $t.tform1_label38.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label39 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label39.tcomponent_setname("Label39");
   $t.tform1_label39.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label14 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label14.tcomponent_setname("Label14");
   $t.tform1_label14.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label35 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label35.tcomponent_setname("Label35");
   $t.tform1_label35.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label40 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label40.tcomponent_setname("Label40");
   $t.tform1_label40.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label41 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label41.tcomponent_setname("Label41");
   $t.tform1_label41.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label42 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label42.tcomponent_setname("Label42");
   $t.tform1_label42.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label47 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label47.tcomponent_setname("Label47");
   $t.tform1_label47.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label48 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label48.tcomponent_setname("Label48");
   $t.tform1_label48.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label49 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label49.tcomponent_setname("Label49");
   $t.tform1_label49.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label64 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label64.tcomponent_setname("Label64");
   $t.tform1_label64.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_image10 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image10.tcomponent_setname("Image10");
   $t.tform1_image10.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_label13 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label13.tcomponent_setname("Label13");
   $t.tform1_label13.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_edit3 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit3.tcomponent_setname("Edit3");
   $t.tform1_edit3.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_edit4 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit4.tcomponent_setname("Edit4");
   $t.tform1_edit4.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_edit5 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit5.tcomponent_setname("Edit5");
   $t.tform1_edit5.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_edit6 = webctrls_tinputcontrol.create(new webctrls_tedit(), $t);
   $t.tform1_edit6.tcomponent_setname("Edit6");
   $t.tform1_edit6.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_memo1 = webctrls_tmemo.create(new webctrls_tmemo(), $t);
   $t.tform1_memo1.tcomponent_setname("Memo1");
   $t.tform1_memo1.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_checkbox1 = webctrls_tinputcontrol.create(new webctrls_tcheckbox(), $t);
   $t.tform1_checkbox1.tcomponent_setname("CheckBox1");
   $t.tform1_checkbox1.tcontrol_setparent($t.tform1_supportpanel);
   $t.tform1_homepanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_homepanel.tcomponent_setname("Homepanel");
   $t.tform1_image3 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image3.tcomponent_setname("Image3");
   $t.tform1_image3.tcontrol_setparent($t.tform1_homepanel);
   $t.tform1_label15 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label15.tcomponent_setname("Label15");
   $t.tform1_label15.tcontrol_setparent($t.tform1_homepanel);
   $t.tform1_label34 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label34.tcomponent_setname("Label34");
   $t.tform1_label34.tcontrol_setparent($t.tform1_homepanel);
   $t.tform1_downloadpanel = webctrls_tpanel.create(new webctrls_tpanel(), $t);
   $t.tform1_downloadpanel.tcomponent_setname("Downloadpanel");
   $t.tform1_image9 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image9.tcomponent_setname("Image9");
   $t.tform1_image9.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_image15 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image15.tcomponent_setname("Image15");
   $t.tform1_image15.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_label32 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label32.tcomponent_setname("Label32");
   $t.tform1_label32.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_label31 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label31.tcomponent_setname("Label31");
   $t.tform1_label31.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_label33 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label33.tcomponent_setname("Label33");
   $t.tform1_label33.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_label65 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label65.tcomponent_setname("Label65");
   $t.tform1_label65.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_image4 = webctrls_tcontrol.create(new webctrls_timage(), $t);
   $t.tform1_image4.tcomponent_setname("Image4");
   $t.tform1_image4.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tform1_label16 = webctrls_tcontrol.create(new webctrls_tlabel(), $t);
   $t.tform1_label16.tcomponent_setname("Label16");
   $t.tform1_label16.tcontrol_setparent($t.tform1_downloadpanel);
   $t.tcontrol_setleft(0);
   $t.tcontrol_settop(0);
   $t.tcontrol_setwidth(1200);
   $t.tcontrol_setheight(1200);
   $t.tpanel_setcaption("Form1");
   $t.tpanel_setshowborder(false);
   $t.tpanel_setshowcaption(false);
   $t.tform_setthemecolor(false);
   $t.setcolor(15987699);
   $t.tform_setposition(2);
   $t.tform_foncreate = function(sender) { unit1_tform1.$p.tform1_form1create.call($t, sender); };
   $t.tform1_image1.tcontrol_setleft(-8);
   $t.tform1_image1.tcontrol_settop(0);
   $t.tform1_image1.tcontrol_setwidth(1200);
   $t.tform1_image1.tcontrol_setheight(137);
   $t.tform1_image1.timage_setimagename("background.gif");
   $t.tform1_image1.timage_setstretch(true);
   $t.tform1_label1.tcontrol_setleft(291);
   $t.tform1_label1.tcontrol_settop(113);
   $t.tform1_label1.tcontrol_setwidth(90);
   $t.tform1_label1.tcontrol_setheight(16);
   $t.tform1_label1.tcontrol_setalignment(1);
   $t.tform1_label1.tlabel_setautosize(false);
   $t.tform1_label1.tlabel_setcaption("Home");
   $t.tform1_label1.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label1.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label1.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label1.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label1.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label1.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label1.tcontrol_setparentfont(false);
   $t.tform1_label1.tlabel_settransparent(true);
   $t.tform1_label1.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label1click.call($t, sender); };
   $t.tform1_label1.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label1.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label2.tcontrol_setleft(426);
   $t.tform1_label2.tcontrol_settop(113);
   $t.tform1_label2.tcontrol_setwidth(90);
   $t.tform1_label2.tcontrol_setheight(16);
   $t.tform1_label2.tcontrol_setalignment(1);
   $t.tform1_label2.tlabel_setautosize(false);
   $t.tform1_label2.tlabel_setcaption("Product");
   $t.tform1_label2.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label2.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label2.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label2.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label2.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label2.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label2.tcontrol_setparentfont(false);
   $t.tform1_label2.tlabel_settransparent(true);
   $t.tform1_label2.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label2click.call($t, sender); };
   $t.tform1_label2.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label2.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label3.tcontrol_setleft(697);
   $t.tform1_label3.tcontrol_settop(113);
   $t.tform1_label3.tcontrol_setwidth(90);
   $t.tform1_label3.tcontrol_setheight(16);
   $t.tform1_label3.tcontrol_setalignment(1);
   $t.tform1_label3.tlabel_setautosize(false);
   $t.tform1_label3.tlabel_setcaption("Support");
   $t.tform1_label3.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label3.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label3.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label3.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label3.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label3.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label3.tcontrol_setparentfont(false);
   $t.tform1_label3.tlabel_settransparent(true);
   $t.tform1_label3.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label3click.call($t, sender); };
   $t.tform1_label3.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label3.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label4.tcontrol_setleft(561);
   $t.tform1_label4.tcontrol_settop(113);
   $t.tform1_label4.tcontrol_setwidth(90);
   $t.tform1_label4.tcontrol_setheight(16);
   $t.tform1_label4.tcontrol_setalignment(1);
   $t.tform1_label4.tlabel_setautosize(false);
   $t.tform1_label4.tlabel_setcaption("Downloads");
   $t.tform1_label4.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label4.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label4.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label4.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label4.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label4.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label4.tcontrol_setparentfont(false);
   $t.tform1_label4.tlabel_settransparent(true);
   $t.tform1_label4.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label4click.call($t, sender); };
   $t.tform1_label4.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label4.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label5.tcontrol_setleft(832);
   $t.tform1_label5.tcontrol_settop(113);
   $t.tform1_label5.tcontrol_setwidth(90);
   $t.tform1_label5.tcontrol_setheight(16);
   $t.tform1_label5.tcontrol_setalignment(1);
   $t.tform1_label5.tlabel_setautosize(false);
   $t.tform1_label5.tlabel_setcaption("Sales");
   $t.tform1_label5.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label5.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label5.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label5.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label5.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label5.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label5.tcontrol_setparentfont(false);
   $t.tform1_label5.tlabel_settransparent(true);
   $t.tform1_label5.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label5click.call($t, sender); };
   $t.tform1_label5.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label5.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label6.tcontrol_setleft(967);
   $t.tform1_label6.tcontrol_settop(113);
   $t.tform1_label6.tcontrol_setwidth(90);
   $t.tform1_label6.tcontrol_setheight(16);
   $t.tform1_label6.tcontrol_setalignment(1);
   $t.tform1_label6.tlabel_setautosize(false);
   $t.tform1_label6.tlabel_setcaption("Register");
   $t.tform1_label6.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label6.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label6.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label6.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label6.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label6.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label6.tcontrol_setparentfont(false);
   $t.tform1_label6.tlabel_settransparent(true);
   $t.tform1_label6.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label6click.call($t, sender); };
   $t.tform1_label6.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label6.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label9.tcontrol_setleft(456);
   $t.tform1_label9.tcontrol_settop(18);
   $t.tform1_label9.tcontrol_setwidth(109);
   $t.tform1_label9.tcontrol_setheight(21);
   $t.tform1_label9.tlabel_setautosize(false);
   $t.tform1_label9.setcolor(15794175);
   $t.tform1_label9.tlabel_setcaption("Members Login");
   $t.tform1_label9.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label9.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label9.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label9.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label9.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label9.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label9.tcontrol_setparentcolor(false);
   $t.tform1_label9.tcontrol_setparentfont(false);
   $t.tform1_label9.tlabel_settransparent(true);
   $t.tform1_label10.tcontrol_setleft(576);
   $t.tform1_label10.tcontrol_settop(18);
   $t.tform1_label10.tcontrol_setwidth(53);
   $t.tform1_label10.tcontrol_setheight(21);
   $t.tform1_label10.tlabel_setautosize(false);
   $t.tform1_label10.setcolor(15794175);
   $t.tform1_label10.tlabel_setcaption("Email");
   $t.tform1_label10.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label10.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label10.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label10.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label10.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label10.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label10.tcontrol_setparentcolor(false);
   $t.tform1_label10.tcontrol_setparentfont(false);
   $t.tform1_label10.tlabel_settransparent(true);
   $t.tform1_label11.tcontrol_setleft(832);
   $t.tform1_label11.tcontrol_settop(18);
   $t.tform1_label11.tcontrol_setwidth(77);
   $t.tform1_label11.tcontrol_setheight(21);
   $t.tform1_label11.tlabel_setautosize(false);
   $t.tform1_label11.setcolor(15794175);
   $t.tform1_label11.tlabel_setcaption("Password");
   $t.tform1_label11.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label11.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label11.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label11.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label11.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label11.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label11.tcontrol_setparentcolor(false);
   $t.tform1_label11.tcontrol_setparentfont(false);
   $t.tform1_label11.tlabel_settransparent(true);
   $t.tform1_image2.tcontrol_setleft(8);
   $t.tform1_image2.tcontrol_settop(12);
   $t.tform1_image2.tcontrol_setwidth(141);
   $t.tform1_image2.tcontrol_setheight(112);
   $t.tform1_image2.timage_setstretch(true);
   $t.tform1_image2.timage_settransparent(true);
   $t.tform1_label7.tcontrol_setleft(1044);
   $t.tform1_label7.tcontrol_settop(18);
   $t.tform1_label7.tcontrol_setwidth(58);
   $t.tform1_label7.tcontrol_setheight(16);
   $t.tform1_label7.tlabel_setautosize(false);
   $t.tform1_label7.tlabel_setcaption("Login");
   $t.tform1_label7.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label7.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label7.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label7.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label7.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label7.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label7.tcontrol_setparentfont(false);
   $t.tform1_label7.tlabel_settransparent(true);
   $t.tform1_label7.tcontrol_setvisible(false);
   $t.tform1_label7.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label7click.call($t, sender); };
   $t.tform1_label7.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label7.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_label8.tcontrol_setleft(162);
   $t.tform1_label8.tcontrol_settop(56);
   $t.tform1_label8.tcontrol_setwidth(157);
   $t.tform1_label8.tcontrol_setheight(16);
   $t.tform1_label8.tlabel_setautosize(false);
   $t.tform1_label8.tlabel_setcaption("Unlock your data");
   $t.tform1_label8.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label8.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label8.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label8.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label8.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label8.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label8.tcontrol_setparentfont(false);
   $t.tform1_label8.tlabel_settransparent(true);
   $t.tform1_label53.tcontrol_setleft(456);
   $t.tform1_label53.tcontrol_settop(58);
   $t.tform1_label53.tcontrol_setwidth(575);
   $t.tform1_label53.tcontrol_setheight(16);
   $t.tform1_label53.tlabel_setautosize(false);
   $t.tform1_label53.tlabel_setcaption("Members Login");
   $t.tform1_label53.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label53.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label53.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label53.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label53.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label53.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label53.tcontrol_setparentfont(false);
   $t.tform1_label53.tlabel_settransparent(true);
   $t.tform1_label53.tcontrol_setvisible(false);
   $t.tform1_label60.tcontrol_setleft(1044);
   $t.tform1_label60.tcontrol_settop(58);
   $t.tform1_label60.tcontrol_setwidth(38);
   $t.tform1_label60.tcontrol_setheight(16);
   $t.tform1_label60.tlabel_setcaption("Logout");
   $t.tform1_label60.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label60.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label60.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label60.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label60.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label60.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label60.tcontrol_setparentfont(false);
   $t.tform1_label60.tlabel_settransparent(true);
   $t.tform1_label60.tcontrol_setvisible(false);
   $t.tform1_label60.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label60click.call($t, sender); };
   $t.tform1_label60.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label60.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_panel1.tcontrol_setleft(1);
   $t.tform1_panel1.tcontrol_settop(138);
   $t.tform1_panel1.tcontrol_setwidth(185);
   $t.tform1_panel1.tcontrol_setheight(600);
   $t.tform1_panel1.tpanel_setcaption("Panel1");
   $t.tform1_panel1.tpanel_setshowborder(false);
   $t.tform1_panel1.tpanel_setshowcaption(false);
   $t.tform1_panel1.setcolor(15987699);
   $t.tform1_panel1.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_panel1.tcontrol_ffont.tfont_setcolor(0);
   $t.tform1_panel1.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_panel1.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_panel1.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_panel1.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_panel1.tcontrol_setparentcolor(false);
   $t.tform1_panel1.tcontrol_setparentfont(false);
   $t.tform1_panel1.tcontrol_settaborder(0);
   $t.tform1_label20.tcontrol_setleft(66);
   $t.tform1_label20.tcontrol_settop(74);
   $t.tform1_label20.tcontrol_setwidth(88);
   $t.tform1_label20.tcontrol_setheight(19);
   $t.tform1_label20.tcontrol_setalignment(1);
   $t.tform1_label20.tlabel_setcaption("Recent news");
   $t.tform1_label20.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label20.tcontrol_ffont.tfont_setcolor(12632256);
   $t.tform1_label20.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label20.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label20.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label20.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label20.tcontrol_setparentfont(false);
   $t.tform1_label20.tlabel_settransparent(true);
   $t.tform1_label20.tcontrol_fonmouseenter = function(sender) { unit1_tform1.$p.tform1_label1mouseenter.call($t, sender); };
   $t.tform1_label20.tcontrol_fonmouseleave = function(sender) { unit1_tform1.$p.tform1_label1mouseleave.call($t, sender); };
   $t.tform1_image5.tcontrol_setleft(16);
   $t.tform1_image5.tcontrol_settop(55);
   $t.tform1_image5.tcontrol_setwidth(41);
   $t.tform1_image5.tcontrol_setheight(49);
   $t.tform1_image5.timage_setstretch(true);
   $t.tform1_label19.tcontrol_setleft(18);
   $t.tform1_label19.tcontrol_settop(134);
   $t.tform1_label19.tcontrol_setwidth(148);
   $t.tform1_label19.tcontrol_setheight(23);
   $t.tform1_label19.tlabel_setautosize(false);
   $t.tform1_label19.tlabel_setcaption("IQExport released");
   $t.tform1_label19.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label19.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label19.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label19.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label19.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label19.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label19.tcontrol_setparentfont(false);
   $t.tform1_label19.tlabel_setwordwrap(true);
   $t.tform1_label21.tcontrol_setleft(16);
   $t.tform1_label21.tcontrol_settop(198);
   $t.tform1_label21.tcontrol_setwidth(149);
   $t.tform1_label21.tcontrol_setheight(327);
   $t.tform1_label21.tlabel_setautosize(false);
   $t.tform1_label21.tlabel_setcaption("IQExport for TargetView was released on 25 March 2012. It was tested on up to 3 million records, which TargetView imported with ease.");
   $t.tform1_label21.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label21.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label21.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label21.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label21.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label21.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label21.tcontrol_setparentfont(false);
   $t.tform1_label21.tlabel_setwordwrap(true);
   $t.tform1_image8.tcontrol_setleft(18);
   $t.tform1_image8.tcontrol_settop(157);
   $t.tform1_image8.tcontrol_setwidth(33);
   $t.tform1_image8.tcontrol_setheight(33);
   $t.tform1_image8.timage_setstretch(true);
   $t.tform1_image8.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_image9click.call($t, sender); };
   $t.tform1_edit1.tcontrol_setleft(640);
   $t.tform1_edit1.tcontrol_settop(12);
   $t.tform1_edit1.tcontrol_setwidth(185);
   $t.tform1_edit1.tcontrol_setheight(21);
   $t.tform1_edit1.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_edit1.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_edit1.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_edit1.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_edit1.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_edit1.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_edit1.tcontrol_setparentfont(false);
   $t.tform1_edit1.tcontrol_settaborder(2);
   $t.tform1_edit1.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_edit2.tcontrol_setleft(912);
   $t.tform1_edit2.tcontrol_settop(12);
   $t.tform1_edit2.tcontrol_setwidth(121);
   $t.tform1_edit2.tcontrol_setheight(21);
   $t.tform1_edit2.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_edit2.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_edit2.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_edit2.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_edit2.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_edit2.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_edit2.tcontrol_setparentfont(false);
   $t.tform1_edit2.tedit_setpassword(true);
   $t.tform1_edit2.tcontrol_settaborder(3);
   $t.tform1_edit2.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_productpanel.tcontrol_setleft(288);
   $t.tform1_productpanel.tcontrol_settop(153);
   $t.tform1_productpanel.tcontrol_setwidth(977);
   $t.tform1_productpanel.tcontrol_setheight(1200);
   $t.tform1_productpanel.tpanel_setcaption("Homepanel");
   $t.tform1_productpanel.tpanel_setshowborder(false);
   $t.tform1_productpanel.tpanel_setshowcaption(false);
   $t.tform1_productpanel.setcolor(12434877);
   $t.tform1_productpanel.tcontrol_setparentcolor(false);
   $t.tform1_productpanel.tcontrol_settaborder(4);
   $t.tform1_productpanel.tcontrol_setvisible(false);
   $t.tform1_image6.tcontrol_setleft(96);
   $t.tform1_image6.tcontrol_settop(47);
   $t.tform1_image6.tcontrol_setwidth(129);
   $t.tform1_image6.tcontrol_setheight(115);
   $t.tform1_image6.timage_setstretch(true);
   $t.tform1_image6.timage_settransparent(true);
   $t.tform1_label23.tcontrol_setleft(248);
   $t.tform1_label23.tcontrol_settop(88);
   $t.tform1_label23.tcontrol_setwidth(307);
   $t.tform1_label23.tcontrol_setheight(25);
   $t.tform1_label23.tlabel_setautosize(false);
   $t.tform1_label23.tlabel_setcaption("TargetView and your business.");
   $t.tform1_label23.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label23.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label23.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label23.tcontrol_ffont.tfont_setsize(15);
   $t.tform1_label23.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label23.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label23.tcontrol_setparentfont(false);
   $t.tform1_label23.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label13click.call($t, sender); };
   $t.tform1_label25.tcontrol_setleft(97);
   $t.tform1_label25.tcontrol_settop(195);
   $t.tform1_label25.tcontrol_setwidth(656);
   $t.tform1_label25.tcontrol_setheight(55);
   $t.tform1_label25.tlabel_setautosize(false);
   $t.tform1_label25.tlabel_setcaption("Your internal systems generate 1000's of transactions daily.\nIs this information presented in the readable format that you require?\nCondenses data into meaningful information at the click of a button.");
   $t.tform1_label25.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label25.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label25.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label25.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label25.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label25.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label25.tcontrol_setparentfont(false);
   $t.tform1_label25.tlabel_setwordwrap(true);
   $t.tform1_label61.tcontrol_setleft(97);
   $t.tform1_label61.tcontrol_settop(291);
   $t.tform1_label61.tcontrol_setwidth(643);
   $t.tform1_label61.tcontrol_setheight(183);
   $t.tform1_label61.tlabel_setautosize(false);
   $t.tform1_label61.tlabel_setcaption("Who were our top clients for the last month?\n.. and for the year?\n.. and last year?\n.. and what did they buy?\n.. and what other products in the same department did they buy?\n.. and which salesman gave the most discount?\n.. and how much was the biggest sale?\n.. and what was the average purchase amount?\n.. and how many sales were there?\n\n.. and many, many more.");
   $t.tform1_label61.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label61.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label61.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label61.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label61.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label61.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label61.tcontrol_setparentfont(false);
   $t.tform1_label61.tlabel_setwordwrap(true);
   $t.tform1_label62.tcontrol_setleft(97);
   $t.tform1_label62.tcontrol_settop(502);
   $t.tform1_label62.tcontrol_setwidth(448);
   $t.tform1_label62.tcontrol_setheight(135);
   $t.tform1_label62.tlabel_setautosize(false);
   $t.tform1_label62.tlabel_setcaption("Targetview can answer all these questions and more at a click of a button. \nIf you need another question answered, simply select your new view criteria. It takes seconds!\nYou don't wait for 10 minutes! You dont even wait 10 seconds. A million transactions processed in under 10 seconds.\n\nAnd if you want to see the detail, just doubleclick, and drilldown to the source transaction.");
   $t.tform1_label62.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label62.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label62.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label62.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label62.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label62.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label62.tcontrol_setparentfont(false);
   $t.tform1_label62.tlabel_setwordwrap(true);
   $t.tform1_label24.tcontrol_setleft(97);
   $t.tform1_label24.tcontrol_settop(258);
   $t.tform1_label24.tcontrol_setwidth(680);
   $t.tform1_label24.tcontrol_setheight(23);
   $t.tform1_label24.tlabel_setautosize(false);
   $t.tform1_label24.tlabel_setcaption("Your Typical Questions");
   $t.tform1_label24.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label24.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label24.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label24.tcontrol_ffont.tfont_setsize(14);
   $t.tform1_label24.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label24.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label24.tcontrol_setparentfont(false);
   $t.tform1_label24.tlabel_setwordwrap(true);
   $t.tform1_label27.tcontrol_setleft(97);
   $t.tform1_label27.tcontrol_settop(477);
   $t.tform1_label27.tcontrol_setwidth(680);
   $t.tform1_label27.tcontrol_setheight(23);
   $t.tform1_label27.tlabel_setautosize(false);
   $t.tform1_label27.tlabel_setcaption("TargetView Answers");
   $t.tform1_label27.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label27.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label27.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label27.tcontrol_ffont.tfont_setsize(14);
   $t.tform1_label27.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label27.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label27.tcontrol_setparentfont(false);
   $t.tform1_label27.tlabel_setwordwrap(true);
   $t.tform1_label26.tcontrol_setleft(97);
   $t.tform1_label26.tcontrol_settop(637);
   $t.tform1_label26.tcontrol_setwidth(680);
   $t.tform1_label26.tcontrol_setheight(23);
   $t.tform1_label26.tlabel_setautosize(false);
   $t.tform1_label26.tlabel_setcaption("Dont wait. Try it for free.");
   $t.tform1_label26.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label26.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label26.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label26.tcontrol_ffont.tfont_setsize(14);
   $t.tform1_label26.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label26.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label26.tcontrol_setparentfont(false);
   $t.tform1_label26.tlabel_setwordwrap(true);
   $t.tform1_label28.tcontrol_setleft(97);
   $t.tform1_label28.tcontrol_settop(670);
   $t.tform1_label28.tcontrol_setwidth(448);
   $t.tform1_label28.tcontrol_setheight(159);
   $t.tform1_label28.tlabel_setautosize(false);
   $t.tform1_label28.tlabel_setcaption("It is as simple as 1,2,3.\n\n1. Download Targetview and install.\n2. Open the demodata to view.\n\nand if you like what you see?\n\n3. Download the data extractor for your system, extract the TargetView information, and start getting answers!\n\n");
   $t.tform1_label28.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label28.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label28.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label28.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label28.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label28.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label28.tcontrol_setparentfont(false);
   $t.tform1_label28.tlabel_setwordwrap(true);
   $t.tform1_label63.tcontrol_setleft(97);
   $t.tform1_label63.tcontrol_settop(170);
   $t.tform1_label63.tcontrol_setwidth(680);
   $t.tform1_label63.tcontrol_setheight(23);
   $t.tform1_label63.tlabel_setautosize(false);
   $t.tform1_label63.tlabel_setcaption("Your Data");
   $t.tform1_label63.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label63.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label63.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label63.tcontrol_ffont.tfont_setsize(14);
   $t.tform1_label63.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label63.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label63.tcontrol_setparentfont(false);
   $t.tform1_label63.tlabel_setwordwrap(true);
   $t.tform1_salespanel.tcontrol_setleft(360);
   $t.tform1_salespanel.tcontrol_settop(337);
   $t.tform1_salespanel.tcontrol_setwidth(977);
   $t.tform1_salespanel.tcontrol_setheight(609);
   $t.tform1_salespanel.tpanel_setcaption("Homepanel");
   $t.tform1_salespanel.tpanel_setshowborder(false);
   $t.tform1_salespanel.tpanel_setshowcaption(false);
   $t.tform1_salespanel.setcolor(2263842);
   $t.tform1_salespanel.tcontrol_setparentcolor(false);
   $t.tform1_salespanel.tcontrol_settaborder(7);
   $t.tform1_salespanel.tcontrol_setvisible(false);
   $t.tform1_label44.tcontrol_setleft(96);
   $t.tform1_label44.tcontrol_settop(55);
   $t.tform1_label44.tcontrol_setwidth(315);
   $t.tform1_label44.tcontrol_setheight(25);
   $t.tform1_label44.tlabel_setautosize(false);
   $t.tform1_label44.tlabel_setcaption("Sales");
   $t.tform1_label44.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label44.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label44.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label44.tcontrol_ffont.tfont_setsize(15);
   $t.tform1_label44.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label44.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label44.tcontrol_setparentfont(false);
   $t.tform1_label44.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label13click.call($t, sender); };
   $t.tform1_label45.tcontrol_setleft(96);
   $t.tform1_label45.tcontrol_settop(127);
   $t.tform1_label45.tcontrol_setwidth(680);
   $t.tform1_label45.tcontrol_setheight(303);
   $t.tform1_label45.tlabel_setautosize(false);
   $t.tform1_label45.tlabel_setcaption("There is no complicated licence agreement. As long as you pay your monthly fee, your TargetView will carry on working.\n\nYou can currently only pay by internet transfer.\n\nPaypal payments will be available soon.\n\nOn receipt of payment, you will be sent a licence key, which you must enter in the provided area in TargetView.\n\nThe cost is R75.00 per month, or R750.00 per year.\n\nBank Details..\n\nAccount : TargetView\nNumber : 132456\nBank      : Standard Bank\nBranch  : Helderberg");
   $t.tform1_label45.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label45.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label45.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label45.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label45.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label45.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label45.tcontrol_setparentfont(false);
   $t.tform1_label45.tlabel_setwordwrap(true);
   $t.tform1_label46.tcontrol_setleft(96);
   $t.tform1_label46.tcontrol_settop(87);
   $t.tform1_label46.tcontrol_setwidth(680);
   $t.tform1_label46.tcontrol_setheight(23);
   $t.tform1_label46.tlabel_setautosize(false);
   $t.tform1_label46.tlabel_setcaption("No nonsense licence agreement");
   $t.tform1_label46.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label46.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label46.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label46.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label46.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label46.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label46.tcontrol_setparentfont(false);
   $t.tform1_label46.tlabel_setwordwrap(true);
   $t.tform1_registerpanel.tcontrol_setleft(288);
   $t.tform1_registerpanel.tcontrol_settop(377);
   $t.tform1_registerpanel.tcontrol_setwidth(977);
   $t.tform1_registerpanel.tcontrol_setheight(609);
   $t.tform1_registerpanel.tpanel_setcaption("Homepanel");
   $t.tform1_registerpanel.tpanel_setshowborder(false);
   $t.tform1_registerpanel.tpanel_setshowcaption(false);
   $t.tform1_registerpanel.setcolor(14150650);
   $t.tform1_registerpanel.tcontrol_setparentcolor(false);
   $t.tform1_registerpanel.tcontrol_settaborder(8);
   $t.tform1_registerpanel.tcontrol_setvisible(false);
   $t.tform1_label51.tcontrol_setleft(96);
   $t.tform1_label51.tcontrol_settop(55);
   $t.tform1_label51.tcontrol_setwidth(315);
   $t.tform1_label51.tcontrol_setheight(25);
   $t.tform1_label51.tlabel_setautosize(false);
   $t.tform1_label51.tlabel_setcaption("Register with TargetView");
   $t.tform1_label51.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label51.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label51.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label51.tcontrol_ffont.tfont_setsize(15);
   $t.tform1_label51.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label51.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label51.tcontrol_setparentfont(false);
   $t.tform1_label51.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label13click.call($t, sender); };
   $t.tform1_label52.tcontrol_setleft(192);
   $t.tform1_label52.tcontrol_settop(119);
   $t.tform1_label52.tcontrol_setwidth(150);
   $t.tform1_label52.tcontrol_setheight(23);
   $t.tform1_label52.tlabel_setautosize(false);
   $t.tform1_label52.tlabel_setcaption("Email Address");
   $t.tform1_label52.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label52.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label52.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label52.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label52.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label52.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label52.tcontrol_setparentfont(false);
   $t.tform1_label52.tlabel_setwordwrap(true);
   $t.tform1_label54.tcontrol_setleft(192);
   $t.tform1_label54.tcontrol_settop(154);
   $t.tform1_label54.tcontrol_setwidth(150);
   $t.tform1_label54.tcontrol_setheight(23);
   $t.tform1_label54.tlabel_setautosize(false);
   $t.tform1_label54.tlabel_setcaption("Password");
   $t.tform1_label54.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label54.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label54.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label54.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label54.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label54.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label54.tcontrol_setparentfont(false);
   $t.tform1_label54.tlabel_setwordwrap(true);
   $t.tform1_label55.tcontrol_setleft(192);
   $t.tform1_label55.tcontrol_settop(189);
   $t.tform1_label55.tcontrol_setwidth(150);
   $t.tform1_label55.tcontrol_setheight(23);
   $t.tform1_label55.tlabel_setautosize(false);
   $t.tform1_label55.tlabel_setcaption("Confirm Password");
   $t.tform1_label55.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label55.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label55.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label55.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label55.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label55.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label55.tcontrol_setparentfont(false);
   $t.tform1_label55.tlabel_setwordwrap(true);
   $t.tform1_label56.tcontrol_setleft(192);
   $t.tform1_label56.tcontrol_settop(225);
   $t.tform1_label56.tcontrol_setwidth(150);
   $t.tform1_label56.tcontrol_setheight(23);
   $t.tform1_label56.tlabel_setautosize(false);
   $t.tform1_label56.tlabel_setcaption("Company");
   $t.tform1_label56.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label56.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label56.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label56.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label56.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label56.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label56.tcontrol_setparentfont(false);
   $t.tform1_label56.tlabel_setwordwrap(true);
   $t.tform1_label57.tcontrol_setleft(192);
   $t.tform1_label57.tcontrol_settop(260);
   $t.tform1_label57.tcontrol_setwidth(150);
   $t.tform1_label57.tcontrol_setheight(23);
   $t.tform1_label57.tlabel_setautosize(false);
   $t.tform1_label57.tlabel_setcaption("Contact Person");
   $t.tform1_label57.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label57.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label57.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label57.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label57.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label57.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label57.tcontrol_setparentfont(false);
   $t.tform1_label57.tlabel_setwordwrap(true);
   $t.tform1_label58.tcontrol_setleft(192);
   $t.tform1_label58.tcontrol_settop(295);
   $t.tform1_label58.tcontrol_setwidth(150);
   $t.tform1_label58.tcontrol_setheight(23);
   $t.tform1_label58.tlabel_setautosize(false);
   $t.tform1_label58.tlabel_setcaption("Telephone Number");
   $t.tform1_label58.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label58.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label58.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label58.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label58.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label58.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label58.tcontrol_setparentfont(false);
   $t.tform1_label58.tlabel_setwordwrap(true);
   $t.tform1_label59.tcontrol_setleft(624);
   $t.tform1_label59.tcontrol_settop(298);
   $t.tform1_label59.tcontrol_setwidth(55);
   $t.tform1_label59.tcontrol_setheight(16);
   $t.tform1_label59.tcontrol_setalignment(1);
   $t.tform1_label59.setcolor(13826810);
   $t.tform1_label59.tlabel_setcaption("Register");
   $t.tform1_label59.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label59.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label59.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label59.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label59.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label59.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label59.tcontrol_setparentcolor(false);
   $t.tform1_label59.tcontrol_setparentfont(false);
   $t.tform1_label59.tlabel_settransparent(true);
   $t.tform1_label59.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label59click.call($t, sender); };
   $t.tform1_errorpanel.tcontrol_setleft(192);
   $t.tform1_errorpanel.tcontrol_settop(359);
   $t.tform1_errorpanel.tcontrol_setwidth(520);
   $t.tform1_errorpanel.tcontrol_setheight(31);
   $t.tform1_errorpanel.tcontrol_setalignment(1);
   $t.tform1_errorpanel.tlabel_setautosize(false);
   $t.tform1_errorpanel.tlabel_setcaption("ErrorPanel");
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setcolor(255);
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_errorpanel.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_errorpanel.tcontrol_setparentfont(false);
   $t.tform1_errorpanel.tcontrol_setvisible(false);
   $t.tform1_label12.tcontrol_setleft(192);
   $t.tform1_label12.tcontrol_settop(399);
   $t.tform1_label12.tcontrol_setwidth(590);
   $t.tform1_label12.tcontrol_setheight(23);
   $t.tform1_label12.tlabel_setautosize(false);
   $t.tform1_label12.tlabel_setcaption("Send us a mail if you want to participate in our referring partner program");
   $t.tform1_label12.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label12.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label12.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label12.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label12.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label12.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label12.tcontrol_setparentfont(false);
   $t.tform1_label12.tlabel_setwordwrap(true);
   $t.tform1_emailedit.tcontrol_setleft(400);
   $t.tform1_emailedit.tcontrol_settop(116);
   $t.tform1_emailedit.tcontrol_setwidth(185);
   $t.tform1_emailedit.tcontrol_setheight(21);
   $t.tform1_emailedit.tcontrol_sethint("The email address is CaSe sensitive!");
   $t.tform1_emailedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_emailedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_emailedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_emailedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_emailedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_emailedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_emailedit.tcontrol_setparentfont(false);
   $t.tform1_emailedit.tcontrol_settaborder(0);
   $t.tform1_emailedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_passwordedit.tcontrol_setleft(400);
   $t.tform1_passwordedit.tcontrol_settop(151);
   $t.tform1_passwordedit.tcontrol_setwidth(185);
   $t.tform1_passwordedit.tcontrol_setheight(21);
   $t.tform1_passwordedit.tcontrol_sethint("The password will be converted to uppercase");
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_passwordedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_passwordedit.tcontrol_setparentfont(false);
   $t.tform1_passwordedit.tcontrol_settaborder(1);
   $t.tform1_passwordedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_passwordcedit.tcontrol_setleft(400);
   $t.tform1_passwordcedit.tcontrol_settop(186);
   $t.tform1_passwordcedit.tcontrol_setwidth(185);
   $t.tform1_passwordcedit.tcontrol_setheight(21);
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_passwordcedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_passwordcedit.tcontrol_setparentfont(false);
   $t.tform1_passwordcedit.tcontrol_settaborder(2);
   $t.tform1_passwordcedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_companyedit.tcontrol_setleft(400);
   $t.tform1_companyedit.tcontrol_settop(222);
   $t.tform1_companyedit.tcontrol_setwidth(185);
   $t.tform1_companyedit.tcontrol_setheight(21);
   $t.tform1_companyedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_companyedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_companyedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_companyedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_companyedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_companyedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_companyedit.tcontrol_setparentfont(false);
   $t.tform1_companyedit.tcontrol_settaborder(3);
   $t.tform1_companyedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_contactedit.tcontrol_setleft(400);
   $t.tform1_contactedit.tcontrol_settop(257);
   $t.tform1_contactedit.tcontrol_setwidth(185);
   $t.tform1_contactedit.tcontrol_setheight(21);
   $t.tform1_contactedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_contactedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_contactedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_contactedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_contactedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_contactedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_contactedit.tcontrol_setparentfont(false);
   $t.tform1_contactedit.tcontrol_settaborder(4);
   $t.tform1_contactedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_telephoneedit.tcontrol_setleft(400);
   $t.tform1_telephoneedit.tcontrol_settop(292);
   $t.tform1_telephoneedit.tcontrol_setwidth(185);
   $t.tform1_telephoneedit.tcontrol_setheight(21);
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_telephoneedit.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_telephoneedit.tcontrol_setparentfont(false);
   $t.tform1_telephoneedit.tcontrol_settaborder(5);
   $t.tform1_telephoneedit.teditcontrol_fonchange = function(sender) { unit1_tform1.$p.tform1_edit1change.call($t, sender); };
   $t.tform1_timer1.ttimer_setenabled(true);
   $t.tform1_timer1.ttimer_setinterval(10000);
   $t.tform1_timer1.ttimer_fontimer = function(sender) { unit1_tform1.$p.tform1_timer1timer.call($t, sender); };
   $t.tform1_supportpanel.tcontrol_setleft(208);
   $t.tform1_supportpanel.tcontrol_settop(329);
   $t.tform1_supportpanel.tcontrol_setwidth(1200);
   $t.tform1_supportpanel.tcontrol_setheight(609);
   $t.tform1_supportpanel.tpanel_setcaption("Homepanel");
   $t.tform1_supportpanel.tpanel_setshowborder(false);
   $t.tform1_supportpanel.tpanel_setshowcaption(false);
   $t.tform1_supportpanel.setcolor(2237106);
   $t.tform1_supportpanel.tcontrol_setparentcolor(false);
   $t.tform1_supportpanel.tcontrol_settaborder(6);
   $t.tform1_supportpanel.tcontrol_setvisible(false);
   $t.tform1_label37.tcontrol_setleft(272);
   $t.tform1_label37.tcontrol_settop(47);
   $t.tform1_label37.tcontrol_setwidth(315);
   $t.tform1_label37.tcontrol_setheight(25);
   $t.tform1_label37.tlabel_setautosize(false);
   $t.tform1_label37.tlabel_setcaption("Support");
   $t.tform1_label37.tcontrol_ffont.tfont_setname("tahoma");
   $t.tform1_label37.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label37.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label37.tcontrol_ffont.tfont_setsize(15);
   $t.tform1_label37.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label37.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label37.tcontrol_setparentfont(false);
   $t.tform1_label37.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label13click.call($t, sender); };
   $t.tform1_label38.tcontrol_setleft(272);
   $t.tform1_label38.tcontrol_settop(119);
   $t.tform1_label38.tcontrol_setwidth(680);
   $t.tform1_label38.tcontrol_setheight(71);
   $t.tform1_label38.tlabel_setautosize(false);
   $t.tform1_label38.tlabel_setcaption("In order to keep your costs down, TargetView is supported only via E-Mail. \nSimply fill in the contact us form, with as much information as possible, \nand we will attend to your problem or suggestion within hours.");
   $t.tform1_label38.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label38.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label38.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label38.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label38.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label38.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label38.tcontrol_setparentfont(false);
   $t.tform1_label38.tlabel_setwordwrap(true);
   $t.tform1_label39.tcontrol_setleft(272);
   $t.tform1_label39.tcontrol_settop(79);
   $t.tform1_label39.tcontrol_setwidth(680);
   $t.tform1_label39.tcontrol_setheight(23);
   $t.tform1_label39.tlabel_setautosize(false);
   $t.tform1_label39.tlabel_setcaption("Support available only via E-Mail");
   $t.tform1_label39.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label39.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label39.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label39.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label39.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label39.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label39.tcontrol_setparentfont(false);
   $t.tform1_label39.tlabel_setwordwrap(true);
   $t.tform1_label14.tcontrol_setleft(272);
   $t.tform1_label14.tcontrol_settop(183);
   $t.tform1_label14.tcontrol_setwidth(680);
   $t.tform1_label14.tcontrol_setheight(23);
   $t.tform1_label14.tlabel_setautosize(false);
   $t.tform1_label14.tlabel_setcaption("Contact Form");
   $t.tform1_label14.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label14.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label14.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label14.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label14.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label14.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label14.tcontrol_setparentfont(false);
   $t.tform1_label14.tlabel_setwordwrap(true);
   $t.tform1_label35.tcontrol_setleft(272);
   $t.tform1_label35.tcontrol_settop(239);
   $t.tform1_label35.tcontrol_setwidth(150);
   $t.tform1_label35.tcontrol_setheight(23);
   $t.tform1_label35.tlabel_setautosize(false);
   $t.tform1_label35.tlabel_setcaption("Company :");
   $t.tform1_label35.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label35.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label35.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label35.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label35.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label35.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label35.tcontrol_setparentfont(false);
   $t.tform1_label35.tlabel_setwordwrap(true);
   $t.tform1_label40.tcontrol_setleft(272);
   $t.tform1_label40.tcontrol_settop(263);
   $t.tform1_label40.tcontrol_setwidth(150);
   $t.tform1_label40.tcontrol_setheight(23);
   $t.tform1_label40.tlabel_setautosize(false);
   $t.tform1_label40.tlabel_setcaption("Name :");
   $t.tform1_label40.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label40.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label40.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label40.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label40.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label40.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label40.tcontrol_setparentfont(false);
   $t.tform1_label40.tlabel_setwordwrap(true);
   $t.tform1_label41.tcontrol_setleft(272);
   $t.tform1_label41.tcontrol_settop(287);
   $t.tform1_label41.tcontrol_setwidth(150);
   $t.tform1_label41.tcontrol_setheight(23);
   $t.tform1_label41.tlabel_setautosize(false);
   $t.tform1_label41.tlabel_setcaption("Phone :");
   $t.tform1_label41.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label41.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label41.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label41.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label41.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label41.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label41.tcontrol_setparentfont(false);
   $t.tform1_label41.tlabel_setwordwrap(true);
   $t.tform1_label42.tcontrol_setleft(272);
   $t.tform1_label42.tcontrol_settop(311);
   $t.tform1_label42.tcontrol_setwidth(150);
   $t.tform1_label42.tcontrol_setheight(23);
   $t.tform1_label42.tlabel_setautosize(false);
   $t.tform1_label42.tlabel_setcaption("Email :");
   $t.tform1_label42.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label42.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label42.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label42.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label42.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label42.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label42.tcontrol_setparentfont(false);
   $t.tform1_label42.tlabel_setwordwrap(true);
   $t.tform1_label47.tcontrol_setleft(272);
   $t.tform1_label47.tcontrol_settop(335);
   $t.tform1_label47.tcontrol_setwidth(150);
   $t.tform1_label47.tcontrol_setheight(23);
   $t.tform1_label47.tlabel_setautosize(false);
   $t.tform1_label47.tlabel_setcaption("Questions/Comments:");
   $t.tform1_label47.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label47.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label47.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label47.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label47.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label47.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label47.tcontrol_setparentfont(false);
   $t.tform1_label47.tlabel_setwordwrap(true);
   $t.tform1_label48.tcontrol_setleft(732);
   $t.tform1_label48.tcontrol_settop(450);
   $t.tform1_label48.tcontrol_setwidth(58);
   $t.tform1_label48.tcontrol_setheight(16);
   $t.tform1_label48.tlabel_setautosize(false);
   $t.tform1_label48.tlabel_setcaption("Send");
   $t.tform1_label48.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label48.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label48.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label48.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label48.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label48.tcontrol_ffont.tfont_setweight(1);
   $t.tform1_label48.tcontrol_setparentfont(false);
   $t.tform1_label48.tlabel_settransparent(true);
   $t.tform1_label48.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_label48click.call($t, sender); };
   $t.tform1_label49.tcontrol_setleft(272);
   $t.tform1_label49.tcontrol_settop(447);
   $t.tform1_label49.tcontrol_setwidth(150);
   $t.tform1_label49.tcontrol_setheight(23);
   $t.tform1_label49.tlabel_setautosize(false);
   $t.tform1_label49.tlabel_setcaption("Copy of mail to yourself?");
   $t.tform1_label49.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label49.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label49.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label49.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label49.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label49.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label49.tcontrol_setparentfont(false);
   $t.tform1_label49.tlabel_setwordwrap(true);
   $t.tform1_label64.tcontrol_setleft(272);
   $t.tform1_label64.tcontrol_settop(479);
   $t.tform1_label64.tcontrol_setwidth(615);
   $t.tform1_label64.tcontrol_setheight(15);
   $t.tform1_label64.tlabel_setautosize(false);
   $t.tform1_label64.tlabel_setcaption("Thank you.  Your mail was sent and we will respond as soon as possible");
   $t.tform1_label64.tcontrol_ffont.tfont_setname("Segoe UI");
   $t.tform1_label64.tcontrol_ffont.tfont_setcolor(3937500);
   $t.tform1_label64.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label64.tcontrol_ffont.tfont_setsize(9);
   $t.tform1_label64.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label64.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label64.tcontrol_setparentfont(false);
   $t.tform1_label64.tcontrol_setvisible(false);
   $t.tform1_image10.tcontrol_setleft(96);
   $t.tform1_image10.tcontrol_settop(47);
   $t.tform1_image10.tcontrol_setwidth(129);
   $t.tform1_image10.tcontrol_setheight(105);
   $t.tform1_image10.timage_setstretch(true);
   $t.tform1_label13.tcontrol_setleft(96);
   $t.tform1_label13.tcontrol_settop(175);
   $t.tform1_label13.tcontrol_setwidth(130);
   $t.tform1_label13.tcontrol_setheight(15);
   $t.tform1_label13.tcontrol_setalignment(1);
   $t.tform1_label13.tlabel_setautosize(false);
   $t.tform1_label13.tlabel_setcaption("www.targetview.co.za");
   $t.tform1_edit3.tcontrol_setleft(456);
   $t.tform1_edit3.tcontrol_settop(239);
   $t.tform1_edit3.tcontrol_setwidth(250);
   $t.tform1_edit3.tcontrol_setheight(21);
   $t.tform1_edit3.tcontrol_settaborder(0);
   $t.tform1_edit4.tcontrol_setleft(456);
   $t.tform1_edit4.tcontrol_settop(263);
   $t.tform1_edit4.tcontrol_setwidth(250);
   $t.tform1_edit4.tcontrol_setheight(21);
   $t.tform1_edit4.tcontrol_settaborder(1);
   $t.tform1_edit5.tcontrol_setleft(456);
   $t.tform1_edit5.tcontrol_settop(287);
   $t.tform1_edit5.tcontrol_setwidth(250);
   $t.tform1_edit5.tcontrol_setheight(21);
   $t.tform1_edit5.tcontrol_settaborder(2);
   $t.tform1_edit6.tcontrol_setleft(456);
   $t.tform1_edit6.tcontrol_settop(311);
   $t.tform1_edit6.tcontrol_setwidth(250);
   $t.tform1_edit6.tcontrol_setheight(21);
   $t.tform1_edit6.tcontrol_settaborder(3);
   $t.tform1_memo1.tcontrol_setleft(456);
   $t.tform1_memo1.tcontrol_settop(343);
   $t.tform1_memo1.tcontrol_setwidth(250);
   $t.tform1_memo1.tcontrol_setheight(89);
   $t.tform1_memo1.tcontrol_settaborder(4);
   $t.tform1_checkbox1.tcontrol_setleft(456);
   $t.tform1_checkbox1.tcontrol_settop(447);
   $t.tform1_checkbox1.tcontrol_setwidth(33);
   $t.tform1_checkbox1.tcontrol_setheight(21);
   $t.tform1_checkbox1.tcontrol_settaborder(5);
   $t.tform1_homepanel.tcontrol_setleft(576);
   $t.tform1_homepanel.tcontrol_settop(169);
   $t.tform1_homepanel.tcontrol_setwidth(977);
   $t.tform1_homepanel.tcontrol_setheight(1200);
   $t.tform1_homepanel.tpanel_setcaption("Homepanel");
   $t.tform1_homepanel.tpanel_setshowborder(false);
   $t.tform1_homepanel.tpanel_setshowcaption(false);
   $t.tform1_homepanel.setcolor(15794175);
   $t.tform1_homepanel.tcontrol_setparentcolor(false);
   $t.tform1_homepanel.tcontrol_settaborder(1);
   $t.tform1_image3.tcontrol_setleft(96);
   $t.tform1_image3.tcontrol_settop(47);
   $t.tform1_image3.tcontrol_setwidth(129);
   $t.tform1_image3.tcontrol_setheight(105);
   $t.tform1_image3.timage_setstretch(true);
   $t.tform1_image3.timage_settransparent(true);
   $t.tform1_label15.tcontrol_setleft(88);
   $t.tform1_label15.tcontrol_settop(159);
   $t.tform1_label15.tcontrol_setwidth(163);
   $t.tform1_label15.tcontrol_setheight(24);
   $t.tform1_label15.tlabel_setautosize(false);
   $t.tform1_label15.tlabel_setcaption("What is TargetView.");
   $t.tform1_label15.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label15.tcontrol_ffont.tfont_setcolor(8421440);
   $t.tform1_label15.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label15.tcontrol_ffont.tfont_setsize(12);
   $t.tform1_label15.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label15.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label15.tcontrol_setparentfont(false);
   $t.tform1_label15.tlabel_setwordwrap(true);
   $t.tform1_label34.tcontrol_setleft(88);
   $t.tform1_label34.tcontrol_settop(191);
   $t.tform1_label34.tcontrol_setwidth(680);
   $t.tform1_label34.tcontrol_setheight(407);
   $t.tform1_label34.tlabel_setautosize(false);
   $t.tform1_label34.tlabel_setcaption("TargetView is a business intelligence and data reporting tool that gives you the answers you are looking for regarding your business performance.  Our product processes your accounting software data and presents logical information instantly.  Get the information you need by formatting your report using a simple drag and drop interface.   Getting simple answers from complex data is now easier than ever.\n\n\nUsers can select only the information they require on a report view, and save this report view for instant access later.  Data presentation and comparative views are instantly definable and saved.  \n\nIf you are looking for an easy-to-use, affordable business intelligence tool, then TargetView is ideal for your reporting purposes.  TargetView is available as a fully functional trial download.  Please watch our short introductory video to get you started. \n\nData is displayed in any of the following formats:\n1.  Grouped\n2.  Expanded\n3.  Drill-Down\n4.  High quality quantitive graphs(Pie, Line, Comparitive, Pivot, 3D)\n\nWe currently support high speed data reading from:\n1.  Pastel Accounting Software\n2.  IQ Retail Accounting Software\n3.  Quickbooks Accounting Software");
   $t.tform1_label34.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label34.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label34.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label34.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label34.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label34.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label34.tcontrol_setparentfont(false);
   $t.tform1_label34.tlabel_setwordwrap(true);
   $t.tform1_downloadpanel.tcontrol_setleft(296);
   $t.tform1_downloadpanel.tcontrol_settop(361);
   $t.tform1_downloadpanel.tcontrol_setwidth(977);
   $t.tform1_downloadpanel.tcontrol_setheight(609);
   $t.tform1_downloadpanel.tpanel_setcaption("Homepanel");
   $t.tform1_downloadpanel.tpanel_setshowborder(false);
   $t.tform1_downloadpanel.tpanel_setshowcaption(false);
   $t.tform1_downloadpanel.setcolor(16748574);
   $t.tform1_downloadpanel.tcontrol_setparentcolor(false);
   $t.tform1_downloadpanel.tcontrol_settaborder(5);
   $t.tform1_downloadpanel.tcontrol_setvisible(false);
   $t.tform1_image9.tcontrol_setleft(360);
   $t.tform1_image9.tcontrol_settop(527);
   $t.tform1_image9.tcontrol_setwidth(65);
   $t.tform1_image9.tcontrol_setheight(57);
   $t.tform1_image9.timage_setimagename("IQEnterprise.jpg");
   $t.tform1_image9.timage_setstretch(true);
   $t.tform1_image9.tcontrol_setvisible(false);
   $t.tform1_image9.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_image9click.call($t, sender); };
   $t.tform1_image15.tcontrol_setleft(280);
   $t.tform1_image15.tcontrol_settop(535);
   $t.tform1_image15.tcontrol_setwidth(65);
   $t.tform1_image15.tcontrol_setheight(57);
   $t.tform1_image15.timage_setimagename("pastel.jpg");
   $t.tform1_image15.timage_setstretch(true);
   $t.tform1_image15.tcontrol_setvisible(false);
   $t.tform1_image15.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_image15click.call($t, sender); };
   $t.tform1_label32.tcontrol_setleft(240);
   $t.tform1_label32.tcontrol_settop(48);
   $t.tform1_label32.tcontrol_setwidth(377);
   $t.tform1_label32.tcontrol_setheight(104);
   $t.tform1_label32.tlabel_setautosize(false);
   $t.tform1_label32.tlabel_setcaption("TargetViewSetup (Ver 1.0.0.1) 25 Mar 2012\nContains\nTargetview.exe    10,907,136 (Ver 1.0.0.0)\nPastelexport.exe       720,384 (Ver 0.84 Beta)\nIQExport.exe             283,648 (Ver 1.0.0.0)");
   $t.tform1_label32.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label32.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label32.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label32.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label32.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label32.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label32.tcontrol_setparentfont(false);
   $t.tform1_label32.tlabel_settransparent(true);
   $t.tform1_label31.tcontrol_setleft(96);
   $t.tform1_label31.tcontrol_settop(432);
   $t.tform1_label31.tcontrol_setwidth(377);
   $t.tform1_label31.tcontrol_setheight(16);
   $t.tform1_label31.tlabel_setautosize(false);
   $t.tform1_label31.tlabel_setcaption("IQExport (Ver 1.0.0.1) 25 Mar 2012");
   $t.tform1_label31.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label31.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label31.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label31.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label31.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label31.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label31.tcontrol_setparentfont(false);
   $t.tform1_label31.tlabel_settransparent(true);
   $t.tform1_label31.tcontrol_setvisible(false);
   $t.tform1_label33.tcontrol_setleft(96);
   $t.tform1_label33.tcontrol_settop(456);
   $t.tform1_label33.tcontrol_setwidth(377);
   $t.tform1_label33.tcontrol_setheight(16);
   $t.tform1_label33.tlabel_setautosize(false);
   $t.tform1_label33.tlabel_setcaption("PastelExport (Ver 1.0.0.1) 25 Mar 2012");
   $t.tform1_label33.tcontrol_ffont.tfont_setname("Tahoma");
   $t.tform1_label33.tcontrol_ffont.tfont_setcolor(8421504);
   $t.tform1_label33.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label33.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label33.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label33.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label33.tcontrol_setparentfont(false);
   $t.tform1_label33.tlabel_settransparent(true);
   $t.tform1_label33.tcontrol_setvisible(false);
   $t.tform1_label65.tcontrol_setleft(96);
   $t.tform1_label65.tcontrol_settop(23);
   $t.tform1_label65.tcontrol_setwidth(477);
   $t.tform1_label65.tcontrol_setheight(17);
   $t.tform1_label65.tlabel_setautosize(false);
   $t.tform1_label65.tlabel_setcaption("You must first log on to download.");
   $t.tform1_label65.tcontrol_ffont.tfont_setname("Segoe UI");
   $t.tform1_label65.tcontrol_ffont.tfont_setcolor(255);
   $t.tform1_label65.tcontrol_ffont.tfont_setdecoration(0);
   $t.tform1_label65.tcontrol_ffont.tfont_setsize(10);
   $t.tform1_label65.tcontrol_ffont.tfont_setstyle(0);
   $t.tform1_label65.tcontrol_ffont.tfont_setweight(0);
   $t.tform1_label65.tcontrol_setparentfont(false);
   $t.tform1_label65.tcontrol_setvisible(false);
   $t.tform1_image4.tcontrol_setleft(96);
   $t.tform1_image4.tcontrol_settop(47);
   $t.tform1_image4.tcontrol_setwidth(129);
   $t.tform1_image4.tcontrol_setheight(105);
   $t.tform1_image4.timage_setstretch(true);
   $t.tform1_image4.timage_settransparent(true);
   $t.tform1_image4.tcontrol_fonclick = function(sender) { unit1_tform1.$p.tform1_image4click.call($t, sender); };
   $t.tform1_label16.tcontrol_setleft(96);
   $t.tform1_label16.tcontrol_settop(175);
   $t.tform1_label16.tcontrol_setwidth(130);
   $t.tform1_label16.tcontrol_setheight(15);
   $t.tform1_label16.tcontrol_setalignment(1);
   $t.tform1_label16.tlabel_setautosize(false);
   $t.tform1_label16.tlabel_setcaption("www.targetview.co.za");
   webforms_tform.$p.initialize.call($t);
};


// Main Program Declarations

function index_load()
{
   webhttp_init();
   webctrls_init();
   webforms_init();
   webforms_application.tapplication_settheme("Default");
   webforms_application.tapplication_fdesktop.setcolor(webctrls_cldesktopbackground);
   webforms_application.tapplication_fimagepath = "images";
   webforms_application.tapplication_fthemepath = "themes";
   webforms_application.tapplication_fdesktop.tcontrol_setheight(1200);
   webforms_application.tapplication_fdesktop.tdesktop_setautowidth(true);
   webforms_application.initialize();
   unit1_form1 = webforms_tform.create(new unit1_tform1(), webforms_application);
   webforms_application.run();
}

function index_unload()
{
   webforms_final();
   webctrls_final();
   webhttp_final();
}
